function agv(p1,p2,p3,p4,p5,seltype);
% AGV  FDIDGUI Variances and/or Averaging Window
% Private function of  FDTOOL.
%

%       Copyright (c) I. Kollar and Vrije Universiteit Brussel, ELEC, 1997-2003
%       All rights reserved.
%       $Revision: $
%       Written by Gy. Simon
%       Last modified: 27-Dec-2003, IK

mainfig=findall(0, 'tag','fdtool_main');
Me='average_main';
myfcn='agv';

if nargin >0 & ~strcmp(p1, 'init')
  myfig=findall(0, 'tag',Me);
  if nargin == 6
    sender=p5;
  else
    seltype=get(myfig,'selectiontype');
    eval(['sender=p', num2str(nargin) ';']);
  end
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%                 INITIALIZATION
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if nargin == 0 | strcmp(p1, 'init')
  tmp=findall(0, 'tag','average_main');
  if ~isempty(tmp)
    % set(tmp,'visible','on');
    %figure(tmp);
    guiclose('average')
  end

  % An initialization file belongst to each window. This file defines the standard
  % layout of the particular window. This mainly serves for development purposes.
  % The resize function 'resizes' all the components on screeen.

  agvdef

  fig = figure(...
    'position',[ fig_offsx fig_offsy fig_dx fig_dy ],...
    'resize','on','tag','average',...
    'Name','Variances and/or Averaging',...
    'NumberTitle','off',...
    'IntegerHandle', 'off', ...
    'windowbuttonmotion','fdtool(''callback'',''agv'',''mouse_motion'')',...
    'Handlevisibility', 'off',...
    'color',figure_col,...
    'tag', 'average_main',...
    'deletefcn', 'fdtool(''callback'',''agv'',''destroyed'',''average_main'')',...
    'resizefcn','fdtool(''callback'',''agv'',''resize'',''resize'')',...
    'visible','off');
  myfig=fig;
  fdwindef(myfig); % set default window props
  %  Uicontrol Object Creation

  agv_uic_averageframe = uicontrol(...
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ averageframe_offsx averageframe_offsy  averageframe_dx averageframe_dy ],...
    'BackgroundColor',frame_bgr_col,...
    'ForegroundColor',frame_fg_col,...
    'Visible','on',...
    'String','Data to fit',...
    'HorizontalAlignment','center',...
    'Style','frame',...
    'Tag','agv_uic_averageframe',...
    'UserData','');
  agv_uic_averagetext = uicontrol(...
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ averagetext_offsx averagetext_offsy  averagetext_dx averagetext_dy ],...
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'Visible','on',...
    'String','Data to fit',...
    'tooltipstring','Selection of Fourier amplitudes to fit',...
    'HorizontalAlignment','center',...
    'Style','text',...
    'Tag','agv_uic_averagetext',...
    'UserData','');
  guititle(agv_uic_averagetext);
  agv_uic_avrb(1) = uicontrol(...
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''agv'',''agv_uic_avrb(1)'',''agv_uic_avrb(1)'');',...
    'Units','pixels',...
    'Position',[ avrb1_offsx avrb1_offsy  avrb1_dx avrb1_dy ],...
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'Visible','on',...
    'String','Select Experiment #',...
    'tooltipstring','Serial number of experiment to be used',...
    'HorizontalAlignment','left',...
    'Style','radiobutton',...
    'Tag','agv_uic_avrb(1)',...
    'Value',[ 0 ],...
    'UserData','');
  agv_uic_enedit = uicontrol(...
    'Parent',fig,...
    'CallBack', 'fdtool(''callback'',''agv'',''ui_edit'',''agv_uic_enedit'');',...
    'Position',[ enedit_offsx enedit_offsy  enedit_dx enedit_dy ],...
    'BackgroundColor',edit_bgr_col,...
    'ForegroundColor',edit_fg_col,...
    'String','1',...
    'HorizontalAlignment','right',...
    'Style','edit',...
    'Enable','on',...
    'Tag','agv_uic_enedit',...
    'ToolTipString','Number of experiment',...
    'UserData','');
  agv_uic_avrb(2) = uicontrol(...
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''agv'',''agv_uic_avrb(2)'',''agv_uic_avrb(2)'');',...
    'Units','pixels',...
    'Position',[ avrb2_offsx avrb2_offsy  avrb2_dx avrb2_dy ],...
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'Visible','on',...
    'String','Average synchronized per. data',...
    'tooltipstring','Average Fourier amplitudes across experiments assuming periodic data and synchronized measurements',...
    'HorizontalAlignment','left',...
    'Style','radiobutton',...
    'Tag','agv_uic_avrb(2)',...
    'Value',[ 1 ],...
    'UserData','');
  agv_uic_avrb(3) = uicontrol(...
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''agv'',''agv_uic_avrb(3)'',''agv_uic_avrb(3)'');',...
    'Units','pixels',...
    'Position',[ avrb3_offsx avrb3_offsy avrb3_dx avrb3_dy ],...
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'Visible','on',...
    'String','Synchronize and avg. per. data',...
    'tooltipstring','Synchronize periodic data from different experiments and then average',...
    'HorizontalAlignment','left',...
    'Style','radiobutton',...
    'Tag','agv_uic_avrb(3)',...
    'Value',[ 0 ],...
    'UserData','');
  agv_uic_avrb(4) = uicontrol(...
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''agv'',''agv_uic_avrb(4)'',''agv_uic_avrb(4)'');',...
    'Units','pixels',...
    'Position',[ avrb4_offsx avrb4_offsy avrb4_dx avrb4_dy ],...
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'Visible','on',...
    'String','Power spectral analysis',...
    'tooltipstring','Calculate and average G_yu(k) and G_uu(k)',...
    'HorizontalAlignment','left',...
    'Style','radiobutton',...
    'Tag','agv_uic_avrb(4)',...
    'Value',[ 0 ],...
    'UserData','');
  agv_uic_getvframe = uicontrol(...
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ getvframe_offsx getvframe_offsy  getvframe_dx getvframe_dy ],...
    'BackgroundColor',frame_bgr_col,...
    'ForegroundColor',frame_fg_col,...
    'Visible','on',...
    'String','Get variances',...
    'HorizontalAlignment','left',...
    'Style','frame',...
    'Tag','agv_uic_getvframe',...
    'Enable','off',...
    'UserData','');
  agv_uic_gettext = uicontrol(...
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ gettext_offsx gettext_offsy gettext_dx gettext_dy ],...
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'Visible','on',...
    'String','Get variances',...
    'HorizontalAlignment','center',...
    'Style','text',...
    'Tag','agv_uic_gettext',...
    'UserData','');
  guititle(agv_uic_gettext);
  agv_uic_getrb(1) = uicontrol(...
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''agv'',''agv_uic_getrb(1)'',''agv_uic_getrb(1)'');',...
    'Units','pixels',...
    'Position',[ getrb1_offsx getrb1_offsy getrb1_dx getrb1_dy ],...
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'Visible','on',...
    'String','Set to Constant',...
    'tooltipstring','Set input and output variances to constant values',...
    'HorizontalAlignment','left',...
    'Style','radiobutton',...
    'Tag','agv_uic_getrb(1)',...
    'Value',[ 0 ],...
    'UserData','');
  agv_uic_vxtext = uicontrol(...
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ vxtext_offsx vxtext_offsy  vxtext_dx vxtext_dy ],...
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'Visible','off',...
    'String','vu',...
    'HorizontalAlignment','right',...
    'Style','text',...
    'Tag','agv_uic_vxtext',...
    'UserData','CONSTANT_VARIANCE');
  agv_uic_vxedit = uicontrol(...
    'Parent',fig,...
    'CallBack', 'fdtool(''callback'',''agv'',''ui_edit'',''agv_uic_vxedit'');',...
    'Position',[ vxedit_offsx vxedit_offsy vxedit_dx vxedit_dy ],...
    'BackgroundColor',edit_bgr_col,...
    'ForegroundColor',edit_fg_col,...
    'String','1',...
    'tooltipstring','Input variances',...
    'HorizontalAlignment','right',...
    'Style','edit',...
    'Visible','off',...
    'Tag','agv_uic_vxedit',...
    'UserData','CONSTANT_VARIANCE');
  agv_uic_getrb(2) = uicontrol(...
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''agv'',''agv_uic_getrb(2)'',''agv_uic_getrb(2)'');',...
    'Units','pixels',...
    'Position',[ getrb2_offsx getrb2_offsy  getrb2_dx getrb2_dy ],...
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'Visible','on',...
    'String','Take from Data',...
    'tooltipstring','Use variances given in data object',...
    'HorizontalAlignment','left',...
    'Style','radiobutton',...
    'Tag','agv_uic_getrb(2)',...
    'Value',[ 0 ],...
    'UserData','');
  agv_uic_vytext = uicontrol(...
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ vytext_offsx vytext_offsy  vytext_dx vytext_dy ],...
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'Visible','off',...
    'String','vy',...
    'HorizontalAlignment','right',...
    'Style','text',...
    'Tag','agv_uic_vytext',...
    'UserData','CONSTANT_VARIANCE');
  agv_uic_vyedit = uicontrol(...
    'Parent',fig,...
    'CallBack', 'fdtool(''callback'',''agv'',''ui_edit'', ''agv_uic_vyedit'');',...
    'Position',[ vyedit_offsx vyedit_offsy  vyedit_dx vyedit_dy ],...
    'BackgroundColor',edit_bgr_col,...
    'ForegroundColor',edit_fg_col,...
    'String','1',...
    'tooltipstring','Output variances',...
    'HorizontalAlignment','right',...
    'Style','edit',...
    'visible','off',...
    'Tag','agv_uic_vyedit',...
    'UserData','CONSTANT_VARIANCE');
  agv_uic_getrb(3) = uicontrol(...
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''agv'',''agv_uic_getrb(3)'',''agv_uic_getrb(3)'');',...
    'Units','pixels',...
    'Position',[ getrb3_offsx getrb3_offsy getrb3_dx getrb3_dy ],...
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'Visible','on',...
    'String','Import...',...
    'tooltipstring','Import variances from object in workspace or a file',...
    'HorizontalAlignment','left',...
    'Style','radiobutton',...
    'Interruptible', 'off', ...
    'Tag','agv_uic_getrb(3)',...
    'Value',[ 0 ],...
    'UserData','');
  agv_uic_getrb(4) = uicontrol(...
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''agv'',''agv_uic_getrb(4)'',''agv_uic_getrb(4)'');',...
    'Units','pixels',...
    'Position',[ getrb4_offsx getrb4_offsy  getrb4_dx getrb4_dy ],...
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'Visible','on',...
    'String','Output of this window',...
    'tooltipstring','Use variance data available at VA output',...
    'HorizontalAlignment','left',...
    'Style','radiobutton',...
    'Tag','agv_uic_getrb(4)',...
    'Value',[ 0 ],...
    'UserData','');
  agv_uic_getrb(5) = uicontrol(...
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''agv'',''agv_uic_getrb(5)'',''agv_uic_getrb(5)'');',...
    'Units','pixels',...
    'Position',[ getrb5_offsx getrb5_offsy  getrb5_dx getrb5_dy ],...
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'Visible','on',...
    'String','Perform Var. Anal.',...
    'tooltipstring','Variance analysis across experiments',...
    'HorizontalAlignment','left',...
    'Style','radiobutton',...
    'Tag','agv_uic_getrb(5)',...
    'Value',[ 1 ],...
    'UserData','');
  agv_uic_alltext = uicontrol(...
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ alltext_offsx alltext_offsy  alltext_dx alltext_dy ],...
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'Visible','off',...
    'String','Scaling factor',...
    'tooltipstring','Multiplicative factor to rescale variance values (for Import, VA output, and From Data)',...
    'HorizontalAlignment','center',...
    'Style','text',...
    'Tag','agv_uic_alltext',...
    'UserData','SCALING FACTOR');
  agv_uic_multext = uicontrol(...
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ multext_offsx multext_offsy  multext_dx multext_dy ],...
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'Visible','off',...
    'String','x',...
    'HorizontalAlignment','right',...
    'Style','text',...
    'Tag','agv_uic_multext',...
    'UserData','SCALING FACTOR');
  agv_uic_muledit = uicontrol(...
    'Parent',fig,...
    'CallBack', 'fdtool(''callback'',''agv'',''ui_edit'',''agv_uic_muledit'');',...
    'Position',[ muledit_offsx muledit_offsy  muledit_dx muledit_dy ],...
    'BackgroundColor', edit_bgr_col, ...
    'ForegroundColor',  edit_fg_col, ...
    'String','1',...
    'tooltipstring','Multiplicative factor to rescale variance values (for Import, VA output, and From Data)',...
    'HorizontalAlignment','right',...
    'Style','edit',...
    'Visible','off',...
    'Tag','agv_uic_muledit',...
    'UserData','SCALING FACTOR');
  agv_uic_dataframe = uicontrol(...
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ dataframe_offsx dataframe_offsy dataframe_dx dataframe_dy ],...
    'ForegroundColor',frame_fg_col,...
    'BackgroundColor',frame_bgr_col,...
    'Visible','on',...
    'String','Data info',...
    'HorizontalAlignment','left',...
    'Style','frame',...
    'Tag','agv_uic_dataframe',...
    'Enable','off',...
    'UserData','');
  agv_uic_datatext = uicontrol(...
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ datatext_offsx datatext_offsy  datatext_dx datatext_dy ],...
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'Visible','on',...
    'String','Data info',...
    'HorizontalAlignment','center',...
    'Style','text',...
    'Tag','agv_uic_datatext',...
    'UserData','');
  guititle(agv_uic_datatext);
  agv_uic_infotext(1) = uicontrol(...
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ infotext1_offsx infotext1_offsy  infotext1_dx infotext1_dy ],...
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'Visible','on',...
    'String','',...
    'HorizontalAlignment','left',...
    'Style','text',...
    'Tag','agv_uic_infotext(1)',...
    'UserData','');
  agv_uic_infotext(2) = uicontrol(...
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ infotext2_offsx infotext2_offsy  infotext2_dx infotext2_dy ],...
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'Visible','on',...
    'String','',...
    'HorizontalAlignment','left',...
    'Style','text',...
    'Tag','agv_uic_infotext(2)',...
    'UserData','');
  agv_uic_infotext(3) = uicontrol(...
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ infotext3_offsx infotext3_offsy  infotext3_dx infotext3_dy ],...
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'Visible','on',...
    'String','',...
    'HorizontalAlignment','left',...
    'Style','text',...
    'Tag','agv_uic_infotext(3)',...
    'UserData','');
  agv_uic_infotext(4) = uicontrol(...
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ infotext4_offsx infotext4_offsy infotext4_dx infotext4_dy ],...
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'Visible','on',...
    'String','',...
    'HorizontalAlignment','left',...
    'Style','text',...
    'Tag','agv_uic_infotext(4)',...
    'UserData','');
  agv_uic_infotext(5) = uicontrol(...
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ infotext5_offsx infotext5_offsy infotext5_dx infotext5_dy ],...
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'Visible','on',...
    'String','',...
    'HorizontalAlignment','left',...
    'Style','text',...
    'Tag','agv_uic_infotext(5)',...
    'UserData','');
  agv_uic_infotext(6) = uicontrol(...
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ infotext6_offsx infotext6_offsy infotext6_dx infotext6_dy ],...
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'Visible','on',...
    'String','',...
    'HorizontalAlignment','left',...
    'Style','text',...
    'Tag','agv_uic_infotext(6)',...
    'UserData','');
  agv_uic_infotext(7) = uicontrol(...
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ infotext7_offsx infotext7_offsy infotext7_dx infotext7_dy ],...
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'Visible','on',...
    'String','',...
    'HorizontalAlignment','left',...
    'Style','text',...
    'Tag','agv_uic_infotext(7)',...
    'UserData','');
  agv_uic_infotext(8) = uicontrol(...
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ infotext8_offsx infotext8_offsy  infotext8_dx infotext8_dy ],...
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'Visible','on',...
    'String','',...
    'HorizontalAlignment','left',...
    'Style','text',...
    'Tag','agv_uic_infotext(8)',...
    'UserData','');
  agv_uic_infotext(9) = uicontrol(...
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ infotext9_offsx infotext9_offsy  infotext9_dx infotext9_dy ],...
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'Visible','on',...
    'String','',...
    'HorizontalAlignment','left',...
    'Style','text',...
    'Tag','agv_uic_infotext(9)',...
    'UserData','');
  agv_uic_infotext(10) = uicontrol(...
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ infotext10_offsx infotext10_offsy  infotext8_dx infotext10_dy ],...
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'Visible','on',...
    'String','',...
    'HorizontalAlignment','left',...
    'Style','text',...
    'Tag','agv_uic_infotext(10)',...
    'UserData','');
  agv_uic_frffxfypop = uicontrol(...
    'Parent',fig,...
    'CallBack', 'fdtool(''callback'',''agv'', ''agv_uic_frffxfypop'', ''agv_uic_frffxfypop'')',...
    'Units','pixels',...
    'Position',[ frffxfypop_offsx frffxfypop_offsy frffxfypop_dx frffxfypop_dy ],...
    'BackgroundColor',popup_bgr_col,...
    'ForegroundColor',popup_fg_col,...
    'HorizontalAlignment','right',...
    'String',{'frf','mag-phase','output-input'},...
    'tooltipstring','Type of plot',...
    'Style','popup',...
    'Tag','agv_uic_frffxfypop',...
    'UserData','');
  agv_uic_varpop = uicontrol(...
    'Parent',fig,...
    'CallBack', 'fdtool(''callback'', ''agv'', ''agv_uic_varpop'', ''agv_uic_varpop'')',...
    'Units','pixels',...
    'Position',[ varpop_offsx varpop_offsy varpop_dx varpop_dy ],...
    'BackgroundColor',popup_bgr_col,...
    'ForegroundColor',popup_fg_col,...
    'HorizontalAlignment','right',...
    'String',{'var on','var off'},...
    'tooltipstring','Show or do not show variance data in plot',...
    'Style','popup',...
    'Tag','agv_uic_varpop',...
    'UserData','');
  agv_uic_linloghpop = uicontrol(...
    'Parent',fig,...
    'CallBack', 'fdtool(''callback'',''agv'', ''agv_uic_linloghpop'', ''agv_uic_linloghpop'')',...
    'Units','pixels',...
    'Position',[ linloghpop_offsx linloghpop_offsy linloghpop_dx linloghpop_dy ],...
    'BackgroundColor',popup_bgr_col,...
    'ForegroundColor',popup_fg_col,...
    'HorizontalAlignment','right',...
    'String',{'lin freq','log freq'},...
    'tooltipstring','Linear/logarithmic frequency axis',...
    'Style','popup',...
    'Tag','agv_uic_linloghpop',...
    'UserData','');
  agv_uic_windowpop = uicontrol(...
    'Parent',fig,...
    'CallBack', 'fdtool(''callback'',''agv'', ''agv_uic_windowpop'', ''agv_uic_windowpop'')',...
    'Units','pixels',...
    'Position',[ windowpop_offsx windowpop_offsy windowpop_dx windowpop_dy ],...
    'BackgroundColor',popup_bgr_col,...
    'ForegroundColor',popup_fg_col,...
    'HorizontalAlignment','right',...
    'String',{'rect','sine','Hanning','Hamming'},...
    'tooltipstring','Type of window function applied',...
    'Style','popup',...
    'Tag','agv_uic_windowpop',...
    'enable','off',...
    'UserData','');
  agv_uic_windowtext = uicontrol(...
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ windowtext_offsx windowtext_offsy  windowtext_dx windowtext_dy ],...
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'Visible','on',...
    'String','window',...
    'HorizontalAlignment','right',...
    'Style','text',...
    'Tag','agv_uic_windowtext',...
    'enable','off',...
    'UserData','WINDOW');
  agv_uic_freqpb = uicontrol(...
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''agv'',''agv_uic_freqpb'',''agv_uic_freqpb'');',...
    'Position',[ freqpb_offsx freqpb_offsy  freqpb_dx freqpb_dy ],...
    'BackgroundColor',pushb_bgr_col,...
    'ForegroundColor',pushb_fg_col,...
    'Visible','on',...
    'String','Frequency selection',...
    'tooltipstring','Select frequencies if not all of them will be used later',...
    'HorizontalAlignment','center',...
    'Style','pushbutton',...
    'Enable', 'off',...
    'Tag','agv_uic_freqpb',...
    'UserData','');
  agv_uic_evalpb = uicontrol(...
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''agv'',''agv_uic_evalpb'',''agv_uic_evalpb'');',...
    'Position',[ evalpb_offsx evalpb_offsy evalpb_dx evalpb_dy ],...
    'BackgroundColor',pushb_bgr_col,...
    'ForegroundColor',pushb_fg_col,...
    'Visible','on',...
    'String','Execute',...
    'tooltipstring','Determine Fourier and variance data',...
    'HorizontalAlignment','center',...
    'Style','pushbutton',...
    'Enable', 'off',...
    'Tag','agv_uic_evalpb',...
    'UserData','');
  agv_uic_cancelpb = uicontrol(...
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''agv'',''agv_uic_cancelpb'',''agv_uic_cancelpb'');',...
    'Position',[ cancelpb_offsx cancelpb_offsy cancelpb_dx cancelpb_dy ],...
    'BackgroundColor',pushb_bgr_col,...
    'ForegroundColor',pushb_fg_col,...
    'Visible','on',...
    'String','Cancel',...
    'tooltipstring','Close window, return no data',...
    'HorizontalAlignment','center',...
    'Style','pushbutton',...
    'Tag','agv_uic_cancelpb',...
    'UserData','');
  agv_uic_donepb = uicontrol(...
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''agv'',''agv_uic_donepb'',''agv_uic_donepb'');',...
    'Position',[ donepb_offsx donepb_offsy  donepb_dx donepb_dy ],...
    'BackgroundColor',pushb_bgr_col,...
    'ForegroundColor',pushb_fg_col,...
    'Visible','on',...
    'String','Close',...
    'tooltipstring','Close window, return result',...
    'HorizontalAlignment','center',...
    'Style','pushbutton',...
    'Enable', 'off',...
    'Tag','agv_uic_donepb',...
    'UserData','');
  agv_uic_suggestpb = uicontrol(...
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''agv'',''agv_uic_suggestpb'',''agv_uic_suggestpb'');',...
    'Position',[ suggestpb_offsx suggestpb_offsy suggestpb_dx suggestpb_dy ],...
    'BackgroundColor',pushb_bgr_col,...
    'ForegroundColor',pushb_fg_col,...
    'Visible','on',...
    'String','Suggest',...
    'tooltipstring','Set choices suggested by the GUI',...
    'HorizontalAlignment','center',...
    'Style','pushbutton',...
    'Enable', 'on',...
    'Tag','agv_uic_suggestpb',...
    'UserData','');
  agv_uic_statusframe = uicontrol(...
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ statusframe_offsx statusframe_offsy statusframe_dx statusframe_dy ],...
    'BackgroundColor',frame_bgr_col,...
    'ForegroundColor',frame_fg_col,...
    'Visible','on',...
    'String','',...
    'HorizontalAlignment','left',...
    'Style','frame',...
    'Enable','off',...
    'Tag',[Me '_statusframe'],...
    'UserData','');
  agv_uic_statustext = uicontrol(...
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ statustext_offsx statustext_offsy  statustext_dx statustext_dy ],...
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'Visible','on',...
    'String','',...
    'HorizontalAlignment','left',...
    'Style','text',...
    'Tag',[Me '_status'],...
    'UserData','');


  %  Menu Object Creation


  %  Axes and Text Object Creation

  agv_axes_uaxes = axes(...
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ uaxes_offsx uaxes_offsy uaxes_dx uaxes_dy ],...
    'Color',[1 1 1],...
    'Xgrid','off', ...
    'Ygrid','off', ...
    'Xlim',[ 0 1 ],...
    'Ylim',[ 0 1 ],...
    'defaultlinehittest', 'off',...
    'nextplot', 'replacechildren',...
    'Clipping','on', ...
    'ButtonDownFcn','fdtool(''callback'',''agv'',''click_on_axes_uaxes'',''agv_axes_uaxes'')',...
    'visible','off',...
    'Tag','agv_axes_uaxes', ...
    'UserData','');
  agv_axes_laxes = axes(...
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ laxes_offsx laxes_offsy laxes_dx laxes_dy ],...
    'Color',[1 1 1],...
    'Xgrid','off', ...
    'Ygrid','off', ...
    'Xlim',[ 0 1 ],...
    'Ylim',[ 0 1 ],...
    'defaultlinehittest', 'off',...
    'nextplot', 'replacechildren',...
    'Clipping','on', ...
    'ButtonDownFcn','fdtool(''callback'',''agv'',''click_on_axes_laxes'',''agv_axes_laxes'')',...
    'visible','on',...
    'Tag','agv_axes_laxes', ...
    'UserData','');


  % set gropID's for rb groups
  set(agv_uic_avrb, 'UserData','agv_uic_avrb');
  set(agv_uic_getrb, 'UserData', 'agv_uic_getrb');

  % init help fcns
  helpmgr('init_help', '', myfcn, myfig );

  % create menu
  guimenus('average_main','average','agv');

  winmenu(myfig);

  if nargin >1
    if ~isempty(p2) % agv('init', initvar): load session
      storewin('restore_all', Me, p2) % bring up window with settings in p2
      load_need=0;
    else
      load_need=1;
      % agv('init', ''): default settings
    end
  else % agv or agv('init') : no initvars, restore if possible
    load_need=storewin('recover', Me);
  end
  if strcmp(lower(guiinfos('userlevel')),'automatic')
    fdtool('status', '#yAutomatic execution of AGV... For interactive mode please select higher UserLevel.')
  else
    intoscr({'average_main'});

    % The above function, intoscr positions the windows given by their labels
    % into the actual screen. This might come handy when the session has been saved
    % on a machine with different resolution than that of the present machine.

    set(fig,'visible','on'); %drawnow
    agv('status', 'Please wait...')
  end
  if load_need
    %% Load input variable
    inp=guidtard('fdtool_main', ['INPUT_average']);
    inpval=guidtard('fdtool_main', ['OUTPUT_', inp.from]);
    if isempty(inpval)
      errordlg('Input of the window is missing','Internal Error')
      %guiclose('average')
      return
    end
    guidtawr(Me,'DATA_Fdat','direct',inpval);
    guidtawr(Me,'FINAL_DATA','direct',[]);
    guidtawr(Me,'FV_DATA','direct',[]);
    agv('suggest')
  else
    % set PreviousVal RB since suggest not called here
    oldvar=CheckPreviousRB(Me); % output's variance if can be used here
    if isempty(oldvar)
      set(agv_uic_getrb(4), 'enable', 'off')
    else
      set(agv_uic_getrb(4), 'enable', 'on')
    end
    % set FromData RB since suggest not called here
    if isempty(CheckFromDataRB(Me))
      set(agv_uic_getrb(2), 'enable', 'off')
    else
      set(agv_uic_getrb(2), 'enable', 'on')
    end
  end % if load_need
  %
  if 1
    %Set constant variance values to reasonable values
    if strcmp(get(agv_uic_donepb,'enable'),'off') %not evaluated yet
      outp=guidtard(Me,'FINAL_DATA');
      inp=guidtard(Me, 'DATA_Fdat');
      if iscell(inp.input), vu=mean(abs(inp.input{1})).^2/200;
      else vu=mean(abs(inp.input)).^2/200;
      end
      vustr=sprintf('%3.2g',vu); ind=[findstr(vustr,'-00'),findstr(vustr,'+00')];
      if ~isempty(ind), vustr(ind+[1:2])=''; end
      if iscell(inp.output), vy=mean(abs(inp.output{1})).^2/200;
      else vy=mean(abs(inp.output)).^2/200;
      end
      vystr=sprintf('%3.2g',vy); ind=[findstr(vystr,'-00'),findstr(vystr,'+00')];
      if ~isempty(ind), vystr(ind+[1:2])=''; end
      set(agv_uic_vxedit,'string',vustr);
      set(agv_uic_vyedit,'string',vystr);
    end
  end
  %
  ulevctrl(Me)
  if strcmp(lower(guiinfos('userlevel')), 'automatic')
    if strcmpi(guiinfos('signaltype'),'periodic')
      agv('suggest')
      inp=guidtard(Me,'DATA_Fdat');
      if inp.expn==1 & isempty(inp.SiSoVariance)
        if get(agv_uic_getrb(1), 'value')  % constant
          set([agv_uic_vxedit, agv_uic_vyedit], 'string', '1') % set var to [1 1]
          warning_need=1;
        elseif get(agv_uic_getrb(4), 'value')  % output of this window
          set([agv_uic_muledit], 'string', '1') % set scaling factor to 1
          warning_need=2;
        end
      else
        warning_need=0;
      end
      %
      agv('agv_evalpb')
      %
      if warning_need==1
        fdtool('status','Warning: Only one experiment in data, variance set to constant')
      elseif warning_need==2
        fdtool('status','Warning: Only one experiment in data, previous variance used.')
      end
    else %all
      %agv('update_plot')
      %agv('info_update')
      if load_need
        agv('disable_select')
      end
      SetEditObjs(myfig)
      agv('agv_evalpb')
      agv('status','Ready.')
      %fixpopups(findall(0,'type','figure','tag','average_main'))
      init_var=[];
      % itt ki kell vadaszni az esetleges elozo szelekciokat
      % es az indexvektort at kell adni az init_var-ban
      freqsel('init', myfcn, 'AVERAGE', init_var)
    end
    set(myfig,'visible','on')
  else %higher than automatic
    %try, agv('agv_evalpb'), catch, agv('suggest'); agv('agv_evalpb'), end
    %agv('agv_evalpb')
    set(myfig,'visible','on')
  end
  
  %end of init

  
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %
  %   AGV commands
  %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


  %%%%%%%%%%%  AVERAGE SYNC/NONSYNC  RB GROUP
elseif strcmp(p1, 'mouse_motion')
  guiready(myfig, 'agv')

elseif strcmp(p1,'agv_uic_avrb(1)') % experiment #
  agv('status', 'Select experiment number...')
  rbtag(sender);
  h1=findobj(myfig, 'Tag','agv_uic_enedit');
  h2=findobj(myfig, 'tag', 'agv_uic_getrb(5)');
  set([h1],'visible', 'on','enable','on')  %enable editbox
  set(findobj(myfig,'Tag','agv_uic_windowpop'),'enable','off')
  set(findobj(myfig,'Tag','agv_uic_windowtext'),'enable','off')
  %set([h2],'enable', 'off') %disable variance anal: several exp possible
  if get(h2, 'value') % if varanal selected then check, and suggest, if necessary
    agv('suggestGetVariances')
  end
  agv('disable_select')

elseif strcmp(p1,'agv_uic_enedit') % experiment # editbox
  agv('disable_select')


elseif strcmp(p1,'agv_uic_avrb(2)') % average sync data
  agv('status', 'Average synchronized data selected')
  rbtag(sender);
  h1=findobj(myfig, 'Tag','agv_uic_enedit');
  h2=findobj(myfig, 'tag', 'agv_uic_getrb(5)');
  set([h1],'visible', 'off')  %disable editbox
  set([h2],'enable', 'on') %enable variance anal
  set(findobj(myfig,'Tag','agv_uic_windowpop'),'enable','off')
  set(findobj(myfig,'Tag','agv_uic_windowtext'),'enable','off')
  agv('disable_select')

elseif strcmp(p1,'agv_uic_avrb(3)') % average nonsync data
  agv('status', 'Average nonsynchronized data selected')
  rbtag(sender);
  h1=findobj(myfig, 'Tag','agv_uic_enedit');
  h2=findobj(myfig, 'tag', 'agv_uic_getrb(5)');
  set([h1],'visible', 'off')  %disable editbox
  set([h2],'enable', 'on') %enable variance anal
  set(findobj(myfig,'Tag','agv_uic_windowpop'),'enable','off')
  set(findobj(myfig,'Tag','agv_uic_windowtext'),'enable','off')
  agv('disable_select')

elseif strcmp(p1,'agv_uic_avrb(4)') % power spectra
  agv('status', 'Calculate power spectra')
  rbtag(sender);
  h1=findobj(myfig, 'Tag','agv_uic_enedit');
  h2=findobj(myfig, 'tag', 'agv_uic_getrb(5)');
  set([h1],'visible', 'off')  %disable editbox
  set([h2],'enable', 'on') %enable variance anal
  set(findobj(myfig,'Tag','agv_uic_windowpop'),'enable','on')
  set(findobj(myfig,'Tag','agv_uic_windowtext'),'enable','on')
  agv('disable_select')

  %%%%%%%%%%%  GET VARIANCES  RB GROUP

elseif strcmp(p1,'agv_uic_getrb(1)')|strcmp(p1,'agv_uic_getrb(1)') % constant
  agv('status', 'Variance set to constant. Set variance values in editboxes')
  rbtag(sender);
  SetEditObjs(myfig)
  agv('disable_select')

elseif strcmp(p1,'agv_uic_vxedit')
  %
elseif strcmp(p1,'agv_uic_vyedit')
  %

elseif strcmp(p1,'agv_uic_getrb(2)') % from data
  input_data=guidtard(Me, 'DATA_Fdat');
  if any(findstr(get(findobj(myfig,'tag','agv_uic_getrb(5)'),'string'),'Interp'))
    agv('status', 'Nonlinear error weights taken from data')
  elseif ~isempty(input_data.SiSoVariance)
    agv('status', 'Variance values taken from data')
  else
    agv('status','Warning: Coherence values taken from data')
    coh=input_data.cohvect;
    tf=input_data.output./input_data.input;
    vartf=coh2var(coh,tf);
    input_data.SiSoVariance=[zeros(size(vartf)),vartf];
  end
  rbtag(sender);
  SetEditObjs(myfig)
  agv('disable_select')

elseif strcmp(p1,'agv_uic_getrb(3)') % import
  rbtag(sender);
  SetEditObjs(myfig)
  agv('status','Import variances... ')
  agv('disable_select')
  guifreez(Me, 'freeze_strong', 'agv_import');
  guiimpv('init', myfcn, 'Variance', [], 'filter: fiddata Object with Variance')
  agv('status', 'Please specify frequency data in the Import window...');

elseif strcmp(p1,'agv_uic_getrb(4)') % previous value of VA output
  agv('status', 'Variance values taken from previous output of this box')
  rbtag(sender);
  SetEditObjs(myfig)
  agv('disable_select')

elseif strcmp(p1,'agv_uic_getrb(5)') % variance anal
  if any(findstr(get(findobj(myfig,'tag','agv_uic_getrb(5)'),'string'),'Interp'))
    agv('status', 'Weighting by nonlinear errors, interpolated from data')
  elseif any(findstr(get(findobj(myfig,'tag','agv_uic_getrb(5)'),'string'),'Nonlin'))
    agv('status', 'Weighting by nonlinear errors')
  else
    agv('status', 'Variance analysis')
  end
  rbtag(sender);
  SetEditObjs(myfig)
  agv('disable_select')

elseif strcmp(p1, 'import_ready')
  guifreez(Me, 'unfreeze', 'force');
  switch  p2
    case 'cancel'
      rbtag('agv_uic_getrb(1)')
      SetEditObjs(myfig)
    case 'done'
      data=guidtard('fdtool_importfig', 'IMPORTED_VAR');
      var=CheckImported(Me, data); M=data.M;
      if isempty(var)
        rbtag('agv_uic_getrb(1)')
        agv('status', 'Error: Imported variance does not correspond with current input. Import cancelled.')
      else
        hist=data.history{end}; if iscell(hist), hist=hist{end}; end
        guidtawr(Me,'IMPORT_INFO','direct',hist);
        varstruct.var=var; varstruct.M=M;
        guidtawr(Me,'VARIANCE_DATA','direct',varstruct);
        agv('status', 'Variance values loaded')
      end
  end



  %%%%%%%%%%%  PLOT TYPE  POP
elseif strcmp(p1,'agv_uic_frffxfypop')
  val=get(findobj(myfig, 'tag','agv_uic_frffxfypop'),'value');
  string=get(findobj(myfig, 'tag','agv_uic_frffxfypop'),'string');
  if any(findstr(string{val},'frf'))|any(findstr(string{val},'output only'))
    set(findobj(myfig, 'tag','agv_axes_uaxes'),'visible','off');
    agv('resize','resize');
  else
    set(findobj(myfig, 'tag','agv_axes_uaxes'),'visible','on');
    agv('resize','resize');
  end;
  agv('update_plot')
  if strcmp(popupstr(findobj(myfig, 'tag','agv_uic_frffxfypop')),'mag-phase')
    %disable variances for mag-phase
    set(findobj(myfig, 'tag','agv_uic_varpop'),'enable','off')
    %else
    %  set(findobj(myfig, 'tag','agv_uic_varpop'),'enable','on')
  end

elseif strcmp(p1,'agv_uic_varpop')
  agv('update_plot')

elseif strcmp(p1,'agv_uic_windowpop')
  agv('disable_select')

elseif strcmp(p1,'agv_uic_linloghpop')

  agv('update_plot')

elseif strcmp(p1,'agv_uic_freqpb')
  init_var=[];
  % itt ki kell vadaszni az esetleges elozo szelekciokat
  % es az indexvektort at kell adni az init_var-ban
  freqsel('init', myfcn, 'AVERAGE', init_var)

  %%%%%%%%%%%  CANCEL  PB
elseif strcmp(p1,'agv_uic_cancelpb')
  agv('status', 'canceling...', Me);
  %set(myfig,'visible','off');
  guiclose('average')
  fdtool('finished_box', 'rect_average', 'cancel', Me);
  fdtool('status', 'Average... panel closed by Cancel. ', Me);


  %%%%%%%%%%%  DONE  PB
elseif strcmp(p1,'agv_uic_donepb') |strcmp(p1,'agv_autofinish')

  h_eval=findobj(allchild(myfig),'flat', 'tag', 'agv_uic_evalpb');
  stat=get(h_eval, 'enable');
  if strcmp('on', stat)
    agv('status', 'Please wait', Me);
    agv('agv_evalpb')
  end
  agv('status', 'Closing...', Me);
  input_data=guidtard(Me, 'DATA_Fdat');
  final_data=guidtard(Me, 'FINAL_DATA');
  final_data.history=input_data.history;
  final_data.state=input_data.state;
  addhist(final_data, HistStr(myfig));
  guidtawr('fdtool_main', 'OUTPUT_average', 'direct', final_data);
  % store settings
  storewin('remember', Me)
  guiclose('average')
  fdtool('finished_box', 'rect_average', 'Done', Me);
  fdtool('status', 'Average... panel closed. ', Me);
  if strcmp(lower(guiinfos('userlevel')),'automatic');
    fdtool('click_on_select','rect_select')
    fdtool('status','#yEPM block is automatically opened...')
    sme('status','#yIf model orders are known, please write them into the corresponding fields before starting.')
  end

  %%%%%%%%%%%  EVAL  PB
elseif strcmp(p1,'agv_uic_evalpb')|strcmp(p1,'agv_evalpb') %Execute
  guifreez(Me, 'freeze', 'agv_evalpb');
  agv('status', 'Please wait... determining Fourier amplitudes and variances.')
  figure(myfig), drawnow
  getvar_acth=findobj(myfig, 'userdata','agv_uic_getrb','value',1);
  getvar_actt=get(getvar_acth, 'tag'); % tag of the pressed get variance rb
  h=findobj(myfig, 'tag','agv_uic_enedit');
  expstr=get(h,'string');

  % get rid of similar values, if any:
  exp_NUM=str2num(expstr);
  [sorted, sortix]=sort(exp_NUM);
  exp_NUM(sortix(find(~diff(sorted))))=[];
  expstr=num2str(exp_NUM);

  inpval=guidtard(Me, 'DATA_Fdat'); Fdat=inpval;
  
  avr_acth=findobj(myfig, 'userdata','agv_uic_avrb','value',1);
  avr_actt=get(avr_acth, 'tag'); % tag of the select ampl r
  if any(findstr(avr_actt,'(4)')) %Power spectral analysis
    %windowing
    windowh=findobj(myfig, 'tag','agv_uic_windowpop');
    window=popupstr(windowh);
    Fdat=frf_power(Fdat,window);
  end
  
  if isa(inpval,'iddat')
    fvl=length(Fdat.freqpoints);
  else
    fvl=length(Fdat.places);
  end

  scalefac=str2num(get(findobj(allchild(myfig),'flat',...
    'tag','agv_uic_muledit'),'string'));

  if any(findstr(avr_actt,'(2)'))|any(findstr(avr_actt,'(4)')) % syncron'd data
    synch='synchronized';
  elseif any(findstr(avr_actt,'(3)')) % nonsync'd data
    synch=inpval.synchronization;
    if isempty(synch)&isempty(inpval.reference)
      synch='delayed';
    end
  elseif any(findstr(getvar_actt,'(5)')) % Experiment #i & Variance analysis
    Fdat=eval(['Fdat{:,[',expstr,']}']);
    if length(str2num(expstr))<2 % only one experiment selected
      msg='Cannot perform Variance Analysis. More than one experiments required.';
      agv('status', ['Warning: ' msg])
      return
    end
  end
  pbstate=get(findobj(myfig, 'tag','agv_uic_avrb(1)'),'value');

  %vartoset=1; %variance is still to be set
  if any(findstr(getvar_actt,'(1)')) % Constant
    hvx=findobj(myfig, 'tag', 'agv_uic_vxedit');
    hvy=findobj(myfig, 'tag', 'agv_uic_vyedit');
    vx=str2num(get(hvx,'string'));
    vy=str2num(get(hvy,'string'));

    %data.inf='Variance values set to constant';
    data=[vy*ones(fvl,1),vx*ones(fvl,1)];
    varstruct.var=data; varstruct.M=[];
    guidtawr(Me, 'VARIANCE_DATA', 'direct', varstruct)
    %vartoset=0;

  elseif any(findstr(getvar_actt,'(3)')) % Import
    var=guidtard(Me,'VARIANCE_DATA');
    var.var=var.var*scalefac;
    guidtawr(Me,'VARIANCE_DATA','direct',var);
    %vartoset=0;

  elseif any(findstr(getvar_actt,'(4)')) % Previous output of VA
    outval=guidtard('fdtool_main', 'OUTPUT_average');
    if guiinfos('islinear')
      var=outval.SiSoVariance; M=outval.M;
    else
      var=sisononlinerror(outval);
      M=outval.nonlinM;
    end
    if isnumeric(var), var=var*scalefac;
    else
      for ii=1:prod(size(var))
        var{ii}=var{ii}*scalefac;
      end
    end
    varstruct.var=var; varstruct.M=M;
    guidtawr(Me, 'VARIANCE_DATA', 'direct', varstruct)
    %vartoset=0;

  elseif any(findstr(getvar_actt,'(2)')) % accept variance given in data
    %data.inf='Given variance values held.';
    if guiinfos('islinear')
      var=inpval.SiSoVariance; M=inpval.M;
      %vartoset=0;
    else
      if israndomized(inpval)
        var=sisononlinerror(inpval);
        M=inpval.nonlinM;
        %vartoset=1;
      else
        var=sisononlinerror(inpval);
        M=inpval.nonlinM;
        %vartoset=0;
      end
    end
    if iscell(var)
      for ii=1:length(var), var{ii}=var{ii}*scalefac; end
    else var=var*scalefac;
    end
    if (isempty(var)|(iscell(var)&isempty(var{1})))&guiinfos('islinear')
      var=[coh2var(inpval.cohvect,inpval.output)*scalefac,...
        zeros(size(inpval.input))];
      M=[];
      agv('status','Warning: Coherence values taken from data')
    end
    varstruct.var=var; varstruct.M=M;
    guidtawr(Me, 'VARIANCE_DATA', 'direct', varstruct)

  elseif ~any(findstr(getvar_actt,'(5)')) % even not last possibility: variance analysis
    guifreez(Me, 'unfreeze', 'agv_evalpb');
    error('AGV: Get variances RBgrop handling error.')
  end

  if any(findstr(avr_actt,'(2)'))|any(findstr(avr_actt,'(3)'))|any(findstr(avr_actt,'(4)'))|...
      any(findstr(getvar_actt,'(5)')) %average sychronized/unsynchronized data, varanal
    if any(findstr(getvar_actt,'(5)')), runmod='';
    else runmod='novariance';
    end
    if guiinfos('islinear')
      if ~strncmp(synch,'synch',5)&~strncmp(synch,'delayed',5)
        fvdat=nonlinvar(Fdat);
        fvdat=nonlinvar2var(fvdat); %simulate linear processing
      else
        %if ~isempty(synch); hsynchfig=figure; end
        fvdat=varanal(Fdat,synch,[],runmod);
        if ~isempty(synch)
          %pause(1), delete(hsynchfig);
        end
      end
      if any(fvdat.M<4)
        agv('status',sprintf(['Warning: only %.0f experiments could be averaged. ',...
          'Synchronization unsuccessful?'],fvdat.M))
      end
      infotext('agv','Expno',[],'M',fvdat.M)
    else %nonlinear
      if israndomized(inpval)|strcmp(get(inpval,'synchron'),'on')
        if get(inpval,'expnumber')>1
          fvdat=varanal(inpval,synch,[],'noreduce');
        else
          fvdat=inpval;
        end
        fvdat=interpvar(fvdat);
        infotext('agv','M',fvdat.M)
      else
        if ~strcmp(get(inpval,'synchron'),'samepower')
          agv('status',['Error: obj.synchronization is ''',get(inpval,'synchron'),''', and not ''samepower'''])
          error(['obj.synchronization is ''',get(inpval,'synchron'),''', and not ''samepower'''])
        end
        fvdat=nonlinvar(Fdat);
        infotext('agv','Meq',fvdat.M)
      end
    end
    if any(findstr(avr_actt,'(2)'))|any(findstr(avr_actt,'(3)'))|any(findstr(avr_actt,'(4)'))
      fv_data=fvdat; %if variance from varanal, data ready
      expnodone=1;
    else
      expnodone=0;
    end
  else
    fv_data=Fdat;
    expnodone=0;
  end
  if expnodone==0
    h=findobj(myfig, 'tag','agv_uic_enedit');
    expstr=get(h,'string');
    if strcmp(expstr,':')
      fv_data=Fdat;
    else
      eval(['fv_data=Fdat{:,[',expstr,']};'])
    end
  end

  if ~any(findstr(getvar_actt,'(5)')) % not Variance analysis
    if isa(Fdat,'fiddata')
      fv=Fdat.inputfreqpoints;
      x=Fdat.input;
      y=Fdat.output;
      if iscell(fv)
        fv=cat(1,fv{:}); x=cat(1,x{:}); y=cat(1,y{:});
      end
      fvl=length(fv);
    end
    vdatst=guidtard(Me,'VARIANCE_DATA');
    vdat=vdatst.var; M=vdatst.M;
    %      vx=impvar(vdat);
    vx=vdat(:,2);
    if (size(vx,1)~=fvl) & (size(vx,1) ~=1)
      agv('status', ...
        sprintf('Error: F=%.0f ~= length(vx)=%.0f',fvl,length(vx)))
      return
    end
    h=findobj(myfig, 'tag','agv_uic_enedit');
    expstr=get(h,'string');
    if strcmp(expstr,':')
    else
      if (fv_data.expn<Fdat.expn)&iscell(vdat)&...
          (size(vdat,2)==Fdat.expn)
        if iscell(vdat)
          eval(['vdat=vdat(:,[',expstr,']);'])
        end
        %error('Not yet ready')
      end
    end
    covvect=[];
    if ~iscell(vdat)
      varx=vdat(:,2); vary=vdat(:,1);
      if (isnumeric(vdat)&(size(vdat,2)==3)) |...
          (iscell(vdat)&(size(vdat{1},2)==3))
        covvect=vdat(:,3);
      end
    else
      varx=cell(size(vdat)); vary=varx;
      for ii=1:length(vdat(:))
        varx{ii}=vdat{ii}(:,2); vary{ii}=vdat{ii}(:,1);
        if size(vdat{ii},2)==3
          if isempty(covvect), covvect=cell(size(vdat)); end
          covvect{ii}=vdat{ii}(:,3);
        end
      end
      if length(varx)==1
        varx=varx{1}; vary=vary{1};
        if (isnumeric(vdat)&(size(vdat,2)==3)) |...
            (iscell(vdat)&(size(vdat{1},2)==3))
          covvect=covvect{1};
        end
      end
    end
    if guiinfos('islinear')
      set(fv_data,'covvect',covvect,'inputvariance',varx,'outputvariance',vary,'M',M)
    else
      set(fv_data,'nonlincovvect',covvect,'InputNonlinError',varx,'OutputNonlinError',...
        vary,'NonlinM',M,'covariancematrix',[],'M',[])
    end
  end

  guidtawr(Me,'FV_DATA','direct',fv_data)
  guidtawr(Me,'FINAL_DATA','direct',fv_data)

  % plot no
  agv('update_plot',Me)
  guifreez(Me, 'unfreeze', 'agv_evalpb');
  SetVarOnOff(myfig)
  agv('enable_select')

  %%%%%%%%%%% OTHER COMMANDS

elseif strcmp(p1,'destroyed')
  % close all children
  guiclose('average')
  fdtool('finished_box', 'rect_average', 'cancel', Me);

elseif strcmp(p1,'update_plot')
  agv('status', 'Updating plot')
  guifreez(Me, 'freeze', 'agv_update_plot');
  arrplot('agv_update');
  guifreez(Me, 'unfreeze', 'agv_update_plot');
  SetVarOnOff(myfig)

elseif strcmp(p1, 'suggest') | strcmp(p1, 'agv_uic_suggestpb')| strcmp(p1, 'suggestGetVariances')
  if any(findstr(p1, 'GetVariances'))
    SuggestFit=0;  % do not change Data to Fit rb's
  else
    SuggestFit=1;
  end
  linear=guiinfos('islinear');
  agv('status', 'Suggestion in progress...')
  c=allchild(myfig);

  havsynch=findobj(c, 'flat', 'tag', 'agv_uic_avrb(2)'); % average synch
  h2=findobj(c, 'flat', 'tag', 'agv_uic_avrb(3)'); % average nonsynch
  hvaran=findobj(c, 'flat', 'tag', 'agv_uic_getrb(5)'); % perform varanal
  h4=findobj(c, 'flat', 'tag', 'agv_uic_enedit'); % experiment #
  h5=findobj(c, 'flat', 'tag', 'agv_uic_avrb(1)'); % select experiment #
  hconst=findobj(c, 'flat', 'tag', 'agv_uic_getrb(1)'); % set to constant
  htake=findall(c, 'flat', 'tag', 'agv_uic_getrb(2)'); %Take from data
  htxt= findall(c, 'flat', 'tag', 'agv_uic_gettext');
  ptxt=get(htxt,'position');

  inpval=guidtard(Me, 'DATA_Fdat'); expno=get(inpval,'expnumber');
  if ~linear
    ptxt(3)=134; ptxt(1)=83;
    set(htxt,'string','Get nonlinear errors','position',ptxt)
    if expno>1, set(havsynch,'enable','off'), end
  else %linear
    ptxt(3)=78; ptxt(1)=111;
    set(htxt,'string','Get variances','position',ptxt)
    set(havsynch,'enable','on')
  end

  if isa(inpval,'iddat')
    freqvect=inpval.freqpoints;
    falleq=1;
    if iscell(freqvect)
      f1=freqvect{1};
      for ii=2:size(freqvect,2)
        if ~isequal(f1,freqvect{ii}), falleq=0; break, end
      end
    end
    if (falleq==1)|(inpval.expn==1), estr='1';
    else estr=sprintf('1:%.0f',inpval.expn);
    end
    x=inpval.input;
    y=inpval.output;
    expno=inpval.expn;
    if linear, vdat=inpval.SiSoVariance;
    else
      vdat=sisononlinerror(inpval);
    end
    F=inpval.freqn;
    cohdat=inpval.coherence;
  end
  oldvar_val=CheckPreviousRB(Me); % output's variance if can be used here
  h=findobj(c, 'flat', 'tag', 'agv_uic_getrb(4)'); %previous val
  if isempty(oldvar_val) % % previous val doesn't exist
    set(h, 'enable', 'off');
  else
    set(h, 'enable', 'on');
  end
  if SuggestFit
    if (expno==1)|(falleq==0)
      % grey pb's
      rbtag('agv_uic_avrb(1)');
      set([havsynch h2 hvaran],'enable', 'off')
      set(h4, 'visible', 'on','enable','on','string','1')
    else
      set([havsynch h2 hvaran],'enable', 'on')
      set(h4, 'visible', 'off')
      if (strcmp(inpval.synchroniz,'yes')|strcmp(inpval.synchroniz,'on'))
        rbtag('agv_uic_avrb(2)');
      else %nonlinear or not synch
        rbtag('agv_uic_avrb(3)');
        if ~linear, set([havsynch],'enable','off'), end
      end
    end
    if linear
      set(hconst,'enable','on') %set to constant
    else
      set(hconst,'enable','off') %set to constant
    end
  end
  getvset=0;
  if ~linear&israndomized(inpval)
    set(hvaran,'String','Interp. NL Var. Anal.','tooltipstring','Nonlinearity level analysis and variance analysis across experiments')
  else
    set(hvaran,'String','Perform Var. Anal.','tooltipstring','Variance analysis across experiments')
  end
  if (linear&isempty(vdat)&isempty(cohdat))|...
      (~linear&isempty(inpval.OutputNonlinError))
    set(htake,'enable', 'off')
  else
    set(htake,'enable', 'on')
    getvset=1; %get interpolated nonlinear errors
    rbtag('agv_uic_getrb(5)'); %variance analysis pb
  end
  if ~get(h5, 'value')|((length(str2num(get(h4, 'string'))) >= 2)&(falleq==1))
    % suggest select exp if the number of experiments is at least ^^^ 2
    rbtag('agv_uic_getrb(5)'); %select exp pb
  elseif ~isempty(vdat) %variance given
    rbtag('agv_uic_getrb(2)'); %from data pb
  elseif linear&~isempty(cohdat)
    rbtag('agv_uic_getrb(2)'); %from data pb
    agv('status','Warning: No variance, only coherence is given')
  elseif ~isempty(oldvar_val)
    rbtag('agv_uic_getrb(4)'); %previous pb
  elseif linear %variance constant
    rbtag('agv_uic_getrb(1)'); %constant pb
  elseif getvset
  else
    if linear
      agv('status','Error: cannot reasonably set "Get variances" option')
      error('agv cannot reasonably set "Get variances" option')
    else
      agv('status','Error: cannot reasonably set "Get nonlinear errors" option')
      %error('agv cannot reasonably set "Get nonlinear errors" option')
      %agv('disable_exec')
    end
  end
  %%%% update info text
  % expno=expno;
  agv('info_update')
  agv('disable_select')
  SetEditObjs(myfig)
  %
  inpval=guidtard(Me, 'DATA_Fdat');
  hpm=findobj(myfig,'tag', 'agv_uic_frffxfypop');
  if ~guiinfos('islinear')&~strcmp(get(inpval,'synchronization'),'samepower')&...
      strcmp(popupstr(hpm),'frf')
    set(hpm,'value',2)
  end
  %
  agv('status', 'Suggestion finished, settings modified.')

elseif strcmp(p1, 'info_update')
  inpval=guidtard(Me, 'DATA_Fdat');
  Fstr='F';
  if isa(inpval,'iddat')
    freqvect=inpval.inputfreqpoints;
    if iscell(freqvect), freqvect=cat(1,freqvect{:}); Fstr='allF';
    end
    expno=inpval.expn; M=inpval.M;
  end
  F=length(freqvect);
  fmax=max(freqvect);
  fmin=min(freqvect);
  dfi=dfcalc(freqvect);

  if dfi>0, fmdfi=fmax/dfi; else fmdfi=NaN; end
  infotext('agv','Expno', expno, ...
    'dfi', dfi, Fstr, F, 'fmin', fmin, 'fmax', fmax, 'fmax/dfi', fmdfi,'M',M)

elseif strcmp(p1,'status')
  c=allchild(myfig);
  h_txt=findobj(c,'flat','Tag',[Me '_status']);
  h_frm=findobj(c,'flat','Tag',[Me '_statusframe']);
  glstatus(myfig, h_txt, h_frm, p2)

elseif strcmp(p1,'freqsel_ready')
  switch p2
    case 'done'
      result=p3;
      guidtawr(Me, ['FINAL_DATA'], 'direct', result);
      agv('update_plot')
    case 'cancel'
  end
  figure(myfig)

elseif strcmp(p1,'ui_edit') % check and correct input value
  h=findobj(myfig,'tag',sender);
  edit_str=get(h,'string');
  edit_num=str2num(edit_str);
  old_edit_num=edit_num;
  if isempty(edit_num) | ~isa(edit_num, 'double')
    edit_num=0; old_edit_num=inf;
  end
  switch sender
    case 'agv_uic_enedit'
      IDtext='Experiment number';
      inpval=guidtard(Me, 'DATA_Fdat');
      if isa(inpval,'iddat')
        freqvect=inpval.inputfreqpoints;
        x=inpval.input;
        y=inpval.output;
        expno=inpval.expn;
      else
        [freqvect, x,y,expno]=impfou(inpval);
      end
      edit_num=floor(edit_num);
      if isempty(edit_num)
        edit_num=1;
      elseif any(edit_num <1)
        edit_num =1;
      elseif any(edit_num > expno)
        edit_num=expno;
      end
    case {'agv_uic_vxedit', 'agv_uic_vyedit'}
      IDtext=[sender(9:10) ' variance value'];
      edit_num=edit_num(1);
      if edit_num <0
        edit_num=0;
      elseif ~isfinite(edit_num)
        edit_num=realmax;
      end
    case 'agv_uic_muledit'
      IDtext='Scaling factor';
      edit_num=edit_num(1);
      if edit_num <0
        edit_num=abs(edit_num);
      elseif ~isfinite(edit_num)
        edit_num=realmax;
      elseif edit_num==0
        edit_num=1;
      end
  end
  if length(edit_num)~=length(old_edit_num) |...
      any(edit_num ~= old_edit_num)
    edit_str=sprintf(' %.3g',edit_num);
    set(h,'string',edit_str);
    agv('status', ['Warning: ' IDtext ' automatically corrected. Please check again.'])
  else
    agv('status', [IDtext ' set to ' get(h, 'string')])
  end
  agv('disable_select')


elseif strcmp(p1,'disable_select')
  h(1)=findobj(myfig, 'Tag', 'agv_uic_freqpb');
  set(h,'enable','off');
  h=findobj(myfig, 'Tag', 'agv_uic_evalpb');
  set(h,'enable','on');
  is_old_empty=isempty(guidtard(Me, 'FINAL_DATA'));
  % delete old computed data
  guidtawr(Me, 'FV_DATA', 'direct', '')
  guidtawr(Me, 'FINAL_DATA', 'direct', '')
  data=guidtard(Me,'DATA_Fdat');
  infotext('agv','M',data.M,'Expno',data.Expn)
  if ~is_old_empty % plot input data if old plot contains variance
    agv('update_plot')
  end
  % disable done
  h(1)=findobj(myfig, 'Tag', 'agv_uic_donepb');
  h(2)=findobj(myfig, 'Tag', 'average_menu_file_close');
  set(h,'enable','off');

elseif strcmp(p1,'enable_select')
  h(1)=findobj(myfig, 'Tag', 'agv_uic_freqpb');
  set(h,'enable','on');
  h=findobj(myfig, 'Tag', 'agv_uic_evalpb');
  set(h,'enable','off');

  % enable done
  h(1)=findobj(myfig, 'Tag', 'agv_uic_donepb');
  h(2)=findobj(myfig, 'Tag', 'average_menu_file_close');
  set(h,'enable','on');

elseif strcmp(p1,'disable_exec')
  h=findobj(myfig, 'Tag', 'agv_uic_evalpb');
  set(h,'enable','off');

elseif strcmp(p1,'click_on_axes')
  % dummy, just for help, no action here

elseif strcmp(p1, 'info_print')
  % p2: tag, p3: string
  h=findobj(get(myfig, 'children'), 'flat', 'tag', p2);
  set(h, 'string', p3);

elseif any(findstr(p1, 'click_on_axes'))
  arrplot('agv_update_extra')

elseif strcmp(p1,'agv_uic_print')
  %agv print command
  fdgprint(Me)
  agv('status','Print figure done.')

elseif strcmp(p1,'agv_mod_print_ps')
  %agv print command
  fdgprint(Me,'ps')

elseif strcmp(p1, 'preload')
  % preload, nothing to do

elseif strcmp(p1, 'setplottype')
  hpm=findobj(myfig,'tag', 'agv_uic_frffxfypop');
  if guiinfos('islinear')
    set(hpm,'string',{'frf','mag-phase','output-input'})
  else
    if israndomized(guidtard(Me,'DATA_Fdat'))
      set(hpm,'string',{'frf','output only','output-input'})
    else
      set(hpm,'string',{'frf','output only','output-input'})
      if isequal(get(hpm,'value'),3), set(hpm,'value',2), end
    end
  end

elseif strcmp(p1,'resize')
  % The resize function is responsible to keep the logical
  % coherence of the figure when resizing. The size and
  % position of graphical objects are maintained in pixels
  % in order to give a constant appearance for the controls.
  % To keep the alignment, the new positions has to be
  % recalculated. Usually there are some outstanding objects
  % to which the others are aligned.

  axdiffy=45; %this is the distance bw the two axeses
  mindx=638;  %the minimum size of the window. It should
  mindy=425;  %be the same as that specified in the
  %corresponding def file (agvdef.m).
  scr=get(0,'screensize');
  mainfigmaxx=scr(3);
  mainfigmaxy=scr(4);

  % The code below would not allow the window to be resize to smaller than its original
  % minimal size.

  pos=get(findobj(myfig, 'tag','average_main'),'position');
  fig_offsx=pos(1);
  fig_offsy=pos(2);
  fig_dx=pos(3);
  fig_dy=pos(4);
  if fig_dx < mindx
    fig_dx=mindx;
  end;
  if fig_dy < mindy
    fig_dy=mindy;
  end;
  %      if fig_offsx+fig_dx > mainfigmaxx
  %         fig_offsx=10;
  %      end;

  % If the window is out of screen, this drags into the screen.

  if fig_offsy+fig_dy > mainfigmaxy
    intoscr({'average_main'});
    %fig_offsy=20;
  end;
  set(myfig,'position',[fig_offsx fig_offsy fig_dx fig_dy]);

  % These predefined constants stating the difference of some controls from the frames.

  fromframe_dx=60;
  fromevalpb_dy=60;

  % After resizing, the position of the averageframe is queried. This will serve as
  % a cornerstone to which all the contained elements are repositioned. The logical order is
  % the same as it was defined in the respective definition file.

  pos=get(findobj(myfig, 'tag','agv_uic_averageframe'),'position');
  frame_offsx=pos(1);
  frame_dx=pos(3);

  % Based on the actual position, a vertical offset is calculated for the elements
  % that are positioned relative to the averageframe.
  % This offset is used later on in positioning such controls.
  % This repositioning fixes the vertical dimensions of the frame,
  % it simply slides the frame and all its contents upwards.

  gr_offsy=fig_dy-20-(pos(2)+pos(4));

  % First, the frame itself is repositioned vertically.
  % In the case of controls below the only change is that the controls should be
  % slided upwards with the offset. (The frame is the lefthand side
  % frame of the window, logically it should remain there.
  % Thus, the x coordinates will not change. Since the original appearance is to
  % be preserved, the only change will occur in the y offset of the controls.

  set(findobj(myfig, 'tag','agv_uic_averageframe'),'position',[pos(1) pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','agv_uic_averagetext'),'position');
  set(findobj(myfig, 'tag','agv_uic_averagetext'),'position',[pos(1) pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','agv_uic_avrb(1)'),'position');
  set(findobj(myfig, 'tag','agv_uic_avrb(1)'),'position',[pos(1) pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','agv_uic_enedit'),'position');
  set(findobj(myfig, 'tag','agv_uic_enedit'),'position',[pos(1) pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','agv_uic_avrb(2)'),'position');
  set(findobj(myfig, 'tag','agv_uic_avrb(2)'),'position',[pos(1) pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','agv_uic_avrb(3)'),'position');
  set(findobj(myfig, 'tag','agv_uic_avrb(3)'),'position',[pos(1) pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','agv_uic_avrb(4)'),'position');
  set(findobj(myfig, 'tag','agv_uic_avrb(4)'),'position',[pos(1) pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','agv_uic_windowpop'),'position');
  set(findobj(myfig, 'tag','agv_uic_windowpop'),'position',[pos(1) pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','agv_uic_windowtext'),'position');
  set(findobj(myfig, 'tag','agv_uic_windowtext'),'position',[pos(1) pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','agv_uic_getvframe'),'position');
  set(findobj(myfig, 'tag','agv_uic_getvframe'),'position',[pos(1) pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','agv_uic_gettext'),'position');
  set(findobj(myfig, 'tag','agv_uic_gettext'),'position',[pos(1) pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','agv_uic_getrb(1)'),'position');
  set(findobj(myfig, 'tag','agv_uic_getrb(1)'),'position',[pos(1) pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','agv_uic_vxtext'),'position');
  set(findobj(myfig, 'tag','agv_uic_vxtext'),'position',[pos(1) pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','agv_uic_vxedit'),'position');
  set(findobj(myfig, 'tag','agv_uic_vxedit'),'position',[pos(1) pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','agv_uic_vytext'),'position');
  set(findobj(myfig, 'tag','agv_uic_vytext'),'position',[pos(1) pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','agv_uic_vyedit'),'position');
  set(findobj(myfig, 'tag','agv_uic_vyedit'),'position',[pos(1) pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','agv_uic_getrb(2)'),'position');
  set(findobj(myfig, 'tag','agv_uic_getrb(2)'),'position',[pos(1) pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','agv_uic_getrb(3)'),'position');
  set(findobj(myfig, 'tag','agv_uic_getrb(3)'),'position',[pos(1) pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','agv_uic_getrb(4)'),'position');
  set(findobj(myfig, 'tag','agv_uic_getrb(4)'),'position',[pos(1) pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','agv_uic_getrb(5)'),'position');
  set(findobj(myfig, 'tag','agv_uic_getrb(5)'),'position',[pos(1) pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','agv_uic_alltext'),'position');
  set(findobj(myfig, 'tag','agv_uic_alltext'),'position',[pos(1) pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','agv_uic_multext'),'position');
  set(findobj(myfig, 'tag','agv_uic_multext'),'position',[pos(1) pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','agv_uic_muledit'),'position');
  set(findobj(myfig, 'tag','agv_uic_muledit'),'position',[pos(1) pos(2)+gr_offsy pos(3) pos(4)]);


  % The statusframe's width is the same as that of the window. After resize, it has to be adjusted.

  pos=get(findobj(myfig, 'tag',[Me '_statusframe']),'position');
  set(findobj(myfig, 'tag',[Me '_statusframe']),'position',[pos(1) pos(2) fig_dx pos(4)]);
  pos=get(findobj(myfig, 'tag',[Me '_status']),'position');
  set(findobj(myfig, 'tag',[Me '_status']),'position',[pos(1) pos(2) fig_dx-6 pos(4)]);


  % The control buttons are logically organized as in the definition file: the donepb
  % should go to bottom right with 20 pixel margin.
  % The rest of the buttons would follow the same layout as originally (one above other)...

  pos=get(findobj(myfig, 'tag','agv_uic_donepb'),'position');
  set(findobj(myfig, 'tag','agv_uic_donepb'),'position',[fig_dx-pos(3)-20 pos(2) pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','agv_uic_cancelpb'),'position');
  set(findobj(myfig, 'tag','agv_uic_cancelpb'),'position',[fig_dx-pos(3)-20 pos(2) pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','agv_uic_freqpb'),'position');
  set(findobj(myfig, 'tag','agv_uic_freqpb'),'position',[fig_dx-pos(3)-20 pos(2) pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','agv_uic_evalpb'),'position');
  set(findobj(myfig, 'tag','agv_uic_evalpb'),'position',[fig_dx-pos(3)-20 pos(2) pos(3) pos(4)]);


  % The axes and the related controls need a little bit more elaboration.
  % The lower axes is positioned relative to the averageframe. Horizontally it is
  % a certain distance from the frame.

  pos=get(findobj(myfig, 'tag','agv_uic_averageframe'),'position');
  axl_offsx=pos(1)+pos(3)+fromframe_dx;

  % The width is defined to use all the available space. Leave off 40 pixels.

  axl_dx=fig_dx-axl_offsx-40;
  pos=get(findobj(myfig, 'tag','agv_uic_dataframe'),'position');

  % The lower axes is vertically aligned with the dataframe.

  axl_offsy=pos(2)+pos(4);
  val=get(findobj(myfig, 'tag','agv_uic_frffxfypop'),'value');
  string=get(findobj(myfig, 'tag','agv_uic_frffxfypop'),'string');

  % The above control relates to the axes. If frf is the value string,
  % there is only one axes. It uses all teh available space, except from some margin.

  if any(findstr(string{val},'frf'))|any(findstr(string{val},'output only'))
    axl_dy=fig_dy-axl_offsy-20;

    % Else there are two axes, an upper axes is also present. In this case the available
    % vertical space has to be split equally between the two axes.

  else
    axl_dy=(fig_dy-axl_offsy-20-axdiffy)/2;
  end;


  set(findobj(myfig, 'tag','agv_axes_laxes'),'position',[ axl_offsx axl_offsy axl_dx axl_dy]);
  set(findobj(myfig, 'tag','agv_axes_uaxes'),'position',[ axl_offsx axl_offsy+axl_dy+axdiffy axl_dx axl_dy]);

  % The associated controls are aligned with the axes.

  pos=get(findobj(myfig, 'tag','agv_uic_frffxfypop'),'position');
  set(findobj(myfig, 'tag','agv_uic_frffxfypop'),'position',[ axl_offsx pos(2) pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','agv_uic_frffxfypop'),'position');

  % Some control buttons has to be realigned.

  pos1=get(findobj(myfig, 'tag','agv_uic_suggestpb'),'position');
  pos2=get(findobj(myfig, 'tag','agv_uic_donepb'),'position');
  set(findobj(myfig, 'tag','agv_uic_suggestpb'),'position',[ pos(1) pos2(2) pos1(3) pos1(4)]);

elseif strcmp(p1, 'test')
  HistStr(myfig)
else
  if guiinfos('isdevelopment')
    error(['Error: unknown AGV command:' p1])
  end
end
%%%%%%%%%%%%%%%%%%%%%% end of function agv %%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function SetEditObjs(myfig)
% set Constant vx vy and Scaling factors objects' enable property on/off
% depending on the current Get Variances settings
c=allchild(myfig);
h_rb=findobj(c, 'flat', 'UserData', 'agv_uic_getrb');
active_rb=findobj(h_rb, 'value', 1);
pos_active_rb=get(active_rb,'position');
switch get(active_rb, 'tag')
  case {'agv_uic_getrb(1)'}
    const_en='on';
    scale_en='off';
  case {'agv_uic_getrb(2)', 'agv_uic_getrb(3)', 'agv_uic_getrb(4)'}
    const_en='off';
    scale_en='on';
  case {'agv_uic_getrb(5)'}
    const_en='off';
    scale_en='off';
  otherwise
end
h_const=findobj(c, 'flat', 'UserData','CONSTANT_VARIANCE');
h_scale=findobj(c, 'flat', 'UserData','SCALING FACTOR');
set(h_const, 'visible', const_en,'enable',const_en)
set(h_scale, 'visible', scale_en,'enable',scale_en)
if strcmp(scale_en,'on') %scale factor active
end

function out=CheckPreviousRB(Me)
% return output's variance if corresponds to that of the current input data
inputval=guidtard(Me, 'DATA_Fdat');
old_out=guidtard('fdtool_main', 'OUTPUT_average');
out=CheckIfVarOK(inputval, old_out);

function out=CheckFromDataRB(Me)
% return input's variance exists
inputval=guidtard(Me, 'DATA_Fdat');
out=CheckIfVarOK(inputval, inputval);
if ~isempty(inputval.coherence), out=1; end

function out=CheckImported(Me, imported)
% return inported var's variance if corresponds to that of the current input data
inputval=guidtard(Me, 'DATA_Fdat');
out=CheckIfVarOK(inputval, imported);

function out=CheckIfVarOK(inputval, newval)
% check if newval's variance corresponds to inputval
if isa(inputval,'iddat')
  freqvect=inputval.freqpoints;
end
F=length(freqvect);
if isempty(newval)
  out=[]; return
end
if ~guiinfos('islinear')
  new_var=sisononlinerror(newval);
else
  new_var=newval.SiSoVariance;
end
if any(size(new_var,1)==[1,F])
  out=new_var;
else
  if guiinfos('islinear'), new_coh=newval.coherence; else new_coh=[]; end
  if any(size(new_coh,1)==[1,F])
    out=new_coherence;
  else
    out=[];
  end
end

function out=HistStr(myfig)
% generate history string
c=allchild(myfig);
h1=findobj(c, 'flat', 'userdata', 'agv_uic_avrb', 'value', 1);
t1=get(h1, 'tag');
h2=findobj(c, 'flat', 'userdata', 'agv_uic_getrb', 'value', 1);
t2=get(h2, 'tag');
text1=get(h1, 'string');
text2=get(h2, 'string');
if any(findstr(t1, '(1)')) % expno
  hexpno=findobj(c, 'flat', 'tag', 'agv_uic_enedit');
  text1=[text1, get(hexpno, 'string')];
end
if any(findstr(t2, '(1)')) % constant
  hvx=findobj(c, 'flat', 'tag', 'agv_uic_vxedit');
  hvy=findobj(c, 'flat', 'tag', 'agv_uic_vyedit');
  text2=[text2, ' (vx=' get(hvx, 'string') ', vy=' get(hvx, 'string') ')'];
elseif any(findstr(t2, '(3)')) % import
  text2=['Import: ' guidtard('average_main', 'IMPORT_INFO')];
end
if any(findstr(t2(14:16), '(2)|(3)|(4)')) % from data, import, VA output
  hsc=findobj(c, 'flat', 'tag', 'agv_uic_muledit');
  text2=[text2, ' (scaling factor=' get(hsc, 'string') ')'];
end

out=sprintf('Variances calculated by AGV with settings:\n      %s,\n      %s', ...
  text1, text2);



function  SetVarOnOff(myfig)
% set var on/off combo according to current fddata on the plot
Me=get(myfig, 'tag');
fvdata=guidtard(Me,'FINAL_DATA');
inpdata=guidtard(Me,'DATA_Fdat');
if isa(fvdata,'iddat')
  fdata=fvdata;
else
  fdata=inpdata;
end
h=findobj(allchild(myfig), 'flat', 'tag', 'agv_uic_varpop');
if isempty(fdata)
  on=0;
elseif isempty(fdata.SiSoVariance)&isempty(fdata.OutputNonlinError)
  on=0;
else
  on=1;
end
if on
  % set(h, 'enable', 'on', 'value', 1) % var on
  set(h, 'enable', 'on') % var on
else
  %set(h, 'enable', 'off', 'value', 2) % var off
  set(h, 'enable', 'off') % var off
end
%
%End of file agv.m
