function  compinp(p1,p2, p3, p4, p5, seltype)
% COMPINP: compose input for time or frequency domain data
% function of fdidgui

% 'command window' calls: 
%         compinp('init1') time domain
%         compinp('init2') freq domain
% 'gui' calls:
%         compinp('init1|2', caller, id) 
%  when done, compinp calls the caller:
%  caller('compose_ready', 'done|cancel', id, t|fiddata_object)

%       Copyright (c) I. Kollar and Vrije Universiteit Brussel, ELEC, 1997-2002
%       All rights reserved.
%       $Revision: $
%       Written by Gy. Simon
%       Last modified: 22-Dec-2002,IK

if nargin==0
   p1='init1';
end

myfig=[findall(allchild(0), 'flat', 'tag', 'fdtool_compinput_time_main');...
      findall(allchild(0), 'flat', 'tag', 'fdtool_compinput_time2_main');...
      findall(allchild(0), 'flat', 'tag', 'fdtool_compinput_freq_main')];
%myfig=findall(allchild(0), 'flat', 'tag', 'fdtool_compinput');
%
if length(myfig)>1
   delete(myfig(2:end))
   myfig=myfig(1);
end
Me=get(myfig,'tag');
myfcn='compinp';


if nargin == 6
   sender=p5;
elseif (nargin==3)&isstr(p3)&strcmp(p3,'simple')
   seltype=get(myfig,'selectiontype');
   eval(['sender=p', num2str(nargin-1) ';']);
else
   seltype=get(myfig,'selectiontype');
   eval(['sender=p', num2str(nargin) ';']);
end

if findstr(p1,'init')
   if findstr(p1, '2')
      mode=2; % freq 
      Me='fdtool_compinput_freq_main';
      %Me='fdtool_compinput';
      Name='Compose Frequency Domain Data';
   else
      if isempty(p3)
        mode=1; % time
        Me='fdtool_compinput_time_main';
      else
        mode=0; %simplified time
        Me='fdtool_compinput_time2_main';
      end
      %Me='fdtool_compinput';
      Name='Compose Time Domain Data';
   end
   
   delete(myfig)
   
   col=get(0,'defaultuicontrolbackground');
   h0 = figure('Units','pixels', ...
      'Handlevisibility', 'off',...
      'tag',Me, ...
      'Name',Name,...
      'NumberTitle','off', ...
      'color', col, ...
      'integerhandle','off',...
      'Position',[420 301 573 426], ...
      'windowbuttonmotionfcn', 'fdtool(''callback'',''compinp'',''mousemotion'')', ...
      'visible', 'off', ...   
      'CloseRequestFcn', 'fdtool(''callback'',''compinp'', ''ui_fdidgui_compinp_pb_cancel'')');
   ver=version;
   if ~strncmp(ver,'5.2',3), set(h0,'ToolBar','none'), end
    
   myfig=h0;
   %set(myfig, 'visible', 'on')
   h1 = uicontrol('Parent',h0, ...
      'Units','pixels', ...
      'ListboxTop',0, ...
      'Position',[93 260 232 143], ...
      'Style','frame', ...
      'tag','frame1');
   h1 = uicontrol('Parent',h0, ...
      'Units','pixels', ...
      'HorizontalAlignment','center', ...
      'ListboxTop',0, ...
      'Position',[160 392 99 19], ...
      'String','Output', ...
      'Style','text', ...
      'tooltipstring','',...
      'tag','ui_fdidgui_compinp_text_output');
   guititle(h1)
   h1 = uicontrol('Parent',h0, ...
      'Units','pixels', ...
      'ListboxTop',0, ...
      'Position',[334 260 232 143], ...
      'Style','frame', ...
      'tooltipstring','',...
      'tag','frame2');
   h1 = uicontrol('Parent',h0, ...
      'Units','pixels', ...
      'HorizontalAlignment','center', ...
      'ListboxTop',0, ...
      'Position',[403 392 99 19], ...
      'String','Input', ...
      'Style','text', ...
      'tag','ui_fdidgui_compinp_text_input');
   guititle(h1)
   
   
   %data
   h1 = uicontrol('Parent',h0, ...
      'Units','pixels', ...
      'ForegroundColor',[1 0 0], ...
      'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      'Position',[11 365 49 19], ...
      'String','Data', ...
      'Style','text', ...
      'tooltipstring','OutputData',...
      'tag','ui_fdidgui_compinp_text_data');
   h1 = uicontrol('Parent',h0, ...
      'Units','pixels', ...
      'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      'Position',[102 367 157 19], ...
      'String','Data', ...
      'tooltipstring','Set OutputData',...
      'Style','edit', ...
      'tag','ui_fdidgui_compinp_edit_data_out');
   h1 = uicontrol('Parent',h0, ...
      'Units','pixels', ...
      'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      'Position',[102 367 77 19], ...
      'String','Data', ...
      'tooltipstring','Gain vector, data in decibels',...
      'Style','edit', ...
      'visible','off', ...
      'tag','ui_fdidgui_compinp_edit_data_out_gain');
   h1 = uicontrol('Parent',h0, ...
      'Units','pixels', ...
      'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      'Position',[102+77+3 367 77 19], ...
      'String','Data', ...
      'tooltipstring','Phase vector, data in degrees',...
      'Style','edit', ...
      'visible','off', ...
      'tag','ui_fdidgui_compinp_edit_data_out_phase');
   h1 = uicontrol('Parent',h0, ...
      'Units','pixels', ...
      'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      'Position',[342 367 159 19], ...
      'ToolTipString','Set InputData', ...
      'Style','edit', ...
      'tag','ui_fdidgui_compinp_edit_data_inp');
   h1 = uicontrol('Parent',h0, ...
      'Units','pixels', ...
      'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      'Position',[265 368 54 19], ...
      'String','Browse...', ...
      'ToolTipString','Browse files for OutputData', ...
      'tag','fdidgui_compinp_pb_browse_data_out');
   h1 = uicontrol('Parent',h0, ...
      'Units','pixels', ...
      'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      'Position',[504 368 54 18], ...
      'String','Browse...', ...
      'ToolTipString','Browse files for InputData', ...
      'tag','fdidgui_compinp_pb_browse_data_inp');
   
   
   
   %unit
   h1 = uicontrol('Parent',h0, ...
      'Units','pixels', ...
      'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      'Position',[11 340 49 19], ...
      'String','Unit', ...
      'ToolTipString','Amplitude units',...
      'Style','text', ...
      'tag','ui_fdidgui_compinp_text_unit');
   h1 = uicontrol('Parent',h0, ...
      'Units','pixels', ...
      'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      'Position',[102 342 157 19], ...
      'String','Unit', ...
      'Style','edit', ...
      'ToolTipString','Output amplitude units',...
      'tag','ui_fdidgui_compinp_edit_unit_out');
   h1 = uicontrol('Parent',h0, ...
      'Units','pixels', ...
      'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      'Position',[343 342 157 19], ...
      'String','unit', ...
      'ToolTipString','Input amplitude units',...
      'Style','edit', ...
      'tag','ui_fdidgui_compinp_edit_unit_inp');
   
   %character
   hchar = uicontrol('Parent',h0, ...
      'Units','pixels', ...
      'ForegroundColor',[1 0 0], ...
      'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      'Position',[11 315 49 19], ...
      'String','Character', ...
      'ToolTipString','Character of data (ZOH, bandlimited, etc.)',...
      'Style','text', ...
      'tag','ui_fdidgui_compinp_text_character');
   h1 = uicontrol('Parent',h0, ...
      'Units','pixels', ...
      'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      'Position',[102 317 157 19], ...
      'String',{'Choose one...', 'BL', 'Samples', 'Discrete'}, ...
      'Style','popupmenu', ...
      'ToolTipString','Character of OutputData (samples, bandlimited, etc.)',...
      'tag','ui_fdidgui_compinp_edit_character_out', ...
      'Value',1);
   h1 = uicontrol('Parent',h0, ...
      'Units','pixels', ...
      'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      'Position',[343 317 157 19], ...
      'String',{'Choose one...','BL', 'ZOH', 'Samples', 'Discrete'}, ...
      'ToolTipString','Character of InputData (ZOH, bandlimited, etc.)',...
      'Style','popupmenu', ...
      'tag','ui_fdidgui_compinp_edit_character_inp', ...
      'Value',1);
   
   % name
   h1 = uicontrol('Parent',h0, ...
      'Units','pixels', ...
      'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      'Position',[11 290 49 19], ...
      'String','Name', ...
      'ToolTipString','Name of channel', ...
      'Style','text', ...
      'tag','ui_fdidgui_compinp_text_name');
   h1 = uicontrol('Parent',h0, ...
      'Units','pixels', ...
      'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      'Position',[102 292 157 19], ...
      'String','Name', ...
      'Style','edit', ...
      'ToolTipString','Name of OutputChannel', ...
      'tag','ui_fdidgui_compinp_edit_name_out', ...
      'Value',1);
   h1 = uicontrol('Parent',h0, ...
      'Units','pixels', ...
      'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      'Position',[343 292 157 19], ...
      'String','name', ...
      'Style','edit', ...
      'ToolTipString','Name of InputChannel', ...
      'tag','ui_fdidgui_compinp_edit_name_inp', ...
      'Value',1);
   
   
   % Tstart
   if mode<=1
      h1 = uicontrol('Parent',h0, ...
         'Units','pixels', ...
         'HorizontalAlignment','left', ...
         'ListboxTop',0, ...
         'Position',[11 265 49 19], ...
         'String','TStart (s)', ...
         'Style','text', ...
         'ToolTipString','Starting time (seconds)',...
         'tag','ui_fdidgui_compinp_text_tstart');
      h1 = uicontrol('Parent',h0, ...
         'Units','pixels', ...
         'HorizontalAlignment','left', ...
         'ListboxTop',0, ...
         'Position',[102 267 157 19], ...
         'String','Tstart', ...
         'ToolTipString','Starting time for output (seconds)',...
         'Style','edit', ...
         'tag','ui_fdidgui_compinp_edit_tstart_out', ...
         'Value',1);
      h1 = uicontrol('Parent',h0, ...
         'Units','pixels', ...
         'HorizontalAlignment','left', ...
         'ListboxTop',0, ...
         'Position',[343 267 157 19], ...
         'String','tstart', ...
         'Style','edit', ...
         'ToolTipString','Starting time for input (seconds)',...
         'tag','ui_fdidgui_compinp_edit_tstart_inp', ...
         'Value',1);
   else
      h1 = uicontrol('Parent',h0, ...
         'Units','pixels', ...
         'HorizontalAlignment','left', ...
         'ListboxTop',0, ...
         'Position',[11 265 49 19], ...
         'String','Variance', ...
         'Style','text', ...
         'tag','ui_fdidgui_compinp_text_variance');
      h1 = uicontrol('Parent',h0, ...
         'Units','pixels', ...
         'HorizontalAlignment','left', ...
         'ListboxTop',0, ...
         'Position',[102 267 157 19], ...
         'String','Variance', ...
         'ToolTipString','OutputVariance vector',...
         'Style','edit', ...
         'tag','ui_fdidgui_compinp_edit_variance_out', ...
         'Value',1);
      
      h1 = uicontrol('Parent',h0, ...
         'Units','pixels', ...
         'HorizontalAlignment','left', ...
         'ListboxTop',0, ...
         'Position',[343 267 157 19], ...
         'String','variance', ...
         'ToolTipString','InputVariance vector',...
         'Style','edit', ...
         'tag','ui_fdidgui_compinp_edit_variance_inp', ...
         'Value',1);
      h1 = uicontrol('Parent',h0, ...
         'Units','pixels', ...
         'HorizontalAlignment','left', ...
         'ListboxTop',0, ...
         'Position',[265 268 54 19], ...
         'String','Browse...', ...
         'ToolTipString','Browse files for OutputVariance',...
         'tag','fdidgui_compinp_pb_browse_variance_out');
      h1 = uicontrol('Parent',h0, ...
         'Units','pixels', ...
         'HorizontalAlignment','left', ...
         'ListboxTop',0, ...
         'Position',[504 267 54 19], ...
         'String','Browse...', ...
         'ToolTipString','Browse files for InputVariance',...
         'tag','fdidgui_compinp_pb_browse_variance_inp');
   end
   
   % covariances
   if mode==2
      h1 = uicontrol('Parent',h0, ...
         'Units','pixels', ...
         'ListboxTop',0, ...
         'Position',[334 153 232 100], ...
         'Style','frame', ...
         'tag','frame3');
      
      h1 = uicontrol('Parent',h0, ...
         'Units','pixels', ...
         'HorizontalAlignment','left', ...
         'ListboxTop',0, ...
         'Position',[343 230 60 19], ...
         'String','Covariance', ...
         'Style','text', ...
         'tag','ui_fdidgui_compinp_text_covariance');
      h1 = uicontrol('Parent',h0, ...
         'Units','pixels', ...
         'HorizontalAlignment','left', ...
         'ListboxTop',0, ...
         'Position',[343 210 157 19], ...
         'String','covariance', ...
         'Style','edit', ...
         'tag','ui_fdidgui_compinp_edit_covariance', ...
         'Value',1);
      h1 = uicontrol('Parent',h0, ...
         'Units','pixels', ...
         'HorizontalAlignment','left', ...
         'ListboxTop',0, ...
         'Position',[504 211 54 19], ...
         'String','Browse...', ...
         'ToolTipString','Browse files for Covariance',...
         'tag','fdidgui_compinp_pb_browse_covariance');
      h1 = uicontrol('Parent',h0, ...
         'Units','pixels', ...
         'HorizontalAlignment','left', ...
         'ListboxTop',0, ...
         'Position',[343 180 80 19], ...
         'String','Coherence', ...
         'Style','text', ...
         'tag','ui_fdidgui_compinp_text_coherence');
      h1 = uicontrol('Parent',h0, ...
         'Units','pixels', ...
         'HorizontalAlignment','left', ...
         'ListboxTop',0, ...
         'Position',[343 160 157 19], ...
         'String','coherence', ...
         'Style','edit', ...
         'ToolTipString','Coherence vector',...
         'tag','ui_fdidgui_compinp_edit_coherence', ...
         'Value',1);
      h1 = uicontrol('Parent',h0, ...
         'Units','pixels', ...
         'HorizontalAlignment','left', ...
         'ListboxTop',0, ...
         'Position',[504 161 54 19], ...
         'String','Browse...', ...
         'ToolTipString','Browse files for Coherence',...
         'tag','fdidgui_compinp_pb_browse_coherence');
      
   end
   
   
   
   % excitation frequencies
   %'ForegroundColor',[1 0 0], ...
   if mode<=1
     hexcf = uicontrol('Parent',h0, ...
       'Units','pixels', ...
       'ForegroundColor',[0 0.8 0], ...
       'HorizontalAlignment','left', ...
       'ListboxTop',0, ...
       'Position',[11 233 82 19], ...
       'String','Excit. freqs (Hz)', ...
       'ToolTipString',['Excitation frequencies (Hz)',...
       ', maybe given as <indexvector>*df, e.g. as [1:2:11]*df'],...
       'Style','text', ...
       'tag','ui_fdidgui_compinp_text_excitfreq');
     h1 = uicontrol('Parent',h0, ...
       'Units','pixels', ...
       'HorizontalAlignment','left', ...
       'ListboxTop',0, ...
       'Position',[102 235 157 19], ...
       'String','Excit. Freqs', ...
       'Style','edit', ...
       'ToolTipString',['Excitation frequencies (Hz)',...
       ', maybe given as <indexvector>/Tr, e.g. as [1:2:11]/Tr'],...
       'tag','ui_fdidgui_compinp_edit_excitfreq', ...
       'Value',1);
     vshift=0;
     %
     h1 = uicontrol('Parent',h0, ...
       'Units','pixels', ...
       'HorizontalAlignment','left', ...
       'ListboxTop',0, ...
       'Position',[265 235 54 19], ...
       'String','Browse...', ...
       'ToolTipString','Browse files for excitation frequencies',...
       'tag','fdidgui_compinp_pb_browse_excitfreq');

   elseif mode==2
     h1 = uicontrol('Parent',h0, ...
       'Units','pixels', ...
       'ForegroundColor',[1 0 0], ...
       'HorizontalAlignment','left', ...
       'ListboxTop',0, ...
       'Position',[11 233 82 19], ...
       'string','FreqPoints (Hz)', ...
       'ToolTipString','Frequency Points (Hz)',...
       'Style','text', ...
       'tag','ui_fdidgui_compinp_text_freqpoints');
     h1 = uicontrol('Parent',h0, ...
       'Units','pixels', ...
       'HorizontalAlignment','left', ...
       'ListboxTop',0, ...
       'Position',[102 235 157 19], ...
       'string','FreqPoints', ...
       'Style','edit', ...
       'ToolTipString','Frequency Points (Hz)',...
       'tag','ui_fdidgui_compinp_edit_freqpoints', ...
       'Value',1);
     h1 = uicontrol('Parent',h0, ...
       'Units','pixels', ...
       'HorizontalAlignment','left', ...
       'ListboxTop',0, ...
       'Position',[265 235 54 19], ...
       'String','Browse...', ...
       'ToolTipString','Browse files for frequency points',...
       'tag','fdidgui_compinp_pb_browse_freqpoints');
     %
     vshift=25; 
     if guiinfos('islinear'), foregc=[0 0 0]; else foregc=[0 0.8 0]; end
     h11 = uicontrol('Parent',h0, ...
       'Units','pixels', ...
       'ForegroundColor',foregc, ...
       'HorizontalAlignment','left', ...
       'ListboxTop',0, ...
       'Position',[11 233-vshift 82 19], ...
       'String','Excit. freqs (Hz)', ...
       'ToolTipString',['Excitation frequencies (Hz)',...
       ', maybe given as <indexvector>*df, e.g. as [1:2:11]*df'],...
       'Style','text', ...
       'tag','ui_fdidgui_compinp_text_excitfreq');
     h11 = uicontrol('Parent',h0, ...
       'Units','pixels', ...
       'HorizontalAlignment','left', ...
       'ListboxTop',0, ...
       'Position',[102 235-vshift 157 19], ...
       'String','Excit. Freqs', ...
       'Style','edit', ...
       'ToolTipString',['Excitation frequencies (Hz)',...
       ', maybe given as <indexvector>/Tr, e.g. as [1:2:11]/Tr'],...
       'tag','ui_fdidgui_compinp_edit_excitfreq', ...
       'Value',1);
     %
     h11 = uicontrol('Parent',h0, ...
       'Units','pixels', ...
       'HorizontalAlignment','left', ...
       'ListboxTop',0, ...
       'Position',[265 235-vshift 54 19], ...
       'String','Browse...', ...
       'ToolTipString','Browse files for excitation frequencies',...
       'tag','fdidgui_compinp_pb_browse_excitfreq');
   end
  
   % Ts/IO delay
   if mode<=1
      h1 = uicontrol('Parent',h0, ...
         'Units','pixels', ...
         'ForegroundColor',[1 0 0], ...
         'HorizontalAlignment','left', ...
         'ListboxTop',0, ...
         'Position',[11 208 49 19], ...
         'String','Ts (s)', ...
         'ToolTipString','Sampling interval (seconds)',...
         'Style','text', ...
         'tag','ui_fdidgui_compinp_text_ts');
      h1 = uicontrol('Parent',h0, ...
         'Units','pixels', ...
         'HorizontalAlignment','left', ...
         'ListboxTop',0, ...
         'Position',[102 210 157 19], ...
         'String','Ts', ...
         'Style','edit', ...
         'ToolTipString','Sampling interval (seconds)',...
         'tag','ui_fdidgui_compinp_edit_ts', ...
         'Value',1);
   else
      h1 = uicontrol('Parent',h0, ...
         'Units','pixels', ...
         'HorizontalAlignment','left', ...
         'ListboxTop',0, ...
         'Position',[11 208-vshift 60 19], ...
         'String','O/I delay (s)', ...
         'ToolTipString','Output/input delay (seconds)',...
         'Style','text', ...
         'tag','ui_fdidgui_compinp_text_oidelay');
      h1 = uicontrol('Parent',h0, ...
         'Units','pixels', ...
         'HorizontalAlignment','left', ...
         'ListboxTop',0, ...
         'Position',[102 210-vshift 157 19], ...
         'String','delay', ...
         'Style','edit', ...
         'ToolTipString','Set output/input delay (seconds)',...
         'tag','ui_fdidgui_compinp_edit_oidelay', ...
         'Value',1);
   end
   %state
   hstate = uicontrol('Parent',h0, ...
      'Units','pixels', ...
      'ForegroundColor',[1 0 0], ...
      'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      'Position',[11 183-vshift 80 19], ...
      'String','State', ...
      'ToolTipString','State of system during measurement (steady-state or transient)',...
      'Style','text', ...
      'tag','ui_fdidgui_compinp_text_state');
   h1 = uicontrol('Parent',h0, ...
      'Units','pixels', ...
      'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      'Position',[102 185-vshift 157 19], ...
      'String',{'Choose one...', 'steady-state', 'transient'}, ...
      'ToolTipString','State of system during measurement (steady-state or transient)',...
      'Style','popupmenu', ...
      'tag','ui_fdidgui_compinp_edit_state', ...
      'Value',1);
   
   % Synchronization
   h1 = uicontrol('Parent',h0, ...
      'Units','pixels', ...
      'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      'Position',[11 158-vshift 80 19], ...
      'String','Synchronization', ...
      'ToolTipString','Synchronization of different experiments',...
      'Style','text', ...
      'tag','ui_fdidgui_compinp_text_synch');
   h1 = uicontrol('Parent',h0, ...
      'Units','pixels', ...
      'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      'Position',[102 160-vshift 157 19], ...
      'String',{'Choose one...','on', 'off','samepower'}, ...
      'Style','popupmenu', ...
      'ToolTipString','Synchronization of different experiments',...
      'tag','ui_fdidgui_compinp_edit_synch', ...
      'Value',1);

    %Reference
    vpmod=28;
    h1 = uicontrol('Parent',h0, ...
      'Units','pixels', ...
      'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      'Position',[258 156-vpmod 80 19], ...
      'horizontalalignment','right', ...
      'String','RefData', ...
      'ToolTipString','Reference data (noiseless input)',...
      'Style','text', ...
      'tag','ui_fdidgui_compinp_text_ref');
     h1 = uicontrol('Parent',h0, ...
       'Units','pixels', ...
       'HorizontalAlignment','left', ...
       'ListboxTop',0, ...
       'Position',[342 158-vpmod 159 19], ...
       'ToolTipString','Set Reference Data (noiseless input)', ...
       'Style','edit', ...
       'tag','ui_fdidgui_compinp_edit_data_ref');
     h1 = uicontrol('Parent',h0, ...
      'Units','pixels', ...
      'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      'Position',[504 158-vpmod 54 18], ...
      'String','Browse...', ...
      'ToolTipString','Browse files for Reference Data', ...
      'tag','fdidgui_compinp_pb_browse_data_ref');

    if mode<=1
      % period length
      hperlen = uicontrol('Parent',h0, ...
         'Units','pixels', ...
         'ForegroundColor',[0 0.8 0], ...
         'HorizontalAlignment','left', ...
         'ListboxTop',0, ...
         'Position',[11 133 84 19], ...
         'ToolTipString',['Period length of periodic excitation (in seconds)',...
         ', maybe given as samplenumber*Ts'],...
         'String','Period length  (s)', ...
         'Style','text', ...
         'tag','ui_fdidgui_compinp_text_periodlength');
      h1 = uicontrol('Parent',h0, ...
         'Units','pixels', ...
         'HorizontalAlignment','left', ...
         'ListboxTop',0, ...
         'Position',[102 133 157 19], ...
         'String','PeriodLength', ...
         'ToolTipString',['Period length of periodic excitation (in seconds)',...
         ', maybe given as samplenumber*Ts'],...
         'Style','edit', ...
         'tag','ui_fdidgui_compinp_edit_periodlength', ...
         'Value',1);
   end
   
   % date
   h1 = uicontrol('Parent',h0, ...
      'Units','pixels', ...
      'HorizontalAlignment','right', ...
      'ListboxTop',0, ...
      'Position',[237 103 49 19], ...
      'String','Date', ...
      'Style','text', ...
      'ToolTipString','Date of object', ...
      'tag','ui_fdidgui_compinp_text_date');
   h1 = uicontrol('Parent',h0, ...
      'Units','pixels', ...
      'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      'Position',[289 103 161 20], ...
      'String','Date', ...
      'Style','edit', ...
      'ToolTipString','Set date of object', ...
      'tag','ui_fdidgui_compinp_edit_date', ...
      'Value',1);
   
   % notes
   h1 = uicontrol('Parent',h0, ...
      'Units','pixels', ...
      'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      'Position',[11 103 43 19], ...
      'String','Notes', ...
      'ToolTipString','Set notes for object (simple text)', ...
      'Style','text', ...
      'tag','ui_fdidgui_compinp_text_notes');
   h1 = uicontrol('Parent',h0, ...
      'Units','pixels', ...
      'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      'Position',[12 35 439 63], ...
      'min', 0, ...
      'max', 10, ...
      'String','Notes', ...
      'ToolTipString','Set notes for object (simple text)', ...
      'Style','edit', ...
      'tag','ui_fdidgui_compinp_edit_notes');
   
   % pushbuttons
   
   if 0
      %This is a temporary switch between time and frequency domains
      h1 = uicontrol('Parent',h0, ...
         'Units','pixels', ...
         'ListboxTop',0, ...
         'Position',[477 126 73 22], ...
         'String','Switch', ...
         'tooltipstring','Temporary switch between the input windows of the two domains',...
         'tag','ui_fdidgui_compinp_pb_switch');
   end
   
   h1 = uicontrol('Parent',h0, ...
      'Units','pixels', ...
      'ListboxTop',0, ...
      'Position',[467 102 93 22], ...
      'String','Compose', ...
      'ToolTipString','Check settings of window and compose object', ...
      'tag','ui_fdidgui_compinp_pb_compose');
   h1 = uicontrol('Parent',h0, ...
      'Units','pixels', ...
      'ListboxTop',0, ...
      'Position',[467 78 93 19], ...
      'String','Clear', ...
      'ToolTipString','Clear window', ...
      'tag','ui_fdidgui_compinp_pb_clear');
   h1 = uicontrol('Parent',h0, ...
      'Units','pixels', ...
      'ListboxTop',0, ...
      'Position',[467 56 93 19], ...
      'ToolTipString','Close window without saving data', ...
      'String','Cancel', ...
      'tag','ui_fdidgui_compinp_pb_cancel');
   h1 = uicontrol('Parent',h0, ...
      'Units','pixels', ...
      'ListboxTop',0, ...
      'Position',[467 34 93 19], ...
      'ToolTipString','Close window, saving data', ...
      'String','Done', ...
      'tag','ui_fdidgui_compinp_pb_done');

    if mode==0
      set([hchar,hstate],'foregroundcolor',[0,0,0])
      set([hexcf,hperlen],'foregroundcolor',[0,0,0])
      hnc=findobj(myfig,'Foregroundcolor',[0,0,0]);
      set(hnc,'foregroundcolor',0.65*[1,1,1])
      hblack=[findobj(myfig,'tag','fdidgui_compinp_pb_browse_data_out'),...
        findobj(myfig,'tag','fdidgui_compinp_pb_browse_data_inp'),...
        findobj(myfig,'tag','ui_fdidgui_compinp_pb_compose'),...
        findobj(myfig,'tag','ui_fdidgui_compinp_pb_clear'),...
        findobj(myfig,'tag','ui_fdidgui_compinp_pb_cancel'),...
        findobj(myfig,'tag','ui_fdidgui_compinp_pb_done'), ...
        findobj(myfig,'tag','ui_fdidgui_compinp_edit_ts'),...
        findobj(myfig,'tag','ui_fdidgui_compinp_edit_data_out'),...
        findobj(myfig,'tag','ui_fdidgui_compinp_edit_data_inp'),...
        ];
      set(hblack,'foregroundcolor',[0,0,0])
      %***
    end
    
   % statusbar
   statusframe = uicontrol(... F
      'Parent',myfig,...
      'Units','pixels',...
      'Position',[1 1 573 24],... 
      'String','',... 
      'HorizontalAlignment','left',... 
      'Style','frame',... 
      'Enable','off',... 
      'ToolTipString','Information on window', ...
      'tag','compinp_statusframe',... 
      'UserData',''); 
   statustext = uicontrol(... 
      'Parent',myfig,...
      'Units','pixels', ...
      'Position',[4 4 567 19],... 
      'String','Help area',... 
      'HorizontalAlignment','left',... 
      'Style','text',... 
      'ToolTipString','Information on window', ...
      'tag','compinp_statustext',... 
      'UserData',''); 
   
   
   if nargin>2
      call_info=struct('caller', p2, 'id', p3);
      guidtawr(Me,'caller_info','direct',call_info);
   else
      guidtawr(Me,'caller_info','direct','');
   end

   
   % fill in editboxes' callback properties
   h=findall(myfig, 'style', 'edit');
   for ii=1:length(h)
      cbstr=['fdtool(''callback'',''compinp'',''ui_edit'', ''',  get(h(ii),'tag'), ''')'];
      set(h(ii), 'callback', cbstr)
   end
   
   % set frame object hittest to 'off' to avoid help request on them
   h=findall(myfig, 'style', 'frame');
   set(h, 'hittest', 'off')
   
   % fill in popupmenus' callback properties
   h=findall(myfig, 'style', 'popupmenu');
   for ii=1:length(h)
      cbstr=['fdtool(''callback'',''compinp'',''ui_popup'', ''',  get(h(ii),'tag'), ''')'];
      set(h(ii), 'callback', cbstr)
   end
   
   % fill in pushbuttons' callback properties
   h=findall(myfig, 'style', 'pushbutton');
   for ii=1:length(h)
      tag=get(h(ii),'tag');
      if findstr(tag, 'browse') % browse buttons
         cbstr=['fdtool(''callback'',''compinp'',''ui_browse_pushed'', ''',  tag, ''')'];
      else % close, cancel, done
         cbstr=['fdtool(''callback'',''compinp'', ''',  tag, ''')'];
      end
      set(h(ii), 'callback', cbstr)
   end
   
   % create menus
   guimenus(Me,'compinput','compinp');
   compinp('clear') % clear input fields and reset popups   
   storewin('recover_settings', Me); % restore previous setting, if stored
   
   % init help
   helpmgr('init_help', '', myfcn, myfig );
   
   compinp('status', 'Ready.')   
   compinp('disable_done')
   intoscr(Me);   
   set(myfig, 'visible', 'on')
   % end of init
   
   
elseif strcmp(p1, 'mousemotion')
   guiready(myfig, myfcn)
   
elseif strcmp(p1,'status')
   c=allchild(myfig);
   status=findobj(c, 'flat', 'tag','compinp_statustext');
   statusfr=findobj(c, 'flat', 'tag','compinp_statusframe');
   glstatus(myfig, status, statusfr, p2)
   
elseif strcmp(p1,'ui_edit')|strcmp(p1,'ui_popup')
   %compinp('disable_done')
   h_edit=findobj(allchild(myfig), 'flat', 'tag', p2);
   [var, status, msg]=ChkVar(Me, p2);
   compinp('status', msg)
   if ~status
      blink(h_edit)
   end
   
elseif strcmp(p1,'ui_browse_pushed')
  if strcmp(sender,'fdidgui_compinp_pb_browse_data_out') &...
      strcmp(get(findall(0, 'tag', 'ui_fdidgui_compinp_edit_data_out_gain'),'visible'),'on')
    %Double input (phase and gain)
    %h=findall(0, 'tag', 'ui_fdidgui_compinp_edit_data_out_gain');
    h=findall(0, 'tag', 'fdidgui_compinp_pb_browse_data_out');
    itype=get(h,'userdata');
    if isempty(itype)|strcmp(itype,'phase')
      %previous: phase
      set(h,'userdata','gain');
      guiimpv('init', 'compinp' , [p2,'_gain'], '', 'filter: gain vector for compose input')
    else %previous: gain
      set(h,'userdata','phase');
      guiimpv('init', 'compinp' , [p2,'_phase'], '', 'filter: phase vector for compose input')
    end
  elseif strcmp(sender,'fdidgui_compinp_pb_browse_data_out')|...
      strcmp(sender,'fdidgui_compinp_pb_browse_data_in')|...
      strcmp(sender,'fdidgui_compinp_pb_browse_data_ref')
    guiimpv('init', 'compinp' , p2, '', 'filter: vector or cell array for compose input')
  else
    guiimpv('init', 'compinp' , p2, '', 'filter: vector for compose input')
    %   [file, path]=uigetfile('*.*', 'import');
    %   if ~isequal(path, 0) % not cancel
    %      h_edit=findobj(allchild(myfig), 'flat', 'tag', ['ui_', strrep(p2,'_pb_browse_', '_edit_')]);
    %      set(h_edit, 'string', ['<' path file '>'])
    %      cb=get(h_edit, 'callback');
    %      eval(cb)
    %   end
  end
  
elseif strcmp(p1, 'import_ready')
   switch p2
   case 'done'
      sets=guiimpv('GetSettings');
      switch sets.CurrentSource
      case 'FILE' % import from file
         % check if path really needed
         wh=which('-all', sets.CurrentFileName);
         if length(wh)~=1
            filename=[sets.CurrentPath, sets.CurrentFileName];
         else
            filename=[sets.CurrentFileName];
         end
         varname=sets.CurrentVarName;
         if any(findstr(varname, '<'))  % <text file data>
            editstring=['<' filename '>'];
         else
            editstring=['<' filename '>:' varname];
         end
      otherwise %'WP' import from workspace
         editstring=sets.CurrentVarName;
      end      
      
      %h=findall(0, 'tag', 'fdtool_importfig');
      %loadedvar=guidtard('fdtool_importfig', 'IMPORTED_VAR');
      
      h_edit=findobj(allchild(myfig), 'flat', 'tag', ['ui_', strrep(p3,'_pb_browse_', '_edit_')]);
      set(h_edit, 'string', editstring)
      
      
      cb=get(h_edit, 'callback');
      eval(cb)
      
   case 'cancel'
   end
   
   
elseif findstr(p1, 'switch')
   if findstr('time',Me), compinp('init2')
   elseif findstr('freq',Me), compinp('init1')
   else error('Me invalid')
   end
   
elseif findstr(p1, 'able_done') % enable_done or disable_done
   ch=allchild(myfig);
   h=[findall(ch, 'flat', 'tag', 'ui_fdidgui_compinp_pb_done'),...
         findall(ch, 'tag', 'compinput_menu_file_close'), ...
         findall(ch, 'tag', 'compinput_menu_file_save_object')]; % pb & menu
   if findstr(lower(p1), 'enable')
      onoff='on';
   else
      guidtawr(Me,'COMPOSED_DATA','direct','');
      onoff='off';
   end
   set(h,'enable', onoff);
   
elseif findstr(p1, 'clear')
   ch=allchild(myfig);
   edits=findall(ch, 'flat', 'style', 'edit');
   popups=findall(ch, 'flat', 'style', 'popup');
   dateedit=findall(ch, 'flat', 'tag', 'ui_fdidgui_compinp_edit_date');
   set(edits, 'string', '')
   set(popups, 'value', 1)
   set(dateedit, 'string', ['''',datestr(now),''''])
   
elseif findstr(p1, 'kill')
   delete(myfig)
   
elseif findstr(p1, 'done')
   if findstr(Me, 'freq'), mode='fiddata'; else mode='tiddata'; end
   h_main=findall(allchild(0), 'flat', 'tag', 'fdtool_main');
   obj=guidtard(Me,'COMPOSED_DATA');
   call_info=guidtard(Me,'caller_info');
   if ~isempty(call_info)
      if~isempty(h_main)
         storewin('remember', Me)
      end
      feval(call_info.caller, 'compose_ready', 'done', call_info.id, obj)
   else
      % save to WS 
      name=['composed_' mode];
      assignin('base', name, obj)
      compinp('status',['Object saved to Workspace variable ''' name ''''])
      pause(1)
      compinp('kill')
   end
   
elseif findstr(p1, 'cancel')
   call_info=guidtard(Me,'caller_info');
   if ~isempty(call_info)
      feval(call_info.caller, 'compose_ready', 'cancel', call_info.id, '')
   else
      compinp('kill')
   end
   
elseif findstr(p1, 'save_object')
   if findstr(Me, 'freq'), mode='fiddata'; else mode='tiddata'; end
   obj=guidtard(Me,'COMPOSED_DATA');
   initvar=struct('CurrentSource','WP', ...
      'CurrentPath', '', ...
      'CurrentFileName', '', ...
      'CurrentVarName', ['composed_' mode], ...
      'ExportData', obj);

   guiimpv('init_export', 'compinp' , '', initvar, ['filter:' mode ' object'])

elseif findstr(p1, 'export_ready')
   compinp('status', 'Object exported.')
   
elseif any(findstr(p1, 'ui_fdidgui_compinp_type_'))
  hm=[findall(0, 'tag', 'compinput_menu_data_type_io');...
      findall(0, 'tag', 'compinput_menu_data_type_frfdb');...
      findall(0, 'tag', 'compinput_menu_data_type_frf')];
  set(hm,'checked','off')
  hs=[findall(0, 'tag', 'ui_fdidgui_compinp_edit_unit_inp');...
      findall(0, 'tag', 'ui_fdidgui_compinp_edit_name_inp');...
      findall(0, 'tag', 'ui_fdidgui_compinp_edit_variance_inp')];      
  h=[findall(0, 'tag', 'ui_fdidgui_compinp_text_input');...
      findall(0, 'tag', 'ui_fdidgui_compinp_edit_data_inp');...
      findall(0, 'tag', 'fdidgui_compinp_pb_browse_data_inp');...
      findall(0, 'tag', 'ui_fdidgui_compinp_edit_character_inp');...
      findall(0, 'tag', 'ui_fdidgui_compinp_edit_character_out');...
      findall(0, 'tag', 'fdidgui_compinp_pb_browse_variance_inp')];
	%if mode==0
  hobl=[findall(0, 'tag', 'ui_fdidgui_compinp_text_character');...
    findall(0, 'tag', 'ui_fdidgui_compinp_text_state')];
  %else
  %  hobl=[];
  %end
  if strcmp(p1, 'ui_fdidgui_compinp_type_io') %Input/Output
    set(findall(0, 'tag', 'compinput_menu_data_type_io'),'checked','on')
    set(findall(0, 'tag', 'ui_fdidgui_compinp_text_output'),'string','Output')
    set(findall(0, 'tag', 'ui_fdidgui_compinp_edit_data_out'),'visible','on',...
      'tooltipstring','Set OutputData')
    set(findall(0, 'tag', 'ui_fdidgui_compinp_edit_data_out_gain'),'visible','off')
    set(findall(0, 'tag', 'ui_fdidgui_compinp_edit_data_out_phase'),'visible','off')
    set([h;hs],'enable','on')
    set(findall(0, 'tag', 'ui_fdidgui_compinp_edit_data_inp'),'string','')
    set(findall(0, 'tag', 'ui_fdidgui_compinp_edit_state'),'value',1,'enable','on')
		set(hobl,'foregroundcolor',[1,0,0])
  else %FRF
    set(findall(0, 'tag', 'ui_fdidgui_compinp_text_output'),'string','FRF')
    if strcmp(p1, 'ui_fdidgui_compinp_type_frfdb')
      set(findall(0, 'tag', 'compinput_menu_data_type_frfdb'),'checked','on')
      set(findall(0, 'tag', 'ui_fdidgui_compinp_edit_data_out'),'visible','off')
      gh=findall(0, 'tag', 'ui_fdidgui_compinp_edit_data_out_gain');
      ph=findall(0, 'tag', 'ui_fdidgui_compinp_edit_data_out_phase');
      set([gh;ph],'visible','on')    
    elseif strcmp(p1, 'ui_fdidgui_compinp_type_frf')
      set(findall(0, 'tag', 'compinput_menu_data_type_frf'),'checked','on')
      set(findall(0, 'tag', 'ui_fdidgui_compinp_edit_data_out'),'visible','on',...
        'tooltipstring','Set complex FRF values')
      set(findall(0, 'tag', 'ui_fdidgui_compinp_edit_data_out_gain'),'visible','off')
      set(findall(0, 'tag', 'ui_fdidgui_compinp_edit_data_out_phase'),'visible','off')
    end
    set([h;hs],'enable','off')
    set(findall(0, 'tag', 'ui_fdidgui_compinp_edit_data_inp'),'string','ones(size(FRF))')
    set(findall(0, 'tag', 'ui_fdidgui_compinp_edit_character_inp'),'value',2)
    set(findall(0, 'tag', 'ui_fdidgui_compinp_edit_character_out'),'value',2)
    set(findall(0, 'tag', 'ui_fdidgui_compinp_edit_state'),'value',2,'enable','off')
    set(hs,'string','')
		set(hobl,'foregroundcolor',[0,0,0])
  end
   
 %elseif any(findstr(p1, 'compinput_menu_data_type_io'))

 elseif findstr(p1, 'compose')
   compinp('status', 'Composition in progress...')
   [data, status, msg]=check_data(Me);
   if status
      addhist(data, 'Data was created in Compose... window')
      guidtawr(Me,'COMPOSED_DATA','direct',data);
      compinp('enable_done')
      compinp('status', 'Composition was successful')
   else  
      guidtawr(Me,'COMPOSED_DATA','direct','');
      compinp('disable_done')
      %compinp('status', msg)
   end   
else
   error(['compinput: bad command'])
end




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                        F U N C T I O N S                                %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [var, status, msg]=ChkVar(Me,tag)
% check if edit/popup input variable is OK

if findstr(Me, 'freq')
   mode='freq';
elseif findstr(Me, 'time2')
   mode='time2';
else
   mode='time';
end
info_cell=dbase(mode, tag);
eval_type=info_cell{4};
obl_flag=info_cell{3};
class_size=info_cell{5};


myfig=findall(allchild(0), 'flat', 'tag', Me);
h=findall(allchild(myfig), 'flat', 'tag', tag);
style=get(h, 'style');
if strcmp(style, 'edit')
   str=get(h, 'string');
   str=deblank(str(end:-1:1)); str=str(end:-1:1);
   if isempty(str), isset=0; else isset=1; end
else % popupmenu
   val=get(h, 'value');
   if val==1
      isset=0;
      str='';   
   else
      isset=1;
      str=popupstr(h);
   end
end

if ~isset 
   if obl_flag
      var=[]; status=0; 
      if strcmp(style, 'edit')
         msg='Error: This field may not be empty.';
      else % popup 'Choose one';
         msg='Error: Please select an option...';
      end
   else
      var=[]; status=1;
      msg='Input OK.';
   end
   return
end

if eval_type==1 % literal
   var=str;
   status=1;
   msg='';
else
  [var, status, msg]=GetVarfromStr(str);
  myfig=[findall(0,'type','figure','tag','fdtool_compinput_time_main'),...
    findall(0,'type','figure','tag','fdtool_compinput_time2_main')];
  if ishandle(myfig)
    if strcmp(tag,'ui_fdidgui_compinp_edit_ts'),
      hts=findall(myfig,'tag',tag);
      if exist('setappdata.m'), setappdata(hts,'Ts',var)
      else setuprop(get(hts,'parent'),'Ts',var)
      end
    elseif strcmp(tag,'ui_fdidgui_compinp_edit_data_inp')|...
        strcmp(tag,'ui_fdidgui_compinp_edit_data_out')
      if ~isempty(var)
        %if iscell(var), var=var{1}; end
        myfig=[findall(0,'type','figure','tag','fdtool_compinput_time_main'),...
    findall(0,'type','figure','tag','fdtool_compinput_time2_main')];
        hts=findall(myfig,'tag','ui_fdidgui_compinp_edit_excitfreq');
        if exist('setappdata.m'), setappdata(hts,'N',length(var))
        else setuprop(get(hts,'parent'),'N',length(var))
        end
      end
    end
  end
end

if isempty(var) & obl_flag
   status=0; msg='Error: This field may not be empty.';
end
  
if status
	% check size
	if (strcmp(tag,'ui_fdidgui_compinp_edit_data_out')|...
			strcmp(tag,'ui_fdidgui_compinp_edit_data_inp')|...
			strcmp(tag,'ui_fdidgui_compinp_edit_data_ref')|...
			strcmp(tag,'ui_fdidgui_compinp_edit_data_out_gain')|...
			strcmp(tag,'ui_fdidgui_compinp_edit_data_out_phase')) & ...
			iscell(var)
		var_save=var;
		if size(var_save,1)~=1
			msg=['Error: cell array must be a cell row vector.'];
			status=0; return
		end
	else
		var_save={var};
	end
	for ii=1:length(var_save)
		var=var_save{ii};
		s=size(var); c=class(var);
		switch(class_size(1))
			case 'd'
				req_c='double';
			case 'c'
				req_c='char';
		end
		if ~isa(var, req_c)
			msg=['Error: this variable must be ', req_c '.'];
			status=0;
		else
			% check size
			if ~strcmp(class_size(2),'x')& s(1)>str2num(class_size(2))
        if exist('str')&isstr(str)
          warning(sprintf(['Size of variable ''',str,''' is %.0f x %.0f'],class_size(1),class_size(2)))
        end
        status=0;
			elseif ~strcmp(class_size(3),'x')& s(2)>str2num(class_size(3))
				status=0;
			end
			if ~status
				switch class_size(2:3)
					case 'x1'
						t='column vector';
					case '1x'
						t='row vector';
					case '11'
						t='scalar';
				end
				msg=['Error: this variable must be a ' t '.']; 
			end
		end
	end %for ii
	if iscell(var_save)
		if length(var_save)==1, var=var_save{1}; 
		elseif length(var_save)>1, var=var_save; 
		else error('programming error')
		end
	end
end
if isempty(msg); msg='Input OK.'; end

function [var, status, msg]=GetVarfromStr(str)
% get variable from the place indicated in str
% possibilities:
% matlab expression (variable, vector spec)
% <file>
% <file>:variable
% <file>:(index)
msg='';
str=deblank(str(end:-1:1)); str=str(end:-1:1);
if isempty(str)
   var=[]; status=1; msg='Empty input.';
   return
end
if findstr(str(1), '<')
   % should contain filename
   ix1=findstr(str, '<');
   ix2=findstr(str, '>');
   ix3=findstr(str, '>:');
   ix4=findstr(str, '(');
   ix5=findstr(str, ')');
   if length(ix1)~=1 | length(ix2)~=1 |...
         length(ix4)~=length(ix5) | (length(ix4)>0 & ix4(1)<ix2+1) |...
         (isempty(ix3) & length(str)>1+max([ix2 ix5]))
      var=0;
      status=0;
      msg='Error: bad file import syntax. See ''''Help on Object'''' for syntax information.';
   else % basic syntax ok
      filename=str(ix1+1:ix2-1);
      if exist(filename, 'file')~=2
         var=0; status=0; msg=['Error: bad filename ''' filename '''.'];
      else % filename OK
         try
             w=who('-file', filename);
         catch
             w=[];
         end    
         if ~isempty(ix3) % check is variable present in the file
            varname=str(ix3+2:min([ix4-1, length(str)]));
            ix=0;
            for ii=1:length(w)
               if strcmp(w{ii},varname), ix=ii; break, end
            end
            if ix 
               try
                  s=load(filename);
                  var=getfield(s,varname);
                  status=1;
               catch
                  var=0; status=0; msg=['Error: cannot load file ''' filename '''.'];   
               end
            else
               var=0; status=0; msg=['Error: bad variable name ''' varname '''.'];
            end
         else % no varname
            if length(w)>1 % file contains multiple variables
               var=0; status=0; msg=['Error: file ''' filename ''' contains multiple variables.'];   
            else
               try
                  s=load(filename);
                  if length(w)==1
                     var=getfield(s, w{1});
                     status=1;
                  else % length(w}=0;
                     var=s;
                  end
                  status=1;
               catch
                  var=0; status=0; msg=['Error: cannot load file ''' filename '''.'];   
               end
            end
         end
         % status==1 means successfully loaded variable (may be of wrong type!!!)
         
         % check type
         if ~isa(var, 'double')& ~isa(var, 'char')
            msg=['Error: this type cannot be loaded (' class(var) ').']; var=0; status=0; 
         end
         
         if status & ~isempty(ix4) % check if index is OK
            index=str(ix4(1):end);
            try
               file_data=var;
               var=eval(['file_data' index '']);
               status=1;
            catch
               var=0; status=0; msg='Error: bad index expression. See command window for details.';
               disp(lasterr)
            end
         end % index handling
      end % filename OK
   end  % basic syntax ok
else
   % matlab expression (not filename)
   try
      if isstr(str)&~any(strcmp(str,'Ts'))&...
          ( any(findstr('Ts',str))|any(findstr('fs',str))|...
          any(findstr('Tr',str))|any(findstr('df',str)) )
        myfig=[findall(0,'type','figure','tag','fdtool_compinput_time_main'),...
          findall(0,'type','figure','tag','fdtool_compinput_time2_main')];
        if ~isempty(myfig)
          mode=1;
          hts=findall(myfig,'tag','ui_fdidgui_compinp_edit_ts');
          htsN=findall(myfig,'tag','ui_fdidgui_compinp_edit_excitfreq');
          Ts=[]; N=[];
          try
            if exist('getappdata.m')
              Ts=getappdata(hts,'Ts'); N=getappdata(htsN,'N');
            else
              Ts=getuprop(get(hts,'parent'),'Ts'); N=getuprop(get(htsN,'parent'),'N');
            end
          catch
          end
          if isempty(Ts), Ts=1; end, if isempty(N), N=128; end
          fs=1/Ts; df=fs/N; Tr=N*Ts;
        else %it is certainly freq domain
          if ~any(strcmp(str,'Ts'))&...
              (any(findstr('Tr',str))|any(findstr('df',str)) )
            myfig=findall(0,'type','figure','tag','fdtool_compinput_freq_main');
            if ~isempty(myfig)
              mode=2;
              hts=findall(myfig,'tag','ui_fdidgui_compinp_edit_freqpoints');
              fv=[];
              try
                if exist('getappdata.m')
                  fv=getappdata(hts,'fv');
                else
                  fv=getuprop(get(hts,'parent'),'fv');
                end
              catch
              end
              df=dfcalc(fv); if isempty(df), df=1; end
              Tr=1/df;
              Ts=[]; N=[];
              if isempty(Ts), Ts=1; end, if isempty(N), N=128; end
              fs=1/Ts; df=fs/N; Tr=N*Ts;
            end
            var=eval(str); 
            if isnumeric(var)&size(var,1)==1, var=var'; end
            status=1;
          end
        end
      else
        var=evalin('base', str);
        status=1;
      end
   catch
     var=0;
     status=0;
     msg='Error in expression. See command window for details';
     disp(lasterr)
   end
end


function blink(h)
def=get(0, 'defaultuicontrolbackgroundcolor');
for ii=1:3
   pause(0.3)
   set(h, 'backgroundcolor', 'red')
   pause(0.3)
   set(h, 'backgroundcolor', def)
end



function [data, status, msg]=check_data(Me)

myfig=findall(0, 'tag', Me);
ch=allchild(myfig);
if any(findstr(Me, 'freq'))
   mode='freq';
elseif any(findstr(Me, 'time2'))
   mode='time2';
elseif any(findstr(Me, 'time'))
   mode='time';
end
db=dbase(mode);

% check if everything important is filled in 
% and load data from window
err_h=[];win_str={}; win_h=[];
for ii=1:length(db)
   dat_i=db{ii};
   tag=dat_i{1}; name=dat_i{2}; flag=dat_i{3};
   h=findall(ch, 'flat', 'tag', tag); win_h(ii)=h;
   if isempty(h)
      error('compinp: bad tag in database')
   end
   ok=1;
   style=get(h, 'style');
   if strcmp(style, 'edit')
      str=get(h, 'string');
      str=deblank(str(end:-1:1)); str=str(end:-1:1);
      if isempty(str), ok=0; end
   else % popupmenu
      val=get(h, 'value');
      if val==1
         ok=0;
         str='';   
      else
         str=popupstr(h);
      end
   end
   win_str{ii}=str;
   if flag & ~ok
      err_h=[err_h, h];
   end
end %for ii
if ~isempty(err_h)
   if length(err_h)>1, s='s'; else s=''; end
   msg=[num2str(length(err_h)) ' unfilled ''red'' data field' s '. Please specify data.'];
   data=[]; status=0;
   compinp('status', ['Error: ' msg])
   blink(err_h)
   return
end


% check if fields are legal 
err_h=[];
w_data={}; msg_lst={};
for ii=1:length(db)
   dat_i=db{ii};
   tag=dat_i{1}; name=dat_i{2}; flag=dat_i{3}; type=dat_i{4}; h=win_h(ii);
   str=win_str{ii};
   %if type ==1 % literal
   %   w_data{ii}=str;
   %else% type==2 % eval
   %   if isempty(str) % empty str, but it's not 'red'
   %      w_data{ii}='';
   %   else
   if strcmp('ui_fdidgui_compinp_edit_data_inp',tag)&...
       strcmp(get(findall(0,'tag','ui_fdidgui_compinp_edit_data_inp'),'enable'),'off')
		 %Generate artificial input for frf data
		 if isnumeric(w_data{ii-1})
			 dat=ones(size(w_data{ii-1}));
		 else
			 w_data{ii}=sell(size(w_data{ii-1}));
			 for ii=1:length(w_data{ii})
				 w_data{ii}=ones(size(w_data{ii-1}));
			 end %for ii
		 end
		 status=1; msg='';
   else
     [dat, status, msg]=ChkVar(Me, tag);
   end
   if status
      w_data{ii}=dat;
   else % field cannot be eval'd
      w_data{ii}='';
      err_h=[err_h, h]; msg_lst=[msg_lst; {[msg, ' (' name ')']}];
   end
   %   end
   %end
end
if ~isempty(err_h)
   if length(err_h)>1, s='s'; else s=''; end
   msg=[num2str(length(err_h)) ' data field' s ' cannot be evaluated (see command window for details). Please correct input data.'];
   data=[]; status=0;
   compinp('status', ['Error: ' msg])
   disp(char(msg_lst))
   blink(err_h)
   return
end

% futher test
% 
switch mode
case 'time'
   % 1. input - output must be of same length 
   ix=1:2; err_h=win_h(ix);
	 if ~strcmp(class(w_data{1}),class(w_data{2}))
		 msg=['Class of Output and Input must be the same.'];
     data=[]; status=0; compinp('status', ['Error: ' msg]), blink(err_h)
     return
	 end
   [w_data,status,msg,err_h]=chk_w_data(w_data,win_h);
	 if status==0, 
		 data=[]; compinp('status', ['Error: ' msg]), blink(err_h)
		 return
	 end
   for ii=1:length(w_data{1})
     ix=1; err_h=win_h(ix);
		 if any(imag(w_data{1}{ii}))
			 msg=['Output must be real.'];
			 data=[]; status=0;
			 compinp('status', ['Error: ' msg])
			 blink(err_h)
			 return
		 end
     ix=2; err_h=win_h(ix);
		 if any(imag(w_data{2}{ii}))
			 msg=['Input must be real.'];
			 data=[]; status=0;
			 compinp('status', ['Error: ' msg])
			 blink(err_h)
			 return
		 end
	 end
	 %
   ix=3; err_h=win_h(ix);
	 if any(imag(w_data{3}))
     msg=['Ts must be real.'];
     data=[]; status=0;
     compinp('status', ['Error: ' msg])
     blink(err_h)
     return
   end
   if any(w_data{3}<0)
     msg=['Ts must be non-negative.'];
     data=[]; status=0;
     compinp('status', ['Error: ' msg])
     blink(err_h)
     return
   end
case 'freq'
  if strcmp(db{1}{2},'Gain')
    isfrfdb=1;
  else
    isfrfdb=0; 
  end
  % 1. input - output must be of same length
   ix=1:2; err_h=win_h(ix);
	 if ~strcmp(class(w_data{1}),class(w_data{2}))
     if isfrfdb
       msg=['Class of Gain and Phase must be the same.'];
     else
       msg=['Class of Output and Input must be the same.'];
     end
     data=[]; status=0; compinp('status', ['Error: ' msg]), blink(err_h)
     return
	 end
   [w_data,status,msg,err_h]=chk_w_data(w_data,win_h,isfrfdb);
	 if status==0, 
		 data=[]; compinp('status', ['Error: ' msg]), blink(err_h)
		 return
	 end
   ix=1:3; err_h=win_h(ix);
	 if any(diff([length(w_data{1}{1}), length(w_data{2}{1}), length(w_data{3})]))
     if isfrfdb
       msg=['Lengths of Gain, Phase and FreqPoints vectors must be the same.'];
     else
       msg=['Lengths of Input, Output and FreqPoints vectors must be the same.'];
     end
     data=[]; status=0; compinp('status', ['Error: ' msg]), blink(err_h)
     return
   end
	 %FreqPoints
   ix=3; err_h=win_h(ix);
	 if any(imag(w_data{3}))
     msg=['FreqPoints must be real.'];
     data=[]; status=0;
     compinp('status', ['Error: ' msg])
     blink(err_h)
     return
   end
   if any(diff(w_data{3})<0)
     msg=['FreqPoints must be monotonously increasing.'];
     data=[]; status=0;
     compinp('status', ['Error: ' msg])
     blink(err_h)
     return
   end
   if any(w_data{3}<0)
     msg=['FreqPoints must be non-negative.'];
     data=[]; status=0;
     compinp('status', ['Error: ' msg])
     blink(err_h)
     return
   end
   % 2. only one of them can be given: coherence and covariance 
   ix=15:16; err_h=win_h(ix);
   if ~isempty(w_data{15})&~isempty(w_data{16})
      msg=['Do not specify both covariance and coherence.'];
      data=[]; status=0;
      compinp('status', ['Error: ' msg])
      blink(err_h)
      return
   end
   % 3. covariance or coherence can be given only if variance is given
   for ii=1:2
      ix=[10:11, 14+ii];err_h=win_h(ix);
      if (isempty(w_data{10})| isempty(w_data{11}))&~isempty(w_data{14+ii})
         msg=[db{14+ii}{2} ' can be specified if variance is also specified.'];
         data=[]; status=0;
         compinp('status', ['Error: ' msg])
         blink(err_h)
         return
      end
   end
end

% now try to build an object
try
   % set basic properties
   switch mode
   case {'time','time2'}
      f_name=[db{1}{2}, ', ', db{2}{2}]; 
      compinp('status', ['setting ' f_name '...'])
      h=win_h(1:2); s='s';
      data=tiddata(w_data{1}, w_data{2});
      next=3;
      %w_data:
      %  3: Ts
      % 12: frequencies 
      f_name='Ts'; Ts=w_data{3};
			if ~isnumeric(Ts)|(length(Ts)~=1)|(imag(Ts)~=0)|~isfinite(Ts)|(Ts<=0)
        ix=[3]; err_h=win_h(ix);
				msg='The sampling time is not a positive scalar.';
				data=[]; status=0;
				compinp('status', ['Error: ' msg])
				blink(err_h)
				return
      elseif any(w_data{12}>=1/2/w_data{3})
				ix=[3,12]; err_h=win_h(ix);
				msg='The given excitation frequencies are too high for the sampling frequency.';
				data=[]; status=0;
				compinp('status', ['Error: ' msg])
				blink(err_h)
				return
      end
   case 'freq'
      f_name=[db{1}{2}, ', ', db{2}{2}, ', ', db{3}{2}]; 
      compinp('status', ['setting ' f_name '...'])
      h=win_h(1:3); s='s';
      if ~isfrfdb
        data=fiddata(w_data{1}, w_data{2}, w_data{3});
      else %FRF dB/degrees
				frf=cell(size(w_data{1}));
				for ii=1:length(w_data{1})
				  frf{ii}=10.^(w_data{1}{ii}/20).*exp(j*w_data{2}{ii}/360*2*pi);
				end
        if iscell(w_data{2}),
          u=cell(size(w_data{2}));
          for ii=1:prod(size(u)), u{ii}=ones(size(w_data{2}{ii})); end
          if length(u)==1, u=u{1}; end
        else
          u=ones(size(w_data{2}));
        end
        data=fiddata(frf, u, w_data{3});
      end
      next=4;
   end
   s='';
   % set other properties one by one
   for ii=next:length(w_data)
      f_name=db{ii}{2};
      compinp('status', ['setting ' f_name '...'])
      h=win_h(ii);
      if ~isempty(w_data{ii})
        set(data, f_name, w_data{ii},'noconsistency')
      end
   end
   if ~get(data,'consistency')
     msg='Cannot generate consistent object. See the command window for a clue.';
     data=[]; status=0;
     compinp('status', ['Error: ' msg])
     err_h=[];
     blink(err_h)
     return
   end
   status=1; msg='';
   %get(data) % test only
catch
   disp(lasterr)
   data=[]; status=0; msg=['Object field' s ' ''' f_name   ''' cannot be set. See command window for details.'];
   disp(msg)
   compinp('status', ['Error: ' msg])
   blink(h)
end

function [w_data,status,msg,err_h]=chk_w_data(w_data,win_h,isfrfdb);
%Common checks of I/O data for time and frequency
status=1; msg=''; err_h=[];
if nargin<3, isfrfdb=0; end
if isnumeric(w_data{1}), 
	if size(w_data{1},2)>1
		w_data{1}=num2cell(w_data{1},1)'; w_data{2}=num2cell(w_data{2},1)';
	else
		w_data{1}={w_data{1}}; w_data{2}={w_data{2}};
	end
end
for ii=1:length(w_data{1})
	if any(size(w_data{1}{1})~=size(w_data{1}{ii}))|...
			any(size(w_data{2}{1})~=size(w_data{2}{ii}))|...
			any(size(w_data{1}{1})~=size(w_data{2}{1}))
    ix=1:2; err_h=win_h(ix);
		if isfrfdb
			msg=['Sizes of all Gain and Phase vectors must be the same.'];
		else
			msg=['Sizes of all Input and Output vectors must be the same.'];
		end
		status=0;
		return
	end
end
if size(w_data{1}{1},2)~=1
  ix=1:2; err_h=win_h(ix);
	if isfrfdb
		msg=['All Gain and Phase data must contain column vectors.'];
	else
		msg=['All Input and Output data must contain column vectors.'];
	end
	status=0;
	return
end 
if isfrfdb
  isc=0;
  for ii=1:length(w_data{1})
    if any(imag(w_data{1}{ii})), isc=1; break, end
  end
  if isc
    ix=1; err_h=win_h(ix);
    msg=['All Gain data must be real.'];
    status=0;
    return
  end
  %
  isc=0;
  for ii=1:length(w_data{2})
    if any(imag(w_data{2}{ii})), isc=1; break, end
  end
  if isc
    ix=2; err_h=win_h(ix);
    msg=['All Phase data must be real.'];
    status=0;
    return
  end
end 

function db=dbase(mode, tag)
% tag, field name in the object, obligatory flag, evaltype, class+size
% obligatory flag: 1 if field must be specified ('red')
% evaltype: 1: literal (string), 2: must be eval'd
% class+size: d for double, c for char; the numbers show the possible sizes (e.g. dx1 is a column vector of any length)
if nargin <2, tag=''; end
db_time={...
    {'ui_fdidgui_compinp_edit_data_out',      'Output',          1, 2, 'dxx'},...
    {'ui_fdidgui_compinp_edit_data_inp',      'Input',           1, 2, 'dxx'},...
    {'ui_fdidgui_compinp_edit_ts',            'Ts',              1, 2, 'd11'},...
    {'ui_fdidgui_compinp_edit_name_out',      'OutputName',      0, 1, 'c1x'},...
    {'ui_fdidgui_compinp_edit_name_inp',      'InputName',       0, 1, 'c1x'},...
    {'ui_fdidgui_compinp_edit_unit_out',      'OutputUnit',      0, 1, 'c1x'},...
    {'ui_fdidgui_compinp_edit_unit_inp',      'InputUnit',       0, 1, 'c1x'},...
    {'ui_fdidgui_compinp_edit_character_out', 'OutputCharacter', 1, 1, 'c1x'},...
    {'ui_fdidgui_compinp_edit_character_inp', 'InputCharacter',  1, 1, 'c1x'},...
    {'ui_fdidgui_compinp_edit_tstart_out',    'OutputTStart',    0, 2, 'd11'},...
    {'ui_fdidgui_compinp_edit_tstart_inp',    'InputTStart',     0, 2, 'd11'},...
    {'ui_fdidgui_compinp_edit_excitfreq',     'Frequencies',     0, 2, 'dx1'},...
    {'ui_fdidgui_compinp_edit_state',         'State',           1, 1, 'c1x'},...
    {'ui_fdidgui_compinp_edit_synch',         'Synchronization', 0, 1, 'c1x'},...
    {'ui_fdidgui_compinp_edit_periodlength',  'PeriodLength',    0, 2, 'd11'},...
    {'ui_fdidgui_compinp_edit_date',          'Date',            0, 2, 'c1x'},...
    {'ui_fdidgui_compinp_edit_notes',         'Notes',           0, 1, 'c1x'},...
    {'ui_fdidgui_compinp_edit_data_ref',      'Reference',       0, 2, 'dx1'},...
  };
db_time2={...
    {'ui_fdidgui_compinp_edit_data_out',      'Output',          1, 2, 'dxx'},...
    {'ui_fdidgui_compinp_edit_data_inp',      'Input',           1, 2, 'dxx'},...
    {'ui_fdidgui_compinp_edit_ts',            'Ts',              1, 2, 'd11'},...
    {'ui_fdidgui_compinp_edit_name_out',      'OutputName',      0, 1, 'c1x'},...
    {'ui_fdidgui_compinp_edit_name_inp',      'InputName',       0, 1, 'c1x'},...
    {'ui_fdidgui_compinp_edit_unit_out',      'OutputUnit',      0, 1, 'c1x'},...
    {'ui_fdidgui_compinp_edit_unit_inp',      'InputUnit',       0, 1, 'c1x'},...
    {'ui_fdidgui_compinp_edit_character_out', 'OutputCharacter', 0, 1, 'c1x'},...
    {'ui_fdidgui_compinp_edit_character_inp', 'InputCharacter',  0, 1, 'c1x'},...
    {'ui_fdidgui_compinp_edit_tstart_out',    'OutputTStart',    0, 2, 'd11'},...
    {'ui_fdidgui_compinp_edit_tstart_inp',    'InputTStart',     0, 2, 'd11'},...
    {'ui_fdidgui_compinp_edit_excitfreq',     'Frequencies',     0, 2, 'dx1'},...
    {'ui_fdidgui_compinp_edit_state',         'State',           0, 1, 'c1x'},...
    {'ui_fdidgui_compinp_edit_synch',         'Synchronization', 0, 1, 'c1x'},...
    {'ui_fdidgui_compinp_edit_periodlength',  'PeriodLength',    0, 2, 'd11'},...
    {'ui_fdidgui_compinp_edit_date',          'Date',            0, 2, 'c1x'},...
    {'ui_fdidgui_compinp_edit_notes',         'Notes',           0, 1, 'c1x'},...
    {'ui_fdidgui_compinp_edit_data_ref',      'Reference',       0, 2, 'dx1'},...
  };
h= findall(0, 'tag', 'ui_fdidgui_compinp_edit_data_out');
if strcmp(get(h,'visible'),'on') %I/O
  db_freq={...
      {'ui_fdidgui_compinp_edit_data_out',      'Output',          1, 2, 'dxx'},...
      {'ui_fdidgui_compinp_edit_data_inp',      'Input',           1, 2, 'dxx'},...
    };
else
  db_freq={...
      {'ui_fdidgui_compinp_edit_data_out_gain', 'Gain',            1, 2, 'dxx'},...
      {'ui_fdidgui_compinp_edit_data_out_phase','Phase',           1, 2, 'dxx'},...
    };
end

db_freq=[db_freq,...
    {...
      {'ui_fdidgui_compinp_edit_freqpoints',    'FreqPoints',      1, 2, 'dx1'},...
      {'ui_fdidgui_compinp_edit_name_out',      'OutputName',      0, 1, 'c1x'},...
      {'ui_fdidgui_compinp_edit_name_inp',      'InputName',       0, 1, 'c1x'},...
      {'ui_fdidgui_compinp_edit_unit_out',      'OutputUnit',      0, 1, 'c1x'},...
      {'ui_fdidgui_compinp_edit_unit_inp',      'InputUnit',       0, 1, 'c1x'},...
      {'ui_fdidgui_compinp_edit_character_out', 'OutputCharacter', 1, 1, 'c1x'},...
      {'ui_fdidgui_compinp_edit_character_inp', 'InputCharacter',  1, 1, 'c1x'},...
      {'ui_fdidgui_compinp_edit_variance_out',  'OutputVariance',  0, 2, 'dx1'},...
      {'ui_fdidgui_compinp_edit_variance_inp',  'InputVariance',   0, 2, 'dx1'},...
      {'ui_fdidgui_compinp_edit_oidelay',       'OutputDelay',     0, 2, 'd11'},...
      {'ui_fdidgui_compinp_edit_state',         'State',           1, 1, 'c1x'},...
      {'ui_fdidgui_compinp_edit_synch',         'Synchronization', 0, 1, 'c1x'},...
      {'ui_fdidgui_compinp_edit_covariance',    'CovVector',       0, 2, 'dx1'},...
      {'ui_fdidgui_compinp_edit_coherence',     'CohVector',       0, 2, 'dx1'},...
      {'ui_fdidgui_compinp_edit_date',          'Date',            0, 2, 'c1x'},...
      {'ui_fdidgui_compinp_edit_notes',         'Notes',           0, 1, 'c1x'},...
      {'ui_fdidgui_compinp_edit_data_ref',      'Reference',       0, 2, 'dx1'},...
      {'ui_fdidgui_compinp_edit_excitfreq',     'Frequencies',      0, 2, 'dx1'},...
      }];
if strcmp(mode, 'time')
  db=db_time;
elseif strcmp(mode, 'time2')
  db=db_time2;
else
  db=db_freq;
end
if ~isempty(tag) % data is needed for a specific tag
   ix=0; 
   for ii=1:length(db)
     if strcmp(db{ii}{1}, tag)
         ix=ii; break
      end
   end
   if ix
      db=db{ix};
   else
      error('Tag is not in database!')
   end
   return
end
