function tbxStruct = demos
%DEMOS   Return demo information to the MATLAB Demo.

%       Copyright (c) I. Kollar and Vrije Universiteit Brussel, ELEC, 1991-2001
%       All rights reserved.
%       $Revision: $
%       Last modified: 15-Jan-2001, I. Kollar

if nargout == 0, demo toolbox; return; end

tbxStruct.Name='Frequency Domain System Identification';
tbxStruct.Type='toolbox';
tbxStruct.Help={ ...
    ' The Frequency Domain System Identification toolbox'
    ' is a collection of MATLAB functions for identifying'
    ' and simulating linear SISO models in the frequency'
    ' domain. Accessibility of complicated methods and functions'
    ' is significantly easier using the graphical user interface.'
    ' Type fdtool to start the GUI.'
    ' '
    ' Frequency domain methods represent an important'
    ' alternative to time domain methods implemented in'
    ' the System Identification Toolbox. They allow accurate'
    ' modeling by parametric transfer function models with'
    ' an external delay.'
    ' '
    ' The toolbox contains tools for the whole identification'
    ' procedure: optimal excitation signal design, data'
    ' preprocessing, parameter estimation, presentation of'
    ' the results, model validation, and simulation.'
    ' '
    ' For more information, please consult the WEB page:'
    '   web(''http://elecwww.vub.ac.be/fdident/'');'
     };

tbxStruct.DemoList={...
      'Introduction to the Use of the GUI','demos_fdtool_intro';...
      'Introduction to Identification','demos_fdident_intro';...
      'Complex Examples and Demos','demos_fdident_complex';...
      '','';...
      'Command-line demonstrations','fdiddemo';...
      'CL demonstrations with measured data','bookdemo'...
    };

%      'Playshow demonstrations:','';...
%      '  Use of basic commands','fdcoursh';...
%      '  Identification of a bandpass filter','bandpsh'...

%      'Start the graphical user interface','fdtool,fdtool(''callback'',''guirecrd'',''loadhist'',''starting.mat''),fdtool(''callback'',''guirecrd'',''stop'')';...
%      'Processing time domain data','fdtool,fdtool(''callback'',''guirecrd'',''loadhist'',''introtdd.mat''),fdtool(''callback'',''guirecrd'',''stop'')';...
%      'Processing frequency domain data','fdtool,fdtool(''callback'',''guirecrd'',''loadhist'',''introfdd.mat''),fdtool(''callback'',''guirecrd'',''stop'')';...
%
%      'Bandpass filter','fdtool,fdtool(''callback'',''guirecrd'',''loadhist'',''bandpdem.mat''),fdtool(''callback'',''guirecrd'',''stop'')';...
%      'Electrical machine','fdtool,fdtool(''callback'',''guirecrd'',''loadhist'',''emachdem.mat''),fdtool(''callback'',''guirecrd'',''stop'')';...
%      'Input channel','fdtool,fdtool(''callback'',''guirecrd'',''loadhist'',''inpchdem.mat''),fdtool(''callback'',''guirecrd'',''stop'')';...
%      'Lowpass filter, z-domain','fdtool,fdtool(''callback'',''guirecrd'',''loadhist'',''lowpdem.mat''),fdtool(''callback'',''guirecrd'',''stop'')';...
%      'Detailed identification example','fdtool,fdtool(''callback'',''guirecrd'',''loadhist'',''lowpdem2.mat''),fdtool(''callback'',''guirecrd'',''stop'')';...
%      'Airplane cabin','fdtool,fdtool(''callback'',''guirecrd'',''loadhist'',''cabindem.mat''),fdtool(''callback'',''guirecrd'',''stop'')';...
%      'Mech. system: aluminum plates','fdtool,fdtool(''callback'',''guirecrd'',''loadhist'',''alupldem.mat''),fdtool(''callback'',''guirecrd'',''stop'')';...
%      'Mech. system: glassfiber plates','fdtool,fdtool(''callback'',''guirecrd'',''loadhist'',''glfibdem.mat''),fdtool(''callback'',''guirecrd'',''stop'')';...
%      'Mech. system: crankcase','fdtool,fdtool(''callback'',''guirecrd'',''loadhist'',''crankdem.mat''),fdtool(''callback'',''guirecrd'',''stop'')';...
%      'Flexible robot arm','fdtool,fdtool(''callback'',''guirecrd'',''loadhist'',''rarmdemo.mat''),fdtool(''callback'',''guirecrd'',''stop'')';...
%      'Wilkinson-type system','fdtool,fdtool(''callback'',''guirecrd'',''loadhist'',''wilkdemo.mat''),fdtool(''callback'',''guirecrd'',''stop'')';...
%      'Treating transient data','fdtool,fdtool(''callback'',''guirecrd'',''loadhist'',''bptrdemo.mat''),fdtool(''callback'',''guirecrd'',''stop'')';...
%      'Use of w=sqrt(s)','fdtool,fdtool(''callback'',''guirecrd'',''loadhist'',''corrdem.mat''),fdtool(''callback'',''guirecrd'',''stop'')';...
%End of demos for fdident
