function essd(p1,p2,p3,p4,p5,seltype) 
% ESSD  Excitation signal design window for fdident GUI
% Private function

%       Copyright (c) I. Kollar and Vrije Universiteit Brussel, ELEC, 1997-2003
%       All rights reserved.
%       $Revision: $
%       Written by Gy. Simon and I. Kollar
%       Last modified: 27-Nov-2003, IK

mainfig=findall(0, 'tag','fdtool_main');
Me = 'excitation_main';
myfcn='essd';
myname='excitation';

if nargin >0 & ~strcmp(p1, 'init')
  %For preload, we can already return
  if strcmp(p1, 'preload'), return, end
  %
  myfig=findall(0,'tag',Me);
  if nargin == 6
    sender=p5;
    replay_mode= 'replay';
  else
    seltype=get(myfig,'selectiontype');
    eval(['sender=p', num2str(nargin) ';']);
    replay_mode= 'normal';
  end
  %
  %prepare for all settings of freqset
  if strcmp(guiinfos('userlevel'),'Automatic')
    fntypelin={'df','# of freqs'};
    fntypelog={'Nf/oct','Nf/dec','df/f','# of freqs'};
  else
    fntypelin={'df','# of freqs','df/fmin','df/fmax'};
    fntypelog={'Nf/oct','Nf/dec','df/f','# of freqs'};
  end
  fntypeall={'df','# of freqs','Nf/oct','Nf/dec','df/f','df/fmin','df/fmax'};
  fmin=str2num(get(findobj(myfig, 'tag', 'essd_uic_figrb(5)'), 'string'));
  fmax=str2num(get(findobj(myfig, 'tag', 'essd_uic_figrb(6)'), 'string'));
  fc=str2num(get(findobj(myfig, 'tag', 'essd_uic_cfedit'),'string'));
  N=str2num(get(findobj(myfig, 'tag', 'essd_uic_ssedit'),'string'));
  df=fc/N;
  %
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%                 INITIALIZATION
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


if nargin ==0 | strcmp(p1, 'init')
  
  tmp=findall(0, 'tag','excitation_main');
  if ~isempty(tmp) 
    % set(tmp,'visible','on');
    %figure(tmp);
    guiclose('excitation')         
  end
  
  
  essddef
  
  % essddef is a resource file containing all the coordinates and dimensions
  % for the graphical objects. These properties are loaded here, and the 
  % uicontrol creation calls use them.
  
  fig = figure(...
    'Units','pixels',...
    'Position',[ fig_offsx fig_offsy fig_dx fig_dy ],...
    'Resize','off',...
    'color',figure_col,...
    'Tag','excitation_main',...
    'Name','Excitation Signal Design',...
    'NumberTitle','off',...
    'IntegerHandle', 'off',...
    'Handlevisibility', 'off',...
    'Deletefcn', 'fdtool(''callback'',''essd'',''destroyed'',''excitation_main'')',...
    'windowbuttonmotion', 'fdtool(''callback'',''essd'',''mouse_motion'')',...
    'visible','off');   
  %         'Closerequestfcn','fdtool(''callback'',''essd'',''essd_uic_cancelpb'',''essd_uic_cancelpb'');',... 
  if strncmp(version,'5',1), set(fig,'Position',[ fig_offsx fig_offsy fig_dx fig_dy ]), end %fix in 5.3

  myfig=fig;
  fdwindef(myfig);  % set default window properties
  
  
  %  Uicontrol Object Creation 
  
  essd_uic_donepb = uicontrol(...
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''essd'',''essd_uic_donepb'',''essd_uic_donepb'');', ...
    'Units','pixels',...
    'Position',[ donepb_offsx donepb_offsy donepb_dx donepb_dy ], ...
    'BackgroundColor',pushb_bgr_col,...
    'ForegroundColor',pushb_fg_col,...
    'String','Close', ...
    'ToolTipString','Close window and return signal samples',... 
    'HorizontalAlignment','center', ...
    'Style','pushbutton',...
    'enable', 'on', ...
    'Tag','essd_uic_donepb',...
    'UserData',''); 
  essd_uic_cancelpb = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''essd'',''essd_uic_cancelpb'',''essd_uic_cancelpb'');',... 
    'Units','pixels',...
    'Position',[ cancelpb_offsx cancelpb_offsy cancelpb_dx cancelpb_dy ],... 
    'BackgroundColor',pushb_bgr_col,...
    'ForegroundColor',pushb_fg_col,...
    'String','Cancel',... 
    'ToolTipString','Close window without returning signal',... 
    'HorizontalAlignment','center',...
    'Style','pushbutton',... 
    'enable', 'on', ...
    'Tag','essd_uic_cancelpb',... 
    'UserData',''); 
  essd_uic_designpb = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''essd'',''essd_uic_designpb'',''essd_uic_designpb'');',... 
    'Units','pixels',...
    'Position',[ designpb_offsx designpb_offsy designpb_dx designpb_dy ],... 
    'BackgroundColor',pushb_bgr_col,...
    'ForegroundColor',pushb_fg_col,...
    'String','Design',... 
    'ToolTipString','Design signal with given parameters',... 
    'HorizontalAlignment','center',...
    'Style','pushbutton',... 
    'enable', 'on', ...
    'Tag','essd_uic_designpb',... 
    'UserData',''); 
  essd_uic_viewpb = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''essd'',''essd_uic_viewpb'',''essd_uic_viewpb'');',... 
    'Units','pixels',...
    'Position',[ viewpb_offsx viewpb_offsy viewpb_dx viewpb_dy ],... 
    'BackgroundColor',pushb_bgr_col,...
    'ForegroundColor',pushb_fg_col,...
    'String','View Spect.',... 
    'ToolTipString','View spectral lines to generate',... 
    'HorizontalAlignment','center',...
    'Style','pushbutton',... 
    'enable', 'on', ...
    'Tag','essd_uic_viewpb',... 
    'UserData',''); 
  
  essd_uic_adjustpb = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''essd'',''essd_uic_adjustpb'',''essd_uic_adjustpb'');',... 
    'Units','pixels',...
    'Position',[ adjustpb_offsx adjustpb_offsy adjustpb_dx adjustpb_dy ],... 
    'BackgroundColor',pushb_bgr_col,...
    'ForegroundColor',pushb_fg_col,...
    'String','Adjust freqs',... 
    'ToolTipString','Adjust frequencies (fmin, fmax and number of freqs) to DFT grid and other parameters to instrument type',...
    'HorizontalAlignment','center',...
    'Style','pushbutton',... 
    'enable', 'on', ...
    'Tag','essd_uic_adjustpb',... 
    'UserData','');
  
  essd_uic_adjustpbn = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''essd'',''essd_uic_adjustpbn'',''essd_uic_adjustpbn'');',... 
    'Units','pixels',...
    'Position',[ adjustpbn_offsx adjustpbn_offsy adjustpbn_dx adjustpbn_dy ],... 
    'BackgroundColor',pushb_bgr_col,...
    'ForegroundColor',pushb_fg_col,...
    'String','Adjust samples',... 
    'ToolTipString','Adjust clock frequency and number of samples according to fmin, fmax and number of freqs',...
    'HorizontalAlignment','center',...
    'Style','pushbutton',... 
    'enable', 'on', ...
    'Tag','essd_uic_adjustpbn',... 
    'UserData','');
  
  essd_uic_mainframe = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ mainframe_offsx mainframe_offsy mainframe_dx mainframe_dy ],... 
    'BackgroundColor',frame_bgr_col,...
    'ForegroundColor',frame_fg_col,...
    'String','mainframe',... 
    'HorizontalAlignment','left',...
    'Style','frame',... 
    'Tag','essd_uic_mainframe',... 
    'Enable','off',... 
    'UserData',''); 
  essd_uic_ampframe = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ ampframe_offsx ampframe_offsy ampframe_dx ampframe_dy ],... 
    'BackgroundColor',frame_bgr_col,...
    'ForegroundColor',frame_fg_col,...
    'String','Amplitude shape',... 
    'HorizontalAlignment','left',...
    'Style','frame',... 
    'Tag','essd_uic_ampframe',... 
    'Enable','off',... 
    'UserData',''); 
  if exist('krgodfrey.mat')
    Atxt='Apeak';
    Attstr='Peak value of the time domain signal';
    tagadd='_peak';
  else
    Atxt='RMS';
    Attstr='RMS value of the time domain signal';
    tagadd='';
  end
  essd_uic_agtext(20) = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ ag20text_offsx ag20text_offsy ag20text_dx ag20text_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String',[Atxt,' = '],... 
    'ToolTipString',Attstr,...
    'HorizontalAlignment','right',...
    'Style','text',... 
    'Tag',['essd_uic_agtext',tagadd,'(20)'],... 
    'UserData',''); 
  essd_uic_agedit(21) = uicontrol(... 
    'Parent',fig,...
    'CallBack', ['fdtool(''callback'',''essd'', ''ui_edit'', ''essd_uic_agedit',tagadd,'(21)'');'],...
    'Units','pixels',...
    'Position',[ ag21edit_offsx ag21edit_offsy ag21edit_dx ag21edit_dy ],... 
    'BackgroundColor',edit_bgr_col,...
    'ForegroundColor',edit_fg_col,...
    'String','0.7',... 
    'ToolTipString',Attstr,...
    'HorizontalAlignment','right',...
    'Style','edit',... 
    'Tag',['essd_uic_agedit',tagadd,'(21)'],... 
    'UserData',''); 
  essd_uic_cycltext = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ cycltext_offsx cycltext_offsy cycltext_dx cycltext_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','Iter = ',... 
    'ToolTipString','The number of iteration cycles in optimization for model',...
    'HorizontalAlignment','right',...
    'Style','text',... 
    'Tag','essd_uic_cycltext',...
    'enable','off',...
    'UserData',''); 
  essd_uic_cycledit = uicontrol(... 
    'Parent',fig,...
    'CallBack',  'fdtool(''callback'',''essd'', ''ui_edit'', ''essd_uic_cycledit'');',...
    'Units','pixels',...
    'Position',[ cycledit_offsx cycledit_offsy cycledit_dx cycledit_dy ],... 
    'BackgroundColor',edit_bgr_col,...
    'ForegroundColor',edit_fg_col,...
    'String','1',... 
    'ToolTipString','The number of iteration cycles in optimization for model',...
    'HorizontalAlignment','right',...
    'Style','edit',... 
    'enable','on',...
    'Tag','essd_uic_cycledit',... 
    'UserData',''); 
  essd_uic_reptext = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ reptext_offsx reptext_offsy reptext_dx reptext_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','Reps = ',... 
    'ToolTipString','The number of repetitions of signal segment after design',...
    'HorizontalAlignment','right',...
    'Style','text',... 
    'Tag','essd_uic_reptext',...
    'enable','on',...
    'UserData',''); 
  essd_uic_repedit = uicontrol(... 
    'Parent',fig,...
    'CallBack',  'fdtool(''callback'',''essd'', ''ui_edit'', ''essd_uic_repedit'');',...
    'Units','pixels',...
    'Position',[ repedit_offsx repedit_offsy repedit_dx repedit_dy ],... 
    'BackgroundColor',edit_bgr_col,...
    'ForegroundColor',edit_fg_col,...
    'String','1',... 
    'ToolTipString','The number of repetitions of signal segment after design',...
    'HorizontalAlignment','right',...
    'Style','edit',... 
    'enable','on',...
    'Tag','essd_uic_repedit',... 
    'UserData',''); 
  essd_uic_exptext = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ exptext_offsx exptext_offsy exptext_dx exptext_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','Exps = ',... 
    'ToolTipString','The number of different experiments with different (random) phases',...
    'HorizontalAlignment','right',...
    'Style','text',... 
    'Tag','essd_uic_exptext',...
    'enable','on',...
    'UserData',''); 
  essd_uic_expedit = uicontrol(... 
    'Parent',fig,...
    'CallBack',  'fdtool(''callback'',''essd'', ''ui_edit'', ''essd_uic_expedit'');',...
    'Units','pixels',...
    'Position',[ expedit_offsx expedit_offsy expedit_dx expedit_dy ],... 
    'BackgroundColor',edit_bgr_col,...
    'ForegroundColor',edit_fg_col,...
    'CallBack', 'fdtool(''callback'',''essd'',''ui_edit'',''essd_uic_expedit'');',...
    'String','1',... 
    'ToolTipString','The number of different experiments with different (random) phases',...
    'HorizontalAlignment','right',...
    'Style','edit',... 
    'enable','on',...
    'Tag','essd_uic_expedit',... 
    'UserData',''); 
  essd_uic_agrb(7) = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''essd'',''essd_uic_agrb(7)'',''essd_uic_agrb(7)'');',... 
    'Units','pixels',...
    'Position',[ ag7rb_offsx ag7rb_offsy ag7rb_dx ag7rb_dy ],... 
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'String','Optimize',... 
    'ToolTipString','Design optimal excitation signal shape for given model',...
    'HorizontalAlignment','left',...
    'Style','radiobutton',... 
    'Tag','essd_uic_agrb(7)',... 
    'Value',0,...
    'UserData','');
  essd_uic_agrb(6) = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''essd'',''essd_uic_agrb(6)'',''essd_uic_agrb(6)'');',... 
    'Units','pixels',...
    'Position',[ ag6rb_offsx ag6rb_offsy ag6rb_dx ag6rb_dy ],... 
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'String','Follow frf',... 
    'ToolTipString','Follow transfer function given in fiddata object',...
    'HorizontalAlignment','left',...
    'Style','radiobutton',... 
    'Tag','essd_uic_agrb(6)',... 
    'Value',0,...
    'UserData','');
  essd_uic_agrb(5) = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''essd'',''essd_uic_agrb(5)'',''essd_uic_agrb(5)'');',... 
    'Units','pixels',...
    'Position',[ ag5rb_offsx ag5rb_offsy ag5rb_dx ag5rb_dy ],... 
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'String','Matlab expression',... 
    'ToolTipString','Matlab expression of amplitude vector. May contain fv (column vector of frequencies).',... 
    'HorizontalAlignment','left',...
    'Style','radiobutton',... 
    'Tag','essd_uic_agrb(5)',... 
    'Value',0,...
    'UserData',''); 
  essd_uic_agrb(4) = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''essd'',''essd_uic_agrb(4)'',''essd_uic_agrb(4)'');',... 
    'Units','pixels',...
    'Position',[ ag4rb_offsx ag4rb_offsy ag4rb_dx ag4rb_dy ],... 
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'String','Import...',...
    'ToolTipString','Import amplitude vector from workspace',...
    'HorizontalAlignment','left',...
    'Style','radiobutton',... 
    'Tag','essd_uic_agrb(4)',... 
    'Value',0,...
    'UserData','');
  essd_uic_agrb(3) = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''essd'',''essd_uic_agrb(3)'',''essd_uic_agrb(3)'');',... 
    'Units','pixels',...
    'Position',[ ag3rb_offsx ag3rb_offsy ag3rb_dx ag3rb_dy ],... 
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'String','f',... 
    'ToolTipString','Amplitude values proportional to frequencies',... 
    'HorizontalAlignment','left',...
    'Style','radiobutton',... 
    'Tag','essd_uic_agrb(3)',... 
    'Value',0,...
    'UserData',''); 
  essd_uic_agrb(2) = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''essd'',''essd_uic_agrb(2)'',''essd_uic_agrb(2)'');',... 
    'Units','pixels',...
    'Position',[ ag2rb_offsx ag2rb_offsy ag2rb_dx ag2rb_dy ],... 
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'String','1/f',... 
    'ToolTipString','Amplitude values inversely proportional to frequencies',... 
    'HorizontalAlignment','left',...
    'Style','radiobutton',... 
    'Tag','essd_uic_agrb(2)',... 
    'Value',0,...
    'UserData',''); 
  essd_uic_agrb(1) = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''essd'',''essd_uic_agrb(1)'',''essd_uic_agrb(1)'');',... 
    'Units','pixels',...
    'Position',[ ag1rb_offsx ag1rb_offsy ag1rb_dx ag1rb_dy ],... 
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'String','Constant',... 
    'ToolTipString','Uniform amplitude values',... 
    'HorizontalAlignment','left',...
    'Style','radiobutton',... 
    'Tag','essd_uic_agrb(1)',... 
    'Value',1,...
    'UserData',''); 
  essd_uic_amphdtext = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ amphdtext_offsx amphdtext_offsy amphdtext_dx amphdtext_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','Amplitudes',... 
    'ToolTipString','Define amplitudes at selected frequencies',... 
    'HorizontalAlignment','center',...
    'Style','text',...
    'Tag','essd_uic_amphdtext',... 
    'UserData',''); 
  
  guititle(essd_uic_amphdtext);
  
  essd_uic_freqframe = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ freqframe_offsx freqframe_offsy freqframe_dx freqframe_dy ],... 
    'BackgroundColor',frame_bgr_col,...
    'ForegroundColor',frame_fg_col,...
    'String','Frequencies',... 
    'HorizontalAlignment','left',...
    'Style','frame',... 
    'Tag','essd_uic_freqframe',... 
    'Enable','off',... 
    'UserData',''); 
  essd_uic_fgrb(6) = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''essd'',''essd_uic_fgrb(6)'',''essd_uic_fgrb(6)'');',... 
    'Units','pixels',...
    'Position',[ fg6rb_offsx fg6rb_offsy fg6rb_dx fg6rb_dy ],... 
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'String','Randomized odd linear',...
    'ToolTipString','Randomized odd grid from DFT lines (about 1/3 of lines randomly dropped)',...
    'HorizontalAlignment','left',...
    'Style','radiobutton',... 
    'Tag','essd_uic_fgrb(6)',... 
    'Value',0,...
    'UserData','');
  essd_uic_fgrb(9) = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''essd'',''essd_uic_fgrb(9)'',''essd_uic_fgrb(9)'');',... 
    'Units','pixels',...
    'Position',[ fg9rb_offsx fg9rb_offsy fg9rb_dx fg9rb_dy ],... 
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'String','Quasilog',...
    'ToolTipString','Approximate logarithmic set from DFT grid',...
    'HorizontalAlignment','left',...
    'Style','radiobutton',... 
    'Tag','essd_uic_fgrb(9)',... 
    'Value',0,...
    'UserData','');
  essd_uic_fgrb(5) = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''essd'',''essd_uic_fgrb(5)'',''essd_uic_fgrb(5)'');',... 
    'Units','pixels',...
    'Position',[ fg5rb_offsx fg5rb_offsy fg5rb_dx fg5rb_dy ],... 
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'String','Matlab expression',... 
    'ToolTipString','Matlab expression of frequency vector. May contain fc or df. See Help on Object.',... 
    'HorizontalAlignment','left',...
    'Style','radiobutton',... 
    'Tag','essd_uic_fgrb(5)',... 
    'Value',0,...
    'UserData','');    
  essd_uic_fgrb(4) = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''essd'',''essd_uic_fgrb(4)'',''essd_uic_fgrb(4)'');',... 
    'Units','pixels',...
    'Position',[ fg4rb_offsx fg4rb_offsy fg4rb_dx fg4rb_dy ],... 
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'String','Import...',... 
    'ToolTipString','Import frequency vector from workspace',...
    'HorizontalAlignment','left',...
    'Style','radiobutton',... 
    'Tag','essd_uic_fgrb(4)',... 
    'Value',0,...
    'UserData','');
  essd_uic_fgrb(7) = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''essd'',''essd_uic_fgrb(7)'', ''essd_uic_fgrb(7)'');',... 
    'Units','pixels',...
    'Position',[ fg5rb_offsx fg5rb_offsy-23 fg5rb_dx fg5rb_dy ],... 
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'String','All DFT freqs',... 
    'ToolTipString', 'All DFT frequencies',...
    'HorizontalAlignment','left',...
    'Style','radiobutton',... 
    'Value',0,...
    'Tag','essd_uic_fgrb(7)',... 
    'UserData','');  
  essd_uic_fgrb(8) = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''essd'',''essd_uic_fgrb(8)'', ''essd_uic_fgrb(8)'');',... 
    'Units','pixels',...
    'Position',[ fg5rb_offsx fg5rb_offsy-46 fg5rb_dx fg5rb_dy ],... 
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'String','Most DFT freqs',... 
    'ToolTipString', 'All DFT frequencies except dc and fs/2',...
    'HorizontalAlignment','left',...
    'Style','radiobutton',... 
    'Value',0,...
    'Tag','essd_uic_fgrb(8)',... 
    'UserData','');  
  essd_uic_fgrb(3) = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''essd'',''essd_uic_fgrb(3)'',''essd_uic_fgrb(3)'');',... 
    'Units','pixels',...
    'Position',[ fg3rb_offsx fg3rb_offsy fg3rb_dx fg3rb_dy ],... 
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'String','Odd quasilog',...
    'ToolTipString','Approximate logarithmic set from odd DFT grid',...
    'HorizontalAlignment','left',...
    'Style','radiobutton',... 
    'Tag','essd_uic_fgrb(3)',... 
    'Value',0,...
    'UserData','');
  essd_uic_fgrb(2) = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''essd'',''essd_uic_fgrb(2)'',''essd_uic_fgrb(2)'');',... 
    'Units','pixels',...
    'Position',[ fg2rb_offsx fg2rb_offsy fg2rb_dx fg2rb_dy ],... 
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'String','Odd linear',... 
    'ToolTipString','Odd frequencies: (2*i+1)*df from DFT grid',...
    'HorizontalAlignment','left',...
    'Style','radiobutton',... 
    'Tag','essd_uic_fgrb(2)',... 
    'Value',0,...
    'UserData',''); 
  essd_uic_fgrb(1) = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''essd'',''essd_uic_fgrb(1)'',''essd_uic_fgrb(1)'');',... 
    'Units','pixels',...
    'Position',[ fg1rb_offsx fg1rb_offsy fg1rb_dx fg1rb_dy ],... 
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'String','Linear',... 
    'ToolTipString','Frequencies linearly distributed in DFT grid',...
    'HorizontalAlignment','left',...
    'Style','radiobutton',... 
    'Tag','essd_uic_fgrb(1)',... 
    'Value',1,...
    'UserData',''); 
  essd_uic_freqhdtext = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ freqhdtext_offsx freqhdtext_offsy freqhdtext_dx freqhdtext_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','Frequencies',... 
    'ToolTipString','Define vector of excited frequencies',...
    'HorizontalAlignment','center',...
    'Style','text',...
    'Tag','essd_uic_freqhdtext',... 
    'UserData',''); 
  
  guititle(essd_uic_freqhdtext);
  
  essd_uic_figrb(1) = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ fig1rb_offsx fig1rb_offsy fig1rb_dx fig1rb_dy ],... 
    'BackgroundColor',frame_bgr_col,...
    'ForegroundColor',frame_fg_col,...
    'String','hidden',... 
    'HorizontalAlignment','left',...
    'Style','frame',... 
    'Tag','essd_uic_figrb(1)',... 
    'Enable','off',... 
    'UserData',''); 
  essd_uic_figrb(2) = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ fig2rb_offsx fig2rb_offsy fig2rb_dx fig2rb_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','fmin = ',...
    'ToolTipString','Minimum frequency',...
    'HorizontalAlignment','right',...
    'Style','text',... 
    'Tag','essd_uic_figrb(2)',... 
    'UserData',''); 
  essd_uic_figrb(3) = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ fig3rb_offsx fig3rb_offsy fig3rb_dx fig3rb_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','fmax = ',... 
    'ToolTipString','Maximum frequency',...
    'HorizontalAlignment','right',...
    'Style','text',... 
    'Tag','essd_uic_figrb(3)',... 
    'UserData',''); 
  essd_uic_figrb(4) = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ fig4rb_offsx fig4rb_offsy fig4rb_dx fig4rb_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String',' = ',... 
    'ToolTipString','Number of frequencies',...
    'HorizontalAlignment','right',...
    'Style','text',... 
    'Tag','essd_uic_figrb(4)',... 
    'UserData',''); 
  essd_uic_figpopup(4) = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ fig4pm_offsx fig4pm_offsy fig4pm_dx fig4pm_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String',{'df','# of freqs','df/fmin','df/fmax'},...
    'value',1,...
    'CallBack','fdtool(''callback'',''essd'',''essd_uic_figpopup(4)'',''essd_uic_figpopup(4)'');',... 
    'ToolTipString','Form of defining the number of frequencies',...
    'HorizontalAlignment','right',...
    'Style','popupmenu',... 
    'Tag','essd_uic_figpopup(4)',... 
    'UserData','# of freqs');     
  essd_uic_figrb(5) = uicontrol(... 
    'Parent',fig,...
    'CallBack', 'fdtool(''callback'',''essd'', ''ui_edit'', ''essd_uic_figrb(5)'');',...
    'Units','pixels',...
    'Position',[ fig5rb_offsx fig5rb_offsy fig5rb_dx fig5rb_dy ],... 
    'BackgroundColor',edit_bgr_col,...
    'ForegroundColor',edit_fg_col,...
    'String','100',... 
    'ToolTipString','Minimum frequency',...
    'HorizontalAlignment','left',...
    'Style','edit',... 
    'Tag','essd_uic_figrb(5)',... 
    'UserData',''); 
  essd_uic_figrb(6) = uicontrol(... 
    'Parent',fig,...
    'CallBack', 'fdtool(''callback'',''essd'',''ui_edit'',''essd_uic_figrb(6)'');',...
    'Units','pixels',...
    'Position',[ fig6rb_offsx fig6rb_offsy fig6rb_dx fig6rb_dy ],... 
    'BackgroundColor',edit_bgr_col,...
    'ForegroundColor',edit_fg_col,...
    'String','1000',... 
    'ToolTipString','Maximum frequency',...
    'HorizontalAlignment','left',...
    'Style','edit',... 
    'Tag','essd_uic_figrb(6)',... 
    'UserData',''); 
  essd_uic_figrb(7) = uicontrol(... 
    'Parent',fig,...
    'CallBack', 'fdtool(''callback'',''essd'',''ui_edit'',''essd_uic_figrb(7)'');',...
    'Units','pixels',...
    'Position',[ fig7rb_offsx fig7rb_offsy fig7rb_dx fig7rb_dy ],... 
    'BackgroundColor',edit_bgr_col,...
    'ForegroundColor',edit_fg_col,...
    'String','19',... 
    'ToolTipString','Number of frequencies',...
    'HorizontalAlignment','left',...
    'Style','edit',... 
    'Tag','essd_uic_figrb(7)',... 
    'UserData',''); 
  essd_uic_figrb(8) = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ fig8rb_offsx fig8rb_offsy fig8rb_dx fig8rb_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','Pno = ',... 
    'ToolTipString','Number of periods in signal',...
    'HorizontalAlignment','right',...
    'Style','text',... 
    'Tag','essd_uic_figrb(8)',... 
    'UserData',''); 
  essd_uic_figrb(9) = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ fig9rb_offsx fig9rb_offsy fig9rb_dx fig9rb_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','',... 
    'ToolTipString','Number of periods in signal',...
    'HorizontalAlignment','left',...
    'Style','text',... 
    'Tag','essd_uic_figrb(9)',... 
    'UserData',''); 
  essd_uic_figrb(10) = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ fig10rb_offsx fig10rb_offsy fig10rb_dx fig10rb_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','Np = ',... 
    'ToolTipString','Period length in samples',...
    'HorizontalAlignment','right',...
    'Style','text',... 
    'Tag','essd_uic_figrb(10)',... 
    'UserData',''); 
  essd_uic_figrb(11) = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ fig11rb_offsx fig11rb_offsy fig11rb_dx fig11rb_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','',... 
    'ToolTipString','Period length in samples',...
    'HorizontalAlignment','left',...
    'Style','text',... 
    'Tag','essd_uic_figrb(11)',... 
    'UserData',''); 
  essd_uic_figrb(12) = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ fig12rb_offsx fig12rb_offsy fig12rb_dx fig12rb_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','dfp = ',...
    'ToolTipString','Frequency resolution of DFT of a period',...
    'HorizontalAlignment','right',...
    'Style','text',... 
    'Tag','essd_uic_figrb(12)',... 
    'UserData',''); 
  essd_uic_figrb(13) = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ fig13rb_offsx fig13rb_offsy fig13rb_dx fig13rb_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','',... 
    'ToolTipString','Frequency resolution of DFT of a period',...
    'HorizontalAlignment','left',...
    'Style','text',... 
    'Tag','essd_uic_figrb(13)',... 
    'UserData',''); 
  essd_uic_figrb(14) = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ fig14rb_offsx fig14rb_offsy fig14rb_dx fig14rb_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','Tr = ',... 
    'ToolTipString','Record length',...
    'HorizontalAlignment','right',...
    'Style','text',... 
    'Tag','essd_uic_figrb(14)',... 
    'UserData',''); 
  essd_uic_figrb(15) = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ fig15rb_offsx fig15rb_offsy fig15rb_dx fig15rb_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','',... 
    'ToolTipString','Record length',...
    'HorizontalAlignment','left',...
    'Style','text',... 
    'Tag','essd_uic_figrb(15)',... 
    'UserData',''); 
  essd_uic_figrb(16) = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ fig16rb_offsx fig16rb_offsy fig16rb_dx fig16rb_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','Bit freq. = ',... 
    'ToolTipString','Clock frequency of shift register',...
    'HorizontalAlignment','right',...
    'Style','text',... 
    'enable', 'off', ...
    'Tag','essd_uic_figrb(16)',... 
    'UserData',''); 
  essd_uic_figrb(17) = uicontrol(... 
    'Parent',fig,...
    'CallBack', 'fdtool(''callback'',''essd'',''ui_edit'',''essd_uic_figrb(17)'');',...
    'Units','pixels',...
    'Position',[ fig17rb_offsx fig17rb_offsy fig17rb_dx fig17rb_dy ],... 
    'BackgroundColor',edit_bgr_col,...
    'ForegroundColor',edit_fg_col,...
    'String','1024',... 
    'ToolTipString','Clock frequency of the shift register',...
    'HorizontalAlignment','left',...
    'Style','edit',... 
    'enable', 'off', ...
    'Tag','essd_uic_figrb(17)',... 
    'UserData',''); 
  essd_uic_figrb(18) = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ fig18rb_offsx fig18rb_offsy fig18rb_dx fig18rb_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','log2(Np+1) = ',... 
    'ToolTipString','Shift register length, for MLBS only',...
    'HorizontalAlignment','right',...
    'Style','text',... 
    'enable', 'off', ...
    'Tag','essd_uic_figrb(18)',... 
    'UserData',''); 
  essd_uic_figrb(19) = uicontrol(... 
    'Parent',fig,...
    'CallBack', 'fdtool(''callback'',''essd'',''ui_edit'',''essd_uic_figrb(19)'');',...
    'Units','pixels',...
    'Position',[ fig19rb_offsx fig19rb_offsy fig19rb_dx fig19rb_dy ],... 
    'BackgroundColor',edit_bgr_col,...
    'ForegroundColor',edit_fg_col,...
    'String','8',... 
    'ToolTipString','Shift register length, for MLBS only',...
    'HorizontalAlignment','left',...
    'Style','edit',... 
    'enable', 'off', ...
    'Tag','essd_uic_figrb(19)',... 
    'UserData',''); 
  essd_uic_figrb(22) = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ fig22rb_offsx fig22rb_offsy fig22rb_dx fig22rb_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','Hz',... 
    'HorizontalAlignment','left',...
    'Style','text',... 
    'Tag','essd_uic_figrb(22)',... 
    'UserData',''); 
  essd_uic_figrb(23) = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ fig23rb_offsx fig23rb_offsy fig23rb_dx fig23rb_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','Hz',... 
    'HorizontalAlignment','left',...
    'Style','text',... 
    'Tag','essd_uic_figrb(23)',... 
    'UserData',''); 
  essd_uic_figrb(24) = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ fig24rb_offsx fig24rb_offsy fig24rb_dx fig24rb_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','',... 
    'HorizontalAlignment','left',...
    'Style','text',... 
    'Tag','essd_uic_figrb(24)',... 
    'UserData',''); 
  essd_uic_figrb(25) = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ fig25rb_offsx fig25rb_offsy fig25rb_dx fig25rb_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','s',... 
    'HorizontalAlignment','left',...
    'Style','text',... 
    'Tag','essd_uic_figrb(25)',... 
    'UserData',''); 
  essd_uic_figrb(26) = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ fig26rb_offsx fig26rb_offsy fig26rb_dx fig26rb_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','Hz',... 
    'HorizontalAlignment','left',...
    'Style','text',... 
    'Tag','essd_uic_figrb(26)',... 
    'UserData','');    
  essd_uic_figrb(27) = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ fig27rb_offsx fig27rb_offsy fig27rb_dx fig27rb_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','Hz',... 
    'HorizontalAlignment','left',...
    'Style','text',... 
    'Tag','essd_uic_figrb(27)',... 
    'UserData','');    
  essd_uic_figrb(28) = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ fig28rb_offsx fig28rb_offsy fig28rb_dx fig28rb_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','Hz',... 
    'HorizontalAlignment','left',...
    'Style','text',... 
    'Tag','essd_uic_figrb(28)',... 
    'UserData',''); 
  essd_uic_parhdtext = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ parhdtext_offsx parhdtext_offsy parhdtext_dx parhdtext_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','Parameters',... 
    'ToolTipString','Parameters',...
    'HorizontalAlignment','center',...
    'Style','text',...
    'Tag','essd_uic_parhdtext',... 
    'UserData',''); 
  
  guititle(essd_uic_parhdtext);
  
  %   essd_uic_figrb(22) = uicontrol(... 
  %      'Parent',fig,...
  %      'CallBack','fdtool(''callback'',''essd'',''essd_uic_figrb(22)'',num2str(get(findall(0,''tag'', ''essd_uic_figrb(22)''),''value'')),''essd_uic_figrb(22)'');',... 
  %      'Units','pixels',...
  %      'Position',[ fig22rb_offsx fig22rb_offsy fig22rb_dx fig22rb_dy ],... 
  %      'BackgroundColor',checkb_bgr_col,...
  %      'ForegroundColor',checkb_fg_col,...
  %      'String','Inverse Repeat',... 
  %      'HorizontalAlignment','left',...
  %      'Style','checkbox',...
  %      'enable','off',...
  %      'Tag','essd_uic_figrb(22)',... 
  %      'UserData',''); 
  %   essd_uic_figrb(23) = uicontrol(... 
  %      'Parent',fig,...
  %      'CallBack','fdtool(''callback'',''essd'',''essd_uic_figrb(23)'',num2str(get(findall(0,''tag'', ''essd_uic_figrb(23)''),''value'')),''essd_uic_figrb(23)'');',... 
  %      'Units','pixels',...
  %      'Position',[ fig22rb_offsx fig22rb_offsy-20 fig22rb_dx fig22rb_dy ],... 
  %      'BackgroundColor',checkb_bgr_col,...
  %      'ForegroundColor',checkb_fg_col,...
  %      'String','Adjust',... 
  %      'ToolTipString','Adjust frequencies (or signal samples for MLBS) to DFT grid',...
  %      'HorizontalAlignment','left',...
  %      'Style','checkbox',... 
  %      'Value', 1, ...
  %      'Tag','essd_uic_figrb(23)',... 
  %      'UserData',''); 
  essd_uic_ncframe = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ ncframe_offsx ncframe_offsy ncframe_dx ncframe_dy ],... 
    'BackgroundColor',frame_bgr_col,...
    'ForegroundColor',frame_fg_col,...
    'String','ncframe',... 
    'HorizontalAlignment','left',...
    'Style','frame',... 
    'Tag','essd_uic_ncframe',... 
    'Enable','off',... 
    'UserData',''); 
  essd_uic_cftext = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ cftext_offsx cftext_offsy cftext_dx cftext_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','Clock frequency',... 
    'ToolTipString','Clock frequency of the signal generator (rate of samples sent to the DAC)',...
    'HorizontalAlignment','left',...
    'Style','text',... 
    'Tag','essd_uic_cftext',... 
    'UserData',''); 
  essd_uic_hztext = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ hztext_offsx hztext_offsy hztext_dx hztext_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String',' Hz',... 
    'ToolTipString','Clock frequency of the signal generator (rate of samples sent to the DAC)',...
    'HorizontalAlignment','right',...
    'Style','text',... 
    'Tag','essd_uic_hztext',... 
    'UserData',''); 
  essd_uic_cfedit = uicontrol(... 
    'Parent',fig,...
    'CallBack', 'fdtool(''callback'',''essd'',''ui_edit'',''essd_uic_cfedit'');',...
    'Units','pixels',...
    'Position',[ cfedit_offsx cfedit_offsy cfedit_dx cfedit_dy ],... 
    'BackgroundColor',edit_bgr_col,...
    'ForegroundColor',edit_fg_col,...
    'String','2048',... 
    'ToolTipString','Clock frequency of the signal generator (rate of samples sent to the DAC)',...
    'HorizontalAlignment','right',...
    'Style','edit',... 
    'Tag','essd_uic_cfedit',... 
    'UserData',''); 
  essd_uic_nsstext = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ nsstext_offsx nsstext_offsy nsstext_dx nsstext_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','Number of samples',... 
    'ToolTipString','Number of signal samples (without repetitions)',... 
    'HorizontalAlignment','left',...
    'Style','text',... 
    'Tag','essd_uic_nsstext',... 
    'UserData',''); 
  essd_uic_ssedit = uicontrol(... 
    'Parent',fig,...
    'CallBack', 'fdtool(''callback'',''essd'',''ui_edit'',''essd_uic_ssedit'');',...
    'Units','pixels',...
    'Position',[ ssedit_offsx ssedit_offsy ssedit_dx ssedit_dy ],... 
    'BackgroundColor',edit_bgr_col,...
    'ForegroundColor',edit_fg_col,...
    'String','512',... 
    'ToolTipString','Number of signal samples (without repetitions)',... 
    'HorizontalAlignment','right',...
    'Style','edit',... 
    'Tag','essd_uic_ssedit',... 
    'UserData',''); 
  essd_uic_gentypetext = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ gentypetext_offsx gentypetext_offsy gentypetext_dx gentypetext_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','Generator Type',...
    'tooltipstring','Type of generator which will produce signal (precompensation may be necessary)',...
    'HorizontalAlignment','left',...
    'Style','text',... 
    'Tag','essd_uic_gentypetext',... 
    'UserData',''); 
  essd_uic_genpop = uicontrol(... 
    'Parent',fig,...
    'CallBack', 'fdtool(''callback'', ''essd'', ''essd_uic_genpop'', ''essd_uic_genpop'')',...
    'Units','pixels',...
    'Position',[ genpop_offsx genpop_offsy genpop_dx genpop_dy ],... 
    'BackgroundColor',popup_bgr_col,...
    'ForegroundColor',popup_fg_col,...
    'String',{''},... 
    'tooltipstring','Type of generator which will produce signal (precompensation may be necessary)',...
    'HorizontalAlignment','right',...
    'Style','popupmenu',... 
    'Tag','essd_uic_genpop',... 
    'Min',[ 1 ],... 
    'Value',[ 1 ],... 
    'UserData','');
  essd('setgenpop')
  %
  essd_uic_recfilttext = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ recfilttext_offsx recfilttext_offsy recfilttext_dx recfilttext_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','Smoothing Filter',... 
    'ToolTipString','Lowpass filter which smoothes DAC output',...
    'HorizontalAlignment','left',...
    'Style','text',...
    'Tag','essd_uic_recfilttext',... 
    'UserData','');
  essd_uic_recfiltrb(1) = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''essd'',''essd_uic_recfiltrb(1)'',''essd_uic_recfiltrb(1)'');',... 
    'Units','pixels',...
    'Position',[ recfiltrb1_offsx recfiltrb1_offsy recfiltrb1_dx recfiltrb1_dy ],... 
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'String','on',... 
    'ToolTipString','Lowpass filter which smoothes DAC output will be applied',...
    'HorizontalAlignment','left',...
    'Style','radiobutton',... 
    'Tag','essd_uic_recfiltrb(1)',... 
    'Value',0,...
    'UserData','');
  essd_uic_recfiltrb(2) = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''essd'',''essd_uic_recfiltrb(2)'',''essd_uic_recfiltrb(2)'');',... 
    'Units','pixels',...
    'Position',[ recfiltrb2_offsx recfiltrb2_offsy recfiltrb2_dx recfiltrb2_dy ],... 
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'String','off',... 
    'ToolTipString','DAC output will be applied without smoothing',...
    'HorizontalAlignment','left',...
    'Style','radiobutton',... 
    'Tag','essd_uic_recfiltrb(2)',... 
    'Value',1,...
    'UserData',''); 
  essd_uic_mainhdtext = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ mainhdtext_offsx mainhdtext_offsy mainhdtext_dx mainhdtext_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','Generator',... 
    'HorizontalAlignment','center',...
    'Style','text',...
    'Tag','essd_uic_mainhdtext',... 
    'UserData',''); 
  
  guititle(essd_uic_mainhdtext);
  
  
  essd_uic_rbframe = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ rbframe_offsx rbframe_offsy rbframe_dx rbframe_dy ],... 
    'BackgroundColor',frame_bgr_col,...
    'ForegroundColor',frame_fg_col,...
    'String','rbframe',... 
    'HorizontalAlignment','left',...
    'Style','frame',... 
    'Tag','essd_uic_rbframe',... 
    'Enable','off',... 
    'UserData','');    
  essd_uic_rbhdtext = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ rbhdtext_offsx rbhdtext_offsy rbhdtext_dx rbhdtext_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','Excitation',... 
    'HorizontalAlignment','center',...
    'Style','text',...
    'Tag','essd_uic_rbhdtext',... 
    'UserData',''); 
  
  guititle(essd_uic_rbhdtext);
  
  essd_uic_stsgrb(1) = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''essd'',''essd_uic_stsgrb(1)'',''essd_uic_stsgrb(1)'');',... 
    'Units','pixels',...
    'Position',[ stsg1rb_offsx stsg1rb_offsy stsg1rb_dx stsg1rb_dy ],... 
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'String','Multisine',... 
    'ToolTipString','Sum of harmonically related sinusoids',...
    'HorizontalAlignment','left',...
    'Style','radiobutton',... 
    'Tag','essd_uic_stsgrb(1)',... 
    'Value',1,...
    'UserData',''); 
  essd_uic_stsgrb(2) = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''essd'',''essd_uic_stsgrb(2)'',''essd_uic_stsgrb(2)'');',... 
    'Units','pixels',...
    'Position',[ stsg2rb_offsx stsg2rb_offsy stsg2rb_dx stsg2rb_dy ],... 
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'String','DIBS',... 
    'ToolTipString','Discrete Interval Binary Sequence',...
    'HorizontalAlignment','left',...
    'Style','radiobutton',... 
    'Tag','essd_uic_stsgrb(2)',... 
    'Value',0,...
    'UserData',''); 
  essd_uic_stsgrb(4) = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''essd'',''essd_uic_stsgrb(4)'',''essd_uic_stsgrb(4)'');',... 
    'Units','pixels',...
    'Position',[ stsg4rb_offsx stsg4rb_offsy stsg4rb_dx stsg4rb_dy ],... 
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'String','DITS',... 
    'ToolTipString','Discrete Interval Three-level (Ternary) Sequence',...
    'HorizontalAlignment','left',...
    'Style','radiobutton',... 
    'Tag','essd_uic_stsgrb(4)',... 
    'Value',0,...
    'UserData',''); 
  essd_uic_stsgrb(3) = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''essd'',''essd_uic_stsgrb(3)'',''essd_uic_stsgrb(3)'');',... 
    'Units','pixels',...
    'Position',[ stsg3rb_offsx stsg3rb_offsy stsg3rb_dx stsg3rb_dy ],... 
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'String','PRBS',... 
    'min',0,...
    'max',1,...
    'ToolTipString','Pseudo Random Binary Sequence (Maximum Length Binary Sequence)',...
    'HorizontalAlignment','left',...
    'Style','radiobutton',... 
    'Tag','essd_uic_stsgrb(3)',... 
    'Value',0,...
    'UserData',''); 
  
  essd_uic_stsgrb4_singleexp = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''essd'',''essd_uic_stsgrb(4)_singleexp'',''essd_uic_stsgrb(4)_singleexp'');',... 
    'Units','pixels',...
    'Position',[ stsg4rb_offsx stsg4rb_offsy+0 stsg4rb_dx*2 stsg4rb_dy ],... 
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'String','Fast single-experiment',... 
    'ToolTipString','Single experiment with nonexcited lines',...
    'HorizontalAlignment','left',...
    'Style','radiobutton',... 
    'Tag','essd_uic_stsgrb(4)_singleexp',... 
    'visible','on',...
    'Value',0,...
    'UserData','essd_uic_stsgrb_exp'); 
  essd_uic_stsgrb3_multiexp = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''essd'',''essd_uic_stsgrb(3)_multiexp'',''essd_uic_stsgrb(3)_multiexp'');',... 
    'Units','pixels',...
    'Position',[ stsg3rb_offsx stsg3rb_offsy+2 stsg3rb_dx*2 stsg3rb_dy ],... 
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'String','Robust multi-experiment',... 
    'ToolTipString','Several experiments with random phase multisines',...
    'HorizontalAlignment','left',...
    'Style','radiobutton',... 
    'Tag','essd_uic_stsgrb(3)_multiexp',... 
    'Value',1,...
    'visible','on',...
    'UserData','essd_uic_stsgrb_exp'); 
  
  essd_uic_startpop = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''essd'',''essd_uic_startpop'',''essd_uic_startpop'');',... 
    'Units','pixels',...
    'Position',[ startpop_offsx startpop_offsy startpop_dx startpop_dy ],... 
    'BackgroundColor',popup_bgr_col,...
    'ForegroundColor',popup_fg_col,...
    'String',{'Random','Fixed','Schroeder'},... 
    'ToolTipString','Way of setting the starting phases for the iteration',...
    'HorizontalAlignment','left',...
    'Style','popupmenu',... 
    'Tag','essd_uic_startpop',... 
    'Value',1,...
    'UserData',''); 
  essd_uic_starttext = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ starttext_offsx starttext_offsy starttext_dx starttext_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','Starting phases',... 
    'ToolTipString','Way of setting the starting phases for the iteration',...
    'HorizontalAlignment','left',...
    'Style','text',...
    'Tag','essd_uic_starttext',... 
    'UserData','');
  essd_uic_iteredit = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''essd'',''ui_edit'',''essd_uic_iteredit'');',... 
    'Units','pixels',...
    'Position',[ iteredit_offsx iteredit_offsy iteredit_dx iteredit_dy ],... 
    'BackgroundColor',popup_bgr_col,...
    'ForegroundColor',popup_fg_col,...
    'String','200',... 
    'ToolTipString','Number of iterations',...
    'HorizontalAlignment','right',...
    'Style','edit',... 
    'Tag','essd_uic_iteredit',... 
    'UserData',''); 
  essd_uic_itertext = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ itertext_offsx itertext_offsy itertext_dx itertext_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','Iters:',... 
    'ToolTipString','Number of iterations',...
    'HorizontalAlignment','left',...
    'Style','text',...
    'Tag','essd_uic_itertext',... 
    'UserData','');
  essd_uic_stateedit = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''essd'',''ui_edit'',''essd_uic_stateedit'');',... 
    'Units','pixels',...
    'Position',[ stateedit_offsx stateedit_offsy stateedit_dx stateedit_dy ],... 
    'BackgroundColor',popup_bgr_col,...
    'ForegroundColor',popup_fg_col,...
    'String','0',... 
    'ToolTipString','Initial state of the random generator',...
    'HorizontalAlignment','right',...
    'Style','edit',... 
    'Tag','essd_uic_stateedit',... 
    'UserData',''); 
  essd_uic_statetext = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ statetext_offsx statetext_offsy statetext_dx statetext_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','Init:',... 
    'ToolTipString','Initial state of the random generator',...
    'HorizontalAlignment','left',...
    'Style','text',...
    'Tag','essd_uic_statetext',... 
    'UserData','');
  essd_uic_statusframe = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ statusframe_offsx statusframe_offsy statusframe_dx statusframe_dy ],... 
    'BackgroundColor',frame_bgr_col,...
    'ForegroundColor',frame_fg_col,...
    'String','statusframe',... 
    'HorizontalAlignment','left',...
    'Style','frame',... 
    'Tag','essd_uic_statusframe',... 
    'Enable','off',... 
    'UserData',''); 
  essd_uic_statustext = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ statustext_offsx statustext_offsy statustext_dx statustext_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','',... 
    'HorizontalAlignment','left',...
    'Style','text',...
    'Tag','essd_uic_statustext',... 
    'UserData',''); 
  
  %  Menu Object Creation 
  
  %  Axes and Text Object Creation
  
    for ii=1:length(essd_uic_recfiltrb)
      set(essd_uic_recfiltrb(ii), 'UserData', 'essd_uic_recfiltrb');
    end
    for ii=1:length(essd_uic_figrb)
      if all(ii~=[20,21]), set(essd_uic_figrb(ii),'UserData', 'essd_uic_figrb'); end
    end
    for ii=1:length(essd_uic_stsgrb)
      set(essd_uic_stsgrb(ii), 'UserData', 'essd_uic_stsgrb');
    end
    for ii=1:length(essd_uic_fgrb)
      set(essd_uic_fgrb(ii),   'UserData', 'essd_uic_fgrb');
    end
    for ii=1:length(essd_uic_agrb)
      set(essd_uic_agrb(ii),   'UserData', 'essd_uic_agrb');
    end

  
  % init help fcns
  helpmgr('init_help', '', myfcn, myfig );
  
  guimenus('excitation_main','excitation','essd');
  if nargin >1 
    storewin('restore_all', Me, p2) % bring up window with settings in p2
  else
    storewin('recover', Me); % restore previous settings if any
    essd('setgenpop')
    set(findall(0, 'tag', 'essd_uic_fgrb(6)'),'string','Randomized odd linear')
    set(findall(0, 'tag', 'essd_uic_fgrb(9)'),'string','Quasilog')
    set(findall(0, 'tag', 'essd_uic_fgrb(3)'),'string','Randomized odd quasilog')
  end
  intoscr({'excitation_main'});
  % The above function, intoscr positions the windows given by their labels
  % into the actual screen. This might come handy when the session has been saved 
  % on a machine with different resolution than that of the present machine.
  
  if strncmpi(guiinfos('modeltype'),'Nonlinear errors',4)
    if get(findobj(myfig, 'tag', 'essd_uic_stsgrb(4)_singleexp'),'value')
      set(findobj(myfig, 'tag','essd_uic_repedit'),'String','7')
      set(findobj(myfig, 'tag','essd_uic_expedit'),'String','1')       
    elseif get(findobj(myfig, 'tag', 'essd_uic_stsgrb(3)_multiexp'),'value')
      set(findobj(myfig, 'tag','essd_uic_repedit'),'String','2')
      set(findobj(myfig, 'tag','essd_uic_expedit'),'String','7')
    end
  end
  if get(essd_uic_stsgrb(3), 'value')
    essd('essd_mod_stsgrb(3)')
  elseif get(essd_uic_stsgrb(2), 'value')
    essd('essd_mod_stsgrb(2)')
  elseif get(essd_uic_stsgrb(4), 'value')
    essd('essd_mod_stsgrb(4)')
  elseif get(essd_uic_stsgrb(1), 'value')
    essd('essd_mod_stsgrb(1)') %multisine
  end
  
  IterSetEnable(myfig) % set iteration number controls' enable property
  if isempty(guidtard(Me, 'OUTPUT_DATA'))
    closeenable(myfig, 'off')
  end
  ulevctrl(Me);
  essd('essd_uic_figpopup(4)') %type of freqs
  essd('essd_uic_adjustpb')
  set(fig,'visible','on'); 
  winmenu(myfig);
  essd('status', 'Ready.')
  
  % instructions not changing VIEW data
elseif strcmp(p1,'essd_uic_figpopup(4)') %nftype: df, freqs, etc.
  c=allchild(myfig);
  hfntype=findobj(c, 'flat', 'tag','essd_uic_figpopup(4)');
  hHz=findobj(allchild(myfig),'flat','tag','essd_uic_figrb(28)');
  prev=get(hfntype,'userdata');
  if isempty(prev), prev='df'; end
  set(hfntype,'userdata',popupstr(hfntype)) %store actual value
  hfnedit=findobj(c,'flat','tag','essd_uic_figrb(7)');
  fnval=str2num(get(hfnedit,'string'));
  fnnew=setfn(prev,fnval,fmin,fmax);
  fntype=popupstr(hfntype);
  hnF=[findobj(allchild(myfig),'flat','tag','essd_uic_figrb(4)');
    findobj(allchild(myfig),'flat','tag','essd_uic_figrb(7)')];
  set(hHz,'visible','off')
  if strcmp(fntype,'df')
    set(hHz,'visible','on')
    set(hnF,'tooltipstring','Average frequency resolution')  
  elseif strcmp(fntype,'# of freqs')
    set(hnF,'tooltipstring','Number of frequencies')  
  elseif strcmp(fntype,'df/fmin')
    set(hnF,'tooltipstring','Frequency resolution relative to fmin')  
  elseif strcmp(fntype,'df/fmax')
    set(hnF,'tooltipstring','Frequency resolution relative to fmax')  
  elseif strcmp(fntype,'df/f')
    set(hnF,'tooltipstring','Relative frequency resolution')  
  elseif strcmp(fntype,'Nf/oct')
    set(hnF,'tooltipstring','Number of frequencies in an octave')  
  elseif strcmp(fntype,'Nf/dec')
    set(hnF,'tooltipstring','Number of frequencies in a decade')  
  end
  %
  fnvalstr=prepfnval(fntype,fnnew,fmin,fmax);
  set(hfnedit,'string',fnvalstr)
  
elseif strcmp(p1,'status')
  c=allchild(myfig);
  status=findobj(c, 'flat', 'tag','essd_uic_statustext');
  statusfr=findobj(c, 'flat', 'tag','essd_uic_statusframe');
  glstatus(myfig, status, statusfr, p2)
  
elseif strcmp(p1, 'mouse_motion')   
  guiready(myfig, 'essd')
  
  
elseif strcmp(p1,'essd_uic_viewpb')|strcmp(p1,'essd_mod_viewpb')
  %'View spectrum' pushed
  essd('status', 'View spectrum in progress...')
  guifreez(Me, 'freeze', 'essd_view_spectrum');
  errmsg='Dummy errmsg'; errmsgold='';
  while ~isempty(errmsg)&~strcmp(errmsg,errmsgold)
    errmsgold=errmsg;
    [freqvect,errmsg,parameters,ampvect,xt]=getfv(myfig);
    if isempty(parameters)
      try
        essd('essd_uic_adjustpb')
      catch
        essd('essd_uic_adjustpbn')
      end
    end
    if ~isempty(errmsg)
      essd('status',errmsg)
      if findstr('error',lower(errmsg))
        guifreez(Me, 'unfreeze', 'essd_view_spectrum');
        return
      end
    end
  end %while
  if isempty(errmsg)
    essd('status','View spectrum is in progress')
  elseif any(findstr(lower(errmsg),'error'))
    guifreez(Me, 'unfreeze', 'essd_view_spectrum');
    return
  else %msg was already shown in the status line
    %essd('status',errmsg)
    guifreez(Me, 'unfreeze', 'essd_view_spectrum');
    %return
  end
  %
  fmin=parameters.fmin;
  fmax=parameters.fmax;
  dfi=parameters.dfi;
  fc=parameters.fc;
  stepfreq=parameters.stepfreq;
  F=parameters.F;
  N=parameters.N;
  periodno=parameters.periodno;
  type_str=parameters.type_str;
  cx=parameters.cx;
  %
  %Now plotting of amplitudes follows
  h=findall(0, 'type','figure','tag', 'amplitude_spectrum');
  if isempty(h)
    [pos,units]=getfpos;
    h=figure(1); drawnow
    set(h,'Units',units, 'position',pos,'name', 'Amplitude Spectrum Shape', ...
      'numbertitle', 'off','tag', 'amplitude_spectrum');
    if ~strncmp('5.2',version,3), set(h,'toolbar','none'); end
    %zoom on
  end
  axh=findobj(h, 'type', 'axes'); delete(axh);
  figure(h); pause(0) 
  axh=axes('position',[0.13 0.11 0.775 0.815],'parent',h);
  plot([freqvect;-1], [ampvect;-1],'+b','parent',axh)
  mampl=max([ampvect;0]); ax=zeros(1,4);
  ax(3)=0; ax(4)=mampl*1.05;
  ax(1)=0; ax(2)=max([freqvect;0])*1.05;
  if ax(2)==ax(1), ax(1:2)=ax(1)+1e-6*[-1,1]; end
  if ax(4)==ax(3), ax(3:4)=ax(3)+1e-6*[-1,1]; end
  set(axh,'xlim',ax(1:2),'ylim',ax(3:4))  
  set(get(axh,'xlabel'),'string',...
    sprintf('Frequencies, F=%.0f,   dfi=%.4g Hz,   fc= %.4g Hz',F,dfi,fc))
  set(get(axh,'title'),'string','Desired amplitudes vs. frequency')
  dismispb('amplitude_spectrum')
  zoom(h,'on')
  %
  if get(findobj(allchild(myfig),'tag','essd_uic_recfiltrb(2)'),'value')
    %Smoothing filter off
    chm='ZOH';
  elseif strcmp(popupstr(findobj(allchild(myfig),'tag','essd_uic_genpop')),'Filtered DAC')
    chm='ZOHf';
  else
    chm='BL';
  end
  data=tiddata([],xt,1/fc);
  pl=N/fc;
  df=dfcalc([freqvect(:)]);
  if 1/df<0.6*pl, pl=1/df; end
  set(data,'frequencies',freqvect,'periodlength',pl)
  if ~isempty(xt)
    set(data,'inputchar',chm)
  end
  viewdata.data=data;
  viewdata.ampvect=ampvect;
  viewdata.type_str=type_str;
  viewdata.fc=fc;
  viewdata.stepfreq=stepfreq;
  viewdata.N=N;
  viewdata.cx=cx;
  viewdata.info='Generated by ''View Spectrum''';
  guidtawr(Me, 'DATA_VIEW', 'direct', viewdata)
  ok=1;
  guifreez(Me, 'unfreeze', 'essd_view_spectrum');
  essd('status', 'View spectrum finished.')
  
elseif strcmp(p1,'essd_uic_designpb')|strcmp(p1,'essd_mod_designpb')
  guifreez(Me, 'freeze', 'essd_design');
  viewdata=guidtard(Me, 'DATA_VIEW');
  if isempty(viewdata)
    essd('essd_mod_viewpb'); % call view if necessary
    viewdata=guidtard(Me, 'DATA_VIEW');
    if isempty(viewdata)  % possibly error during view process
      guifreez(Me, 'unfreeze', 'essd_design');
      return
    end
  end
  h=findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_stsgrb(3)');
  if get(h, 'value') % MLBS -> calculate
    essd('status', 'Calculating...')
  else % MS, DIBS -> Iterate
    essd('status', 'Iterating... Use the ''Iteration'' menu in the ''Signal Shape'' window to control iteration.')
  end
  ampvect=viewdata.ampvect;
  if isa(viewdata.data,'tiddata')
    freqvect=viewdata.data.frequencies;
    fc=1/viewdata.data.ts;
    xt=viewdata.data.input;
    pl=viewdata.data.periodlength;
    if isempty(pl)
      if ~isempty(freqvect), pl=dfcalc(freqvect);
      else pl=viewdata.data.samplen*viewdata.data.ts;
      end
    end
  else
    freqvect=viewdata.data.freqvect;
    fc=viewdata.data.fs;
    xt=viewdata.data.u;
    pl=viewdata.data.periodlength;
  end
  type_str=viewdata.type_str;
  N=viewdata.N;
  stepfreq=viewdata.stepfreq;
  cx=viewdata.cx;
  periodno=N/fc/pl;
  %periodno=1;
  
  c=get(myfig,'children');   
  h=findobj(c, 'flat', 'userdata', 'essd_uic_fgrb', 'value',1);
  freqdist_str=get(h,'string');
  if findstr(lower(freqdist_str),'odd') & strcmp(lower(type_str), 'prbs')
    lengthmod=2; %Only for mlbs
  else lengthmod=1;
  end
  
  h=findall(0, 'tag', 'signal_shape');
  if isempty(h)
    [pos,units]=getfpos;
    h=figure('Units',units, 'position',pos,...
      'name','Signal Shape','numbertitle','off','tag','signal_shape');
    if ~strncmp('5.2',version,3), set(h,'toolbar','none'); end
  end
  figure(h);
  axh=findobj(h, 'type', 'axes'); delete(axh);
  hexp=findobj(c, 'flat','tag','essd_uic_expedit');
  expno=str2num(get(hexp,'string'));
  hrep=findobj(c, 'flat','tag','essd_uic_repedit');
  repno=str2num(get(hrep,'string'));
  samepower=0;
  switch lower(type_str)
    case 'multisine'
      clf
      iterctrl('initialize',h);
      if ~guiinfos('islinear')|~isequal(expno,1), itno=0; 
      elseif guirecrd('gettestmode')==2, itno=2;
      else
        itno=str2num(get(findobj(myfig,'tag','essd_uic_iteredit'),'string'));
      end
      %
      hrf=findobj(c, 'flat', 'tag', 'essd_uic_recfiltrb(1)'); %Smoothing filter on
      reconstruction_filter=get(hrf,'value');
      hrg=findobj(c, 'flat', 'tag', 'essd_uic_genpop'); %Generator
      gentype=popupstr(hrg);
      if strcmp(lower(gentype),'interpolator')
        runmod.crestmode='BL';
        dev='screen';
      elseif any(findstr(lower(gentype),'discrete'))
        runmod.crestmode='discrete';
        dev='screen';
      else
        if reconstruction_filter
          runmod.crestmode='fDAC';
        else
          runmod.crestmode='ZOH';
        end
        dev='DAC';
      end
      if ~isempty(itno)
        runmod.itno=itno; if itno==0, samepower=1; end
      end
      if ~isempty(N), runmod.N=N; end
      if strcmp('on',get(findobj(myfig,'tag','excitation_menu_plots_rare'),'checked'))
        %runmod.graphs='lastgraph';
        runmod.plottime=10;
      end
      %
      h=findobj(c,'flat','tag','essd_uic_startpop');
      str=popupstr(h);
      xt=[];
      for ii=1:expno
        if strcmpi(str,'Random')
          ampvect=ampvect.*exp(j*2*pi*rand(size(ampvect)));
          runmod.initset='input';
        elseif strcmpi(str,'Fixed')
          state=str2num(get(findobj(c,'flat','tag','essd_uic_stateedit'),'string'));
          state0=rand('state'); rand('state',state);
          ampvect=ampvect.*exp(j*2*pi*rand(size(ampvect)));
          rand('state',state0);
          runmod.initset='input'; samepower=0;
        else
          runmod.initset='Schroeder'; samepower=0;
				end
				runmod.showmsgs='no';
				signal=msinclip(fiddata([],ampvect,freqvect),runmod);
        cx=signal.u;
        iterctrl('delete',h);    
        if any(cx)
          xtii=msinprep(freqvect, cx, N, fc, dev);
          cx=cx/N;
        else
          %error('Empty output of msinclip')
          cx=[]; xtii=[];
        end
        xt=[xt,xtii];
      end %for ii
    case 'dibs'
      clf
      iterctrl('initialize',h);      
      if ~isequal(expno,1), trialno=1; runmod.cyclemax=1; 
      elseif guirecrd('gettestmode')==2, trialno=2;
      else
        trialno=str2num(get(findobj(myfig,'tag','essd_uic_iteredit'),'string'));
      end
      %xt=dibs(N, 1/fc, freqvect, ampvect,trialno);
      runmod.trialno=trialno;
      c=allchild(myfig);
      hod=findobj(c, 'flat','tag','essd_uic_fgrb(2)'); %odd
      rmv='';
      if isequal(get(hod,'value'),1), rmv='odd';
      end
      runmod.type=rmv;
      h=findobj(c,'flat','tag','essd_uic_startpop');
      str=popupstr(h);
      if strcmpi(str,'Fixed')
        state=str2num(get(findobj(c,'flat','tag','essd_uic_stateedit'),'string'));
        runmod.state=state;
      end
      if strcmp('on',get(findobj(myfig,'tag','excitation_menu_plots_rare'),'checked'))
        runmod.graphmod='raregraph';
      end
      xt=[];
      for ii=1:expno
        xto=dibs(fiddata([],ampvect,freqvect),N,fc,runmod);
        xt=[xt,xto.data];
      end
      iterctrl('delete',h);    
    case 'dits'
      clf
      iterctrl('initialize',h);      
      if ~isequal(expno,1), trialno=1; runmod.cyclemax=1;
      elseif guirecrd('gettestmode')==2, trialno=2;
      else
        trialno=str2num(get(findobj(myfig,'tag','essd_uic_iteredit'),'string'));
      end
      %xt=dibs(N, 1/fc, freqvect, ampvect,trialno);
      runmod.trialno=trialno;
      c=allchild(myfig);
      hod=findobj(c, 'flat','tag','essd_uic_fgrb(2)'); %odd
      hro=findobj(c, 'flat','tag','essd_uic_fgrb(6)'); %randomized odd
      hql=findobj(c, 'flat','tag','essd_uic_fgrb(9)'); %quasilog
      rmv='';
      if isequal(get(hro,'value'),1), rmv='nothird';
      elseif isequal(get(hod,'value'),1), rmv='odd';
      end
      runmod.type=rmv;
      h=findobj(c,'flat','tag','essd_uic_startpop');
      str=popupstr(h);
      if strcmpi(str,'Fixed')
        state=str2num(get(findobj(c,'flat','tag','essd_uic_stateedit'),'string'));
        runmod.state=state;
      end
      if strcmp('on',get(findobj(myfig,'tag','excitation_menu_plots_rare'),'checked'))
        runmod.graphmod='raregraph';
      end
      xt=[];
      for ii=1:expno
        xto=dits(fiddata([],ampvect,freqvect),N,fc,runmod);
        xt=[xt,xto.data];
      end
      iterctrl('delete',h);    
    case 'prbs'
      Nmlbs=N/lengthmod/(fc/stepfreq);
      if abs(rem(Nmlbs+0.3,1)-0.3)<1e-5*Nmlbs, Nmlbs=round(Nmlbs); end
      h=findobj(c, 'flat', 'tag', 'essd_uic_figrb(19)');
      reglength=str2num(get(h,'string'));
      %if reglength>30
      %   essd('status','Register length is too large')
      %   guifreez(Me, 'unfreeze', 'essd_view_spectrum');
      %   return
      %end
      xt=mlbs(reglength);
      if lengthmod==2
        nx=length(xt)-1;
        bitmod=[ones(1,nx/2);-ones(1,nx/2)]; bitmod=[bitmod(:);1];
        xt=xt.*bitmod; xt=[xt;-xt];
      end
      if fc/stepfreq>1
        xt=xt(:,ones(1,fc/stepfreq))'; xt=xt(:);
      end
      X=fft(xt)/N;
      ind=find(abs(X(2:round(N/2)-1))>eps*1e5*N);
      freqvect=ind*fc/N;
      indxt=[1:N]/(fc/stepfreq);
      ind=find(indxt<floor(indxt)+eps*length(indxt));
      if ~isempty(ind), indxt(ind)=floor(indxt(ind)); end
      lxt=length(xt); indxt=rem(ceil(indxt)-1,lxt)+1;
      if (fc==stepfreq)&(N==(pow2(reglength)-1)*lengthmod)&...
          any(indxt~=[1:length(xt)])
        error('Algorithmic error for the default case')
      end
      %
      axh=gca;
      stairs([1:length(xt)+1]-1',[xt;xt(length(xt))]);
      title('Designed signal')
      ax=axis; ax(3:4)=1.1*ax(3:4); ax(2)=length(xt)+1; axis(ax)
      ind=find(diff(xt)==0);
      %dxt=0.003*diff(ax(3:4));
      %plot(ind,xt(ind)*(1+dxt),'.',ind,xt(ind)*(1-dxt),'.','markersize',5.99)     
      set(axh,'nextplot','add')
      plot(ind,xt(ind)*(1),'+','markersize',2,'parent',axh)
      if lengthmod==2, plot(length(xt)/2+0.5*[1,1],ax(3:4),':','parent',axh), end
      zoom(gcf,'on')
      % hf=gcf; set(hf,'nextplot','add','tag','mlbs_signal_shape'), pause(0)
      % dismispb('signal_shape')
    end
    
    dismispb('signal_shape')
    zoom(findall(0,'type','figure','tag','signal_shape'),'on')
    
    if ~isempty(xt)
      ok=1;
    else
      ok=0;
    end
    
    h=findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_genpop'); %Generator type
    genpopi=get(h,'value');
    genpopstr=get(h,'string');
    h=findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_recfiltrb(1)'); %Smoothing filter on
    reconstruction_filter=get(h,'value');
    if strncmpi(genpopstr(genpopi),'discrete seq',12)
      chmode='Discrete';
    elseif strcmpi(genpopstr(genpopi),'Interpolator')
      chmode='BL';
    elseif strcmpi(genpopstr(genpopi),'Filtered DAC')
      chmode='ZOHf';
    else
      chmode='ZOH';
    end
    pl=N/fc/periodno;
    df=dfcalc([freqvect(:)]);
    if 1/df<0.6*pl, pl=1/df; end
    if repno>1, xt=kron(ones(repno,1),xt); end
    outdata=tiddata([],num2cell(xt,1),1/fc);
    if ~isempty(xt)
      set(outdata,'inputchar',chmode,'noconsistency');
      set(outdata,'frequencies',freqvect,'periodlength',pl,'noconsistency')
    end
    if (expno>1)&samepower
      set(outdata,'synchronization','samepower')
    end
    if any([repno,expno]~=1), exptxt=sprintf(', repetitions: %.0f, experiments: %.0f',repno,expno);
    else exptxt='';
    end
    outdata.history={['Excitation signal design in GUI',exptxt]};
    if ok
      guidtawr(Me, 'OUTPUT_DATA', 'direct', outdata);
      guifreez(Me, 'unfreeze', 'essd_design');
      essd('status', 'Design finished')
      closeenable(myfig, 'on')   
    else
      guidtawr(Me, 'OUTPUT_DATA', 'direct', []);
      guifreez(Me, 'unfreeze', 'essd_design');
      essd('status', 'Error: Design cancelled')
    end      
    %h=[findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_donepb')];
    
    
  elseif findstr(p1,'click_on')
    % no action, help only
    
  elseif  findstr(p1,'setgenpop')
    if strcmpi(guiinfos('userlevel'),'Automatic')|strcmpi(guiinfos('userlevel'),'Interactive')
      genpop=[{'DAC','Filtered DAC','Generic'},fdhwf0('hardware')];
    else %advanced
      genpop=[{'DAC','Filtered DAC','Interpolator',...
            'Discrete Seq.','Generic'},fdhwf0('hardware')];
    end
    genpop=genpop(:)';
    hw=fdhwcall('hardware');
    if ~isempty(hw), genpop=[genpop,hw(:)']; end
    for ii=length(genpop):-1:1
      %eliminate repeated equipment
      ind=strmatch(genpop{ii},genpop,'exact');
      if length(ind)>1, genpop(ii)=[]; end
    end
    h=findobj(allchild(myfig),'flat','Tag','essd_uic_genpop');
    gval=get(h,'value');
    gstr=get(h,'string');
    if ~isempty(gval)&(length(gval)==1)&(gval>=1)&(gval<=length(gstr))
      vistr=gstr{gval};
      gval=strmatch(vistr,genpop,'exact');
      if isempty(gval), gval=1;
      else gval=gval(1);
      end
    else
      gval=1;
    end
    set(h,'string',genpop,'value',gval)
    hm=findobj(allchild(myfig),'flat','Tag','essd_uic_stsgrb(1)');
    if ~isequal(get(hm,'value'),1)
      if strcmp(popupstr(h),'Interpolator')
        set(h,'value',1)
      end
    end
    %elseif strcmp(p1,'essd_MENU_file_main')
    %   % it is not necessary, enable is set along with the close button
    %   return
    %   
    %   if ~guiinfos('ishelpmode',myfig) 
    %      h=findobj(allchild(myfig), 'tag', 'excitation_menu_file_save');
    %      outval=guidtard(Me, 'OUTPUT_DATA');
    %      if isempty(outval)
    %         set(h, 'enable', 'off')
    %      else
    %         set(h, 'enable', 'on')
    %      end
    %   end   
    
  elseif strcmp(p1,'ui_save_vector')|strcmp(p1,'ui_save_object')
    essd('status', 'Saving signal...')
    guifreez(Me, 'freeze', 'essd_save_data');
    signal=guidtard(Me, 'OUTPUT_DATA');
    if ~isa(signal,'tiddata')
      essd('status','Error: signal not yet designed')
      guifreez(Me, 'unfreeze', 'essd_save_data');
      return
    end
    signal=setA(signal,myfig);
    
    if strcmp(p1,'ui_save_vector')
      filter='filter: amplitude vector';
      data=signal.input;
      dataname='ex_sig_vect';
    elseif strcmp(p1,'ui_save_object')
      filter='filter: tiddata object (single channel)';
      data=signal;
      dataname='ex_sig_obj';
    end
    initvar=struct(...
      'CurrentSource', 'WP', ...
      'CurrentPath', [''],...
      'CurrentFileName', 'excitation_signal',...
      'CurrentVarName', dataname);
    initvar.ExportData=data; % it does not work with struct !!!!
    guiimpv('init_export', 'essd', 'EXPORT_DATA', initvar, filter)
    
  elseif strcmp(p1,'export_ready')
    guifreez(Me, 'unfreeze', 'essd_save_data');
    switch p2
      case 'done'
        essd('status', 'Signal exported.')
      case 'cancel'
        essd('status', 'Signal not exported.')
    end
    
  elseif strcmp(p1,'essd_uic_donepb')
    essd('status', 'Closing...')
    outval=guidtard(Me, 'OUTPUT_DATA');
    if isempty(outval)
      essd('essd_mod_designpb') % call design if necessary
      outval=guidtard(Me, 'OUTPUT_DATA');
    end      
    if isempty(outval) % design may be cancelled
      % nothing to do here, error message should be on screen
    else
      essd('status', 'closing...');
      outval=setA(outval, myfig);
      % write back output data to main window
      guidtawr('fdtool_main', ['OUTPUT_' myname], 'direct', outval);
      % refresh state variables (if necessary)
      storewin('remember', Me);
      fdtool('finished_box', 'rect_excitation', 'done', Me);
      guiclose('excitation')   
    end
    ulevctrl
    
  elseif strcmp(p1,'essd_uic_cancelpb')
    essd('status', 'Canceling...', Me);
    guiclose('excitation')
    fdtool('finished_box', 'rect_excitation', 'cancel', Me);
    fdtool('status', 'Excitation panel closed by Cancel. ', Me);
    
  elseif strcmp(p1,'essd_uic_print')
    %essd print command
    fdgprint(Me)
    essd('status','Print figure done.')
    
  elseif strcmp(p1,'essd_mod_print_ps')
    %essd print command
    fdgprint(Me,'ps')
    
  elseif strcmp(p1,'essd_uic_plot_spectrum')
    essd('status', 'Plotting excitation spectrum...')
    signal=guidtard(Me, 'OUTPUT_DATA');
    signal=setA(signal,myfig);
    u=signal.u; N=length(u);
    fv=signal.frequencies;
    ts=signal.ts;
    ch=signal.inputchar;
    U=fft(u);
    h=findobj('type','figure','tag','amplitude_spectrum');
    if ~isempty(h), figure(h); else clf, end
    if ~isempty(fv)
      Uf=abs(U(round(fv*ts*length(u))+1));
    else
      absU=abs(U);
      ind=find(absU(2:end/2-1)>eps*1e4*max(absU));
      Uf=absU(ind+1); fv=1/ts/length(u)*ind;
    end
    if strncmpi(ch,'ZOH',3), Uf=Uf.*(sin(pi*fv*ts+eps)./(pi*fv*ts+eps)); end
    clf, plot(fv,Uf/N,'+')
    ylim=get(gca,'ylim'); ylim(1)=0; ylim(2)=1.05*max(Uf)/N; set(gca,'ylim',ylim);
    xlim=get(gca,'xlim'); xlim(1)=0; xlim(2)=1.05*max(fv); set(gca,'xlim',xlim);
    set(gcf,'Name','Designed Amplitude Spectrum','tag','amplitude_spectrum','numbertitle','off')
    xlabel('Hz'), title('Amplitudes vs. frequency')
    zoom on, shg
    essd('status', 'Done.')
    
  elseif strcmp(p1,'essd_uic_plot_signal')
    essd('status', 'Plotting excitation signal...')
    signal=guidtard(Me, 'OUTPUT_DATA');
    signal=setA(signal,myfig);
    h=findobj('type','figure','tag','signal_shape');
    if ~isempty(h), figure(h); else clf, end
    ha=plot(signal);
    set(gcf,'Name','Designed Signal Shape','tag','signal_shape','numbertitle','off')
    zoom on, shg
    essd('status', 'Done.')
    
  elseif strcmp(p1,'essd_uic_plots_on')
    c=allchild(myfig);
    set(findobj(c,'tag','excitation_menu_plots_on'),'checked','on')
    set(findobj(c,'tag','excitation_menu_plots_rare'),'checked','off')
    essd('status', 'Plots set on.')
    %X=fft(xt)/N;
    %X=X(1:round(N/2));
    %ind=find(abs(X)>eps*N*1e5);
    %cx=X(ind);
    %freqvect=(ind-1)*fc/N;
    %if ind(1)==1, indc=[2:length(cx)]; else indc=[1:length(cx)]; end
    %cx(indc)=cx(indc).*sin(pi*freqvect(indc)/fc)./(pi*freqvect(indc)/fc);
    
  elseif strcmp(p1,'essd_uic_plots_rare')
    c=allchild(myfig);
    set(findobj(c,'tag','excitation_menu_plots_rare'),'checked','on')
    set(findobj(c,'tag','excitation_menu_plots_on'),'checked','off')
    essd('status', 'Plots set off.')
    
  elseif strcmp(p1,'essd_uic_adjustpb')
    MakeMeDirty(myfig)
    errmsg='Initial errmsg'; errmsgold='';
    while ~isempty(errmsg)&~strcmp(errmsg,errmsgold)
      errmsgold=errmsg;
      [freqvect,errmsg,parameters]=getfv(myfig,'adjust');
      essd('status',errmsg)
    end %while
    if ~isempty(errmsg)
      return
    else
      essd('status','Parameter setting is now consistent')
    end
    
    
  elseif strcmp(p1,'essd_uic_adjustpbn')
    MakeMeDirty(myfig)
    [dummy,errmsg]=getfv(myfig);
    if ~isempty(errmsg)
      errmsg='Initial errmsg'; errmsgold='';
      while ~isempty(errmsg)&~strcmp(errmsg,errmsgold)
        errmsgold=errmsg;
        [freqvect,errmsg,parameters]=getfv(myfig,'adjustn');
        essd('status',errmsg)
      end %while
    end
    if ~isempty(errmsg)
      return
    else
      essd('status','Parameter setting is now consistent')
    end
    
  elseif strcmp(p1,'essd_uic_agrb(7)') %Optimize for model
    MakeMeDirty(myfig)
    rbtag(sender);
    IterSetEnable(myfig)
    guifreez(Me, 'freeze_strong', 'optimize_for_model');
    essd('status', 'Optimize for Model selected, please specify a model in the Import window...');
    %
    %clear previous model:
    guidtawr(Me, 'IMPORTDATA_MODEL','direct',[]);
    %
    filtstr='fidmodel object';
    guiimpv('init', myfcn, 'MODEL', [], ['filter: ',filtstr] )
    % after input is finished execution continues right here: (optimize_for_model_2)
    
  elseif strcmp(p1, 'optimize_for_model_2')
    model_data=guidtard(Me, 'IMPORTDATA_MODEL');
    frf_data='';
    if ~isempty(model_data)  
      %clear previous data:
      guidtawr(Me, 'IMPORTDATA_FRF','direct',[]);
      essd('status', 'Optimize for Model, please specify variance data in the Import window...');
      filtstr='Fiddata object with variance';
      guiimpv('init', myfcn, 'FRF', [], ['filter: ',filtstr])
    else
      essd('status','Error: missing data for optimization. Optimize for model cancelled.')
    end
    % after input exec continues here: (optimize_for_model_3)
    
  elseif strcmp(p1, 'optimize_for_model_3')
    frf_data=guidtard(Me, 'IMPORTDATA_FRF');
    guifreez(Me, 'unfreeze', 'optimize_for_model');
    if isempty(frf_data)
      essd('status','Error: missing data for optimization. Optimize for model cancelled.')
    else
      essd('status','Optimize for model: Import finished.')
    end
    
  elseif strcmp(p1,'essd_uic_agrb(6)') %import amplitude
    MakeMeDirty(myfig)
    rbtag(sender);
    IterSetEnable(myfig)
    guifreez(Me, 'freeze_strong', 'import_amplitude');
    essd('status','Please specify transfer function in the Import window')
    guiimpv('init', myfcn, 'FRF', [], 'filter: Fiddata object')
    
  elseif strcmp(p1,'essd_uic_agrb(5)') %Matlab expression
    MakeMeDirty(myfig)
    rbtag(sender);
    IterSetEnable(myfig)
    essd('status','Enter Matlab expression. You can use ''fv'' for the actual frequency vector.')
    amplstr=guidtard(Me, 'EXPR_DATA_AMPL');
    gmexp('init', myfcn, 'ampl', amplstr)
    
  elseif strcmp(p1,'essd_uic_agrb(4)') %import amplitude
    MakeMeDirty(myfig)
    rbtag(sender);
    IterSetEnable(myfig)
    guifreez(Me, 'freeze_strong', 'import_amplitude');
    essd('status','Please specify amplitude data in the Import window')
    guiimpv('init', myfcn, 'AMPL', [], 'filter: Amplitude Vector')
    
    
    
  elseif strcmp(p1,'essd_uic_agrb(3)') %f proportional
    MakeMeDirty(myfig)
    rbtag(sender);
    IterSetEnable(myfig)
    essd('status','Amplitudes proportional to frequency set')
    
    
  elseif strcmp(p1,'essd_uic_agrb(2)') %1/f proportional
    MakeMeDirty(myfig)
    rbtag(sender);
    IterSetEnable(myfig)
    essd('status','Amplitudes inversely proportional to frequency set')
    
  elseif strcmp(p1,'essd_uic_agrb(1)') %constant amplitudes
    MakeMeDirty(myfig)
    rbtag(sender);
    IterSetEnable(myfig)
    essd('status','Constant amplitudes set')
    
  elseif strcmp(p1, 'import_ready')
    mywindowforward=1;
    switch  p2
      case 'cancel'
        switch p3 % caller_ID
          case 'FREQ'
            rbtag('essd_uic_fgrb(1)')
          case {'AMPL', 'MODEL', 'FRF'}
            rbtag('essd_uic_agrb(1)')
        end
        
      case 'done'
        data=guidtard('fdtool_importfig', 'IMPORTED_VAR');
        switch p3 % caller_ID
          case 'FREQ'
            %essd('status', 'Frequency data loaded')
            guidtawr('excitation_main','IMPORTDATA_FREQ','direct',data);
            
            freqvect=data;
            c=get(myfig,'children');
            hfmin=findobj(c, 'flat', 'tag', 'essd_uic_figrb(5)');
            set(hfmin,'string',num2str(min(freqvect)))
            hfmax=findobj(c, 'flat', 'tag', 'essd_uic_figrb(6)');
            set(hfmax,'string',num2str(max(freqvect)))
            hFtype=findobj(c, 'flat', 'tag', 'essd_uic_figpopup(4)');
            set(hFtype,'value',2,'userdata','# of freqs')
            hF=findobj(c, 'flat', 'tag', 'essd_uic_figrb(7)');
            set(hF,'string',num2str(length(freqvect)))
            
            
          case 'AMPL'
            if any(data<0)
              rbtag('essd_uic_agrb(1)')
              IterSetEnable(myfig)
              essd('status', 'Error: Amplitude vector may not contain negative values. Import cancelled.')
            else
              guidtawr('excitation_main','IMPORTDATA_AMPL','direct',data);
            end
          case 'FRF'
            guidtawr('excitation_main','IMPORTDATA_FRF','direct',data);
            c=get(myfig,'children');
            h=findobj(c, 'flat', 'tag', 'essd_uic_agrb(7)');
            if get(h, 'value') % if optimize for model
              essd('optimize_for_model_3')
            end
          case 'MODEL'
            guidtawr('excitation_main','IMPORTDATA_MODEL','direct',data);
            % continue with loading variance
            essd('optimize_for_model_2')
            mywindowforward=0;
        end
    end
    if ishandle(myfig)&mywindowforward
      figure(myfig)
      guifreez(Me, 'unfreeze', 'force');
    end
    IterSetEnable(myfig) % set iter no controls' enable (must be placed _after_ guifreeze call!)
    
    
  elseif strcmp(p1,'gmexp_ready')
    switch  p2
      case 'cancel'
        switch p4 % caller_ID
          case 'freq'
            rbtag('essd_uic_fgrb(1)')
            essd('enable_freqset', 'on')
          case 'ampl'
            rbtag('essd_uic_agrb(1)')
        end
        
        %gettime('finished_box','rect_gettdata','cancel');
      case 'done'
        % p3 is the command string. 
        % Store it, check when Adjust or View Spectrum
        data=p3;
        switch p4 % caller_ID
          case 'freq'
            guidtawr('excitation_main','EXPR_DATA_FREQ','direct',data);
            %Set information fields
            freqstr=data;
            c=get(myfig,'children');
            h=findobj(c, 'flat', 'tag', 'essd_uic_cfedit');
            fc=str2num(get(h,'string'));
            hN=findobj(c, 'flat', 'tag', 'essd_uic_ssedit');
            N=str2num(get(hN,'string'));
            dfi=fc/N;
            [status, freqvect]=CalcMatlabExpr('FREQ', freqstr, fc, dfi);
            if ~status
              errmsg=[lasterr ' Check Matlab expression.'];
              essd('status',errmsg)
              %essd('status','Cannot evaluate Matlab expression')
              %disp(['freqstr = ''',freqstr,''''])
              return
            end
            hfmin=findobj(c, 'flat', 'tag', 'essd_uic_figrb(5)');
            set(hfmin,'string',num2str(min(freqvect)))
            hfmax=findobj(c, 'flat', 'tag', 'essd_uic_figrb(6)');
            set(hfmax,'string',num2str(max(freqvect)))
            hFtype=findobj(c, 'flat', 'tag', 'essd_uic_figpopup(4)');
            set(hFtype,'value',2,'userdata','# of freqs')
            hF=findobj(c, 'flat', 'tag', 'essd_uic_figrb(7)');
            set(hF,'string',num2str(length(freqvect)))
            
          case 'ampl'
            guidtawr('excitation_main','EXPR_DATA_AMPL','direct',data);
        end
    end
    if ishandle(myfig)
      figure(myfig)
    end
    IterSetEnable(myfig)
    
    
    %Frequency distribution buttons follow
  elseif strcmp(p1,'essd_freqsel_execute') %execute selected freq distribution button, except import
    h= findall(0, 'userdata', 'essd_uic_fgrb');
    selii=[];
    for ii=length(h):-1:1
      str=get(h(ii),'string');
      if strcmp(str,'Matlab expression')|any(findstr(str,'Import'))
        h(ii)=[];
      else
        if isequal(get(h(ii),'value'),1), selii=h(ii); end
      end
    end
    if ~isempty(selii), essd(get(selii,'tag')), end
    
  elseif strcmp(p1,'essd_uic_fgrb(1)') %linear
    MakeMeDirty(myfig)
    ClearInfo(myfig)
    rbtag(sender);
    essd('status','Linear frequency grid set')
    %
    hfntype=findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figpopup(4)');
    set(hfntype,'string',fntypelin,'value',1,'userdata','df') %df
    hnf=findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figrb(7)');
    set(hnf,'string',num2str(df))
    essd('essd_uic_figpopup(4)')
    %
    essd('enable_freqset', 'on')
    %h=[findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figrb(4)');...
    %    findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figrb(7)')];
    %set(h, 'enable', 'on')
    
  elseif strcmp(p1,'essd_uic_fgrb(2)') %odd linear
    MakeMeDirty(myfig)
    ClearInfo(myfig)
    rbtag(sender);
    c=get(myfig,'children');
    hprbs=findobj(c,'flat','tag','essd_uic_stsgrb(3)');
    if get(hprbs,'value') %PRBS
      essd('status','Inverse repeat (odd frequencies)')
    else 
      essd('status','Odd linear frequency grid set')
    end
    %
    hfntype=findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figpopup(4)');
    set(hfntype,'string',fntypelin,'value',1,'userdata','df') %df
    hnf=findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figrb(7)');
    set(hnf,'string',num2str(2*df))
    essd('essd_uic_figpopup(4)')
    %
    h=findobj(c, 'flat', 'userdata', 'essd_uic_stsgrb', 'value',1);
    type_str=get(h,'string');
    if ~strcmp(lower(type_str),'prbs')
      essd('enable_freqset', 'on')
    else
      essd('enable_freqset', 'off')
    end
    %h=[findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figrb(4)');...
    %    findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figrb(7)')];
    %set(h, 'enable', 'on')
    
  elseif strcmp(p1,'essd_uic_fgrb(6)') %randomized odd linear
    MakeMeDirty(myfig)
    ClearInfo(myfig)
    % randomized odd linear (multisine)
    % odd, no third harmonics (DITS)
    rbtag(sender);
    string=get(findobj(allchild(myfig), 'flat', 'tag', p1),'string');
    essd('status',[string,' frequency grid set'])
    %
    hfntype=findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figpopup(4)');
    set(hfntype,'string',fntypelin,'value',1,'userdata','df') %df
    hnf=findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figrb(7)');
    %set(hnf,'string',num2str(3*df))
    essd('essd_uic_figpopup(4)') %simulate selection of df/#freq choice
    %
    essd('enable_freqset', 'on')
    
    %      h=findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figrb(23)');
    %      set(h, 'enable', 'off', 'value', 1)
    %
    %Now freqs enable/disable
    %if strcmp(p1,'essd_uic_fgrb(9)') %special odd
    %  h=[findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figrb(4)');...
    %    findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figrb(7)')];
    %  set(h, 'enable', 'off')
    %else
    %  h=[findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figrb(4)');...
    %      findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figrb(7)')];
    %  set(h, 'enable', 'on')
    %end
    
  elseif strcmp(p1,'essd_uic_fgrb(9)')|strcmp(p1,'essd_uic_fgrb(3)')
    %Quasilog, Odd quasilog or Randomized odd quasilog
    MakeMeDirty(myfig)
    ClearInfo(myfig)
    rbtag(sender);
    if strncmp(p1,'essd_uic_fgrb(3)',16)
      if any(findstr('Randomized',get(findobj(myfig,'tag',p1),'string')))
        essd('status','Randomized odd quasilog frequency grid set')
      else
        essd('status','Odd quasilog frequency grid set')
      end
    else
      essd('status','Quasilog frequency grid set')
    end
    %
    hfntype=findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figpopup(4)');
    set(hfntype,'string',fntypelog,'value',1,'userdata','Nf/oct') %Nf/oct
    if fmin<df*.99
      hfmin=findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figrb(5)');
      set(hfmin,'string',num2str(df))
      fmin=df;
    end
    hnf=findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figrb(7)');
    Nf=log2(max(fmin/df,1))+1;
    set(hnf,'string',num2str(Nf))
    essd('essd_uic_figpopup(4)')
    %
    essd('enable_freqset', 'on')
    
    %      h=findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figrb(23)');
    %      set(h, 'enable', 'off', 'value', 1)
    %h=[findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figrb(4)');...
    %    findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figrb(7)')];
    %set(h, 'enable', 'on')
    
  elseif strcmp(p1,'essd_uic_fgrb(4)') %Import
    MakeMeDirty(myfig)
    ClearInfo(myfig)
    rbtag(sender);
    guifreez(Me, 'freeze_strong', 'import_frequency');
    essd('status','Please specify frequency data in the Import window')
    essd('enable_freqset', 'off')
    guiimpv('init', 'essd', 'FREQ', [], 'filter: Frequency Vector')
    %
    hfntype=findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figpopup(4)');
    set(hfntype,'string',fntypeall,'value',2,'userdata','# of freqs') %freqs
    hHz=findobj(allchild(myfig),'flat','tag','essd_uic_figrb(28)');
    set(hHz,'visible','off')
    hnf=findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figrb(7)');
    set(hnf,'string',num2str(N))
    %
    
    %      h=findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figrb(23)');
    %      set(h, 'enable', 'on')
    %Mark case that unadjusted vector was read
    %set(findall(myfig, 'tag','essd_uic_adjustpb'),'userdata','not adjusted')
    %h=[findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figrb(4)');...
    %    findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figrb(7)')];
    %set(h, 'enable', 'on')
    
  elseif strcmp(p1,'essd_uic_fgrb(5)') %Matlab expression
    MakeMeDirty(myfig)
    ClearInfo(myfig)
    rbtag(sender);
    essd('status','Enter Matlab expression. You can use fc (clock frequency), and df (DFT resolution).')
    freqstr=guidtard(Me, 'EXPR_DATA_FREQ');
    gmexp('init', myfcn, 'freq', freqstr)
    essd('enable_freqset', 'off')
    %
    hfntype=findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figpopup(4)');
    set(hfntype,'string',fntypeall,'value',2,'userdata','# of freqs') %freqs
    hHz=findobj(allchild(myfig),'flat','tag','essd_uic_figrb(28)');
    set(hHz,'visible','off')
    hnf=findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figrb(7)');
    set(hnf,'string',num2str(N))
    %
    
    set(findobj(allchild(myfig), 'flat', 'tag','essd_uic_adjustpb'),'userdata','not adjusted')
    %h=[findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figrb(4)');...
    %    findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figrb(7)')];
    %set(h, 'enable', 'on')
    
  elseif strcmp(p1,'essd_uic_fgrb(7)') %All DFT frequencies
    MakeMeDirty(myfig)
    ClearInfo(myfig)
    rbtag(sender);
    essd('status','All DFT frequencies selected')
    essd('enable_freqset', 'off')
    
    %Set information fields
    c=get(myfig,'children');
    h=findobj(c, 'flat', 'tag', 'essd_uic_cfedit');
    fc=str2num(get(h,'string'));
    hN=findobj(c, 'flat', 'tag', 'essd_uic_ssedit');
    N=str2num(get(hN,'string'));
    dfi=fc/N;
    
    %
    hfntype=findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figpopup(4)');
    set(hfntype,'string',fntypelin,'value',2,'userdata','# of freqs') %freqs
    hHz=findobj(allchild(myfig),'flat','tag','essd_uic_figrb(28)');
    set(hHz,'visible','off')
    hnf=findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figrb(7)');
    %
    hfmin=findobj(c, 'flat', 'tag', 'essd_uic_figrb(5)');
    set(hfmin,'string',num2str(0))
    hfmax=findobj(c, 'flat', 'tag', 'essd_uic_figrb(6)');
    set(hfmax,'string',num2str(dfi*(floor(fc/2/dfi+0.00001)+0.000000002)))
    hF=findobj(c, 'flat', 'tag', 'essd_uic_figrb(7)');
    set(hF,'string',num2str(floor(N/2)+1))
    hfntype=findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figrb(4)');
    set(hfntype,'value',1)
    
    %h=[findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figrb(4)');...
    %    findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figrb(7)')];
    %set(h, 'enable', 'on')
    
    
  elseif strcmp(p1,'essd_uic_fgrb(8)') %Most DFT frequencies
    MakeMeDirty(myfig)
    ClearInfo(myfig)
    rbtag(sender);
    essd('status','All DFT frequencies selected except dc and fs/2')
    essd('enable_freqset', 'off')
    
    %Set information fields
    c=get(myfig,'children');
    h=findobj(c, 'flat', 'tag', 'essd_uic_cfedit');
    fc=str2num(get(h,'string'));
    hN=findobj(c, 'flat', 'tag', 'essd_uic_ssedit');
    N=str2num(get(hN,'string'));
    dfi=fc/N;
    %
    hfntype=findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figpopup(4)');
    set(hfntype,'string',fntypelin,'value',2,'userdata','# of freqs') %freqs
    hHz=findobj(allchild(myfig),'flat','tag','essd_uic_figrb(28)');
    set(hHz,'visible','off')
    hnf=findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figrb(7)');
    %
    hfmin=findobj(c, 'flat', 'tag', 'essd_uic_figrb(5)');
    set(hfmin,'string',num2str(dfi))
    hfmax=findobj(c, 'flat', 'tag', 'essd_uic_figrb(6)');
    set(hfmax,'string',num2str(dfi*(floor(fc/2/dfi+0.00001)+0.000000002-1)))
    hF=findobj(c, 'flat', 'tag', 'essd_uic_figrb(7)');
    set(hF,'string',num2str(floor(N/2)-1))
    hfntype=findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figrb(4)');
    set(hfntype,'value',1)
    h=[findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figrb(4)');...
        findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figrb(7)')];
    %set(h, 'enable', 'on')
    
    if 0
      h=[findall(0, 'tag', 'essd_uic_fgrb(1)'); %'Linear'
        findall(0, 'tag', 'essd_uic_fgrb(2)'); %'Odd linear'
        findall(0, 'tag', 'essd_uic_fgrb(6)'); %'Randomized odd linear'
        findall(0, 'tag', 'essd_uic_fgrb(9)'); %'Quasilog'
        findall(0, 'tag', 'essd_uic_fgrb(3)'); %'(Randomized) odd quasilog'
        findall(0, 'tag', 'essd_uic_fgrb(4)'); %'Import...'
        findall(0, 'tag', 'essd_uic_fgrb(5)'); %'Matlab expression'
        findall(0, 'tag', 'essd_uic_fgrb(7)'); %'All DFT freqs'
        findall(0, 'tag', 'essd_uic_fgrb(8)')]; %'Most DFT freqs'
    end
    
  elseif strcmp(p1,'essd_uic_genpop')
    MakeMeDirty(myfig)
    ClearInfo(myfig)
    % nothing to do
    c=allchild(myfig);
    h=findobj(c, 'flat', 'tag','essd_uic_genpop');
    hin=findobj(c, 'flat', 'tag','essd_uic_recfiltrb(2)');
    hiy=findobj(c, 'flat', 'tag','essd_uic_recfiltrb(1)');
    hiall=[hin;hiy;findobj(c, 'flat', 'tag','essd_uic_recfilttext')];
    if strncmp(popupstr(h),'Discrete Seq.',10)|strcmp(popupstr(h),'DAC')|...
        strcmp(popupstr(h),'Interpolator')|strcmp(popupstr(h),'Filtered DAC')
      if strcmpi(popupstr(h),'Interpolator')|strcmp(popupstr(h),'Filtered DAC')
        essd('essd_uic_recfiltrb(1)');
      else
        essd('essd_uic_recfiltrb(2)');
      end
      set(hiall,'enable','off')
    else %Generic, interpolated, other
      set(hiall,'enable','on')     
    end
    if strcmp(popupstr(h),'Interpolator')
      hm=findobj(c, 'flat', 'tag','essd_uic_stsgrb(1)'); %multisine
      if ~isequal(get(hm,'value'),1) %not selected
        set(h,'value',1)
        essd('status','Warning: Interpolator may not be selected for binary signals')
      end
    end  
  elseif strcmp(p1,'essd_uic_stsgrb(1)') | strcmp(p1,'essd_mod_stsgrb(1)')%multisine selected
    MakeMeDirty(myfig)
    ClearInfo(myfig)
    rbtag(sender);
    essd('status','Signal type set to multisine')
    c=allchild(myfig);
    %hMainText=findobj(c, 'flat', 'tag', 'essd_uic_mainhdtext');
    %set(hMainText, 'string', 'Multisine');
    hexp=[findobj(c, 'flat', 'tag','essd_uic_expedit');...
        findobj(c, 'flat', 'tag','essd_uic_exptext')];
    set(hexp,'enable','on')
    h=[findobj(c, 'flat', 'userdata','essd_uic_fgrb');...
        findobj(c, 'flat', 'userdata','essd_uic_agrb');...
        findobj(c, 'flat', 'userdata','essd_uic_figrb');...
        findobj(c, 'flat', 'tag','essd_uic_adjustpb');...
        findobj(c, 'flat', 'tag','essd_uic_starttext')];
    hs=findobj(c, 'flat', 'tag','essd_uic_startpop');
    set([h;hs],'enable','on');
    ho=findobj(c, 'flat', 'tag','essd_uic_fgrb(2)');
    set(ho,'string','Odd linear');
    set(hs,'String',{'Random','Fixed','Schroeder'}) 
    hss=findobj(c, 'flat', 'tag','essd_uic_stateedit');
    hsst=findobj(c, 'flat', 'tag','essd_uic_statetext');
    set([findobj(c, 'flat', 'tag','essd_uic_iteredit');...
          findobj(c, 'flat', 'tag','essd_uic_itertext')],...
       'visible','on','enable','on'); %Fixed phase
    hiter=findobj(c, 'flat', 'tag','essd_uic_iteredit');
    if strcmp(get(hiter,'string'),'25'), set(hiter,'string','200'), end
    if strcmp(popupstr(hs),'Fixed')
      set([hss;hsst],'visible','on','enable','on')
      if strcmp(get(hss,'string'),'NaN'), set(hss,'string','0'), end
    else
      set([hss;hsst],'visible','off')
      set(hss,'string','NaN')  
    end
    hro=findall(c, 'flat', 'tag', 'essd_uic_fgrb(6)');
    set(hro,'enable','on');
    set(findobj(c, 'flat', 'tag','essd_uic_adjustpb'),... 
      'ToolTipString','Adjust frequencies (fmin, fmax and freqs) to DFT grid and other parameters to instrument type')
    set(findobj(c, 'flat', 'tag','essd_uic_adjustpbn'),...
      'ToolTipString','Adjust clock frequency and number of samples according to fmin, fmax and freqs',...
      'visible','on','enable','on')
    rbtag('essd_uic_recfiltrb(2)')
    set(findobj(c, 'flat', 'userdata','essd_uic_recfiltrb'),'enable','on');
    hb=[findobj(c, 'flat', 'tag','essd_uic_figrb(16)');...
        findobj(c, 'flat', 'tag','essd_uic_figrb(17)');...
        findobj(c, 'flat', 'tag','essd_uic_figrb(18)');...
        findobj(c, 'flat', 'tag','essd_uic_figrb(19)');...
        findobj(c, 'flat', 'tag', 'essd_uic_figrb(26)')];
    set(hb,'visible','off');
    %      set(findobj(c, 'flat', 'tag','essd_uic_figrb(23)'),'enable','on');
    %set(findobj(c, 'flat', 'tag', 'essd_uic_figrb(26)'),'value',0);
    essd('essd_uic_genpop') %check generator
    ulevctrl(Me)
    
  elseif strcmp(p1,'essd_uic_stsgrb(2)') | strcmp(p1,'essd_mod_stsgrb(2)') %dibs selected
    MakeMeDirty(myfig)
    ClearInfo(myfig)
    rbtag(sender);
    essd('status','Signal type set to dibs')
    c=allchild(myfig);
    %hMainText=findobj(c, 'flat', 'tag', 'essd_uic_mainhdtext');
    %set(hMainText, 'string', 'DIBS');
    hexp=[findobj(c, 'flat', 'tag','essd_uic_expedit');...
        findobj(c, 'flat', 'tag','essd_uic_exptext')];
    set(hexp,'enable','on')
    h=[findobj(c, 'flat',  'userdata','essd_uic_fgrb');...
        findobj(c, 'flat', 'userdata','essd_uic_agrb');...
        findobj(c, 'flat', 'tag','essd_uic_adjustpb');...
        findobj(c, 'flat', 'userdata','essd_uic_figrb')];
    set(h,'enable','on');
    ho=findobj(c, 'flat', 'tag','essd_uic_fgrb(2)');
    set(ho,'string','Odd linear');    
    hs=findobj(c, 'flat', 'tag','essd_uic_startpop');
    hst=findobj(c, 'flat', 'tag','essd_uic_starttext');
    set([hs;hst],'enable','on');
    set([findobj(c, 'flat', 'tag','essd_uic_iteredit');...
          findobj(c, 'flat', 'tag','essd_uic_itertext')],...
       'visible','on','enable','on'); %Fixed phase
    hiter=findobj(c, 'flat', 'tag','essd_uic_iteredit');
    if strcmp(get(hiter,'string'),'200'), set(hiter,'string','25'), end
    set(hs,'String',{'Random','Fixed'})
    if get(hs,'value')>2, set(hs,'value',2), end
    hss=findobj(c, 'flat', 'tag','essd_uic_stateedit');
    hsst=findobj(c, 'flat', 'tag','essd_uic_statetext');
    if strcmp(popupstr(hs),'Fixed')
      set([hss;hsst],'visible','on','enable','on')
      if strcmp(get(hss,'string'),'NaN'), set(hss,'string','0'), end
    else
      set([hss;hsst],'visible','off')
      set(hss,'string','NaN')  
    end
    hro=findall(c, 'flat', 'tag', 'essd_uic_fgrb(6)');
    set(hro,'enable','off');
    hql=findobj(c, 'flat','tag','essd_uic_fgrb(9)');
    set(hql,'enable','on');
    if strcmp(get(hql,'enable'),'off')&isequal(get(hql,'value'),1)
      rbtag('essd_uic_fgrb(2)')
    end
    if strcmp(get(hro,'enable'),'off')&isequal(get(hro,'value'),1)
      rbtag('essd_uic_fgrb(2)')
    end
    
    set(findobj(c, 'flat', 'tag','essd_uic_adjustpb'),...
      'ToolTipString','Adjust frequencies (fmin, fmax, freqs) to DFT grid')
    set(findobj(c, 'flat', 'tag','essd_uic_adjustpbn'),...
      'ToolTipString','Adjust number of samples, and clock and bit frequencies according to fmin, fmax and freqs',...
      'visible','on','enable','on')
    
    rbtag('essd_uic_recfiltrb(2)')
    
    set(findobj(c, 'flat', 'userdata','essd_uic_recfiltrb'),'enable','off');
    
    hb=[findobj(c, 'flat', 'tag','essd_uic_figrb(16)');...
        findobj(c, 'flat', 'tag','essd_uic_figrb(17)');...
        findobj(c, 'flat', 'tag','essd_uic_figrb(18)');...
        findobj(c, 'flat', 'tag','essd_uic_figrb(19)');...
        findobj(c, 'flat', 'tag', 'essd_uic_figrb(26)')];
    set(hb,'visible','off');
    essd('essd_uic_genpop') %check generator
    ulevctrl(Me)
    
  elseif strcmp(p1,'essd_uic_stsgrb(4)') | strcmp(p1,'essd_mod_stsgrb(4)') %dits selected
    MakeMeDirty(myfig)
    ClearInfo(myfig)
    rbtag(sender);
    essd('status','Signal type set to dits')
    c=allchild(myfig);
    %hMainText=findobj(c, 'flat', 'tag', 'essd_uic_mainhdtext');
    %set(hMainText, 'string', 'DIBS');
    hexp=[findobj(c, 'flat', 'tag','essd_uic_expedit');...
        findobj(c, 'flat', 'tag','essd_uic_exptext')];
    set(hexp,'enable','on')
    h=[findobj(c, 'flat',  'userdata','essd_uic_fgrb');...
        findobj(c, 'flat', 'userdata','essd_uic_agrb');...
        findobj(c, 'flat', 'tag','essd_uic_adjustpb');...
        findobj(c, 'flat', 'userdata','essd_uic_figrb')];
    set(h,'enable','on');
    ho=findobj(c, 'flat', 'tag','essd_uic_fgrb(2)');
    set(ho,'string','Odd linear');
    hro=findobj(c, 'flat','tag','essd_uic_fgrb(6)');
    %set(hro,'string','Odd, no third harmonics','tooltipstring','Every even and third harmonics suppressed')
    hql=findobj(c, 'flat','tag','essd_uic_fgrb(9)');
    %set(hos,'string','Odd, no third harmonics','tooltipstring','Every second and third harmonics suppressed')
    hrandlin=findall(c, 'flat', 'tag', 'essd_uic_fgrb(6)');
    set(hrandlin,'enable','on')
    hs=findobj(c, 'flat', 'tag','essd_uic_startpop');
    hst=findobj(c, 'flat', 'tag','essd_uic_starttext');
    set([hs;hst],'enable','on');
    set([findobj(c, 'flat', 'tag','essd_uic_iteredit');...
          findobj(c, 'flat', 'tag','essd_uic_itertext')],...
       'visible','on','enable','on'); %Fixed phase
    hiter=findobj(c, 'flat', 'tag','essd_uic_iteredit');
    if strcmp(get(hiter,'string'),'200'), set(hiter,'string','25'), end
    set(hs,'String',{'Random','Fixed'})
    if get(hs,'value')>2, set(hs,'value',2), end
    hss=findobj(c, 'flat', 'tag','essd_uic_stateedit');
    hsst=findobj(c, 'flat', 'tag','essd_uic_statetext');
    if strcmp(popupstr(hs),'Fixed')
      set([hss;hsst],'visible','on','enable','on')
      if strcmp(get(hss,'string'),'NaN'), set(hss,'string','0'), end
    else
      set([hss;hsst],'visible','off')
      set(hss,'string','NaN')  
    end
    set(findobj(c, 'flat', 'tag','essd_uic_adjustpb'),...
      'ToolTipString','Adjust frequencies (fmin, fmax, freqs) to DFT grid')
    set(findobj(c, 'flat', 'tag','essd_uic_adjustpbn'),...
      'ToolTipString','Adjust number of samples, and clock and bit frequencies according to fmin, fmax and freqs',...
      'visible','on','enable','on')
    
    rbtag('essd_uic_recfiltrb(4)')
    
    set(findobj(c, 'flat', 'userdata','essd_uic_recfiltrb'),'enable','off');
    
    hb=[findobj(c, 'flat', 'tag','essd_uic_figrb(16)');...
        findobj(c, 'flat', 'tag','essd_uic_figrb(17)');...
        findobj(c, 'flat', 'tag','essd_uic_figrb(18)');...
        findobj(c, 'flat', 'tag','essd_uic_figrb(19)');...
        findobj(c, 'flat', 'tag', 'essd_uic_figrb(26)')];
    set(hb,'visible','off');
    essd('essd_uic_genpop') %check generator
    ulevctrl(Me)

  elseif strcmp(p1,'essd_uic_stsgrb(3)') | strcmp(p1,'essd_mod_stsgrb(3)') % prbs selected
    MakeMeDirty(myfig)
    ClearInfo(myfig)
    rbtag(sender);
    essd('status','Signal type set to prbs')
    c=allchild(myfig);
    %hMainText=findobj(c, 'flat', 'tag', 'essd_uic_mainhdtext');
    %set(hMainText, 'string', 'PRBS');
    h1=[findobj(c, 'flat', 'userdata','essd_uic_agrb');...
        findobj(c, 'flat', 'tag','essd_uic_fgrb(3)');...
        findobj(c, 'flat', 'tag','essd_uic_fgrb(4)');...
        findobj(c, 'flat', 'tag','essd_uic_fgrb(5)');...
        findobj(c, 'flat', 'tag','essd_uic_fgrb(9)')];
    h2=[findobj(c, 'flat', 'tag','essd_uic_startpop');...
      findobj(c, 'flat', 'tag','essd_uic_starttext')];
    h=[h1;h2];
    set(h,'enable','off');
    set(findobj(c, 'flat', 'tag','essd_uic_startpop'),'value',2); %Fixed phase
    %seth2,'visible','off')
    set([findobj(c, 'flat', 'tag','essd_uic_iteredit');...
          findobj(c, 'flat', 'tag','essd_uic_itertext')],...
       'visible','off'); %Fixed phase
    hexp=findobj(c, 'flat', 'tag','essd_uic_expedit');
    set(hexp,'string',1,'enable','off')
    hexpt=findobj(c, 'flat', 'tag','essd_uic_exptext');
    set(hexpt,'enable','off')
    ho=findobj(c, 'flat', 'tag','essd_uic_fgrb(2)');
    %set(ho,'string','Odd linear'); %'tooltipstring','Odd frequencies: (2*i+1)*df from DFT grid')
    set(ho,'string','Inverse repeat (odd)');
    hss=findobj(c, 'flat', 'tag','essd_uic_stateedit');
    hsst=findobj(c, 'flat', 'tag','essd_uic_statetext');
    set([hss;hsst],'visible','off')
    set(hss,'string','NaN')  
    
    h=[findobj(c, 'flat','userdata','essd_uic_figrb')];
    set(h,'enable','on');
    
    set(findobj(c, 'flat', 'tag','essd_uic_adjustpbn'),...
      'ToolTipString','Adjust number of samples to have full PRBS sequences')
    set(findobj(c, 'flat', 'tag','essd_uic_adjustpb'),...
      'enable','off')
    
    set(findobj(c, 'flat', 'tag','essd_uic_figrb(7)'),'enable','off')
    set(findobj(c, 'flat', 'tag','essd_uic_figrb(6)'),'enable','off')
    set(findobj(c, 'flat', 'tag','essd_uic_figrb(5)'),'enable','off')
    %set(findobj(c, 'flat', 'tag','essd_uic_figrb(9)'),'enable','off')
    %set(findobj(c, 'flat', 'tag','essd_uic_figrb(3)'),'enable','off')
    
    for ii=[1,3,4,5,6,9] %if not allowed frequency setting
      hrb=findobj(c, 'tag',['essd_uic_fgrb(',int2str(ii),')']);
      if get(hrb,'value')==1
        set(hrb,'value',0)
        set(findobj(c, 'tag','essd_uic_fgrb(8)'),'value',1); %Select Most DFT freqs
      end   
      set(hrb,'enable','off');
    end
    for ii=1:7 %set amplitudes to constant for mlbs
      hagrb=findobj(c, 'tag', ['essd_uic_agrb(',num2str(ii),')']);
      set(hagrb,'value',ii==1)
    end
    %set(findobj(c, 'flat','tag','essd_uic_figrb(1)'),'enable','off');
    %set(findobj(c, 'flat','tag','essd_uic_figrb(3)'),'enable','off');
    %set(findobj(c, 'flat','tag','essd_uic_figrb(4)'),'enable','off');
    %set(findobj(c, 'flat','tag','essd_uic_figrb(5)'),'enable','off');
    %set(findobj(c, 'flat','tag','essd_uic_figrb(6)'),'enable','off');
    
    rbtag('essd_uic_recfiltrb(2)')
    set(findobj(c, 'flat','userdata','essd_uic_recfiltrb'),'enable','off');
    set(findobj(c, 'flat', 'tag', 'essd_uic_figrb(22)'),'enable','on');
    
    hb=[findobj(c, 'flat', 'tag','essd_uic_figrb(16)');...
        findobj(c, 'flat', 'tag','essd_uic_figrb(17)');...
        findobj(c, 'flat', 'tag','essd_uic_figrb(18)');...
        findobj(c, 'flat', 'tag','essd_uic_figrb(19)');...
        findobj(c, 'flat', 'tag', 'essd_uic_figrb(26)')];
    set(hb,'visible','on');
    essd('essd_uic_genpop') %check generator
    ulevctrl(Me)
    
  elseif any(findstr(p1,'essd_uic_stsgrb'))&any(findstr(p1,'exp'))
    %single/multiexperiment
    rbtag(sender)
    %rbtag('essd_uic_stsgrb(3)_multiexp'), essd('status','Warning: fast single-experiment not yet implemented') %temp only ***
    if get(findobj(myfig, 'tag', 'essd_uic_stsgrb(4)_singleexp'),'value')
      set(findobj(myfig, 'tag','essd_uic_repedit'),'String','7')
      set(findobj(myfig, 'tag','essd_uic_expedit'),'String','1')       
    elseif get(findobj(myfig, 'tag', 'essd_uic_stsgrb(3)_multiexp'),'value')
      set(findobj(myfig, 'tag','essd_uic_repedit'),'String','2')
      set(findobj(myfig, 'tag','essd_uic_expedit'),'String','7')
    end
    ulevctrl(Me)
    
  elseif strcmp(p1,'essd_uic_recfiltrb(1)')
    MakeMeDirty(myfig)
    rbtag(sender);
    essd('status','Smoothing filter on')
    
    
  elseif strcmp(p1,'essd_uic_recfiltrb(2)')
    MakeMeDirty(myfig)
    rbtag(sender);
    essd('status','Smoothing filter off')
    
  elseif strcmp(p1,'enable_freqset')
    ch=get(myfig,'children');
    freqobjs=[...
        findobj(ch, 'flat', 'Tag','essd_uic_figrb(5)'),...
        findobj(ch, 'flat', 'Tag','essd_uic_figrb(6)'),...
        findobj(ch, 'flat', 'Tag','essd_uic_figrb(7)'),...
        findobj(ch, 'flat', 'Tag','essd_uic_figpopup(4)'),...
      ]; 
    %findobj(ch, 'flat', 'Tag','essd_uic_figrb(2)'),... fmin
    %findobj(ch, 'flat', 'Tag','essd_uic_figrb(3)'),... fmax
    %findobj(ch, 'flat', 'Tag','essd_uic_figrb(4)'),... F
    
    
    set(freqobjs,'enable',p2);
    
  elseif strcmp(p1,'essd_uic_startpop')
    MakeMeDirty(myfig)
    % nothing to do
    c=allchild(myfig);
    hs=findobj(c, 'flat', 'tag','essd_uic_startpop');
    hss=findobj(c, 'flat', 'tag','essd_uic_stateedit');
    hsst=findobj(c, 'flat', 'tag','essd_uic_statetext');
    if strcmp(popupstr(hs),'Fixed')
      set([hss;hsst],'visible','on','enable','on')
      if strcmp(get(hss,'string'),'NaN'), set(hss,'string','0'), end
    else
      set([hss;hsst],'visible','off')
      set(hss,'string','NaN')  
    end
    
  elseif strcmp(p1,'ui_edit')
    if ~strcmp(sender, 'essd_uic_agedit(21)')&~strcmp(sender, 'essd_uic_agedit_peak(21)')
      MakeMeDirty(myfig)
    end
    if strcmp(sender, 'essd_uic_cycledit') | ...
        strcmp(sender, 'essd_uic_agedit(21)') | strcmp(sender, 'essd_uic_agedit_peak(21)')
      % no need to clear freq info
      signal=guidtard(Me, 'OUTPUT_DATA');
      if ~isempty(signal)
        signal=setA(signal,myfig)
        guidtawr(Me, 'OUTPUT_DATA','direct',signal);
      end        
    else
      ClearInfo(myfig)
    end
    
    
    c=get(myfig,'children');
    h=findobj(c,'flat','tag',sender);
    str=get(h, 'string'); 
    if size(str,1)>1
      str=str(end,:); set(h, 'string', str);
    end
    num=str2num(str);
    Corr=0;
    if isempty(num)
      num=0; Corr=1;
    end
    numCorr=num; msg='';
    switch sender
      case {'essd_uic_ssedit', 'essd_uic_cycledit', 'essd_uic_figrb(19)',...
            'essd_uic_repedit', 'essd_uic_expedit' }
        % positive integer: total#, iter, log2, 
        if floor(num) ~= num
          numCorr = round(num); Corr=1; num=numCorr;
        end
        if num<0
          numCorr = abs(num); Corr=1;
        elseif num==0
          numCorr = 1; Corr=1;
        end
        if strcmp(sender,'essd_uic_expedit')
          hmlbs=findobj(c, 'flat', 'tag','essd_uic_stsgrb(3)');
          if isequal(get(hmlbs,'value'),1)
            numCorr = 1; Corr=1;          
          end
        end
      case {'essd_uic_iteredit'}
        % non-negative integer 
        if floor(num) ~= num
          numCorr = round(num); Corr=1; num=numCorr;
        end
        if num<0
          numCorr = 0; Corr=1;
        end
      case {'essd_uic_figrb(7)'}
        % #freq, df, ...
        h= findobj(c, 'flat', 'tag', 'essd_uic_figpopup(4)');
        if strcmp(popupstr(h),'# of freqs')&(floor(num) ~= num)
          %make integer
          numCorr = round(num); Corr=1; num=numCorr;
        end
        if num<0
          numCorr = abs(num); Corr=1;
        elseif num==0
          if strcmp(popupstr(h),'# of freqs'), numCorr = 1;
          elseif any(findstr(popupstr(h),'Nf/')), numCorr=5;
          elseif any(findstr(popupstr(h),'/')), numCorr=0.1;
          elseif strcmp(popupstr(h),'# of freqs')
            fs=str2num(get(findobj(c, 'flat', 'tag', 'essd_uic_cfedit'),'string'));
            N=str2num(get(findobj(c, 'flat', 'tag', 'essd_uic_ssedit'),'string'));
          else numCorr=NaN;
          end
          Corr=1;
        end
      case 'essd_uic_figrb(5)'
        % non-negative:  fmin
        if num<0
          numCorr = abs(num); Corr=1;
        end
        % fmin < fmax ?
        fmax=str2num(get(findobj(c,'flat', 'tag', 'essd_uic_figrb(6)'), 'string'));
        if fmax<=numCorr
          %numCorr=fmax/2; Corr=1; msg=' (fmax must be greater than fmin)';
          set(findobj(myfig, 'tag', 'essd_uic_figrb(6)'), 'string',num2str(numCorr))
        end
      case {'essd_uic_figrb(6)', 'essd_uic_figrb(17)', 'essd_uic_cfedit', 'essd_uic_agedit(21)',...
            'essd_uic_agedit_peak(21)'}
        % positive: fmax, bitfreq, clock freq, ampl
        if num<0
          numCorr = abs(num); Corr=1;
        elseif num==0
          numCorr = 1; Corr=1;
        end
        if strcmp(sender, 'essd_uic_figrb(6)')
          % fmin < fmax ?
          fmin=str2num(get(findobj(myfig, 'tag', 'essd_uic_figrb(5)'), 'string'));
          if fmin>numCorr
            numCorr=fmin*2; Corr=1; msg=' (fmax must not be smaller than fmin)';
          end
        end
      case 'essd_uic_stateedit'
        %integer
        if rem(num,1)~=0
          numCorr = round(num); Corr=1;
        end
    end
    
    if Corr
      essd('status', ['Warning: value automatically corrected, check again.' msg])
      set(h,'string', num2str(numCorr));
    else
      essd('status', 'Parameter accepted.')
    end
    
    if strcmp(p2,'essd_uic_expedit') %experiment number
      hstart=findobj(c, 'flat', 'tag','essd_uic_startpop');
      hstartt=findobj(c, 'flat', 'tag','essd_uic_starttext');     
      hstartstr=get(hstart,'string');
      expno=str2num(str);
      if isequal(expno,1)&guiinfos('islinear')
        set([hstart,hstartt],'enable','on')
        essd('essd_uic_startpop');
        set([findobj(c, 'flat', 'tag','essd_uic_itertext');...
          findobj(c, 'flat', 'tag','essd_uic_iteredit')],'enable','on');
      else
        ii=1;
        while ~strcmp(popupstr(hstart),'Random') 
          ii=rem(ii,length(hstartstr))+1; set(hstart,'value',ii)
        end
        essd('essd_uic_startpop');
        set([hstart,hstartt],'enable','off')
        set([findobj(c, 'flat', 'tag','essd_uic_itertext');...
          findobj(c, 'flat', 'tag','essd_uic_iteredit')],'enable','off');
        set([findobj(c, 'flat', 'tag','essd_uic_iteredit')],'string','0');
      end
    end
    
  elseif strcmp(p1,'destroyed')
    % close all children 
    guiclose('excitation')         
    fdtool('finished_box', 'rect_excitation', 'cancel', Me);
    
    
  elseif strcmp(p1,'dirty')
    
  elseif strcmp(p1,'dummy')
    % no action
  else 
    if guiinfos('isdevelopment')
      disp(['Error: essd.m called with incorrect command:' p1]) 
    end
  end
  %
  
  % local functions
  
  function fnnew=setfn(fntypeold,fnval,fmin,fmax);
  %Calculate fn numbers
  if strcmp(fntypeold,'# of freqs'), fnnew=fnval;
  elseif strcmp(fntypeold,'df'), fnnew=round((fmax-fmin)/(fnval+eps)+1);
  elseif strcmp(fntypeold,'df/fmin'), fnnew=round((fmax-fmin)/(fnval*fmin+eps)+1);
  elseif strcmp(fntypeold,'df/fmax'), fnnew=round((fmax-fmin)/(fnval*fmax+eps)+1);
  elseif strcmp(fntypeold,'Nf/oct'), fnnew=fnval*max(log2((fmax+eps)/(fmin+eps)),1)+1;
  elseif strcmp(fntypeold,'Nf/dec'), fnnew=fnval*max(log10((fmax+eps)/(fmin+eps)),1)+1;
  elseif strcmp(fntypeold,'df/f'), fnnew=max(log10((fmax+eps)/(fmin+eps)),1)/(fnval)+1;
  else fnnew=2;
  end
  fnnew=round(fnnew);
  
  function fnvalstr=prepfnval(fntypenew,fnnew,fmin,fmax)
  fnnew=round(fnnew);
  dfnew=(fmax-fmin)/max(fnnew-1,0.45);
  if strcmp(fntypenew,'df')
    fnvalstr=num2str(dfnew);
  elseif strcmp(fntypenew,'# of freqs')
    fnvalstr=num2str(fnnew);
  elseif strcmp(fntypenew,'df/fmin')
    fnvalstr=num2str(dfnew/max(fmin,dfnew));
  elseif strcmp(fntypenew,'df/fmax')
    fnvalstr=num2str(dfnew/fmax);
  elseif strcmp(fntypenew,'Nf/oct')
    fnvalstr=num2str((fnnew-1)/log2((fmax+eps)/(fmin+eps)));
  elseif strcmp(fntypenew,'Nf/dec')
    fnvalstr=num2str((fnnew-1)/log10((fmax+eps)/(fmin+eps)));
  elseif strcmp(fntypenew,'df/f')
    fnvalstr=num2str(log10((fmax+eps)/(fmin+eps))/(fnnew-1));
  else 
    error('Unknown popup string')
  end
  if any(findstr(fntypenew,'/'))&~isfinite(str2num(fnvalstr)), fnvalstr='1'; end
  
  function signalout=setA(signal,myfig)
  %Set the effective value here from RMS in ESSD window
  hA=[findobj(allchild(myfig),'flat','tag','essd_uic_agedit(21)');...
      findobj(allchild(myfig),'flat','tag','essd_uic_agedit_peak(21)')]; 
  Aeff=str2num(get(hA,'string'));
  hsf=findobj(allchild(myfig),'flat','tag','essd_uic_recfiltrb(1)'); %Reconstruction filter
  sfon=get(hsf,'value');
  u=signal.input; if ~iscell(u), u={u}; end
  for ii=1:prod(size(u))
    maxu=max(abs(u{ii}(:))); ueff=sqrt(mean(u{ii}(:).^2)); N=length(u{ii});
    if sfon
      interp=16; Np2=N*interp;
      if strcmp(signal.inputcharacter,'ZOH')
        indcN=ceil(signal.inputfrequencies*signal.Ts*N-0.01)+1;
        uf=u{ii}(:,ones(1,interp))'; uf=uf(:);
        UF=fft(uf); cx=UF(indcN);
        UF=zeros(1,Np2); UF(indcN)=cx;
      else %BL
        indcN=round(signal.inputfrequencies*signal.Ts*N)+1;
        if ~isempty(indcN)&any(abs(rem(indcN+0.3,1)-0.3)>1e5*eps)
          essd('status','Warning! Signal is nonperiodic')
        end
        indcN=round(indcN(:)); ind0=find(diff(indcN)==0);
        if ~isempty(ind0), indcN(ind0)=[]; end
        UFs=fft(u{ii});
        UF=zeros(1,Np2); UF(indcN)=UFs(indcN)/N*Np2; 
      end
      uf=2*real(ifft(UF)); clear UF
      maxu=max(abs(uf)); ueff=sqrt(mean(uf(:).^2));
    else
      uf=[];
    end
    signalout=signal;
    if exist('krgodfrey.mat')
      u{ii}=u{ii}/maxu*Aeff;
    else
      u{ii}=u{ii}/ueff*Aeff;
    end
    %if nargout>=2, uf=uf/ueff*Aeff; end
  end %ii
  if length(u)==1, u=u{1}; end
  set(signalout,'input',u);
  %End of setA
  
  function [status, outvect]=CalcMatlabExpr(varargin)
  % [status, outvect]=CalcMatlabExpr(typestr, evalstr, auxdata,...)
  % FREQ: CalcMatlabExpr('FREQ', evalstr, fs, df)
  % AMPL: CalcMatlabExpr('AMPL', evalstr, freqvect);
  if strcmp(varargin{1}, 'FREQ')
    fc=varargin{3}; fs=fc; df=varargin{4};
    eval(['outvect=' varargin{2} '; status=1;'], 'outvect=[]; status=0;');
  elseif strcmp(varargin{1}, 'AMPL')
    fv=varargin{3}; fv=fv(:);
    eval(['outvect=' varargin{2} '; status=1;'], 'outvect=[]; status=0;');
  end
  if any(outvect<0)
    status=0; outvect=[]; 
    eval('error(''Negative element in vector'')','')
  end    
  %End of CalcMatlabExpr
  
  function [freqvect,errmsg,parameters,ampvect,xt]=getfv(myfig,mode)
  %GETFV Generate freq and ampl vectors, and check consistencies with parameters
  %
  %       Input arguments:
  %       myfig = the figure handle, passed from caller
  %       mode = if 'adjust', then it modifies the values of some design parameters.
  %
  %       Output arguments:
  %       freqvect = frequency vector
  %       errmsg = empty if everything is OK, else contains an error message
  %       parameters = structure of necessary parameters
  %       ampvect = amplitude vector
  %       xt = generated time series (if it exists)
  
  if nargin<2, mode=''; end
  v=version; ip=findstr('.',v); if ip(1)==3, v=[setstr('a'-10+str2num(v(1:2))),v(3:end)]; end
  if v(1)>='9', narginchk(1,2); %Matlab 2016a or later
  else ni=nargin; error(nargchk(1,2,ni)), %earlier
  end
freqvect=[]; ampvect=[]; xt=[]; parameters=[]; errmsg='';
  cx=[];
  
  %Get appropriate parameters
  Me=get(myfig, 'tag');
  c=get(myfig,'children');
  if strncmp(mode,'adjust',6)
    %reminder on adjusting action for import and Matlab expression
    set(findall(c, 'tag','essd_uic_adjustpb'),'userdata','adjusted')
  end
  
  h=findobj(c, 'flat', 'userdata', 'essd_uic_stsgrb', 'value',1);
  type_str=get(h,'string');
  
  hfmin=findobj(c, 'flat', 'tag', 'essd_uic_figrb(5)');
  fmin=str2num(get(hfmin,'string'));
  
  hfmax=findobj(c, 'flat', 'tag', 'essd_uic_figrb(6)');
  fmax=str2num(get(hfmax,'string'));
  
  hfntype=findobj(c, 'flat', 'tag','essd_uic_figpopup(4)');
  fntype=popupstr(hfntype);
  prev=get(hfntype,'userdata');
  if isempty(prev), prev='df'; end
  hF=findobj(c, 'flat', 'tag', 'essd_uic_figrb(7)');
  if strcmp(prev,'# of freqs')
    F=str2num(get(hF,'string'));
  else
    fnval=str2num(get(hF,'string'));
    F=setfn(prev,fnval,fmin,fmax);
  end
  %
  if (F<1)|~isfinite(F), F=1, fnvalstr=prepfnval(fntype,F,fmin,fmax); set(hF,'string',fnvalstr), end
  if abs(F-round(F))<1e-5*F
    F=round(F);
    fnvalstr=prepfnval(fntype,F,fmin,fmax); set(hF,'string',fnvalstr)
  end
  if rem(F,1)~=0, %round to integer
    if strncmp(mode,'adjust',6)
      F=round(F); set(hF,'string',num2str(F))
    else
      errmsg='Error: noninteger number of frequencies';
      return
    end
  end
  
  h=findobj(c, 'flat', 'tag', 'essd_uic_genpop');
  tmpstr=get(h,'string');
  tmpval=get(h,'value');
  gentype=tmpstr{tmpval};
  
  h=findobj(c, 'flat', 'userdata', 'essd_uic_fgrb', 'value',1);
  freqdist_str=get(h,'string');
  
  hN=findobj(c, 'flat', 'tag', 'essd_uic_ssedit');
  N=str2num(get(hN,'string'));
  hfc=findobj(c, 'flat', 'tag', 'essd_uic_cfedit');
  fc=str2num(get(hfc,'string'));
  if strncmp(mode,'adjust',6)
    if fc<=0
      if strncmp(mode,'adjust',6)
        fc=abs(max(abs(fb),max(fc))); if fc==0, fc=1e-6; end
        set(hfc,'string',num2str(fc))
      else
        errmsg='Error: Clock frequency is non-positive';
        return
      end
    end
    if strcmp(lower(type_str), 'prbs')
      if rem(N,1)~=0, %round to integer
        N=round(N); set(hN,'string',num2str(N))
      end
    elseif any(findstr(lower(freqdist_str),'third'))&any(findstr(lower(freqdist_str),'odd'))
      if rem(N,6)~=0, %round to integer
        N=6*round(N/6); set(hN,'string',num2str(N))
      end
    elseif findstr(lower(freqdist_str),'third')
      if rem(N,3)~=0, %round to integer
        N=3*round(N/3); set(hN,'string',num2str(N))
      end
    else
      if rem(N,2)~=0, %round to even integer
        N=2*round(N/2); set(hN,'string',num2str(N))
      end
    end
    if fmax==0
      fmax=fc/N; fmin=fmax;
      set(hfmax,'string',num2str(fmax));
      set(hfmin,'string',num2str(fmin));
    end
  else %check
    if strcmp(lower(type_str), 'prbs')
      if rem(N,1)~=0, %not integer
        errmsg='Error: noninteger number of samples';
        return
      end
    elseif findstr(lower(freqdist_str),'third')&findstr(lower(freqdist_str),'odd')
      if rem(N,6)~=0, %round to integer
        errmsg='Error: number of samples is not a multiple of 6';
        return
      end
    elseif findstr(lower(freqdist_str),'third')
      if rem(N,3)~=0, %round to integer
        errmsg='Error: number of samples is not a multiple of 3';
        return
      end
    else
      if rem(N,2)~=0, %not even integer
        errmsg='Error: noninteger or odd number of samples';
        return
      end
    end
  end
  
  %if strncmp(mode,'adjust',6)
  %  if isempty(fmax), fmax=fc/2; end
  %end
  
  hfb=findobj(c, 'flat', 'tag', 'essd_uic_figrb(17)');
  fb=str2num(get(hfb,'string'));
  if ~isempty(fb)&(fb<=0)
    if strncmp(mode,'adjust',6)
      fb=abs(max(abs(fb),abs(fc))); if fb==0, fb=1e-6; end
      set(hfb,'string',num2str(fb))
    else
      errmsg='Error: Bit frequency is non-positive';
      return
    end
  end
  if (strcmp(lower(type_str),'dibs')|strcmp(lower(type_str),'dits'))&0 %fb inactive now
    if fc<fb
      %fc=fb; set(hfc,'string',num2str(fc))
      fb=fc; set(hfb,'string',num2str(fb))
    end
    Np=fc/fb;
    Npnew=round(Np);
    if abs(rem(Np+0.3,1)-0.3)>Np*eps*1e3
      if strncmp(mode,'adjust',6)
        fc=fb*Npnew; set(hfc,'string',num2str(fc))
      else
        errmsg='Error: clock frequency is not an integer multiple of the bit frequency';
        return
      end
    end
  end
  
  if findstr(lower(freqdist_str),'odd')&strcmp(lower(type_str),'prbs')
    lengthmod=2; %inverse repeat
  else
    lengthmod=1;
  end
  
  h=findobj(c, 'flat', 'userdata', 'essd_uic_agrb', 'value',1);
  ampdist_str=get(h,'string');
  
  h=findobj(c, 'flat', 'tag', 'essd_uic_figrb(19)');
  reglength=str2num(get(h,'string'));
  if strcmp(lower(type_str), 'prbs')  % PRBS
    if strncmp(mode,'adjust',6)
      reglengthi=reglength;
      if reglength>30, reglengthi=30;
      elseif reglength<0, reglengthi=2;
      else reglengthi=round(reglength);
      end
      if reglengthi~=reglength
        reglength=reglengthi;
        set(h,'string',num2str(reglength));
      end         
    else %check
      if (reglength<1)|(reglength>30)|(rem(reglength,1)~=0)
        errmsg='Error: Register length not allowed';
        return
      end
    end
  end
  
  hA=[findobj(c, 'flat', 'tag', 'essd_uic_agedit(21)');findobj(c, 'flat', 'tag', 'essd_uic_agedit_peak(21)')];
  A=str2num(get(hA,'string'));
  
  h=findobj(c, 'flat', 'tag', 'essd_uic_figrb(17)');
  stepfreq=str2num(get(h,'string'));
  
  hif=findobj(c, 'flat', 'tag', 'essd_uic_recfiltrb(1)'); %Smoothing filter on
  reconstruction_filter=get(hif,'enable');
  if strcmp(reconstruction_filter,'on')|strcmp(reconstruction_filter,'inactive')
    reconstruction_filter=get(hif,'value');
  else
    reconstruction_filter=0;
  end
  %reconstruction_filter=1 means that reconstruction is required
  
  %Begin checks
  if strcmp(lower(type_str), 'prbs')  % PRBS
    Nreg=2^reglength-1;
    if strncmp(mode,'adjust',6)
      stepfreq=fc/max(round(fc/stepfreq),1);
      hsf=findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figrb(17)');
      set(hsf, 'string', num2str(stepfreq))
      N=Nreg*lengthmod*round(fc/stepfreq);
      set(hN, 'string',num2str(N))
      if N>1e5, errmsg=sprintf('N=%.0f would be too large',N); return, end
    else %give warning/error
      Ni=Nreg*lengthmod*fc/stepfreq;
      if abs(N-Ni)>Ni*100*eps
        errmsg='Warning: Fractional period in PRBS';
      end
    end
  end
  %
  %Check allowed properties of generator
  if reconstruction_filter==1, rfi='on'; else rfi='off'; end
  data=fdhwcall('Properties',gentype,'fe',fc,'Ne',N,'reconstruction_filter',rfi,'A',A);
  if isstruct(data)
    if strncmp(mode,'adjust',6)
      if data.fe~=fc
        fc=data.fe; set(hfc,'string',num2str(fc))
      end
      if data.Ne~=N
        if strcmp(lower(type_str), 'prbs')  % PRBS
          errmsg='Warning: cannot generate PRBS as given';
          N=data.Ne; set(hN,'string',num2str(N))
          stepfreq=fc*N/Nreg;
          hsf=findobj(allchild(myfig), 'flat', 'tag', 'essd_uic_figrb(17)');
          set(hsf, 'string', num2str(stepfreq))
        end
      end
      if ~strcmp(data.reconstruction_filter,rfi)
        hif2=findobj(c, 'flat', 'tag', 'essd_uic_recfiltrb(2)'); %reconstruction filter off
        %reconstruction_filter=get(hif,'enable');
        %if strcmp(reconstruction_filter,'on'), reconstruction_filter=get(hif,'value'); end
        if strcmp(data.reconstruction_filter,'on')
          %Switch on
          set(hif,'value',1,'enable','on'), set(hif2,'value',0,'enable','on')
        else
          %Switch off from on
          set(hif,'value',0), set(hif2,'value',1)
        end
      end
      if data.A~=A
        A=data.A; set(hA,'string',num2str(A))
      end
    else %check
      if data.fe~=fc
        errmsg='Error: Clock frequency not allowed'; return
      end
      if data.Ne~=N
        if strcmp(lower(type_str), 'prbs')  % PRBS
          errmsg='Warning: cannot generate one sample per bit';
        else
          errmsg='Error: number of samples not allowed'; return    
        end
      end
      if ~strcmp(data.reconstruction_filter,rfi)
        errmsg='reconstruction filter setting not allowed'; return    
      end
      if data.A~=A
        errmsg='RMS value not allowed'; return    
      end
    end
  end
  
  if strcmp(lower(type_str),'multisine')|strcmp(lower(type_str),'dibs')|...
      strcmp(lower(type_str),'dits')
    %Now the number of samples will be set if necessary (adjustn)
    if strcmp(mode,'adjustn')
      switch lower(freqdist_str)
        case {'linear','odd linear','odd odd linear','randomized odd linear','special odd',...
              'no third harmonics','odd, no third harmonics','quasilog','randomized odd quasilog',...
              'all dft freqs', 'most dft freqs'}
          switch lower(freqdist_str)
            case 'linear', df=(fmax-fmin)/(F-0.999999);
            case 'odd linear', df=(fmax-fmin)/(2*(F-0.9999999));
            case 'odd odd linear', df=(fmax-fmin)/(4*(F-0.9999999));
            case 'special odd', df=(fmax-fmin)/(4*(F-0.9999999));
            case 'randomized odd linear', df=(fmax-fmin)/(3*(F-0.9999999));
            case 'no third harmonics', df=(fmax-fmin)/(3/2*(F-0.9999999));
            case 'odd, no third harmonics', df=(fmax-fmin)/(3*(F-0.9999999));
            case 'quasilog', df=(fmax-fmin)^(1/(F-0.9999999))-fmin;      
            case 'randomized odd quasilog', df=(fmax-fmin)^(1/(F-0.9999999))-fmin;      
            case 'all dft freqs', df=(fmax-fmin)/(F-0.9999999);  
            case 'most dft freqs', df=(fmax-fmin)/(F-0.9999999);  
          end
          if df>fc/2, df=fc/2; end
          if fc<=2*fmax
            fc=4*fmax; set(hfc,'string',num2str(fc))
            if strcmp(lower(type_str),'dibs')|strcmp(lower(type_str),'dits')
              fc=4*fmax; set(hfc,'string',num2str(fc))
              if abs(rem(fc/fb+0.3,1)-0.3)>fc*eps*1000
                Nov=round(fc/fb); fb=fc/Nov; set(hfb,'string',num2str(fb))
              end
            end
          end
          N=round(fc/df/2)*2; set(hN,'string',num2str(N))
        end
      end %adjustn
      %
      if N<4, N=4; set(hN,'string',num2str(N)), end
      Np=N;
      if rem(Np,1)~=0
        if strncmp(mode,'adjust',6)
          Np=round(Np); N=Np;
          set(hN,'string',num2str(N))
        else %may not adjust
          errmsg='Error: Noninteger number of periods.'
          return
        end
      end
      if fmax>fc/2
        if strncmp(mode,'adjust',6)
          fmax=fc/2*(Np/2-1)/(Np/2);
          set(hfmax,'string',num2str(fmax))
        else %may not adjust
          errmsg='Error: fmax is larger than fc/2.';
          return
        end
      end
      if fmin>fmax
        if strncmp(mode,'adjust',6)
          fmin=fmax*(Np/2-F+1)/(Np/2); if fmin<0, fmin=0; end
          set(hfmin,'string',num2str(fmin))
        else %may not adjust
          errmsg='Error: fmin is larger than fmax.';
          return
        end
      end
      % 
      dfi=fc/Np; %df in the DFT of a period
      
      %First set common values
      switch lower(freqdist_str)
        case {'linear','odd linear','odd odd linear','special odd','randomized odd linear',...
              'no third harmonics','odd, no third harmonics','quasilog','odd quasilog','randomized odd quasilog',...
              'all dft freqs', 'most dft freqs'}
          switch lower(freqdist_str)
            case 'linear', fiall=[0:Np/2]';
            case 'odd linear', fiall=[1:2:Np/2]';
            case 'odd odd linear', fiall=[1:4:Np/2]';
            case 'special odd', fiall=sort([1:8:Np/2,3:8:Np/2]');
              if strncmp(mode,'adjust',6)
                F=length(fiall); %fmin=min(fiall)*dfi; fmax=max(fiall)*dfi;
              end
            case 'randomized odd linear', fiall=sort([1:2:Np/2]');
            case 'no third harmonics', fiall=sort([1:3:Np/2,2:3:Np/2]');
            case 'odd, no third harmonics', fiall=sort([1:6:Np/2,5:6:Np/2]');
            case 'quasilog', fiall=[1:(Np+1)/2-1]';      
            case {'randomized odd quasilog','odd quasilog'}, fiall=[1:2:(Np+1)/2-1]';      
            case 'all dft freqs', fiall=[0:Np/2]';  
            case 'most dft freqs', fiall=[1:(Np+1)/2-1]';  
          end
          ind=find((fiall>fmin/dfi-0.5)&(fiall<fmax/dfi+0.5));
          fiposs=fiall(ind);
          %Randomize grid
          fmini=min(fiposs)*dfi; fmaxi=max(fiposs)*dfi;
          if strcmp(lower(freqdist_str),'randomized odd linear')
            indn=1:3:length(fiposs)-2; indn=floor(indn+3*(1-eps)*rand(size(indn)));
            fiposs(indn)=[];
          end
          if F>length(fiposs)
            if strncmp(mode,'adjust',6)
              F=length(fiposs);
              fnvalstr=prepfnval(fntype,F,fmin,fmax); set(hF,'string',fnvalstr)
            else %do not adjust
              errmsg='Error: number of frequencies is too large for given rule';
              return
            end
          end
          if abs(fmin-fmini)>dfi/100
            if strncmp(mode,'adjust',6)
              fmin=fmini;
              set(hfmin,'string',num2str(fmin))
            else %may not adjust
              if ~any(findstr(lower(errmsg),'error'))
                errmsg='Warning: fmin differs from the desired DFT frequency';
                fmin=fmini;
                set(hfmin,'string',num2str(fmin))
              end
            end
          end
          if abs(fmax-fmaxi)>dfi/100
            if strncmp(mode,'adjust',6)
              fmax=fmaxi;
              set(hfmax,'string',num2str(fmax))
            else %may not adjust
              if ~any(findstr(lower(errmsg),'error'))
                errmsg='Warning: fmax differs from desired DFT frequency';
                fmax=fmaxi;
                set(hfmax,'string',num2str(fmax))
              end
            end
          end
          
          switch lower(freqdist_str)  
            case {'linear','odd linear','odd odd linear','randomized odd linear',...
                  'quasilog','odd quasilog','randomized odd quasilog',...
                  'special odd','no third harmonics','odd, no third harmonics'}
              if F==1
                freqvect=(fmax+fmin)/2;
                if strncmp(mode,'adjust',6) %pull to DFT grid
                  [minv,ii]=min(abs(freqvect-fiall*dfi));
                  freqvect=fiall(ii)*dfi;
                end
                if fmax~=fmin
                  if strncmp(mode,'adjust',6)
                    fmin=freqvect; fmax=fmin; 
                    set(hfmin,'string',num2str(fmin))
                    set(hfmax,'string',num2str(fmax))
                  else 
                    if ~any(findstr(lower(errmsg),'error'))
                      errmsg='Warning:  freqs = 1, but fmin ~= fmax';
                    end
                  end
                end
              else %F>1
                switch lower(freqdist_str)
                  case 'linear'
                    %possible to deviate from grid
                    fimin=max(0,ceil(fmin/dfi-0.001));
                    fimax=min(round(Np/2),floor(fmax/dfi+0.001));
                  case 'odd linear'
                    fimin=max(1,ceil((fmin/dfi-1.001)/2)*2+1);
                    fimax=min(round(Np/2),floor((fmax/dfi+1.001)/2)*2-1);
                  case 'odd odd linear'
                    fimin=max(1,ceil((fmin/dfi-1.001)/4)*4+1);
                    fimax=min(round(Np/2),floor((fmax/dfi+3.001)/4)*4-3);
                  case {'quasilog','randomized odd quasilog'}
                    fimin=max(ceil(fmin/dfi-0.001),1);
                    fimax=min(floor(fmax/dfi+0.001),round(Np/2));
                  otherwise
                    fimin=max(ceil(fmin/dfi-0.001),1);
                    ind=min(find(fiall>=fimin)); fimin=fiall(ind);
                    fimax=min(floor(fmax/dfi+0.001),round(Np/2));
                    ind=max(find(fiall<=fimax)); fimax=fiall(ind);
                end   
                Ni=length(fiposs);              
                if Ni<F
                  if strncmp(mode,'adjust',6)
                    F=Ni;
                    fnvalstr=prepfnval(fntype,F,fmin,fmax); set(hF,'string',fnvalstr)
                  else
                    errmsg='Error: cannot place more than one frequency';
                    return
                  end
                elseif (F<Ni)&~any(findstr('quasilog',lower(freqdist_str)))
                  essd('status','Warning: less harmonics required than possible in the given frequency range')
                end
                if fimax==fimin
                  if strncmp(mode,'adjust',6)
                    fimax=fimax+1;
                    fmax=fimax*dfi;
                    set(hfmax,'string',num2str(fmax))
                  else
                    errmsg='Error: cannot place more than one frequency';
                    return
                  end
                end
                if strncmp(mode,'adjust',6)
                  fmin=fimin*dfi; set(hfmin,'string',num2str(fmin))
                  fmax=fimax*dfi; set(hfmax,'string',num2str(fmax))
                end
                %
                switch lower(freqdist_str)
                  case 'linear'
                    freqvect=dfi*([0:F-1]'/(F-1)*(fimax-fimin)+fimin);
                    %frequencies must be pulled to DFT grid! 
                    %if strncmp(mode,'adjust',6)
                    if freqvect(1)==0; f0=1; else f0=0; end
                    freqvect=log2qlog(freqvect,fimax,dfi); %pull to DFT grid
                    if f0&~any(freqvect==0), freqvect=[0;freqvect]; end
                    %end
                  case {'odd linear','odd odd linear'}
                    if strcmp(lower(freqdist_str),'odd linear'), ds=2; else ds=4; end
                    fmod=Ni/F;
                    freqvect=dfi*[fimin:fmod*ds:fimax]';
                    for ii=1:length(freqvect)
                      [minv,iii]=min(abs(freqvect(ii)/dfi-fiall));
                      freqvect(ii)=fiall(iii)*dfi;
                    end %for ii
                  case {'quasilog','odd quasilog','randomized odd quasilog'}       
                    Fmin=2; Fmax=fimax-fimin+1;
                    rfmin=fimax/(fimax-1); rfmax=fimax/fimin;
                    %
                    rfnew=(fimax/fimin)^(1/(F-1));
                    if any(findstr('odd',lower(freqdist_str))), di=2; else di=1; end
                    freqvect=lin2qlog(dfi*[fimin:di:fimax]',rfnew);
                    if any(findstr('randomized',lower(freqdist_str)))
                      for ii=fimin:3*di:fimax-2
                        if all(ismember(dfi*(ii+[0,di,2*di]),freqvect))
                          ind=find(dfi*ii==freqvect)+floor(3*(1-eps)*rand(1,1));
                          if ind<=length(freqvect), freqvect(ind)=[]; end
                        end
                      end
                    end
                    Fnew=length(freqvect);
                    %
                    while Fnew~=F
                      if Fnew<F, Fmin=Fnew; rfmax=rfnew;
                      elseif Fnew>F, Fmax=Fnew; rfmin=rfnew;
                      end
                      rfnew=(rfmin*rfmax^9)^(1/10);
                      freqvect=lin2qlog(dfi*[fimin:di:fimax]',rfnew);
                      if any(findstr('randomized',lower(freqdist_str)))
                        for ii=fimin:3*di:fimax-2
                          if all(ismember(dfi*(ii+[0,di,2*di]),freqvect))
                            ind=find(dfi*ii==freqvect)+floor(3*(1-eps)*rand(1,1));
                            if ind<=length(freqvect), freqvect(ind)=[]; end
                          end
                        end
                      end
                      Fnew=length(freqvect);
                    end %while
                    %end quasilog
                  case 'randomized odd linear'
                    if F>1
                      indv=round([1:F]/F*length(fiposs));
                      ind=find(diff(indv)==0); if ~isempty(indv), indv(ind)=[]; end
                    else indv=imin;
                    end
                    freqvect=fiposs(indv)*dfi;
                  otherwise
                    imin=min(find(fiall>=fimin)); 
                    imax=max(find(fiall<=fimax));
                    if F>1, indv=round(imin:(imax-imin)/(F-1):imax+0.5);
                    else indv=imin;
                    end
                    freqvect=fiall(indv)*dfi;
                  end %make freqvect in different cases
                  %
                  if F~=length(freqvect)
                    if strncmp(mode,'adjust',6)
                      F=length(freqvect);
                      fnvalstr=prepfnval(fntype,F,fmin,fmax); set(hF,'string',fnvalstr)
                    else
                      errmsg='Error: frequency number mismatch';
                      return
                    end
                  end
                end %F>1
              case {'all dft freqs', 'most dft freqs'}
                %set F to proper value
                if strncmp(mode,'adjust',6)
                  switch lower(freqdist_str)
                    case 'all dft freqs'
                      fmin=0; fmax=ceil(Np/2)*dfi;
                    otherwise
                      fmin=0.995*dfi; fmax=(ceil(Np/2)-0.995)*dfi;
                  end
                end
                if F~=length(fiall)
                  if strncmp(mode,'adjust',6)
                    F=length(fiall);
                    fnvalstr=prepfnval(fntype,F,fmin,fmax); set(hF,'string',fnvalstr)
                  else %may not adjust
                    errmsg='Error: number of freqs differs from defined number of frequencies';
                    return
                  end
                end
                freqvect=fiall*dfi;
            end  
          case 'import...'  %import 
            freqvect=guidtard(Me, 'IMPORTDATA_FREQ');
            if size(freqvect,1)==1, freqvect=freqvect.'; end
            if any(freqvect<0)
              errmsg='Error: Negative frequency in vector';
              return
              %enable View 
              h=[findobj(get(myfig,'children'), 'flat', 'tag', 'essd_uic_viewpb')];
              set(h, 'enable', 'on');
              return
            end         
          case 'matlab expression'
            freqstr=guidtard(Me, 'EXPR_DATA_FREQ');
            [status, freqvect]=CalcMatlabExpr('FREQ', freqstr, fc, dfi);
            if ~status
              %errmsg='Error in evaluating frequency vector. See command window for details.';
              %disp([lasterr ' Check Matlab expression.'])
              return   
            end
            if size(freqvect,1)==1, freqvect=freqvect.'; end
            if any(freqvect<0)
              errmsg='Error: Negative frequency in vector';
              %enable View 
              h=[findobj(get(myfig,'children'), 'flat', 'tag', 'essd_uic_viewpb')];
              set(h, 'enable', 'on');
              return
            end
            
          otherwise
            error('case ended without match')
          end %freqdist_str
          
          cond=strcmp(lower(freqdist_str),'import...')|...
            strcmp(lower(freqdist_str),'matlab expression');
          adj=cond&strcmp(get(findall(c, 'tag','essd_uic_adjustpb'),'userdata'),'adjusted');
          if strncmp(mode,'adjust',6)|adj
            %pull frequencies to DFT grid
            set(findall(c, 'tag','essd_uic_adjustpb'),'userdata','adjusted')
            freqvect=dfi*round(freqvect/dfi);
            if ~isempty(freqvect)
              freqvect=sort(freqvect);
              dfreqvect=diff(freqvect);
              if ~isempty(dfreqvect)
                ind=find(dfreqvect==0);
                if ~isempty(ind), freqvect(ind)=[]; end
                ind=find(freqvect>fc/2*(1+10*eps));
                if ~isempty(ind), freqvect(ind)=[]; end
              end
              fmax=max(freqvect); set(hfmax,'string',num2str(fmax))
            end
            F=length(freqvect);
            fnvalstr=prepfnval(fntype,F,fmin,fmax); set(hF,'string',fnvalstr)
            %set(hF,'userdata',freqvect) %store adjusted freqvect
          elseif ~strncmp(mode,'adjust',6)
            %check only frequencies
            if any(freqvect>fc/2*(1+10*eps))
              errmsg='Error: frequencies surpass half of clock frequency';
              %return
            end
            if any(abs(freqvect-dfi*round(freqvect/dfi))>1e-5*freqvect)
              %definitely wrong
              errmsg='Error: Frequency vector misses DFT grid. Use ''Adjust'', or correct.';
              %enable View 
              h=[findobj(get(myfig,'children'), 'flat', 'tag', 'essd_uic_viewpb')];
              set(h, 'enable', 'on');
              %return
            elseif (lengthmod==2)&any(rem(round(freqvect/dfi),2)==0)
              %definitely wrong
              errmsg='Error: Even frequency indices in vector. Use ''Adjust'', or correct.';
              %enable View 
              c=get(myfig,'children');
              h=[findobj(c, 'flat', 'tag', 'essd_uic_viewpb')];
              set(h, 'enable', 'on');
              %return
            end
          end %adjust
          dfifv=dfcalc([freqvect(:)]);
          if (dfifv>dfi)&(abs(dfifv-dfi)>1e-5)
            Np=N*dfi/dfifv;
            dfi=dfifv;
          end
          Tp=Np/fc;
          Tr=N/fc;
          
          %AMPVECT CALCULATION
          ampvect=zeros(size(freqvect)); %default
          switch lower(ampdist_str)
            case 'constant'
              ampvect=ones(size(freqvect));
            case '1/f'
              ampvect=ones(size(freqvect));
              if freqvect(1)==0
                errmsg='Cannot calculate 1/f for zero frequency point';
                return
              end
              ampvect=ampvect./freqvect;
            case 'f'
              ampvect=ones(size(freqvect));
              ampvect=ampvect.*freqvect;
            case 'follow frf' 
              if nargout>=4 %amplitude requested
                frf_data=guidtard(Me, 'IMPORTDATA_FRF');
                if isa(frf_data,'iddat')
                  fvfrf=frf_data.freqpoints;   
                  u=frf_data.input;
                  if iscell(u), u=u{1}; end
                  y=frf_data.output;
                  if iscell(y), y=y{1}; end
                else
                  fvfrf=frf_data.places;
                  u=frf_data.u; u=u(:,:,1); y=frf_data.y; y=y(:,:,1);
                end
                Ff=length(fvfrf);
                fvfrf=[-eps;fvfrf;max(2*fvfrf(Ff),max(freqvect))];
                tfrf=[abs(y(1)/u(1));abs(y./u);abs(y(Ff)/u(Ff))];
                ampvect=interp1(fvfrf,tfrf,freqvect);
              end  
            case 'optimize for model'
              if nargout>=4 %amplitude requested
                model_data=guidtard(Me, 'IMPORTDATA_MODEL');
                var_data=guidtard(Me, 'IMPORTDATA_FRF');
                fvvar=var_data.inputfreqpoints;
                u=var_data.input; u=u(:,:,1); y=var_data.output; y=y(:,:,1);
                Ff=size(fvvar,1);
                fvvar=[-eps;fvvar;max(2*fvvar(Ff),(1+eps)*max(freqvect))];
                vxy=var_data.SiSoVariance;
                tvar=[vxy(1,:);vxy;vxy(Ff,:)];
                varmod=interp1(fvvar,tvar,freqvect);
                ampvect=[];
                h=findall(0,'tag','essd_uic_cycledit');
                cycles=str2num(get(h,'string'));
                %cycles=3;
                plotdens=min(cycles,10);
                while isempty(ampvect)
                  hfo=figure(9); %Gyuszi! gyors fix, hogy ne rajzoljon a recorder-be!
                  if isnumeric(varmod), varmod=varmod/2; %prepare old call
                  else
                    for ii=1:length(varmod), varmod{ii}=varmod{ii}/2; end
                  end
                  %New call:
                  runmod.Ncyc=cycles;
                  runmod.plotdens=plotdens;
                  model_data.data=fiddata(ones(size(freqvect)),ones(size(freqvect)),freqvect);
                  model_data.data.SiSoVariance=varmod;
                  %ampvectdat=optexcit(model_data,freqvect,varmod,[],[],cycles,[],plotdens);
                  ampvectdat=optexcit(model_data,[],runmod);
                  ampvect=ampvectdat.input;
                  %ez a szabalyokkal ellentetes, de egyelore mukodik:
                  set(hfo,'tag','optexcit plot')
                  dismispb('optexcit plot')
                end
              end
            case 'import...'
              ampvect=guidtard(Me, 'IMPORTDATA_AMPL');
              if size(ampvect,1)==1, ampvect=ampvect.'; end
              ampvect=abs(ampvect);
            case 'matlab expression'
              ampstr=guidtard(Me, 'EXPR_DATA_AMPL');
              [status, ampvect]=CalcMatlabExpr('AMPL', ampstr, freqvect);
              if ~status
                errmsg=[lasterr ' Check Matlab expression.'];
                essd('status', errmsg)
                %essd('status', 'Error in evaluating amplitude vector. See command window for details.')
                %disp([lasterr ' Check Matlab expression.'])
                return   
              end
              if size(ampvect,1)==1, ampvect=ampvect.'; end
              ampvect=abs(ampvect);
            otherwise
              error('empty case statement')  
            end
            if any(size(ampvect)~=size(freqvect))
              errmsg=sprintf(['Error: Sizes of amplitude and frequency vectors do not match: ',...
                  '%.0fx%.0f ~= %.0fx%0.f'],size(freqvect,1),size(freqvect,2),size(ampvect,1),size(ampvect,2));
              if strncmp(mode,'adjust',6)
                F=length(ampvect);
                if F>0, fnvalstr=prepfnval(fntype,F,fmin,fmax); set(hF,'string',fnvalstr), end
              end
              %enable View 
              %h=[findobj(get(myfig,'children'), 'flat', 'tag', 'essd_uic_viewpb')];
              %set(h, 'enable', 'on');
              return
            end
            %if ~isequal(reconstruction_filter,1)
            %  sincvect=sin(pi*(freqvect+eps)/fc)./(pi*(freqvect+eps)/fc);
            %  ampvect=ampvect(:)./abs(sincvect(:));
            %end
            xt=zeros(1,1,0);
            
          elseif strcmp(lower(type_str), 'prbs')  % PRBS
            Nreg=2^reglength-1;
            Np=N;
            if rem(Np,lengthmod)~=0
              if ~any(findstr(lower(errmsg),'error'))
                errmsg='Error: Noninteger number of periods.';
              end
              return
            end
            dfi=fc/Np;
            %if reglength>30
            %   essd('status','Register length is too large')
            %   guifreez(Me, 'unfreeze', 'essd_view_spectrum');
            %   return
            %end
            xt=mlbs(reglength); 
            if lengthmod==2
              nx=length(xt)-1;
              bitmod=[ones(1,nx/2);-ones(1,nx/2)]; bitmod=[bitmod(:);1];
              xt=xt.*bitmod; xt=[xt;-xt];
            end
            plmod=1;
            if (Np~=Nreg*lengthmod)|(fc~=stepfreq)
              ind=floor([0:Np-1]'*stepfreq/fc)+1;
              ind=rem(ind-1,Nreg*lengthmod)+1;
              %maybe more periods?
              if (rem(stepfreq/fc,1)==0)&(stepfreq/fc>1)&(rem(Np/(stepfreq/fc),1)==0)
                plmod=stepfreq/fc;
                for ii=2:plmod
                  if any(ind(1:Np/plmod)~=ind((ii-1)*Np/plmod+[1:Np/plmod]))
                    plmod=1; break
                  end
                end
              end
              xt=xt(ind);
              if fc<stepfreq
                if ~any(findstr(lower(errmsg),'error'))
                  errmsg='Warning: bit series subsampled.';
                end
              elseif fc>stepfreq
                if ~any(findstr(lower(errmsg),'error'))
                  errmsg='Warning: bit series oversampled.';
                end
              elseif Np<Nreg*lengthmod
                if ~any(findstr(lower(errmsg),'error'))
                  errmsg='Warning: number of samples truncated.';
                end
              elseif Np>Nreg*lengthmod
                if ~any(findstr(lower(errmsg),'error'))
                  errmsg='Warning: number of samples extended.';
                end
              end    
            end
            dfi=fc/Np*plmod;
            cx=fft(xt(1:Np/plmod));
            if strcmp(lower(freqdist_str),'most dft freqs')
              inda=2:(length(cx)-1)/2;
              freqvect=[1:length(inda)]'*dfi;
            elseif strcmp(lower(freqdist_str),'all dft freqs')
              inda=1:(length(cx)+1)/2;
              freqvect=[0:length(inda)-1]'*dfi;
            elseif strcmp(lower(freqdist_str),'odd linear')|strncmpi(lower(freqdist_str),'Inverse repeat',14)
              inda=2:2:(length(cx)-1)/2;
              freqvect=[1:2:2*length(inda)]'*dfi;
            else
              error('incorrect string')
            end
            cx=cx(inda); ampvect=abs(cx); ampvect=ampvect/max(ampvect);
            Tr=N/fc; Tp=Np/fc/plmod;
            fmin=min(freqvect); fmax=max(freqvect); F=length(freqvect);
            if isequal(reconstruction_filter,0)&~strncmpi(gentype,'Discrete seq',12)
              sincvect=sin(pi*(freqvect+eps)/fc)./(pi*(freqvect+eps)/fc);
              ampvect=ampvect(:).*abs(sincvect(:));
              if ~isempty(cx), cx=cx(:).*abs(sincvect(:)); end
            end
          else %unknown type
            error(['Signal type ',type_str,' not known'])
          end %different signal types
          
          if any(abs(rem(freqvect*N/fc+0.3,1)-0.3)>100*eps*freqvect*N/fc)
            ermsg='Frequency vector misses DFT grid. Use ''Adjust'', or correct manually.';
          end
          %
          % fill info data
          h=findobj(c, 'flat', 'tag', 'essd_uic_figrb(5)');
          set(h, 'string', num2str(fmin))
          h=findobj(c, 'flat', 'tag', 'essd_uic_figrb(6)');
          set(h, 'string', num2str(fmax))
          h=findobj(c, 'flat', 'tag', 'essd_uic_figrb(7)');
          fnvalstr=prepfnval(fntype,F,fmin,fmax); set(hF,'string',fnvalstr)
          %end
          h=findobj(c, 'flat', 'tag', 'essd_uic_figrb(9)');
          if ~exist('plmod'), plmod=1; end
          set(h, 'string', num2str(N/Np*plmod))
          h=findobj(c, 'flat', 'tag', 'essd_uic_figrb(11)');
          set(h, 'string', num2str(Np))
          h=findobj(c, 'flat', 'tag', 'essd_uic_figrb(13)');
          set(h, 'string', num2str(dfi))
          h=findobj(c, 'flat', 'tag', 'essd_uic_figrb(15)');
          set(h, 'string', num2str(Tr))
          %
          parameters.fmin=fmin;
          parameters.fmax=fmax;
          parameters.fc=fc;
          parameters.stepfreq=stepfreq;
          parameters.dfi=dfi;
          parameters.F=F;
          parameters.N=N;
          parameters.periodno=N/Np;
          parameters.type_str=type_str;
          parameters.cx=cx;
          if abs(rem(Np+0.3,1)-0.3)>1e4*N*eps
            pOK=0;
            for ii=1:N/Np*(1+1e4*eps)
              if abs(rem(ii*Np+0.3,1)-0.3)<1e4*N*eps, pOK=1; iiOK=ii; break, end
            end
            ststxt=['#yPeriod length covers fractional number of samples: ',num2str(Np)];
            if pOK
              ststxt=[ststxt,sprintf('  (but %.0f periods cover exactly %.0f samples)',iiOK,round(iiOK*Np))];
            end
            essd('status',ststxt)
          end
          
          function IterSetEnable(fig)
          % enable/disable the iter no for optexcit
          h_optex=findobj(fig, 'tag', 'essd_uic_agrb(7)');
          if get(h_optex, 'value')
            en='on';
          else
            en='off';
          end
          h=[findobj(fig,'tag','essd_uic_cycledit');
            findobj(fig,'tag','essd_uic_cycltext')];
          set(h,'enable', en)
          
          function closeenable(fig, onoff)   
          % enable/disable close button & menu
          h=[findobj(fig, 'tag', 'essd_uic_donepb'), ...
              findobj(fig, 'tag', 'excitation_menu_file_save'),...
              findobj(fig, 'tag', 'excitation_menu_file_close'),...
              findobj(fig, 'tag', 'excitation_menu_plot_spectrum'),...
              findobj(fig, 'tag', 'excitation_menu_plot_signal')];
          set(h,'enable', onoff)
          
          function MakeMeDirty(myfig)
          % make window "dirty" (close is disabled), and clear view and output data
          Me=get(myfig, 'tag');
          guidtawr(Me, 'DATA_VIEW', 'direct', '')  % clear previous view data
          guidtawr(Me, 'OUTPUT_DATA', 'direct', '')  % clear previously designed data
          closeenable(myfig, 'off')   
          
          function ClearInfo(fig)   
          % clear info fields (when the old info is not true any more)
          ch=allchild(fig);
          % Pno, dfp, Tp, Tr
          h=[findobj(ch, 'flat', 'tag', 'essd_uic_figrb(9)'), ...
              findobj(ch, 'flat', 'tag', 'essd_uic_figrb(13)'), ...
              findobj(ch, 'flat', 'tag', 'essd_uic_figrb(11)'), ...
              findobj(ch, 'flat', 'tag', 'essd_uic_figrb(15)')];
          set(h,'string', '')
          
          if 0
            h=[findall(0, 'tag', 'essd_uic_fgrb(1)');
              findall(0, 'tag', 'essd_uic_fgrb(2)');
              findall(0, 'tag', 'essd_uic_fgrb(6)');
              findall(0, 'tag', 'essd_uic_fgrb(9)');
              findall(0, 'tag', 'essd_uic_fgrb(3)');
              findall(0, 'tag', 'essd_uic_fgrb(4)');
              findall(0, 'tag', 'essd_uic_fgrb(5)');
              findall(0, 'tag', 'essd_uic_fgrb(7)');
              findall(0, 'tag', 'essd_uic_fgrb(8)')];
            get(h,'string')
            str={'Linear';
              'Odd linear';
              'Randomized odd linear';
              'Quasilog';
              'Randomized odd quasilog';
              'Import...';
              'Matlab expression';
              'All DFT freqs';
              'Most DFT freqs'};
          end
          %
          %End of file
