function gfdd(p1,p2,p3,p4,p5,seltype) 
% GFDD Get Frequency Domain Data
% Private function of the FDID Toolbox

%       Copyright (c) I. Kollar and Vrije Universiteit Brussel, ELEC, 1997-2001
%       All rights reserved.
%       $Revision: $
%       Written by Gy. Simon and Gy. Roman
%       Last modified: 22-Apr-2002, GYS



mainfig=findall(0, 'tag','fdtool_main');
Me = 'getfreq_main';
myfcn='gfdd';
myname='getfreq';

if nargin >0 & ~strcmp(p1, 'init'),        
   myfig=findall(0, 'tag',Me);
   if nargin == 6
      sender=p5;                
   else                                                
      seltype=get(myfig,'selectiontype');
      eval(['sender=p', num2str(nargin) ';']);
   end
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%                 INITIALIZATION
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


if nargin ==0 | strcmp(p1, 'init')
   tmp=findall(0, 'tag','getfreq_main');
   if ~isempty(tmp) 
      % set(tmp,'visible','on');
      %figure(tmp);
      guiclose('getfreq')         
   end
   
   gfdddef
   
   fig = figure(...
      'Units','pixels',...
      'Position',[ fig_offsx fig_offsy fig_dx fig_dy ],... 
      'resize','off',...
      'tag','getfreq_main',...
      'Color',figure_col,...
      'resize','on',...
      'resizefcn','fdtool(''callback'',''gfdd'',''resize'',''resize'')',...
      'Name','Read Frequency Domain Data',... 
      'NumberTitle','off',...
      'IntegerHandle', 'off', ...
      'Handlevisibility', 'off',...
      'windowbuttonmotion', 'fdtool(''callback'',''gfdd'',''mouse_motion'')',...
      'deletefcn', 'fdtool(''callback'',''gfdd'',''destroyed'',''getfreq_main'')', ...
      'visible','off'); 
   
   %         'Closerequestfcn','fdtool(''callback'',''gfdd'',''gfdd_uic_cancelpb'',''gfdd_uic_cancelpb'');',... 
   
   myfig=fig;
   fdwindef(myfig);  % set default window properties
   
   %  Uicontrol Object Creation 
   
   gfdd_uic_donepb = uicontrol(... 
      'Parent',fig,...
      'CallBack','fdtool(''callback'',''gfdd'',''gfdd_uic_donepb'',''gfdd_uic_donepb'');',... 
      'Units','pixels',... 
      'Position',[ donepb_offsx donepb_offsy donepb_dx donepb_dy ],... 
      'BackgroundColor',pushb_bgr_col,... 
      'ForegroundColor',pushb_fg_col,...
      'HorizontalAlignment','center',... 
      'enable', 'off',...
      'String','Close',... 
      'tooltipstring','Close window, return result',...
      'Style','pushbutton',... 
      'Tag','gfdd_uic_donepb',... 
      'UserData',''); 
   gfdd_uic_cancelpb = uicontrol(... 
      'Parent',fig,...
      'CallBack','fdtool(''callback'',''gfdd'',''gfdd_uic_cancelpb'',''gfdd_uic_cancelpb'');',... 
      'Units','pixels',... 
      'Position',[ cancelpb_offsx cancelpb_offsy cancelpb_dx cancelpb_dy ],... 
      'BackgroundColor',pushb_bgr_col,... 
      'ForegroundColor',pushb_fg_col,...
      'HorizontalAlignment','center',... 
      'String','Cancel',... 
      'Tooltipstring','Close window without saving data',...
      'Style','pushbutton',... 
      'Tag','gfdd_uic_cancelpb',... 
      'UserData',''); 
   
   
   gfdd_uic_freqselpb = uicontrol(... 
      'Parent',fig,...
      'CallBack','fdtool(''callback'',''gfdd'',''gfdd_uic_freqselpb'',''gfdd_uic_freqselpb'');',... 
      'Units','pixels',... 
      'Position',[ freqselpb_offsx freqselpb_offsy freqselpb_dx freqselpb_dy ],... 
      'BackgroundColor',pushb_bgr_col,... 
      'ForegroundColor',pushb_fg_col,...
      'HorizontalAlignment','center',... 
      'String','Frequency selection',... 
      'Tooltipstring','Select frequencies to be used later',...
      'Style','pushbutton',... 
      'Tag','gfdd_uic_freqselpb',... 
      'UserData',''); 
   
   gfdd_uic_linloghpop = uicontrol(... 
      'Parent',fig,...
      'CallBack', 'fdtool(''callback'', ''gfdd'', ''gfdd_uic_linloghpop'', ''gfdd_uic_linloghpop'')',...
      'Units','pixels',... 
      'Position',[ linloghpop_offsx linloghpop_offsy linloghpop_dx linloghpop_dy ],... 
      'BackgroundColor',popup_bgr_col,... 
      'ForegroundColor',popup_fg_col,...
      'HorizontalAlignment','right',... 
      'String',{'lin freq','log freq'},... 
      'tooltipstring','Linear/logarithmic frequency axis',...
      'Style','popup',... 
      'Tag','gfdd_uic_linloghpop',... 
      'UserData','');
   gfdd_uic_frffxfypop = uicontrol(... 
      'Parent',fig,...
      'CallBack', 'fdtool(''callback'', ''gfdd'', ''gfdd_uic_frffxfypop'', ''gfdd_uic_frffxfypop'')',...
      'Units','pixels',... 
      'Position',[ frffxfypop_offsx frffxfypop_offsy frffxfypop_dx frffxfypop_dy ],... 
      'BackgroundColor',popup_bgr_col,... 
      'ForegroundColor',popup_fg_col,...
      'HorizontalAlignment','right',... 
      'String',{'frf','mag-phase','output-input'},...
      'tooltipstring','Type of plot',...
      'Style','popup',... 
      'Tag','gfdd_uic_frffxfypop',... 
      'UserData',''); 
   
   
   gfdd_uic_varonoffpop = uicontrol(... 
      'Parent',fig,...
      'CallBack', 'fdtool(''callback'', ''gfdd'', ''gfdd_uic_varonoffpop'', ''gfdd_uic_varonoffpop'')',...
      'Units','pixels',... 
      'Position',[ varonoffpop_offsx varonoffpop_offsy varonoffpop_dx varonoffpop_dy ],... 
      'BackgroundColor',popup_bgr_col,... 
      'ForegroundColor',popup_fg_col,...
      'HorizontalAlignment','right',... 
      'String',{'var on', 'var off'},...
      'tooltipstring','Show or do not show variance data in plot',...
      'Style','popup',... 
      'Tag','gfdd_uic_varonoffpop',... 
      'UserData','');
   
   
   %        gfdd_uic_workspacepb = uicontrol(... 
   %                'Parent',fig,...
   %                'CallBack','fdtool(''callback'',''gfdd'',''gfdd_uic_workspacepb'',''gfdd_uic_workspacepb'');',... 
   %                'Units','pixels',... 
   %                'Position',[ workspacepb_offsx workspacepb_offsy workspacepb_dx workspacepb_dy ],... 
   %                'BackgroundColor',pushb_bgr_col,... 
   %                'ForegroundColor',pushb_fg_col,...
   %                'HorizontalAlignment','center',... 
   %                'String','Workspace...',... 
   %                'Style','pushbutton',... 
   %                'Tag','gfdd_uic_workspacepb',... 
   %                'UserData',''); 
   gfdd_uic_importpb = uicontrol(... 
      'Parent',fig,...
      'CallBack','fdtool(''callback'',''gfdd'',''gfdd_uic_importpb'',''gfdd_uic_importpb'');',... 
      'Units','pixels',... 
      'Position',[ importpb_offsx importpb_offsy importpb_dx importpb_dy ],... 
      'BackgroundColor',pushb_bgr_col,... 
      'ForegroundColor',pushb_fg_col,...
      'HorizontalAlignment','center',... 
      'String','Import...',...
      'Tooltipstring','Read fiddata object from workspace, or from file',...
      'Style','pushbutton',... 
      'Tag','gfdd_uic_importpb',... 
      'UserData',''); 
   gfdd_uic_composepb = uicontrol(... 
      'Parent',fig,...
      'CallBack','fdtool(''callback'',''gfdd'',''gfdd_uic_composepb'',''gfdd_uic_composepb'');',... 
      'Units','pixels',... 
      'Position',[ composepb_offsx composepb_offsy composepb_dx composepb_dy ],... 
      'BackgroundColor',pushb_bgr_col,... 
      'ForegroundColor',pushb_fg_col,...
      'HorizontalAlignment','center',... 
      'String','Compose...',...
      'Tooltipstring','Compose fiddata object',...
      'Style','pushbutton',... 
      'Tag','gfdd_uic_composepb',... 
      'UserData',''); 
   gfdd_uic_measurepb = uicontrol(... 
      'Parent',fig,...
      'CallBack','fdtool(''callback'',''gfdd'',''gfdd_uic_measurepb'',''gfdd_uic_measurepb'');',... 
      'Units','pixels',... 
      'Position',[ measurepb_offsx measurepb_offsy measurepb_dx measurepb_dy ],... 
      'BackgroundColor',pushb_bgr_col,... 
      'ForegroundColor',pushb_fg_col,...
      'HorizontalAlignment','center',... 
      'String','Measure...',... 
      'tooltipstring','Start measurement using hardware connected to computer',...
      'Style','pushbutton',... 
      'Tag','gfdd_uic_measurepb',...
      'enable','on',...
      'UserData',''); %Now it is disabled because measurement cannot be done
   
   gfdd_uic_simulatepb = uicontrol(... 
      'Parent',fig,...
      'CallBack','fdtool(''callback'',''gfdd'',''gfdd_uic_simulatepb'',''gfdd_uic_simulatepb'');',... 
      'Units','pixels',... 
      'Position',[ simulatepb_offsx simulatepb_offsy simulatepb_dx simulatepb_dy ],... 
      'BackgroundColor',pushb_bgr_col,... 
      'ForegroundColor',pushb_fg_col,...
      'HorizontalAlignment','center',... 
      'String','Simulate...',...
      'tooltipstring','Generate noisy simulated data for model, using designed excitation signal',...
      'Style','pushbutton',... 
      'Tag','gfdd_uic_simulatepb',... 
      'UserData',''); 
   gfdd_uic_dataframe = uicontrol(... 
      'Parent',fig,...
      'Units','pixels',... 
      'Position',[ dataframe_offsx dataframe_offsy dataframe_dx dataframe_dy ],... 
      'ForegroundColor',frame_fg_col,...
      'BackgroundColor',frame_bgr_col,...
      'Visible','on',...
      'String','Data info',... 
      'HorizontalAlignment','left',...
      'Style','frame',... 
      'Tag','gfdd_uic_dataframe',... 
      'Enable','off',... 
      'UserData',''); 
   gfdd_uic_datatext = uicontrol(... 
      'Parent',fig,...
      'Units','pixels',... 
      'Position',[ datatext_offsx datatext_offsy datatext_dx datatext_dy ],... 
      'BackgroundColor',text_bgr_col,...
      'ForegroundColor',text_fg_col,...
      'Visible','on',...
      'String','Data info',... 
      'HorizontalAlignment','center',...
      'Style','text',... 
      'Tag','gfdd_uic_datatext',... 
      'UserData',''); 
   
   guititle(gfdd_uic_datatext);
   
   
   gfdd_uic_infotext(1) = uicontrol(... 
      'Parent',fig,...
      'Units','pixels',... 
      'Position',[ infotext1_offsx infotext1_offsy infotext1_dx infotext1_dy ],... 
      'BackgroundColor',text_bgr_col,...
      'ForegroundColor',text_fg_col,...
      'Visible','on',...
      'String','',... 
      'HorizontalAlignment','left',...
      'Style','text',... 
      'Tag','gfdd_uic_infotext(1)',... 
      'UserData',''); 
   gfdd_uic_infotext(2) = uicontrol(... 
      'Parent',fig,...
      'Units','pixels',... 
      'Position',[ infotext2_offsx infotext2_offsy infotext2_dx infotext2_dy ],... 
      'BackgroundColor',text_bgr_col,...
      'ForegroundColor',text_fg_col,...
      'Visible','on',...
      'String','',... 
      'HorizontalAlignment','left',...
      'Style','text',... 
      'Tag','gfdd_uic_infotext(2)',... 
      'UserData',''); 
   gfdd_uic_infotext(3) = uicontrol(... 
      'Parent',fig,...
      'Units','pixels',... 
      'Position',[ infotext3_offsx infotext3_offsy infotext3_dx infotext3_dy ],... 
      'BackgroundColor',text_bgr_col,...
      'ForegroundColor',text_fg_col,...
      'Visible','on',...
      'String','',... 
      'HorizontalAlignment','left',...
      'Style','text',... 
      'Tag','gfdd_uic_infotext(3)',... 
      'UserData',''); 
   gfdd_uic_infotext(4) = uicontrol(... 
      'Parent',fig,...
      'Units','pixels',... 
      'Position',[ infotext4_offsx infotext4_offsy infotext4_dx infotext4_dy ],... 
      'BackgroundColor',text_bgr_col,...
      'ForegroundColor',text_fg_col,...
      'Visible','on',...
      'String','',... 
      'HorizontalAlignment','left',...
      'Style','text',... 
      'Tag','gfdd_uic_infotext(4)',... 
      'UserData',''); 
   gfdd_uic_infotext(5) = uicontrol(... 
      'Parent',fig,...
      'Units','pixels',... 
      'Position',[ infotext5_offsx infotext5_offsy infotext5_dx infotext5_dy ],... 
      'BackgroundColor',text_bgr_col,...
      'ForegroundColor',text_fg_col,...
      'Visible','on',...
      'String','',... 
      'HorizontalAlignment','left',...
      'Style','text',... 
      'Tag','gfdd_uic_infotext(5)',... 
      'UserData',''); 
   gfdd_uic_infotext(6) = uicontrol(... 
      'Parent',fig,...
      'Units','pixels',... 
      'Position',[ infotext6_offsx infotext6_offsy infotext6_dx infotext6_dy ],... 
      'BackgroundColor',text_bgr_col,...
      'ForegroundColor',text_fg_col,...
      'Visible','on',...
      'String','',... 
      'HorizontalAlignment','left',...
      'Style','text',... 
      'Tag','gfdd_uic_infotext(6)',... 
      'UserData',''); 
   gfdd_uic_infotext(7) = uicontrol(... 
      'Parent',fig,...
      'Units','pixels',... 
      'Position',[ infotext7_offsx infotext7_offsy infotext7_dx infotext7_dy ],... 
      'BackgroundColor',text_bgr_col,...
      'ForegroundColor',text_fg_col,...
      'Visible','on',...
      'String','',... 
      'HorizontalAlignment','left',...
      'Style','text',... 
      'Tag','gfdd_uic_infotext(7)',... 
      'UserData',''); 
   gfdd_uic_infotext(8) = uicontrol(... 
      'Parent',fig,...
      'Units','pixels',... 
      'Position',[ infotext8_offsx infotext8_offsy infotext8_dx infotext8_dy ],... 
      'BackgroundColor',text_bgr_col,...
      'ForegroundColor',text_fg_col,...
      'Visible','on',...
      'String','',... 
      'HorizontalAlignment','left',...
      'Style','text',... 
      'Tag','gfdd_uic_infotext(8)',... 
      'UserData',''); 
   
   
   gfdd_uic_infotext(9) = uicontrol(... 
      'Parent',fig,...
      'Units','pixels',... 
      'Position',[ infotext9_offsx infotext9_offsy infotext9_dx infotext9_dy ],... 
      'BackgroundColor',text_bgr_col,...
      'ForegroundColor',text_fg_col,...
      'Visible','on',...
      'String','',... 
      'HorizontalAlignment','left',...
      'Style','text',... 
      'Tag','gfdd_uic_infotext(9)',... 
      'UserData',''); 
   gfdd_uic_infotext(10) = uicontrol(... 
      'Parent',fig,...
      'Units','pixels',... 
      'Position',[ infotext10_offsx infotext10_offsy infotext8_dx infotext10_dy ],... 
      'BackgroundColor',text_bgr_col,...
      'ForegroundColor',text_fg_col,...
      'Visible','on',...
      'String','',... 
      'HorizontalAlignment','left',...
      'Style','text',... 
      'Tag','gfdd_uic_infotext(10)',... 
      'UserData','');         
   
   gfdd_uic_statusframe = uicontrol(... 
      'Parent',fig,...
      'CallBack','fdtool(''callback'',''gfdd'',''gfdd_uic_statusframe'',''gfdd_uic_statusframe'');',... 
      'Units','pixels',...
      'Position',[ statusframe_offsx statusframe_offsy statusframe_dx statusframe_dy ],... 
      'BackgroundColor',frame_bgr_col,...
      'ForegroundColor',frame_fg_col,...
      'String','',... 
      'HorizontalAlignment','left',... 
      'Style','frame',... 
      'Enable','off',... 
      'Tag','gfdd_uic_statusframe',... 
      'UserData',''); 
   gfdd_uic_statustext = uicontrol(... 
      'Parent',fig,...
      'CallBack','fdtool(''callback'',''gfdd'',''gfdd_uic_statustext'',''gfdd_uic_statustext'');',... 
      'Units','pixels',...
      'Position',[ statustext_offsx statustext_offsy statustext_dx statustext_dy ],... 
      'BackgroundColor',text_bgr_col,...
      'ForegroundColor',text_fg_col,...
      'String','',... 
      'HorizontalAlignment','left',... 
      'Style','text',... 
      'Tag','gfdd_uic_statustext',... 
      'UserData',''); 
   
   
   
   %  Axes and Text Object Creation 
   
   gfdd_axes_uaxes = axes(... 
      'Parent',fig,...
      'Units','pixels',... 
      'Position',[ uaxes_offsx uaxes_offsy uaxes_dx uaxes_dy ],... 
      'Color',axes_fg_col,...
      'Fontname',axes_font_name,...
      'Xgrid','on', ... 
      'Ygrid','off', ... 
      'Xlim',[ 0 1 ],... 
      'Ylim',[ 0 1 ],... 
      'Clipping','on', ... 
      'ButtonDownFcn','fdtool(''callback'',''gfdd'',''click_on_axes_uaxes'',''gfdd_axes_uaxes'')',...
      'visible','off',...
      'Tag','gfdd_axes_uaxes', ... 
      'UserData',''); 
   gfdd_axes_laxes = axes(... 
      'Parent',fig,...
      'Units','pixels',... 
      'Position',[ laxes_offsx laxes_offsy laxes_dx laxes_dy ],... 
      'Fontname',axes_font_name,...
      'ButtonDownFcn','fdtool(''callback'',''gfdd'',''click_on_axes_laxes'',''gfdd_axes_laxes'')',...
      'visible','on',...
      'Tag','gfdd_axes_laxes', ... 
      'UserData',''); 
   
   
   % init help fcns
   helpmgr('init_help', '', myfcn, myfig );
   
   guimenus('getfreq_main','getfreq','gfdd');
   if nargin >1 
      storewin('restore_all', Me, p2) % bring up window with settings in p2
   else
      storewin('recover', Me); % restore previous settings if any
   end
   %   # now always enable, check is inside fdsimul
   %   excsig=guidtard('fdtool_main', 'OUTPUT_excitation');
   %   if isempty(excsig)
   %      set([gfdd_uic_simulatepb], 'enable', 'off')
   %   else   
   %      set([gfdd_uic_simulatepb], 'enable', 'on')
   %   end
   
   ulevctrl('getfreq_main'); %user level control
   gfdd('update_plot')
   gfdd('resize');
   
   intoscr({'getfreq_main'});
   
   % The above function, intoscr positions the windows given by their labels
   % into the actual screen. This might come handy when the session has been saved 
   % on a machine with different resolution than that of the present machine.
   
   
   set(fig,'visible','on'); 
   winmenu(myfig)
   gfdd('status', 'Ready.')
   %if ~isempty(hwmsg), gfdd('status',['Warning: ',hwmsg]), end
   if isempty(guidtard(Me, 'SELECT_getfreq'))
      % bypass: old sessions do not contain SELECT_getfreq
      guidtawr(Me,'SELECT_getfreq','direct', guidtard(Me, 'OUTPUT_getfreq'));
   end

   if isempty(guidtard(Me, 'OUTPUT_getfreq'))
      EnableClose('off', myfig)
   else
      EnableClose('on', myfig)
   end      
   
elseif strcmp(p1, 'mouse_motion')   
   guiready(myfig, 'gfdd')
   
elseif strcmp(p1,'status')
   status=findobj(myfig, 'tag','gfdd_uic_statustext');
   statusfr=findobj(myfig, 'tag','gfdd_uic_statusframe');
   glstatus(myfig, status, statusfr, p2);      
   
elseif strcmp(p1,'gfdd_uic_donepb')
   gfdd('status', 'closing...', Me);
   outval=guidtard(Me, 'OUTPUT_getfreq');
   % write back output data to main window
   guidtawr('fdtool_main', ['OUTPUT_' myname], 'direct', outval);
   % refresh state variables
   storewin('remember', Me);
   fdtool('finished_box', 'rect_getfreq', 'done', Me);
   guiclose('getfreq')   
   if strcmp(lower(guiinfos('userlevel')),'automatic');
       agv;    
   end
   
   
elseif strcmp(p1,'gfdd_uic_cancelpb')
   gfdd('status', 'canceling...', Me);
   guiclose('getfreq')
   fdtool('finished_box', 'rect_getfreq', 'cancel', Me);
   fdtool('status', 'Getfreq panel closed by Cancel. ', Me);
   
elseif strcmp(p1,'gfdd_uic_freqselpb')
   init_var=[];
   % itt ki kell vadaszni az esetleges elozo szelekciokat 
   % es az indexvektort at kell adni az init_var-ban
   freqsel('init', myfcn, 'GFDD', init_var)
   
elseif strcmp(p1,'freqsel_ready')
   switch p2
   case 'done'
      result=p3;
      guidtawr(Me, ['OUTPUT_getfreq'], 'direct', result);
      gfdd('update_plot')
   case 'cancel'
      
   end
   figure(myfig)   
   
   
elseif strcmp(p1,'gfdd_uic_linloghpop')
   gfdd('update_plot');  
   h1=findobj(myfig, 'tag','gfdd_uic_linloghpop');
   h2=findobj(myfig, 'tag','gfdd_axes_laxes');
   h3=findobj(myfig, 'tag','gfdd_axes_uaxes');
   string1=get(h1,'string');
   value=get(h1,'value');
   string1=string1{value};
   set([h2 h3],'XScale', string1(1:3));
   gfdd('status', [string1 ' axis set.'])
   
elseif strcmp(p1,'gfdd_uic_varonoffpop')
   string=popupstr(findobj(myfig, 'tag','gfdd_uic_varonoffpop'));
   gfdd('update_plot')
   gfdd('status', ['Variance display is ' string(5:end) '.'])

elseif strcmp(p1,'gfdd_uic_frffxfypop')
   %ezt lehet, hogy modositani kell
   val=get(findobj(myfig, 'tag','gfdd_uic_frffxfypop'),'value');
   string=get(findobj(myfig, 'tag','gfdd_uic_frffxfypop'),'string');
   if strcmp(string{val},'frf')
      set(findobj(myfig, 'tag','gfdd_axes_uaxes'),'visible','off');
      gfdd('resize','resize');
   else
      set(findobj(myfig, 'tag','gfdd_axes_uaxes'),'visible','on');
      gfdd('resize','resize');     
   end;
   gfdd('update_plot')
   gfdd('status', ['Display mode is ''' string{val} '''.'])
   
elseif strcmp(p1,'gfdd_uic_importpb')
   guifreez(Me, 'freeze_strong', 'gfdd_import_open');
   gfdd('status','Opening Import... ')
   guiimpv('init', myfcn, 'Frequency domain data', [], 'filter: fiddata Object')  % filter FREQ: freq domain data
   gfdd('status','#yLoad data in the Import Window...')
   
elseif strcmp(p1,'gfdd_uic_composepb')
   guifreez(Me, 'freeze_strong', 'gfdd_compose_open');
   gfdd('status','Opening Compose... ')
   compinp('init2', 'gfdd', '');
   gfdd('status','#yLoad data in the Compose Window...')

elseif strcmp(p1, 'import_ready')
   guifreez(Me, 'unfreeze', 'gfdd_import_open');
   switch  p2
   case 'cancel'
      %
   case 'done'
      fdata=guidtard('fdtool_importfig', 'IMPORTED_VAR');
      guidtawr(Me,'SELECT_getfreq','direct',fdata);
      guidtawr(Me,'OUTPUT_getfreq','direct',fdata);
      SetVarOnOff(myfig, fdata)
      gfdd('update_plot')
      EnableClose('on', myfig);
   end
   if ishandle(myfig), figure(myfig), end
   
elseif strcmp(p1, 'compose_ready')
   guifreez(Me, 'unfreeze', 'gfdd_compose_open');
   compinp('kill')
   switch  p2
   case 'cancel'
      %
   case 'done'
      fdata=p4;
      guidtawr(Me,'SELECT_getfreq','direct',fdata);
      guidtawr(Me,'OUTPUT_getfreq','direct',fdata);
      SetVarOnOff(myfig, fdata)
      gfdd('update_plot')
      EnableClose('on', myfig);
   end
   if ishandle(myfig), figure(myfig), end
   
elseif strcmp(p1,'gfdd_uic_measurepb')
   guifreez(Me, 'freeze_strong', 'gfdd_measurement_open');
   gfdd('status','Opening Measure... ')
   fdmeasw('init','FREQ','gfdd');
   %addhist(outdata, 'Measured data.');
   %guidtawr(Me, 'OUTPUT_getfreq', 'direct', outdata)
   %arrplot('gfdd_update')
   %EnableClose('on', myfig)
   gfdd('status','#yGet data in the Measurement Window...')
   
elseif strcmp(p1,'gfdd_uic_simulatepb')
   guifreez(Me, 'freeze_strong', 'gfdd_simulation_open');
   gfdd('status','Opening Simulate... ')
   fdsimul('init', 'FREQ', 'gfdd')
   gfdd('status','#yGenerate data in the Simulation Window...')
   
elseif strcmp(p1,'simulation_ready')
   % p2: 'done' or 'cancel'
   % p3: returned data
   guifreez(Me, 'unfreeze', 'gfdd_simulation_open');
   switch p2
   case 'done'
      guidtawr(Me,'SELECT_getfreq','direct', p3);
      guidtawr(Me,'OUTPUT_getfreq','direct', p3);
      SetVarOnOff(myfig, p3)
      gfdd('update_plot')
      EnableClose('on', myfig);
      gfdd('status','Simulation finished')
   case 'cancel'
      gfdd('status','Simulation cancelled ')
   end      
   figure(myfig)
   
elseif strcmp(p1,'measurement_ready')
   % p2: 'done' or 'cancel'
   % p3: returned data
   guifreez(Me, 'unfreeze', 'gfdd_measurement_open');
   switch p2
   case 'done'
      guidtawr(Me,'OUTPUT_getfreq','direct', p3);
      SetVarOnOff(myfig, p3)
      gfdd('update_plot')
      EnableClose('on', myfig);
      gfdd('status','Measurement finished')
   case 'cancel'
      gfdd('status','Measurement cancelled ')
   end      
   if ishandle(myfig), figure(myfig), end
   
elseif strcmp(p1,'destroyed')
   % close all children 
   guiclose('getfreq')         
   fdtool('finished_box', 'rect_getfreq', 'cancel', Me);
   
elseif any(findstr(p1,'update_plot'))
   guifreez(Me, 'freeze', 'gfdd_update_plot');
   gfdd('status', 'Updating plot...')
   
   ax1=findobj(myfig, 'tag','gfdd_axes_uaxes');
   ax2=findobj(myfig, 'tag','gfdd_axes_laxes');
   bfcn_uaxes=get(ax1,'buttondownfcn');
   bfcn_laxes=get(ax2,'buttondownfcn');
   
   arrplot('gfdd_update')
   
   set(ax1,'tag','gfdd_axes_uaxes','buttondownfcn', bfcn_uaxes);
   set(ax2,'tag','gfdd_axes_laxes','buttondownfcn', bfcn_laxes);
   
   gfdd('status', 'Done.')
   guifreez(Me, 'unfreeze', 'gfdd_update_plot');
   
elseif any(findstr(p1,'click_on'))
   arrplot('gfdd_update_extra')
   
elseif strcmp(p1,'gfdd_uic_print')
   %gfdd print command
   fdgprint(Me)
   gfdd('status','Print figure done.')
   
elseif strcmp(p1,'gfdd_mod_print_ps')
   %gfdd print command
   fdgprint(Me,'ps')
   
elseif strcmp(p1, 'preload')
   % preload, nothing to do
   
elseif strcmp(p1,'resize')
   axdiffy=45; 
   mindx=570;
   mindy=400;
   scrs=get(0, 'screensize');
   mainfigmaxx=scrs(3);
   mainfigmaxy=scrs(4);
   pos=get(findobj(myfig, 'tag','getfreq_main'),'position');
   fig_offsx=pos(1);
   fig_offsy=pos(2);
   fig_dx=pos(3);
   fig_dy=pos(4);
   if fig_dx < mindx
      fig_dx=mindx;
   end;
   if fig_dy < mindy
      fig_dy=mindy;
   end;
   %      if fig_offsx+fig_dx > mainfigmaxx
   %         fig_offsx=10;
   %      end;
   if fig_offsy+fig_dy > mainfigmaxy
      fig_offsy=20;
   end;
   set(findobj(myfig, 'tag','getfreq_main'),'position',[fig_offsx fig_offsy fig_dx fig_dy]);
   fromimportpb_dx=60;
   fromdataframe_dy=30;
   pos=get(findobj(myfig, 'tag','gfdd_uic_importpb'),'position');
   importpb_offsx=pos(1);
   importpb_dx=pos(3);
   
   pos=get(findobj(myfig, 'tag','gfdd_uic_statusframe'),'position');
   set(findobj(myfig, 'tag','gfdd_uic_statusframe'),'position',[pos(1) pos(2) fig_dx pos(4)]);
   pos=get(findobj(myfig, 'tag','gfdd_uic_statustext'),'position');
   set(findobj(myfig, 'tag','gfdd_uic_statustext'),'position',[pos(1) pos(2) fig_dx-6 pos(4)]);
   pos=get(findobj(myfig, 'tag','gfdd_uic_donepb'),'position');
   set(findobj(myfig, 'tag','gfdd_uic_donepb'),'position',[fig_dx-pos(3)-20 pos(2) pos(3) pos(4)]);
   pos=get(findobj(myfig, 'tag','gfdd_uic_cancelpb'),'position');
   set(findobj(myfig, 'tag','gfdd_uic_cancelpb'),'position',[fig_dx-pos(3)-20 pos(2) pos(3) pos(4)]);
   pos=get(findobj(myfig, 'tag','gfdd_uic_freqselpb'),'position');
   set(findobj(myfig, 'tag','gfdd_uic_freqselpb'),'position',[fig_dx-pos(3)-20 pos(2) pos(3) pos(4)]);
   pos=get(findobj(myfig, 'tag','gfdd_uic_importpb'),'position');
   offsy=fig_dy-20-pos(2)-pos(4);
   set(findobj(myfig, 'tag','gfdd_uic_importpb'),'position',[pos(1) pos(2)+offsy pos(3) pos(4)]);
   pos=get(findobj(myfig, 'tag','gfdd_uic_measurepb'),'position');
   set(findobj(myfig, 'tag','gfdd_uic_measurepb'),'position',[pos(1) pos(2)+offsy pos(3) pos(4)]);
   pos=get(findobj(myfig, 'tag','gfdd_uic_simulatepb'),'position');
   set(findobj(myfig, 'tag','gfdd_uic_simulatepb'),'position',[pos(1) pos(2)+offsy pos(3) pos(4)]);
   pos=get(findobj(myfig, 'tag','gfdd_uic_importpb'),'position');
   axl_offsx=pos(1)+pos(3)+fromimportpb_dx;
   axl_dx=fig_dx-axl_offsx-40;
   pos=get(findobj(myfig, 'tag','gfdd_uic_dataframe'),'position');
   dframe_offsx=pos(1);
   dframe_dx=pos(3);
   axl_offsy=pos(2)+pos(4)+fromdataframe_dy;
   
   val=get(findobj(myfig, 'tag','gfdd_uic_frffxfypop'),'value');
   string=get(findobj(myfig, 'tag','gfdd_uic_frffxfypop'),'string');
   if strcmp(string{val},'frf')
      axl_dy=fig_dy-axl_offsy-20;
   else
      axl_dy=(fig_dy-axl_offsy-20-axdiffy)/2;
   end;
   
   
   set(findobj(myfig, 'tag','gfdd_axes_laxes'),'position',[ axl_offsx axl_offsy axl_dx axl_dy]);
   set(findobj(myfig, 'tag','gfdd_axes_uaxes'),'position',[ axl_offsx axl_offsy+axl_dy+axdiffy axl_dx axl_dy]);
   pos=get(findobj(myfig, 'tag','gfdd_uic_linloghpop'),'position');
   %ROMAN GYUSZI!
   %set(findobj(myfig, 'tag','gfdd_uic_linloghpop'),'position',[ max(dframe_offsx+dframe_dx+10, axl_offsx+(axl_dx-pos(3))/2) pos(2) pos(3) pos(4)]);
   
else 
   error('Error: GFDD.m called with incorrect command.') 
end 


function  SetVarOnOff(myfig, fdata)
% set var on/off combo according to fddata
h=findobj(allchild(myfig), 'flat', 'tag', 'gfdd_uic_varonoffpop');
if isempty(fdata)
   on=0;
elseif isempty(fdata.covariancematrix)
   on=0;
else
   on=1;
end
if on
   % set(h, 'enable', 'on', 'value', 1) % var on
   set(h, 'enable', 'on') % var on
else
   %set(h, 'enable', 'off', 'value', 2) % var off
   set(h, 'enable', 'off') % var off
end   


function EnableClose(onoff, myfig);
h=findobj(myfig, 'tag', 'gfdd_uic_donepb');
h1=findobj(myfig, 'tag', 'getfreq_menu_file_close');
hs=findobj(myfig, 'tag', 'gfdd_uic_freqselpb');
set([h h1 hs], 'enable', onoff)

