function guimenus(tFig, win_name, fcn_name)
%GUIMENUS fdtool menu generator
%
% tFig    : tag of the window (eg: gettime_main)
% win_name: identifier of the window (eg. gettime)
% fcn_name: name of the function handling the window

%       Copyright (c) I. Kollar and Vrije Universiteit Brussel, ELEC, 1997-99
%       All rights reserved.
%       $Revision: $
%       Written by Gy. Simon
%       Last modified: 25-Sep-2001, GYS
f=findall(0,'tag',[tFig]);
set(f, 'menubar', 'none');


% ########################## F I R S T   M E N U   I T E M S  ########

switch tFig
case 'excitation_main'   
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %%%%%%%%%%%%%%%%%%%% EXCITATION_MAIN %%%%%%%%%%%%%%%%%%%%%
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   tag=[win_name '_MENU_file'];
   menu_file=uimenu(f,'label','&File',...
      'posit',1,...
      'tag', tag); 
   %%not necessary      'callback', ['fdtool(''callback'',''essd'',''essd_MENU_file_main'',''' tag ''');'],...
   menu_file_save=uimenu(menu_file,...
      'label',        '&Save signal',...
      'tag',                [win_name '_menu_file_save']);
   menu_file_save_vector=uimenu(menu_file_save,...
      'label',        'As &vector',...
      'callback',        ['fdtool(''callback'',''essd'', ''ui_save_vector'',''',...
         win_name, '_menu_file_save_vector'')'],...
      'tag',                [win_name '_menu_file_save_vector']);
   menu_file_save_object=uimenu(menu_file_save,...
      'label',        'As &object',...
      'callback',        ['fdtool(''callback'',''essd'',''ui_save_object'',''',...
         win_name, '_menu_file_save_object'')'],...
      'tag',                [win_name '_menu_file_save_object']);
   tag=[win_name, '_menu_file_print'];
   menu_file_print=uimenu(menu_file,...
      'label','Print',...
      'callback', ['fdtool(''callback'',''essd'',''essd_uic_print'',''' tag ''');'],...
      'tag', tag,...
      'separator','on');
   tag=[win_name, '_menu_file_print_ps'];
   menu_file_print_ps=uimenu(menu_file,...
      'label','Print to PS file',...
      'callback', ['fdtool(''callback'',''essd'',''essd_mod_print_ps'',''' tag ''');'],...
      'tag', tag,...
      'separator','off');
   %'tooltipstring','Print figure to postscript file ''fdidgui.ps'' using the Matlab print command',...
   tag=[win_name '_menu_file_cancel'];
   menu_file_cancel=uimenu(menu_file,...
      'label','Cancel',...
      'callback', ['fdtool(''callback'',''essd'',''essd_uic_cancelpb'',''essd_uic_cancelpb'');'],...
      'tag', tag,...
      'separator','on');
   tag=[win_name '_menu_file_close'];
   menu_file_close=uimenu(menu_file,...
      'label','Close',...
      'callback', ['fdtool(''callback'',''essd'',''essd_uic_donepb'',''essd_uic_donepb'');'],...
      'tag', tag);

   position=2;
   tag=[win_name '_MENU_plots'];
   menu_plots=uimenu(f,'label','&Plots',...
      'posit',position,...
      'tag', tag); 
   tag=[win_name, '_menu_plots_on'];
   menu_plots_on=uimenu(menu_plots,...
      'label',        'Plots &on',...
      'callback',        ['fdtool(''callback'',''essd'',''essd_uic_plots_on'',''' tag ''');'],...
      'checked','on',...
      'tag', tag);
   tag=[win_name, '_menu_plots_rare'];
   menu_plots_off=uimenu(menu_plots,...
      'label',        'Plots &rare',...
      'callback',        ['fdtool(''callback'',''essd'',''essd_uic_plots_rare'',''' tag ''');'],...
      'checked','off',...
      'tag',tag);
   tag=[win_name, '_menu_plot_spectrum'];
   menu_plots_spectrum=uimenu(menu_plots,...
      'label',        'Plot s&pectrum',...
      'callback',        ['fdtool(''callback'',''essd'',''essd_uic_plot_spectrum'',''' tag ''');'],...
      'separator','on',...
      'enable','off',...
      'tag',tag);
   tag=[win_name, '_menu_plot_signal'];
   menu_plots_signal=uimenu(menu_plots,...
      'label',        'Plot &signal',...
      'callback',  ['fdtool(''callback'',''essd'',''essd_uic_plot_signal'',''' tag ''');'],...
      'tag', tag);

   position=3;
   
   
case 'getfreq_main'   
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %%%%%%%%%%%%%%%%%%%%%%% GETFREQ_MAIN %%%%%%%%%%%%%%%%%%%%%
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   tag=[win_name '_menu_file'];
   menu_file=uimenu(f,'label','&File',...
      'posit',1,...
      'tag', tag); 
   
   % other menus here...
   
   tag=[win_name '_menu_file_print'];
   menu_file_print=uimenu(menu_file,...
      'label','Print',...
      'callback', ['fdtool(''callback'',''gfdd'',''gfdd_uic_print'',''' tag ''');'],...
      'tag', tag,...
      'separator','off');
   %'tooltipstring','Print figure using the Matlab print command',...
   tag=[win_name '_menu_file_print_ps'];
   menu_file_print_ps=uimenu(menu_file,...
      'label','Print to PS file',...
      'callback', ['fdtool(''callback'',''gfdd'',''gfdd_mod_print_ps'',''' tag ''');'],...
      'tag', tag,...
      'separator','off');
   %'tooltipstring','Print figure to postscript file ''fdidgui.ps'' using the Matlab print command',...
   
   tag=[win_name '_menu_file_cancel'];
   menu_file_cancel=uimenu(menu_file,...
      'label','Cancel',...
      'callback', ['fdtool(''callback'',''gfdd'',''gfdd_uic_cancelpb'',''gfdd_uic_cancelpb'');'],...
      'tag', tag,...
      'separator','on');
   tag=[win_name '_menu_file_close'];
   menu_file_close=uimenu(menu_file,...
      'label','Close',...
      'callback', ['fdtool(''callback'',''gfdd'',''gfdd_uic_donepb'',''gfdd_uic_donepb'');'],...
      'tag', tag);
   position=2;
   
   
   
case 'gettime_main'
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %%%%%%%%%%%%%%%%%%%%%%% GETTIME_MAIN %%%%%%%%%%%%%%%%%%%%%
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   tag=[win_name '_menu_file'];
   menu_file=uimenu(f,'label','&File',...
      'posit',1,...
      'tag', tag); 
   
   %tag=[win_name '_menu_file_save'];
   %menu_file_save=uimenu(menu_file,...
   %   'label','&Save ',...
   %   'tag', tag); 
   
   tag=[win_name '_menu_file_save_arrow'];
   menu_file_save_arrow=uimenu(menu_file,...
      'label','Save Arrow Data...',...
      'callback', ['fdtool(''callback'',''',fcn_name,''',''save_arrow_data'', ''' tag ''')'],...
      'tag', tag);        
   
   %tag=[win_name '_menu_file_load'];
   %menu_file_load=uimenu(menu_file,...
   %   'label','&Load ',...
   %   'tag', tag);
   
   tag=[win_name '_menu_file_load_arrow'];
   menu_file_load_arrow=uimenu(menu_file,...
      'label','Load Arrow Data...',...
      'callback', ['fdtool(''callback'',''',fcn_name,''',''load_arrow_data'', ''' tag ''')'],...
      'tag', tag);
   
   tag=[win_name '_menu_file_forget_data'];
   menu_file_forget_arrow=uimenu(menu_file,...
      'label','Forget Arrow Data',...
      'callback', ['fdtool(''callback'',''',fcn_name,''',''ui_forget_data'', ''' tag ''')'],...
      'tag', tag);
   
   tag=[win_name '_menu_file_print'];
   menu_file_print=uimenu(menu_file,...
      'label','Print',...
      'callback', ['fdtool(''callback'',''gettime'',''gettime_uic_print'',''' tag ''');'],...
      'tag', tag,...
      'separator','on');
   %'tooltipstring','Print figure using the Matlab print command',...
   tag=[win_name '_menu_file_print_ps'];
   menu_file_print_ps=uimenu(menu_file,...
      'label','Print to PS file',...
      'callback', ['fdtool(''callback'',''gettime'',''gettime_mod_print_ps'',''' tag ''');'],...
      'tag', tag,...
      'separator','off');
   %'tooltipstring','Print figure to postscript file ''fdidgui.ps'' using the Matlab print command',...
   
   tag=[win_name '_menu_file_cancel'];
   menu_file_cancel=uimenu(menu_file,...
      'label','Cancel',...
      'callback', ['fdtool(''callback'',''gettime'',''ui_cancel'',''gettime_button_cancel'')'],...
      'tag', tag,...
      'separator','on');
   tag=[win_name '_menu_file_close'];
   menu_file_close=uimenu(menu_file,...
      'label','Close',...
      'callback', ['fdtool(''callback'',''gettime'',''ui_done'',''gettime_button_done'')'],...
      'tag', tag);
   
   position=2;
   
case 'average_main'   
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %%%%%%%%%%%%%%%%%%%%%%% AVERAGE_MAIN %%%%%%%%%%%%%%%%%%%%%
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   tag=[win_name '_menu_file'];
   menu_file=uimenu(f,'label','&File',...
      'posit',1,...
      'tag', tag); 
   
   % other menus here...
   
   tag=[win_name '_menu_file_print'];
   menu_file_print=uimenu(menu_file,...
      'label','Print',...
      'callback', ['fdtool(''callback'',''agv'',''agv_uic_print'',''' tag ''');'],...
      'tag', tag,...
      'separator','off');
   %'tooltipstring','Print figure using the Matlab print command',...
   tag=[win_name '_menu_file_print_ps'];
   menu_file_print_ps=uimenu(menu_file,...
      'label','Print to PS file',...
      'callback', ['fdtool(''callback'',''agv'',''agv_mod_print_ps'',''' tag ''');'],...
      'tag', tag,...
      'separator','off');
   %'tooltipstring','Print figure to postscript file ''fdidgui.ps'' using the Matlab print command',...
   tag=[win_name '_menu_file_cancel'];
   menu_file_cancel=uimenu(menu_file,...
      'label','Cancel',...
      'callback', ['fdtool(''callback'',''agv'',''agv_uic_cancelpb'',''agv_uic_cancelpb'');'],...
      'tag', tag,...
      'separator','on');
   tag=[win_name '_menu_file_close'];
   menu_file_close=uimenu(menu_file,...
      'label','Close',...
      'callback', ['fdtool(''callback'',''agv'',''agv_uic_donepb'',''agv_uic_donepb'');'],...
      'enable', 'off', ...
      'tag', tag);
   position=2;
   
   
case {'select_main', 'aided_main' }
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %%%%%%%%%%%%%%%%% SELECT_MAIN, AIDED_MAIN  %%%%%%%%%%%%%%%
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   tag=[win_name '_menu_file'];
   menu_file=uimenu(f,'label','&File',...
      'posit',1,...
      'tag', tag); 
   
   % other menus here...
   tag=[win_name '_menu_file_save_model'];   
   if strcmp(tFig, 'select_main')
      savelabel='Save model';
   else
      savelabel='&Save models';
   end
   menu_file_save=uimenu(menu_file,...
      'label',savelabel,...
      'callback', ['fdtool(''callback'',''sme'',''sme_uic_save_model'',''' tag ''');'],...
      'tag', tag,...
      'separator','off');
   
   tag=[win_name '_menu_file_load_model'];   
   if strcmp(tFig, 'select_main')
      loadlabel='&Load model';
   else
      loadlabel='Load models';
   end
   menu_file_load=uimenu(menu_file,...
      'label',loadlabel,...
      'callback', ['fdtool(''callback'',''sme'',''sme_uic_load_model'',''' tag ''');'],...
      'tag', tag,...
      'separator','off');

   tag=[win_name '_menu_file_print'];
   menu_file_print=uimenu(menu_file,...
      'label','Print',...
      'callback', ['fdtool(''callback'',''sme'',''sme_uic_print'',''' tag ''');'],...
      'tag', tag,...
      'separator','on');
   %'tooltipstring','Print figure using the Matlab print command',...
   tag=[win_name '_menu_file_print_ps'];
   menu_file_print_ps=uimenu(menu_file,...
      'label','Print to PS file',...
      'callback', ['fdtool(''callback'',''sme'',''sme_mod_print_ps'',''' tag ''');'],...
      'tag', tag,...
      'separator','off');
   %'tooltipstring','Print figure to postscript file ''fdidgui.ps'' using the Matlab print command',...
   
   tag=[win_name '_menu_file_cancel'];
   menu_file_cancel=uimenu(menu_file,...
      'label','Cancel',...
      'callback', ['fdtool(''callback'',''sme'',''sme_uic_cancelpb'',''sme_uic_cancelpb'');'],...
      'tag', tag,...
      'separator','on');
   tag=[win_name '_menu_file_close'];
   menu_file_close=uimenu(menu_file,...
      'label','Close',...
      'callback', ['fdtool(''callback'',''sme'',''sme_uic_donepb'',''sme_uic_donepb'');'],...
      'enable', 'off', ...
      'tag', tag);
   position=2;
   
   tagw=['sme_MENU_runmod'];
   menu_runmod=uimenu(f,'label','&Run modifiers',...
      'callback', ['fdtool(''callback'',''sme'',''sme_update_iterctrl_menu'',''sme_MENU_runmod'');'],...
      'position',2,...
      'tag', tagw); 
   %
   tag=['sme_menu_runmod_stab'];
   menu_runmod_stab=uimenu(menu_runmod,'label','&Stabilization',...
      'tag', tag); 
   tag=['sme_menu_runmod_stab_off'];
   menu_runmod_stab_off=uimenu(menu_runmod_stab,'label','&Off',...
      'callback', ['fdtool(''callback'',''sme'',''sme_uic_runmod_stab_off'',''sme_menu_runmod_stab_off'');'],...
      'tag', tag,'checked','on'); 
   tag=['sme_menu_runmod_stab_refl'];
   menu_runmod_stab_refl=uimenu(menu_runmod_stab,'label','&Reflection',...
      'callback', ['fdtool(''callback'',''sme'',''sme_uic_runmod_stab_refl'',''sme_menu_runmod_stab_refl'');'],...
      'tag', tag);      
   tag=['sme_menu_runmod_stab_contr'];
   menu_runmod_stab_contr=uimenu(menu_runmod_stab,'label','&Contraction',...
      'callback', ['fdtool(''callback'',''sme'',''sme_uic_runmod_stab_contr'',''sme_menu_runmod_stab_contr'');'],...
      'tag', tag);      
   tag=['sme_menu_runmod_stab_limit'];
   menu_runmod_stab_limit=uimenu(menu_runmod_stab,'label','&Limitation',...
      'callback', ['fdtool(''callback'',''sme'',''sme_uic_runmod_stab_limit'',''sme_menu_runmod_stab_limit'');'],...
      'tag', tag);      
   %
   tag=['sme_menu_runmod_fmph'];
   menu_runmod_fmph=uimenu(menu_runmod,'label','Minimum &phase',...
      'tag', tag); 
   tag=['sme_menu_runmod_fmph_off'];
   menu_runmod_fmph_off=uimenu(menu_runmod_fmph,'label','&Off',...
      'callback', ['fdtool(''callback'',''sme'',''sme_uic_runmod_fmph_off'',''sme_menu_runmod_fmph_off'');'],...
      'tag', tag,'checked','on'); 
   tag=['sme_menu_runmod_fmph_refl'];
   menu_runmod_fmph_refl=uimenu(menu_runmod_fmph,'label','&Reflection',...
      'callback', ['fdtool(''callback'',''sme'',''sme_uic_runmod_fmph_refl'',''sme_menu_runmod_fmph_refl'');'],...
      'tag', tag);      
   tag=['sme_menu_runmod_fmph_contr'];
   menu_runmod_fmph_contr=uimenu(menu_runmod_fmph,'label','&Contraction',...
      'callback', ['fdtool(''callback'',''sme'',''sme_uic_runmod_fmph_contr'',''sme_menu_runmod_fmph_contr'');'],...
      'tag', tag);      
   tag=['sme_menu_runmod_fmph_limit'];
   menu_runmod_fmph_limit=uimenu(menu_runmod_fmph,'label','&Limitation',...
      'callback', ['fdtool(''callback'',''sme'',''sme_uic_runmod_fmph_limit'',''sme_menu_runmod_fmph_limit'');'],...
      'tag', tag);      
   %
   tag=['sme_menu_runmod_margin'];
   menu_runmod_margin=uimenu(menu_runmod,'label','&Stability and minphase margin',...
      'callback', ['fdtool(''callback'',''sme'',''sme_uic_runmod_margin'',''sme_menu_runmod_margin'');'],...
      'tag', tag);      
   %
   tag=['sme_menu_runmod_itno'];
   menu_runmod_itno=uimenu(menu_runmod,'label','Max. &Iterations',...
      'tag', tag); 
   tag=['sme_menu_runmod_itno_default'];
   menu_runmod_itno_default=uimenu(menu_runmod_itno,'label','&Default (50)',...
      'callback', ['fdtool(''callback'',''sme'',''sme_uic_runmod_itno_default'',''sme_menu_runmod_itno_default'');'],...
      'tag', tag,'checked','on'); 
   tag=['sme_menu_runmod_itno_value'];
   menu_runmod_itno_value=uimenu(menu_runmod_itno,'label','&Selected value: -',...
      'callback', ['fdtool(''callback'',''sme'',''sme_uic_runmod_itno_value'',''sme_menu_runmod_itno_value'');'],...
      'tag', tag);      
   tag=['sme_menu_runmod_itno_set'];
   menu_runmod_itno_set=uimenu(menu_runmod_itno,'label','&Set max. iter. number',...
      'callback', ['fdtool(''callback'',''sme'',''sme_uic_runmod_itno_set'',''sme_menu_runmod_itno_set'');'],...
      'separator', 'off', ...
      'tag', tag);      
   %
   tag=['sme_menu_runmod_iobj'];
   menu_runmod_iobj=uimenu(menu_runmod,'label','&Starting values',...
      'tag', tag); 
   tag=['sme_menu_runmod_iobj_aml'];
   menu_runmod_iobj_aml=uimenu(menu_runmod_iobj,'label','&AML',...
      'callback', ['fdtool(''callback'',''sme'',''sme_uic_runmod_iobj_aml'',''sme_menu_runmod_iobj_aml'');'],...
      'tag', tag,'checked','off'); 
   tag=['sme_menu_runmod_iobj_ls'];
   menu_runmod_iobj_ls=uimenu(menu_runmod_iobj,'label','&LS',...
      'callback', ['fdtool(''callback'',''sme'',''sme_uic_runmod_iobj_ls'',''sme_menu_runmod_iobj_ls'');'],...
      'tag', tag,'checked','off'); 
   tag=['sme_menu_runmod_iobj_yw'];
   menu_runmod_iobj_yw=uimenu(menu_runmod_iobj,'label','&Y-reduced noise weighting',...
      'callback', ['fdtool(''callback'',''sme'',''sme_uic_runmod_iobj_yw'',''sme_menu_runmod_iobj_yw'');'],...
      'tag', tag,'checked','off'); 
   tag=['sme_menu_runmod_iobj_ew'];
   menu_runmod_iobj_ew=uimenu(menu_runmod_iobj,'label','Equation-&reduced noise weighting',...
      'callback', ['fdtool(''callback'',''sme'',''sme_uic_runmod_iobj_ew'',''sme_menu_runmod_iobj_ew'');'],...
      'tag', tag,'checked','off'); 
   tag=['sme_menu_runmod_iobj_uw'];
   menu_runmod_iobj_uw=uimenu(menu_runmod_iobj,'label','&U-reduced noise weighting',...
      'callback', ['fdtool(''callback'',''sme'',''sme_uic_runmod_iobj_uw'',''sme_menu_runmod_iobj_uw'');'],...
      'tag', tag,'checked','off'); 
   tag=['sme_menu_runmod_iobj_iqml'];
   menu_runmod_iobj_iqml=uimenu(menu_runmod_iobj,'label','&IQML',...
      'callback', ['fdtool(''callback'',''sme'',''sme_uic_runmod_iobj_iqml'',''sme_menu_runmod_iobj_iqml'');'],...
      'tag', tag,'checked','off'); 
   tag=['sme_menu_runmod_iobj_equ'];
   menu_runmod_iobj_equ=uimenu(menu_runmod_iobj,'label','&Equation Error (invfreq)',...
      'callback', ['fdtool(''callback'',''sme'',''sme_uic_runmod_iobj_equ'',''sme_menu_runmod_iobj_equ'');'],...
      'tag', tag,'checked','off'); 
   tag=['sme_menu_runmod_iobj_trials'];
   menu_runmod_iobj_trials=uimenu(menu_runmod_iobj,'label','S&can different algs (default)',...
      'callback', ['fdtool(''callback'',''sme'',''sme_uic_runmod_iobj_trials'',''sme_menu_runmod_iobj_trials'');'],...
      'separator', 'on', ...
      'tag', tag,'checked','on'); 
   tag=['sme_menu_runmod_iobj_object'];
   menu_runmod_iobj_object=uimenu(menu_runmod_iobj,'label','Selected &Object',...
      'callback', ['fdtool(''callback'',''sme'',''sme_uic_runmod_iobj_object'',''sme_menu_runmod_iobj_object'');'],...
      'separator', 'on', ...
      'tag', tag);      
   tag=['sme_menu_runmod_iobj_weight'];
   tag=['sme_menu_runmod_iobj_load'];
   menu_runmod_iobj_load=uimenu(menu_runmod_iobj,'label','Define initial &model object',...
      'tag', tag,'separator','off'); 

   menu_runmod_iobj_weight=uimenu(menu_runmod_iobj,'label','Selected &Weight',...
      'callback', ['fdtool(''callback'',''sme'',''sme_uic_runmod_iobj_weight'',''sme_menu_runmod_iobj_weight'');'],...
      'separator', 'on', ...
      'tag', tag);      
   
   tag=['sme_menu_runmod_iobj_setweight'];
   menu_runmod_iobj_setobject=uimenu(menu_runmod,'label','Load initial &weight',...
      'callback', ['fdtool(''callback'',''sme'',''sme_uic_runmod_iobj_setweight'',''sme_menu_runmod_iobj_setweight'');'],...
      'separator','on','tag', tag);      
   tag=['sme_menu_runmod_iobj_setdefault'];
   menu_runmod_iobj_setdefault=uimenu(menu_runmod,'label','&Clear run modifiers',...
      'callback', ['fdtool(''callback'',''sme'',''sme_uic_runmod_iobj_setdefault'',''sme_menu_runmod_iobj_setdefault'');'],...
      'tag', tag,'separator','on'); 
   
   tag=['sme_menu_runmod_iobj_setobject'];
   menu_runmod_iobj_setobject=uimenu(menu_runmod_iobj_load,'label','&Load object',...
      'callback', ['fdtool(''callback'',''sme'',''sme_uic_runmod_iobj_setobject'',''sme_menu_runmod_iobj_setobject'');'],...
      'tag', tag);      
   
   tag=['sme_menu_runmod_iobj_sme_int'];
   menu_runmod_iobj_setobject=uimenu(menu_runmod_iobj_load,'label','&Result of EPM',...
      'callback', ['fdtool(''callback'',''sme'',''sme_uic_runmod_iobj_sme_int'',''sme_menu_runmod_iobj_sme_int'');'],...
      'tag', tag);
   
   tag=['sme_menu_runmod_iobj_sme'];
   menu_runmod_iobj_setobject=uimenu(menu_runmod_iobj_load,'label','Load output of &EPM',...
      'callback', ['fdtool(''callback'',''sme'',''sme_uic_runmod_iobj_sme'',''sme_menu_runmod_iobj_sme'');'],...
      'tag', tag);
   
   tag=['sme_menu_runmod_iobj_cams'];
   menu_runmod_iobj_setobject=uimenu(menu_runmod_iobj_load,'label','Load best of C&AMS',...
      'callback', ['fdtool(''callback'',''sme'',''sme_uic_runmod_iobj_cams'',''sme_menu_runmod_iobj_cams'');'],...
      'tag', tag);      
   tag=['sme_menu_runmod_iobj_caem'];
   menu_runmod_iobj_setobject=uimenu(menu_runmod_iobj_load,'label','Load output of E&CPM',...
      'callback', ['fdtool(''callback'',''sme'',''sme_uic_runmod_iobj_caem'',''sme_menu_runmod_iobj_caem'');'],...
      'tag', tag);      
   
   %
   position=3;
   if ~strcmp(guiinfos('userlevel'),'Advanced')
      set(menu_runmod,'visible','off')
   end
   
case 'compare_main'
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %%%%%%%%%%%%%%%%%%%%%%% COMPARE_MAIN %%%%%%%%%%%%%%%%%%%%%
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   tag=[win_name '_menu_file'];
   menu_file=uimenu(f,'label','&File',...
      'posit',1,...
      'tag', tag); 
   tag=[win_name '_MENU_file_load']; % no help action
   menu_file_load=uimenu(menu_file,...
      'label','Load',...
      'callback', ['fdtool(''callback'',''',fcn_name,''',''menu_load'', ''' tag ''')'],...
      'tag', tag);           
   tag=[win_name '_menu_file_load_model_replace_1'];
   menu_file_load_model1=uimenu(menu_file_load,...
      'label','Replace Set #1',...
      'callback', ['fdtool(''callback'',''',fcn_name,''',''ui_menu_load_model_replace_1'', ''' tag ''')'],...
      'tag', tag);         
   tag=[win_name '_menu_file_load_model_add_1'];
   menu_file_load_model1=uimenu(menu_file_load,...
      'label','Add to Set #1',...
      'callback', ['fdtool(''callback'',''',fcn_name,''',''ui_menu_load_model_add_1'', ''' tag ''')'],...
      'tag', tag);         
   tag=[win_name '_menu_file_load_model_replace_2'];
   menu_file_load_model1=uimenu(menu_file_load,...
      'label','Replace Set #2',...
      'callback', ['fdtool(''callback'',''',fcn_name,''',''ui_menu_load_model_replace_2'', ''' tag ''')'],...
      'separator', 'on',...
      'tag', tag);         
   tag=[win_name '_menu_file_load_model_add_2'];
   menu_file_load_model1=uimenu(menu_file_load,...
      'label','Add to Set #2',...
      'callback', ['fdtool(''callback'',''',fcn_name,''',''ui_menu_load_model_add_2'', ''' tag ''')'],...
      'tag', tag);         
   tag=[win_name '_MENU_file_save']; % no help action
   menu_file_save=uimenu(menu_file,...
      'label','Save',...
      'callback', ['fdtool(''callback'',''',fcn_name,''',''menu_save'', ''' tag ''')'],...
      'tag', tag);           
   tag=[win_name '_menu_file_save_model1'];
   menu_file_save_model1=uimenu(menu_file_save,...
      'label','Model Set #1',...
      'callback', ['fdtool(''callback'',''',fcn_name,''',''ui_menu_save_model1'', ''' tag ''')'],...
      'userdata', '',...
      'tag', tag);         
   tag=[win_name '_menu_file_save_actual1'];
   menu_file_save_act1=uimenu(menu_file_save,...
      'label','Selected Model #1',...
      'callback', ['fdtool(''callback'',''',fcn_name,''',''ui_menu_save_actual1'', ''' tag ''')'],...
      'userdata', '',...
      'tag', tag);            
   tag=[win_name '_menu_file_save_model2'];
   menu_file_save_model2=uimenu(menu_file_save,...
      'label','Model Set #2',...
      'callback', ['fdtool(''callback'',''',fcn_name,''',''ui_menu_save_model2'', ''' tag ''')'],...
      'userdata', 'Model #2',...
      'separator', 'on',...
      'tag', tag);            
   tag=[win_name '_menu_file_save_actual2'];
   menu_file_save_act2=uimenu(menu_file_save,...
      'label','Selected Model #2',...
      'callback', ['fdtool(''callback'',''',fcn_name,''',''ui_menu_save_actual2'', ''' tag ''')'],...
      'userdata', 'Model #2',...
      'tag', tag);            
   tag=[win_name '_menu_file_print'];
   menu_file_print=uimenu(menu_file,...
      'label','Print',...
      'callback', ['fdtool(''callback'',''caem'',''caem_uic_print'',''' tag ''');'],...
      'tag', tag,...
      'separator','on');
   %'tooltipstring','Print figure using the Matlab print command',...
   tag=[win_name '_menu_file_print_ps'];
   menu_file_print_ps=uimenu(menu_file,...
      'label','Print to PS file',...
      'callback', ['fdtool(''callback'',''caem'',''caem_mod_print_ps'',''' tag ''');'],...
      'tag', tag,...
      'separator','off');
   %'tooltipstring','Print figure to postscript file ''fdidgui.ps'' using the Matlab print command',...
   tag=[win_name '_menu_file_cancel'];
   menu_file_cancel=uimenu(menu_file,...
      'label','Cancel',...
      'callback', ['fdtool(''callback'',''caem'',''caem_uic_cancelpb'',''caem_uic_cancelpb'');'],...
      'tag', tag,...
      'separator','on');
   tag=[win_name '_menu_file_close'];
   menu_file_close=uimenu(menu_file,...
      'label','Close',...
      'callback', ['fdtool(''callback'',''caem'',''caem_uic_donepb'',''caem_uic_donepb'');'],...
      'tag', tag);
   
   tag=[win_name '_menu_edit']; 
   menu_edit=uimenu(f,'label','&Edit Sets',...
      'posit',2,...
      'tag', tag); 
   tag=[win_name '_MENU_copy']; 
   menu_copy=uimenu(menu_edit,...
      'label','&Copy',...
      'callback', ['fdtool(''callback'',''',fcn_name,''',''menu_copy'', ''' tag ''')'],...
      'tag', tag);       
   
   if 1 % copy menu GROUP 
      if 1 % copy menu #11
         tag=[win_name '_menu_copy_set1']; 
         menu_copyset1=uimenu(menu_copy,...
            'label','&Whole Model Set #1',...
            'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_model_copy_set_1'', ''' tag ''')'],...
            'userdata', '',...
            'tag', tag);       
      end % copy menu #11
      if 1 % copy menu #12
         tag=[win_name '_menu_copy_selected1']; 
         menu_copysel1=uimenu(menu_copy,...
            'label','&Selected Model in Set #1',...
            'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_model_copy_selected_1'', ''' tag ''')'],...
            'userdata', '',...
            'tag', tag);       
      end % copy menu #12
      if 1 % copy menu #13
         tag=[win_name '_menu_copy_nonsel1']; 
         menu_copynsel1=uimenu(menu_copy,...
            'label','&Nonselected Models in Set #1',...
            'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_model_copy_nonsel_1'', ''' tag ''')'],...
            'userdata', '',...
            'tag', tag);       
      end % copy menu #13
      if 1 % copy menu #14
         tag=[win_name '_menu_copy_bad1']; 
         menu_copybad1=uimenu(menu_copy,...
            'label','&Bad Models in Set #1',...
            'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_model_copy_bad_1'', ''' tag ''')'],...
            'userdata', '',...
            'tag', tag);       
      end % copy menu #14
      if 1 % copy menu #15
         tag=[win_name '_menu_copy_unstab1']; 
         menu_copybad12=uimenu(menu_copy,...
            'label','&Unstable Models in Set #1',...
            'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_model_copy_unstab_1'', ''' tag ''')'],...
            'userdata', '',...
            'tag', tag);       
      end % copy menu #15
      if 2 % copy menu #21
         tag=[win_name '_menu_copy_set2']; 
         menu_copyset2=uimenu(menu_copy,...
            'label','W&hole Model Set #2',...
            'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_model_copy_set_2'', ''' tag ''')'],...
            'userdata', 'Model #2',...
            'separator', 'on', ...
            'tag', tag);       
      end % copy menu #21
      if 2 % copy menu #22
         tag=[win_name '_menu_copy_selected2']; 
         menu_copysel2=uimenu(menu_copy,...
            'label','S&elected Model in Set #2',...
            'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_model_copy_selected_2'', ''' tag ''')'],...
            'userdata', 'Model #2',...
            'tag', tag);       
      end % copy menu #22
      if 2 % copy menu #23
         tag=[win_name '_menu_copy_nonsel2']; 
         menu_copynsel2=uimenu(menu_copy,...
            'label','N&onselected Models in Set #2',...
            'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_model_copy_nonsel_2'', ''' tag ''')'],...
            'userdata', 'Model #2',...
            'tag', tag);       
      end % copy menu #23
      if 2 % copy menu #24
         tag=[win_name '_menu_copy_bad2']; 
         menu_copybad2=uimenu(menu_copy,...
            'label','B&ad Models in Set #2',...
            'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_model_copy_bad_2'', ''' tag ''')'],...
            'userdata', 'Model #2',...
            'tag', tag);       
      end % copy menu #24
      if 2 % copy menu #25
         tag=[win_name '_menu_copy_unstab2']; 
         menu_copyunstab2=uimenu(menu_copy,...
            'label','Uns&table Models in Set #2',...
            'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_model_copy_unstab_2'', ''' tag ''')'],...
            'userdata', 'Model #2',...
            'tag', tag);       
      end % copy menu #25
      
   end
   if 0 % old menus
      tag=[win_name '_menu_copy_12']; 
      menu_copy12=uimenu(menu_copy,...
         'label','Selected Model #1 to #2',...
         'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_copypb'', ''caem_uic_copypb'')'],...
         'userdata', '',...
         'tag', tag);       
      tag=[win_name '_menu_copy_21']; 
      menu_copy21=uimenu(menu_copy,...
         'label','Selected Model #2 to #1',...
         'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_remcopypb'', ''caem_uic_remcopypb'')'],...
         'userdata', 'Model #2',...
         'tag', tag);       
      tag=[win_name '_menu_copy_set12']; 
      menu_copyset12=uimenu(menu_copy,...
         'label','Set #&1 to #2',...
         'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_copyset12'', ''' tag ''')'],...
         'userdata', '',...
         'tag', tag);       
      tag=[win_name '_menu_copy_set21']; 
      menu_copyset21=uimenu(menu_copy,...
         'label','Set #&2 to #1',...
         'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_copyset21'', ''' tag ''')'],...
         'userdata', 'Model #2',...
         'tag', tag);       
   end
   
   tag=[win_name '_MENU_cut']; 
   menu_cut=uimenu(menu_edit,...
      'label','C&ut',...
      'callback', ['fdtool(''callback'',''',fcn_name,''',''menu_cut'', ''' tag ''')'],...
      'tag', tag);       
   if 1 % cut menu GROUP 
      if 0 % cut menu #11
         tag=[win_name '_menu_cut_set1']; 
         menu_cutset1=uimenu(menu_cut,...
            'label','&Whole Model Set #1',...
            'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_model_cut_set_1'', ''' tag ''')'],...
            'userdata', '',...
            'tag', tag);       
      end % cut menu #11
      if 1 % cut menu #12
         tag=[win_name '_menu_cut_selected1']; 
         menu_cutsel1=uimenu(menu_cut,...
            'label','&Selected Model in Set #1',...
            'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_model_cut_selected_1'', ''' tag ''')'],...
            'userdata', '',...
            'tag', tag);       
      end % cut menu #12
      if 1 % cut menu #13
         tag=[win_name '_menu_cut_nonsel1']; 
         menu_cutnsel1=uimenu(menu_cut,...
            'label','&Nonselected Models in Set #1',...
            'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_model_cut_nonsel_1'', ''' tag ''')'],...
            'userdata', '',...
            'tag', tag);       
      end % cut menu #13
      if 1 % cut menu #14
         tag=[win_name '_menu_cut_bad1']; 
         menu_cutbad1=uimenu(menu_cut,...
            'label','&Bad Models in Set #1',...
            'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_model_cut_bad_1'', ''' tag ''')'],...
            'userdata', '',...
            'tag', tag);       
      end % cut menu #14
      if 1 % cut menu #15
         tag=[win_name '_menu_cut_unstab1']; 
         menu_cutbad12=uimenu(menu_cut,...
            'label','&Unstable Models in Set #1',...
            'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_model_cut_unstab_1'', ''' tag ''')'],...
            'userdata', '',...
            'tag', tag);       
      end % cut menu #15
      if 2 % cut menu #21
         tag=[win_name '_menu_cut_set2']; 
         menu_cutset2=uimenu(menu_cut,...
            'label','W&hole Model Set #2',...
            'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_model_cut_set_2'', ''' tag ''')'],...
            'userdata', 'Model #2',...
            'separator', 'on', ...
            'tag', tag);       
      end % cut menu #21
      if 2 % cut menu #22
         tag=[win_name '_menu_cut_selected2']; 
         menu_cutsel2=uimenu(menu_cut,...
            'label','S&elected Model in Set #2',...
            'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_model_cut_selected_2'', ''' tag ''')'],...
            'userdata', 'Model #2',...
            'tag', tag);       
      end % cut menu #22
      if 2 % cut menu #23
         tag=[win_name '_menu_cut_nonsel2']; 
         menu_cutnsel2=uimenu(menu_cut,...
            'label','N&onselected Models in Set #2',...
            'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_model_cut_nonsel_2'', ''' tag ''')'],...
            'userdata', 'Model #2',...
            'tag', tag);       
      end % cut menu #23
      if 2 % cut menu #24
         tag=[win_name '_menu_cut_bad2']; 
         menu_cutbad2=uimenu(menu_cut,...
            'label','B&ad Models in Set #2',...
            'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_model_cut_bad_2'', ''' tag ''')'],...
            'userdata', 'Model #2',...
            'tag', tag);       
      end % cut menu #24
      if 2 % cut menu #25
         tag=[win_name '_menu_cut_unstab2']; 
         menu_cutunstab2=uimenu(menu_cut,...
            'label','Uns&table Models in Set #2',...
            'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_model_cut_unstab_2'', ''' tag ''')'],...
            'userdata', 'Model #2',...
            'tag', tag);       
      end % cut menu #25
   end
   
   tag=[win_name '_MENU_paste']; 
   menu_paste=uimenu(menu_edit,...
      'label','&Paste',...
      'callback', ['fdtool(''callback'',''',fcn_name,''',''menu_paste'', ''' tag ''')'],...
      'tag', tag);       
   
   tag=[win_name '_menu_paste_add1']; 
   menu_pasteadd1=uimenu(menu_paste,...
      'label','Add to Set #&1',...
      'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_model_paste_add_1'', ''' tag ''')'],...
      'userdata', '',...
      'tag', tag);       
   tag=[win_name '_menu_paste_replace1']; 
   menu_pastereplace1=uimenu(menu_paste,...
      'label','&Replace Set #1',...
      'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_model_paste_replace_1'', ''' tag ''')'],...
      'userdata', '',...
      'tag', tag);       
   tag=[win_name '_menu_paste_add2']; 
   menu_pasteadd2=uimenu(menu_paste,...
      'label','Add to Set #&2',...
      'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_model_paste_add_2'', ''' tag ''')'],...
      'userdata', '',...
      'separator', 'on', ...
      'tag', tag);       
   tag=[win_name '_menu_paste_replace2']; 
   menu_pastereplace2=uimenu(menu_paste,...
      'label','R&eplace Set #2',...
      'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_model_paste_replace_2'', ''' tag ''')'],...
      'userdata', '',...
      'tag', tag);       
   
   if 0 % old menus
      tag=[win_name '_MENU_move']; 
      menu_move=uimenu(menu_edit,...
         'label','&Move',...
         'callback', ['fdtool(''callback'',''',fcn_name,''',''menu_move'', ''' tag ''')'],...
         'tag', tag);       
      
      tag=[win_name '_menu_move_12']; 
      menu_moveset12=uimenu(menu_move,...
         'label','Selected Model #1 to #2',...
         'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_movepb'', ''' tag ''')'],...
         'userdata', '',...
         'tag', tag);       
      tag=[win_name '_menu_move_21']; 
      menu_moveset21=uimenu(menu_move,...
         'label','Selected Model #2 to #1',...
         'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_remmovepb'', ''' tag ''')'],...
         'userdata', 'Model #2',...
         'tag', tag);       
      tag=[win_name '_menu_move_set21']; 
      menu_moveset21=uimenu(menu_move,...
         'label','Set #&2 to #1',...
         'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_moveset21'', ''' tag ''')'],...
         'userdata', 'Model #2',...
         'tag', tag);       
   end
   
   tag=[win_name '_MENU_delete']; % no help action
   menu_delete=uimenu(menu_edit,...
      'label','&Delete',...
      'callback', ['fdtool(''callback'',''',fcn_name,''',''menu_delete'', ''' tag ''')'],...
      'separator', 'on', ...
      'tag', tag);    
   
   
   
   if 1 % delete menu GROUP 
      if 0 % delete menu #11
         tag=[win_name '_menu_delete_set1']; 
         menu_deleteset1=uimenu(menu_delete,...
            'label','&Whole Model Set #1',...
            'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_model_delete_set_1'', ''' tag ''')'],...
            'userdata', '',...
            'tag', tag);       
      end % delete menu #11
      if 1 % delete menu #12
         tag=[win_name '_menu_delete_selected1']; 
         menu_deletesel1=uimenu(menu_delete,...
            'label','&Selected Model in Set #1',...
            'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_model_delete_selected_1'', ''' tag ''')'],...
            'userdata', '',...
            'tag', tag);       
      end % delete menu #12
      if 1 % delete menu #13
         tag=[win_name '_menu_delete_nonsel1']; 
         menu_deletensel1=uimenu(menu_delete,...
            'label','&Nonselected Models in Set #1',...
            'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_model_delete_nonsel_1'', ''' tag ''')'],...
            'userdata', '',...
            'tag', tag);       
      end % delete menu #13
      if 1 % delete menu #14
         tag=[win_name '_menu_delete_bad1']; 
         menu_deletebad1=uimenu(menu_delete,...
            'label','&Bad Models in Set #1',...
            'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_model_delete_bad_1'', ''' tag ''')'],...
            'userdata', '',...
            'tag', tag);       
      end % delete menu #14
      if 1 % delete menu #15
         tag=[win_name '_menu_delete_unstab1']; 
         menu_deletebad12=uimenu(menu_delete,...
            'label','&Unstable Models in Set #1',...
            'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_model_delete_unstab_1'', ''' tag ''')'],...
            'userdata', '',...
            'tag', tag);       
      end % delete menu #15
      if 2 % delete menu #21
         tag=[win_name '_menu_delete_set2']; 
         menu_deleteset2=uimenu(menu_delete,...
            'label','W&hole Model Set #2',...
            'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_model_delete_set_2'', ''' tag ''')'],...
            'userdata', 'Model #2',...
            'separator', 'on', ...
            'tag', tag);       
      end % delete menu #21
      if 2 % delete menu #22
         tag=[win_name '_menu_delete_selected2']; 
         menu_deletesel2=uimenu(menu_delete,...
            'label','S&elected Model in Set #2',...
            'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_model_delete_selected_2'', ''' tag ''')'],...
            'userdata', 'Model #2',...
            'tag', tag);       
      end % delete menu #22
      if 2 % delete menu #23
         tag=[win_name '_menu_delete_nonsel2']; 
         menu_deletensel2=uimenu(menu_delete,...
            'label','N&onselected Models in Set #2',...
            'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_model_delete_nonsel_2'', ''' tag ''')'],...
            'userdata', 'Model #2',...
            'tag', tag);       
      end % delete menu #23
      if 2 % delete menu #24
         tag=[win_name '_menu_delete_bad2']; 
         menu_deletebad2=uimenu(menu_delete,...
            'label','B&ad Models in Set #2',...
            'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_model_delete_bad_2'', ''' tag ''')'],...
            'userdata', 'Model #2',...
            'tag', tag);       
      end % delete menu #24
      if 2 % delete menu #25
         tag=[win_name '_menu_delete_unstab2']; 
         menu_deleteunstab2=uimenu(menu_delete,...
            'label','Uns&table Models in Set #2',...
            'callback', ['fdtool(''callback'',''',fcn_name,''',''caem_uic_model_delete_unstab_2'', ''' tag ''')'],...
            'userdata', 'Model #2',...
            'tag', tag);       
      end % delete menu #25
      
   end
   
   
   
   
   if 0 % old menus
      tag=[win_name '_menu_edit_delete_actual1'];
      menu_file_delete_act1=uimenu(menu_delete,...
         'label','Selected Model #1',...
         'callback', ['fdtool(''callback'',''',fcn_name,''',''ui_menu_delete_actual1'', ''' tag ''')'],...
         'userdata', 'Model #1',...
         'tag', tag);            
      tag=[win_name '_menu_edit_delete_actual2'];
      menu_file_delete_act2=uimenu(menu_delete,...
         'label','Selected Model #2',...
         'callback', ['fdtool(''callback'',''',fcn_name,''',''ui_menu_delete_actual2'', ''' tag ''')'],...
         'userdata', 'Model #2',...
         'tag', tag);              
      tag=[win_name '_menu_edit_delete_model2'];
      menu_file_delete_set2=uimenu(menu_delete,...
         'label','Model Set #&2',...
         'callback', ['fdtool(''callback'',''',fcn_name,''',''ui_menu_delete_model2'', ''' tag ''')'],...
         'userdata', 'Model #2',...
         'tag', tag);                 
   end
   
   tag=[win_name '_menu_clpboardinfo']; 
   menu_delete=uimenu(menu_edit,...
      'label','Clipboard &Info',...
      'callback', ['fdtool(''callback'',''',fcn_name,''',''menu_clipboard_info'', ''' tag ''')'],...
      'separator', 'on', ...
      'tag', tag);    
   position=3;
   
case 'fdsimulation_main'   
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %%%%%%%%%%%%%%%%%% FDSIMULATION_MAIN %%%%%%%%%%%%%%%%%%%%%
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   tag=[win_name '_menu_file'];
   menu_file=uimenu(f,'label','&File',...
      'posit',1,...
      'tag', tag); 
   
   % other menus here...
   
   tag=[win_name '_menu_file_print'];
   menu_file_print=uimenu(menu_file,...
      'label','Print',...
      'callback', ['fdtool(''callback'',''fdsimul'',''fdsimul_uic_print'',''' tag ''');'],...
      'tag', tag,...
      'separator','off');
   %'tooltipstring','Print figure using the Matlab print command',...
   tag=[win_name '_menu_file_print_ps'];
   menu_file_print_ps=uimenu(menu_file,...
      'label','Print to PS file',...
      'callback', ['fdtool(''callback'',''fdsimul'',''fdsimul_mod_print_ps'',''' tag ''');'],...
      'tag', tag,...
      'separator','off');
   %'tooltipstring','Print figure to postscript file ''fdidgui.ps'' using the Matlab print command',...
   
   tag=[win_name '_menu_file_cancel'];
   menu_file_cancel=uimenu(menu_file,...
      'label','Cancel',...
      'callback', ['fdtool(''callback'',''fdsimul'',''fdsimul_uic_cancelpb'',''fdsimul_uic_cancelpb'');'],...
      'tag', tag,...
      'separator','on');
   tag=[win_name '_menu_file_close'];
   menu_file_close=uimenu(menu_file,...
      'label','Close',...
      'callback', ['fdtool(''callback'',''fdsimul'',''fdsimul_uic_donepb'',''fdsimul_uic_donepb'');'],...
      'tag', tag);
   position=2;
   
case 'fdmeasurement_main'   
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %%%%%%%%%%%%%%%%%% FDMEASUREMENT_MAIN %%%%%%%%%%%%%%%%%%%%%
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   tag=[win_name '_menu_file'];
   menu_file=uimenu(f,'label','&File',...
      'posit',1,...
      'tag', tag); 
   
   % other menus here...
   
   tag=[win_name '_menu_file_print'];
   menu_file_print=uimenu(menu_file,...
      'label','Print',...
      'callback', ['fdtool(''callback'',''fdmeasw'',''fdmeas_uic_print'',''' tag ''');'],...
      'tag', tag,...
      'separator','off');
   %'tooltipstring','Print figure using the Matlab print command',...
   tag=[win_name '_menu_file_print_ps'];
   menu_file_print_ps=uimenu(menu_file,...
      'label','Print to PS file',...
      'callback', ['fdtool(''callback'',''fdmeasw'',''fdmeas_mod_print_ps'',''' tag ''');'],...
      'tag', tag,...
      'separator','off');
   %'tooltipstring','Print figure to postscript file ''fdidgui.ps'' using the Matlab print command',...
   
   tag=[win_name '_menu_file_cancel'];
   menu_file_cancel=uimenu(menu_file,...
      'label','Cancel',...
      'callback', ['fdtool(''callback'',''fdmeasw'',''fdmeas_uic_cancelpb'',''fdmeas_uic_cancelpb'');'],...
      'tag', tag,...
      'separator','on');
   tag=[win_name '_menu_file_close'];
   menu_file_close=uimenu(menu_file,...
      'label','Close',...
      'callback', ['fdtool(''callback'',''fdmeasw'',''fdmeas_uic_donepb'',''fdmeas_uic_donepb'');'],...
      'tag', tag);
   position=2;
   
   
case 'fdtool_importfig'
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %%%%%%%%%%%%%%%%%%%%%% IMPORTFIG %%%%%%%%%%%%%%%%%%%%%%%%%
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   tag=[win_name '_menu_file'];
   menu_file=uimenu(f,'label','&File',...
      'posit',1,...
      'tag', tag); 
   
   tag=[win_name '_menu_file_print'];
   menu_file_print=uimenu(menu_file,...
      'label','Print',...
      'callback', ['fdtool(''callback'',''guiimpv'',''guiimpv_uic_print'',''' tag ''');'],...
      'tag', tag,...
      'separator','off');
   %'tooltipstring','Print figure using the Matlab print command',...
   tag=[win_name '_menu_file_print_ps'];
   menu_file_print_ps=uimenu(menu_file,...
      'label','Print to PS file',...
      'callback', ['fdtool(''callback'',''guiimpv'',''guiimpv_mod_print_ps'',''' tag ''');'],...
      'tag', tag,...
      'separator','off');
   %'tooltipstring','Print figure to postscript file ''fdidgui.ps'' using the Matlab print command',...
   
   position=2;
case 'fdtool_exportfig'
   position=1;
case {'freqselfig', 'freqsel2fig', 'freqsel3fig'}   
   tag=[win_name '_menu_file'];
   menu_file=uimenu(f,'label','&File',...
      'posit',1,...
      'tag', tag); 
   
   % other menus here...
   
   tag=[win_name '_menu_file_print'];
   menu_file_print=uimenu(menu_file,...
      'label','Print',...
      'callback', ['fdtool(''callback'',''freqsel'',''freqsel_uic_print'',''' tag ''');'],...
      'tag', tag,...
      'separator','off');
   %'tooltipstring','Print figure using the Matlab print command',...
   tag=[win_name '_menu_file_print_ps'];
   menu_file_print_ps=uimenu(menu_file,...
      'label','Print to PS file',...
      'callback', ['fdtool(''callback'',''freqsel'',''freqsel_mod_print_ps'',''' tag ''');'],...
      'tag', tag,...
      'separator','off');
   %'tooltipstring','Print figure to postscript file ''fdidgui.ps'' using the Matlab print command',...
   
   tag=[win_name '_menu_file_cancel'];
   menu_file_cancel=uimenu(menu_file,...
      'label','Cancel',...
      'callback', ['fdtool(''callback'',''freqsel'',''freqsel_uic_cancelpb'', ''freqsel_uic_cancelpb'');'],...
      'tag', tag,...
      'separator','on');
   tag=[win_name '_menu_file_close'];
   menu_file_close=uimenu(menu_file,...
      'label','Close',...
      'callback', ['fdtool(''callback'',''freqsel'',''freqsel_uic_donepb'', ''freqsel_uic_donepb'');'],...
      'enable', 'off', ...
      'tag', tag);
   position=2;
case 'gettdatafig'
   tag=[win_name '_menu_file'];
   menu_file=uimenu(f,'label','&File',...
      'posit',1,...
      'tag', tag); 
   tag=[win_name '_menu_file_cancel'];
   menu_file_cancel=uimenu(menu_file,...
      'label','Cancel',...
      'callback', 'fdtool(''callback'',''gettdata'',''ui_cancel'',''gettdata_cancel'')', ...
      'tag', tag);
   position=2;
case 'fdtool_getcaldatafig'   
   position=1;
case {'fdtool_compinput_freq_main','fdtool_compinput_time_main'}
      tag=[win_name '_menu_file'];
   menu_file=uimenu(f,'label','&File',...
      'posit',1,...
      'tag', tag); 
   % other menus here...
   tag=[win_name '_menu_file_cancel'];
   menu_file_cancel=uimenu(menu_file,...
      'label','&Cancel',...
      'callback', ['fdtool(''callback'',''compinp'',''ui_fdidgui_compinp_pb_cancel'', ''ui_fdidgui_compinp_pb_cancel'');'],...
      'tag', tag,...
      'separator','off');
   tag=[win_name '_menu_file_close'];
   menu_file_close=uimenu(menu_file,...
      'label','&Done',...
      'callback', ['fdtool(''callback'',''compinp'',''ui_fdidgui_compinp_pb_done'', ''ui_fdidgui_compinp_pb_done'');'],...
      'enable', 'on', ...
      'tag', tag);
   tag=[win_name '_menu_file_save_object'];
   menu_file_save_object=uimenu(menu_file,...
      'label','&Save Object',...
      'callback', ['fdtool(''callback'',''compinp'',''ui_fdidgui_compinp_save_object'', ''' tag ''');'],...
      'tag', tag,...
      'separator','on');
   %tag=[win_name '_menu_file_save_file'];
   %menu_file_close=uimenu(menu_file,...
   %   'label','Save to &File',...
   %   'callback', ['fdtool(''callback'',''compinp'',''ui_fdidgui_compinp_save_file'', ''ui_fdidgui_compinp_save_file'');'],...
   %   'enable', 'on', ...
   %   'tag', tag);
   
   position=2;
   if strcmp(tFig,'fdtool_compinput_freq_main')
     tag=[win_name '_menu_data_type'];   
     %for freq domain compose, allow I/O and FRF
     menu_data_type=uimenu(f,'label','&Data type',...
       'posit',position,...
       'tag', tag); 
     % other menus here...
     tag=[win_name '_menu_data_type_io'];
     menu_data_type_io=uimenu(menu_data_type,...
       'label','&Input/Output',...
       'callback', ['fdtool(''callback'',''compinp'',''ui_fdidgui_compinp_type_io'', ''' tag ''');'],...
       'checked','on',...
       'tag', tag,...
       'separator','off');
     tag=[win_name '_menu_data_type_frfdb'];
     menu_data_type_frfdb=uimenu(menu_data_type,...
       'label','&FRF dB/degrees',...
       'callback', ['fdtool(''callback'',''compinp'',''ui_fdidgui_compinp_type_frfdb'', ''' tag ''');'],...
       'checked','off',...
       'tag', tag,...
       'separator','off');     
     tag=[win_name '_menu_data_type_frf'];
     menu_data_type_frf=uimenu(menu_data_type,...
       'label','&Complex FRF',...
       'callback', ['fdtool(''callback'',''compinp'',''ui_fdidgui_compinp_type_frf'', ''' tag ''');'],...
       'checked','off',...
       'tag', tag,...
       'separator','off');     
     position=3;
   end
      
case 'preload'
   % preload, nothing to do
   return
   
otherwise
   if guiinfos('isdevelopment')
      disp(['Guimenus: 1st menu not defined for ' tFig])
   end
   position=1;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%% COMMON MENUS %%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
menu_window=uimenu(f,'label','&Window ','posit',position,...
   'Callback', ['winmenu(findall(0, ''tag'', ''' tFig '''))'],...
   'tag','winmenu');
menu_help=uimenu(f,'label','&Help','posit',position+1, 'tag', [win_name '_menu_help_top']);

menu_help_fdid=uimenu(menu_help,...
   'label',        '&Fdident GUI',...
   'callback',        [ 'fdtool(''callback'',''helpmgr'',''ui_help_fdid'',''' ...
      fcn_name, ''', ''' win_name, '_menu_help_fdid'')'],...
   'tag',                [win_name '_menu_help_fdid']);

menu_help_this=uimenu(menu_help,...
   'label',        '&This window',...
   'callback',        [ 'fdtool(''callback'',''helpmgr'',''ui_help_this'',''' ...
      fcn_name, ''', ''' win_name, '_menu_help_this'')'],...
   'tag',                [win_name '_menu_help_this']);

if strcmp(tFig,'select_main')|strcmp(tFig,'aided_main')
  menu_help_autoorder=uimenu(menu_help,...
    'label','&Automatic order selection',...
   'callback',        [ 'fdtool(''callback'',''helpmgr'',''ui_help_autoorder'',''' ...
      fcn_name, ''', ''' win_name, '_menu_help_autoorder'')'],...
   'tag',                [win_name '_menu_help_autoorder']);
  
  menu_help_autoorder=uimenu(menu_help,...
    'label','&Demo: automatic order selection',...
    'callback',['fdtool(''callback'',''helpmgr'',''ui_help_autoorder_demo'',''' ...
      fcn_name, ''', ''' win_name, '_menu_help_autoorder_demo'')'],...
    'tag',[win_name '_menu_help_autoorder_demo']);

  menu_help_runmod=uimenu(menu_help,...
      'label','&Modify algorithm',...
   'callback',        [ 'fdtool(''callback'',''helpmgr'',''ui_help_runmod'',''' ...
      fcn_name, ''', ''' win_name, '_menu_help_runmod'')'],...
   'tag',                [win_name '_menu_help_runmod']);
 
end

if strcmp(tFig,'excitation_main')|strcmp(tFig,'select_main')|...
      strcmp(tFig,'aided_main')|strcmp(tFig,'compare_main')
   switch tFig
   case 'excitation_main'
      label='&Saving signal';
   case 'select_main'
      label='&Saving model';
   case 'aided_main'
      label='&Saving models';
   case 'compare_main'
      label='&Saving models';
   end
   menu_help_save=uimenu(menu_help,...
      'label',        label,...
      'callback',        [ 'fdtool(''callback'',''helpmgr'',''ui_help_expimp'',''' ...
         fcn_name, ''', ''' win_name, '_menu_help_save'')'],...
      'tag',                [win_name '_menu_help_save']);
end

if strcmp(tFig,'select_main')|strcmp(tFig,'compare_main')
  label='&Advice on this model';
  if strcmp(tFig,'select_main'), separator='on';
  else separator='on'; 
  end
  if strcmp(tFig,'select_main'), enable='off';
  else enable='on'; 
  end
  menu_help_save=uimenu(menu_help,...
      'label',        label,...
      'separator',separator,...
      'enable',enable,...
      'callback',        [ 'fdtool(''callback'',''',fcn_name,''',''ui_help_advice'',''' ...
         fcn_name, ''', ''' win_name, '_menu_help_advice'')'],...
      'tag',                [win_name '_menu_help_advice']);
end

% info on model menu in sme
if strcmp(tFig,'select_main')|strcmp(tFig,'aided_main')
  if strcmp(tFig,'select_main'), separator='off';
  else separator='on'; 
  end
   menu_help_info_obj=uimenu(menu_help,...
      'label',        '&Info on this model',...
      'callback',        [ 'fdtool(''callback'',''sme'',''sme_uic_info_object'',''' ...
         fcn_name, ''', ''' win_name, '_menu_help_model'')'],...
      'separator', separator, ...
      'enable','off',...
      'tag',                [win_name '_menu_help_model']);
end 
menu_help_object=uimenu(menu_help,...
   'label',        'On &Object',...
   'callback',        [ 'fdtool(''callback'',''helpmgr'',''ui_help_object'',''' ...
      fcn_name, ''', ''' win_name, '_menu_help_object'')'],...
   'tag',                [win_name '_menu_help_object'],...
   'separator','on');

if strcmp(tFig,'fdtool_compinput_freq_main')|...
    strcmp(tFig,'fdtool_compinput_time_main')
  if strcmp(tFig,'fdtool_compinput_time_main'), typ='time';
  elseif strcmp(tFig,'fdtool_compinput_freq_main'), typ='freq';
  end
  menu_help_this=uimenu(menu_help,...
    'label','&Demonstration: basics',...
    'callback',['fdtool(''callback'',''fddemutl'',''compinp'',''',typ,''')'],...
    'tag',[win_name '_menu_help_demo'],...
    'separator','on');
  if strcmp(typ,'freq')
    menu_help_this=uimenu(menu_help,...
      'label','&Demonstration: FRF data',...
      'callback',['fdtool(''callback'',''fddemutl'',''compinp'',''','FRF',''')'],...
      'tag',[win_name '_menu_help_demo'],...
      'separator','off');
  end
end

%   
winmenu(f)
%
%End of file

