function infotext(w, varargin)

for i=1:2:(nargin-1)
   varargin{i};
   switch varargin{i}
   case 'Expno'
     if ~isempty(varargin{i+1})
       set(findall(0, 'tag', [w '_uic_infotext(1)']),...
         'string',sprintf('Expno = %.0f', varargin{i+1}),...
         'tooltipstring','Number of experiments')
     else
       set(findall(0, 'tag', [w '_uic_infotext(1)']),...
         'string','')
     end
   case {'M','Meq'}
     if strcmp(varargin{i},'M'), pos='2'; else pos='2'; end
     if ~isempty(varargin{i+1})
       if guiinfos('islinear')|strcmp(varargin{i},'M')
         set(findall(0, 'tag', [w '_uic_infotext(',pos,')']),...
           'string',sprintf([varargin{i},' = %.0f'], varargin{i+1}),...
           'tooltipstring','Number of records')
       else
         Me='average_main';
         if ~israndomized(guidtard(Me,'DATA_Fdat'))
           set(findall(0, 'tag', [w '_uic_infotext(',pos,')']),...
             'string',sprintf([varargin{i},' = %.0f'], varargin{i+1}),...
             'tooltipstring','Equivalent number of processed records')
         end
       end
       if strcmp(varargin{i},'M')&(varargin{i+1}<=4)&guiinfos('islinear')
         set(findall(0, 'tag', [w '_uic_infotext(',pos,')']),'backgroundcolor',[1,1,0])
       elseif strcmp(varargin{i},'NonlinM')&(varargin{i+1}<6)&~guiinfos('islinear')
         set(findall(0, 'tag', [w '_uic_infotext(',pos,')']),'backgroundcolor',[1,1,0])
       else
         set(findall(0, 'tag', [w '_uic_infotext(',pos,')']),'backgroundcolor',...
           get(findall(0, 'tag', [w '_uic_infotext(1)']),'backgroundcolor'))
       end
     else
       set(findall(0, 'tag', [w '_uic_infotext(',pos,')']),'backgroundcolor',...
         get(findall(0, 'tag', [w '_uic_infotext(1)']),'backgroundcolor'),...
         'string','')
     end
   case 'fs', set(findall(0, 'tag', [w '_uic_infotext(2)']),...
         'string', sprintf('fs = %.4g Hz', varargin{i+1}),...
         'tooltipstring','Sampling frequency',...
         'backgroundcolor',get(findall(0, 'tag', [w '_uic_infotext(1)']),'backgroundcolor'))
   case 'Tri', set(findall(0, 'tag', [w '_uic_infotext(3)']),...
         'string',sprintf('Tri = %.4g s', varargin{i+1}),...
         'tooltipstring','Segment length')
   case 'Ni', set(findall(0, 'tag', [w '_uic_infotext(4)']),...
         'string',sprintf('Ni = %.0f', varargin{i+1}),...
         'tooltipstring','Points in segments')
   case 'dt', set(findall(0, 'tag', [w '_uic_infotext(5)']),...
         'string',sprintf('dt = %.4g s', varargin{i+1}),...
         'tooltipstring','Sampling interval')
   case 'dfi', set(findall(0, 'tag', [w '_uic_infotext(6)']),...
         'string',sprintf('dfi = %.4g Hz', varargin{i+1}),...
         'tooltipstring','Frequency resolution')
   case 'F', set(findall(0, 'tag', [w '_uic_infotext(7)']),...
         'string',sprintf('freqs = %.4g', varargin{i+1}),...
         'tooltipstring','Number of frequencies in each experiment')
   case 'allF', set(findall(0, 'tag', [w '_uic_infotext(7)']),...
         'string',sprintf('allfreqs = %.4g', varargin{i+1}),...
         'tooltipstring','Number of all frequencies in all experiments')
   case 'fmin', set(findall(0, 'tag', [w '_uic_infotext(8)']),...
         'string',sprintf('fmin = %.4g Hz', varargin{i+1}),...
         'tooltipstring','Minimum frequency')
   case 'fmax', set(findall(0, 'tag', [w '_uic_infotext(9)']),...
         'string',sprintf('fmax = %.4g Hz', varargin{i+1}),...
         'tooltipstring','Maximum frequency')
   case 'fmax/dfi', set(findall(0, 'tag', [w '_uic_infotext(10)']),...
         'string',sprintf('fmax/dfi = %.4g', varargin{i+1}),...
         'tooltipstring','Maximum harmonic index')
   otherwise, disp('Unknown parameter.')
   end;
end;
