function segmdata(p1,p2,p3,p4,p5,seltype);
% segment data

%       Last modified: 03-Mar-2001

% common instructions
vers=version; vers=vers(1);

mainfig=findall(0,'tag','fdtool_main');
Me='segmentfig';
MyHand=findall(0, 'tag',Me);

if nargin >0,
   if nargin == 6
      sender=p5;
   else
      seltype=get(MyHand,'selectiontype');
      eval(['sender=p', num2str(nargin) ';']);
   end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%               INITIALIZATION
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


if nargin == 0  % init
   if ~isempty(MyHand), delete(MyHand), end      
   inpdata=guidtard('gettime_main', 'DATA_gotdata');
   tdata=inpdata;
   if isa(tdata,'tiddata')
     timevect=inpdata.samplinginstants;
     xt=inpdata.input; yt=inpdata.output; expno=inpdata.expn;
     dt=inpdata.ts; if ~isempty(dt), fs=1/dt; end
     if isempty(timevect)
       timevect=[0:inpdata.samplen-1]'*dt;
     elseif isempty(dt)
       fs=1/mean(diff(timevect)); dt=1/fs;
     end
   end
   N=length(timevect); Tr=N*dt; df=fs/N;
   Tp=tdata.periodlength;
   if isempty(Tp)|isnan(Tp)
     if isa(tdata,'tiddata')
       freqvect=tdata.frequencies;
     end
     if ~isempty(freqvect), Tp=1/dfcalc([freqvect]);
     else Tp=NaN;
     end
   end
   Np=N/(Tr/Tp);
   
   if expno >1
      segmenteddata=inpdata;
      gettime('status','Multiple experiments, no segmentation required')
      guidtawr('gettime_main', 'DATA_segmenteddata', 'direct', segmenteddata);
      gettime('finished_box', 'rect_segment','done')


      %boxmgr('end_of_segment', 'gettime_main', 'NEWDATA')
      return
   end
   
   scrs=get(0,'screensize');
   sy=scrs(4);
   segmdef
   f=figure(...
     'name', 'Segment Data',...
     'numbertitle', 'off',...
     'menubar', 'none', ...
     'IntegerHandle', 'off',...
     'Handlevisibility', 'off',...
     'units', 'pixels',...
     'position', [50 sy-60-300 400 246],...
     'closerequestfcn', 'fdtool(''callback'',''segmdata'',''ui_cancel'', ''segmentcancel'')',...
     'resize', 'off', ...
     'tag', 'segmentfig');
   if strncmp(version,'5',1), set(f,'Position',[50 sy-60-300 400 246]), end %fix in 5.3
   MyHand=f;
   fdwindef(f);  % set default window properties
   
   frame1=uicontrol(...
      'parent', f,...
      'style', 'frame',...
      'units', 'pixels',...
      'position', [frame1_offsx frame1_offsy frame1_dx frame1_dy],...
      'horizontalalignment', 'left');
   
   text1=uicontrol(...
      'parent', f,...
      'style', 'text',...
      'units', 'pixels',...
      'position', [text1_offsx text1_offsy text1_dx text1_dy],...
      'horizontalalignment', 'left', ...
      'string', 'Tr=',...
      'tooltipstring','Total record length',...
      'tag', 'segment_text1');
         
   
   text2=uicontrol(...
      'parent', f,...
      'style', 'text',...
      'units', 'pixels',...
      'position', [text2_offsx text2_offsy text2_dx text2_dy],...
      'horizontalalignment', 'left', ...
      'string', 'Nr=',...
      'tooltipstring','Total number of samples',...
      'tag', 'segment_text2');

   
   text3=uicontrol(...
      'parent', f,...
      'style', 'text',...
      'units', 'pixels',...
      'position', [text3_offsx text3_offsy text3_dx text3_dy],...
      'horizontalalignment', 'left', ...
      'string', 'Periodlengh:',...
      'tooltipstring','Period length in seconds',...
      'tag', 'segment_text3');

   
   text4=uicontrol(...
      'parent', f,...
      'style', 'text',...
      'units', 'pixels',...
      'position', [text4_offsx text4_offsy text4_dx text4_dy],...
      'horizontalalignment', 'left', ...
      'string', 'Samples in a period:',...
      'tooltipstring','Number of samples in a period',...
      'tag', 'segment_text4');

   text5=uicontrol(...
      'parent', f,...
      'style', 'text',...
      'units', 'pixels',...
      'position', [text5_offsx text5_offsy text5_dx text5_dy],...
      'horizontalalignment', 'left', ...
      'string', '# of periods: ',...
      'tooltipstring','Number of periods',...
      'tag', 'segment_text5');
   
   text6=uicontrol(...
      'parent', f,...
      'style', 'text',...
      'units', 'pixels',...
      'position', [text6_offsx text6_offsy text6_dx text6_dy],...
      'horizontalalignment', 'left', ...
      'string', 'Segment length: ',...
      'tooltipstring','Number of samples in each segment',...
      'tag', 'segment_text6');

   edit1=uicontrol(...
      'parent', f,...
      'style', 'edit',...
      'units', 'pixels',...
      'position', [edit1_offsx edit1_offsy edit1_dx edit1_dy],...
      'horizontalalignment', 'right', ...
      'callback', 'fdtool(''callback'',''segmdata'',''ui_edit'',''segmentedit'');',...
      'string', '1',...
      'tooltipstring','Number of samples in each segment',...
      'tag', 'segmentedit');
   
   text7=uicontrol(...
      'parent', f,...
      'style', 'text',...
      'units', 'pixels',...
      'position', [text7_offsx text7_offsy text7_dx text7_dy],...
      'horizontalalignment', 'left', ...
      'string', 'Overlap: ',...
      'tooltipstring','Overlap of segments in %',...
      'tag', 'segment_text7');
   
   edit2=uicontrol(...
      'parent', f,...
      'style', 'edit',...
      'units', 'pixels',...
      'position', [edit2_offsx edit2_offsy edit2_dx edit2_dy],...
      'horizontalalignment', 'right', ...
      'callback', 'fdtool(''callback'',''segmdata'',''ui_edit'',''overlapedit'');',...
      'string', '0',...
      'tooltipstring','Overlap of segments in %',...
      'tag', 'overlapedit');
   
   edit3=uicontrol(...
      'parent', f,...
      'style', 'edit',...
      'units', 'pixels',...
      'position', [edit3_offsx edit3_offsy edit3_dx edit3_dy],...
      'horizontalalignment', 'right', ...
      'callback', 'fdtool(''callback'',''segmdata'',''ui_edit'',''segment_edit3'');',...
      'string', '1',...
      'tooltipstring','Number of periods',...
      'tag', 'segment_edit3');
   
   edit4=uicontrol(...
      'parent', f,...
      'style', 'edit',...
      'units', 'pixels',...
      'position', [edit4_offsx edit4_offsy edit4_dx edit4_dy],...
      'horizontalalignment', 'right', ...
      'callback', 'fdtool(''callback'',''segmdata'',''ui_edit'',''segment_edit4'');',...
      'string', '1',...
      'tooltipstring','Number of samples in a period',...
      'tag', 'segment_edit4');
   
   edit5=uicontrol(...
      'parent', f,...
      'style', 'edit',...
      'units', 'pixels',...
      'position', [edit5_offsx edit5_offsy edit5_dx edit5_dy],...
      'horizontalalignment', 'right', ...
      'callback', 'fdtool(''callback'',''segmdata'',''ui_edit'',''segment_edit5'');',...
      'string', '',...
      'tooltipstring','Period length in seconds',...
      'tag', 'segment_edit5');
   
   text8=uicontrol(...
      'parent', f,...
      'style', 'text',...
      'units', 'pixels',...
      'position', [text8_offsx text8_offsy text8_dx text8_dy],...
      'horizontalalignment', 'left', ...
      'string', '% ',...
      'tag', 'segment_text8');

    text12=uicontrol(...
      'parent', f,...
      'style', 'text',...
      'units', 'pixels',...
      'position', [text12_offsx text12_offsy text12_dx text12_dy],...
      'horizontalalignment', 'left', ...
      'string', 's ',...
      'tooltipstring','Period length in seconds',...
      'tag', 'segment_text12');
      
   text9=uicontrol(...
      'parent', f,...
      'style', 'text',...
      'units', 'pixels',...
      'position', [text9_offsx text9_offsy text9_dx text9_dy],...
      'horizontalalignment', 'left', ...
      'string', 'Segments: ',...
      'tooltipstring','Number of segments to be generated',...
      'tag', 'segment_text9');
   
   text10=uicontrol(...
      'parent', f,...
      'style', 'text',...
      'units', 'pixels',...
      'position', [text10_offsx text10_offsy text10_dx text10_dy],...
      'horizontalalignment', 'right', ...
      'string', 'NaN',...
      'tooltipstring','Number of segments to be generated',...
      'tag', 'segment_text10');
   
   butt_cancel=uicontrol(...
      'parent', f,...
      'style', 'pushbutton',...
      'units', 'pixels',...
      'position', [cancelpb_offsx cancelpb_offsy cancelpb_dx cancelpb_dy],...
      'callback', 'fdtool(''callback'',''segmdata'',''ui_cancel'', ''segmentcancel'')',...
      'string', 'Cancel', ...
      'tooltipstring','Close window and do not return new data',...
      'tag', 'segmentcancel');
   
   butt_done=uicontrol(...
      'parent', f,...
      'style', 'pushbutton',...
      'units', 'pixels',...
      'position', [donepb_offsx donepb_offsy donepb_dx donepb_dy],...
      'callback', 'fdtool(''callback'',''segmdata'',''ui_done'', ''segmentdone'')',...
      'string', 'Close', ...
      'tooltipstring','Close window and return segmented data',...
      'tag', 'segmentdone');
    
    butt_check=uicontrol(...
      'parent', f,...
      'style', 'pushbutton',...
      'units', 'pixels',...
      'position', [checkpb_offsx checkpb_offsy checkpb_dx checkpb_dy],...
      'callback', 'fdtool(''callback'',''segmdata'',''ui_check'', ''segmentcheck'')',...
      'string', 'Apply Periods', ...
      'tooltipstring',['Set the Segment length to the number of samples in a period',...
        ', or the smallest possible integer multiple of it'],...
      'tag', 'segmentcheck');
    
    butt_apply=uicontrol(...
      'parent', f,...
      'style', 'pushbutton',...
      'units', 'pixels',...
      'position', [applypb_offsx applypb_offsy applypb_dx applypb_dy],...
      'callback', 'fdtool(''callback'',''segmdata'',''ui_apply'', ''segmentapply'')',...
      'string', 'Apply Settings', ...
      'tooltipstring',['Set consistent settings from given parameters'],...
      'tag', 'segmentapply');
    
    % end of figure creation

   
   % load input data
   if ~isnan(Tp)
     segmlen=Np;
     while abs(rem(segmlen+0.5,1)-0.5)>min(1e-2,N/Np*1e-4)
       segmlen=segmlen+Np;
       if segmlen>N, segmlen=N; break, end
     end
   else
      segmlen=N;
   end
   segmlen=round(segmlen);
   
   h=findobj(MyHand,'tag','segmentedit');
   set(h,'string', num2str(segmlen));
   
   segmdata('setinfo','text1', sprintf('Tr = %.4g s', Tr))
   segmdata('setinfo','text2', sprintf('N = %.0f', N))
   %
   %segmdata('setinfo','text3', sprintf('Tp = %.4g s', Tp))
   segmdata('setinfo','edit5', sprintf('%.4g', Tp))
   if rem(Np,1)==0
     %segmdata('setinfo','text4', sprintf('Np = %.0f', Np))
     segmdata('setinfo','edit4', sprintf('%.0f', Np))
   else
     %segmdata('setinfo','text4', sprintf('Np = %.3f', Np))
     segmdata('setinfo','edit4', sprintf('%.3f', Np))
   end
   %segmdata('setinfo','text5', sprintf('Periods = %.0f', N/Np))
   segmdata('setinfo','edit3', sprintf('%.0f', N/Np))
   
   
elseif strcmp(p1, 'ui_check')
  hsegm=findobj(MyHand,'tag','segmentedit');
  set(hsegm,'foregroundcolor','default')
  segmdata('segment#update')  
  segmdata('plot_segments')
  
elseif strcmp(p1, 'ui_apply')
  segmdata('segment#update')  
  segmdata('plot_segments')
  
elseif strcmp(p1, 'ui_done')|strcmp(p1, 'done')|strcmp(p1,'plot_segments')
   if isempty(MyHand), return, end
   if strcmp(p1, 'ui_done')|strcmp(p1, 'done')
      guifreez(Me, 'freeze', 'segmdata_done');
      gettime('status','Please wait, segmentation in progress...' )
   end
   % read input data
   tdata=guidtard('gettime_main', 'DATA_gotdata');
   % segmentation process here
   h=findobj(MyHand,'tag','segmentedit');
   segmlen=str2num(get(h,'string'));
   if isa(tdata,'iddat')
     timevect=tdata.samplinginstants;
     xt=tdata.input; yt=tdata.output; expno=tdata.expn;
     if isempty(timevect)
       dt=tdata.ts; fs=1/dt;
       timevect=[0:tdata.samplen-1]'*dt;
     else
       fs=1/mean(diff(timevect));
     end
   else
     timevect=tdata.places; fs=1/mean(diff(timevect)); 
     xt=tdata.u; yt=tdata.y;
   end
   N=length(timevect); 
   segmlen=min(max(segmlen,2),N); 
   h=findobj(MyHand,'tag','overlapedit');
   overlap=str2num(get(h,'string'))/100;
   overlN=floor(segmlen*overlap);
   overlN=min(segmlen-1,overlN);
   overlap=overlN/segmlen;
   timevect2=timevect(1:segmlen);
   if isa(tdata,'tiddata')
     icyc=0;
     xt2={xt(1:segmlen,:)};
     yt2={yt(1:segmlen,:)};
     for ii=segmlen+1-overlN:segmlen-overlN:N-segmlen+1;
       icyc=icyc+1;
       if strcmp(p1, 'ui_done')|strcmp(p1, 'done')
         xt2{1,icyc+1}=xt(ii:ii+segmlen-1,:);
         yt2{1,icyc+1}=yt(ii:ii+segmlen-1,:);
       end
     end
     segmenteddata=tiddata(yt2,xt2,1/fs);
     set(segmenteddata,'frequencies',tdata.frequencies,'noconsistency')
     set(segmenteddata,'periodlength',tdata.periodlength,'noconsistency')
     set(segmenteddata,'inputcharacter',get(tdata,'inputcharacter'),'noconsistency')
     set(segmenteddata,'outputcharacter',get(tdata,'outputcharacter'),'noconsistency')
     set(segmenteddata,'userdata',overlap,'noconsistency');
     tsi=cell(1,size(xt2,2));
     for ii=1:length(tsi), tsi{ii}=(ii-1)*(segmlen-overlN)/fs; end
     set(segmenteddata,'TStart',tsi,'noconsistency');
     if get(segmenteddata,'expnumber')>1
       set(segmenteddata,'synchronization','on','noconsistency');
     end
     set(segmenteddata,'inputname',tdata.inputname,'noconsistency');
     set(segmenteddata,'outputname',tdata.outputname,'noconsistency');
     set(segmenteddata,'outputvar',tdata.outputvar,'noconsistency');
     set(segmenteddata,'inputvar',tdata.inputvar,'noconsistency');
     set(segmenteddata,'state',tdata.state,'noconsistency');
   end
   outdata=segmenteddata;
   set(outdata,'history',tdata.history,'noconsistency');
   freqvect=tdata.frequencies;
   if ~isempty(freqvect)&...
       any(abs(rem(freqvect/(fs/N)+0.5,1)-0.5)>max(freqvect)*eps)
     fftmsg=' (noninteger periods)';
   else
     fftmsg=' done';
   end
   addhist(outdata,...
     sprintf(['Segmentation',fftmsg,...
     '. Number of segments: %.0f, overlap: %.3g %%'],...
     icyc+1,overlap*100));
   if strcmp(p1,'plot_segments')
     %segmdatacontents=guidtard('gettime_main', 'DATA_segmenteddata');
     %guidtawr('gettime_main', 'DATA_segmenteddata', 'direct', outdata);
     %arrplot('arr12', 'infoupdate')
     %guidtawr('gettime_main', 'DATA_segmenteddata', 'direct', segmdatacontents);
     %plot segments
     %figure(11)
     hpl=gcf; figure(hpl); drawnow
     clf, set(hpl,'tag','arrow_plot_fig_gettime','name','View: Time Domain Data')
     set(hpl,'numbertitle','off')
     plot(tdata); dismispb('arrow_plot_fig_gettime')
     hax=findobj(findobj(0,'type','figure','tag','arrow_plot_fig_gettime'),'type','axes');
     xlim=get(hax(1),'xlim');
     dxlim=diff(xlim); xlim=xlim+dxlim*[-0.05,0.05];
     set(hax,'xlim',xlim)
     Tr=dt*segmlen;
     hsegmno=findobj(allchild(MyHand), 'flat', 'tag', 'segment_text10');
     segmno=str2num(get(hsegmno,'string'));
     plotsegm(Tr,segmno,overlap,hax(1))
     plotsegm(Tr,segmno,overlap,hax(2))
   else %done button
     %if ishandle(11), delete(11), end
     delete(MyHand); %delete segment window
     guidtawr('gettime_main', 'DATA_segmenteddata', 'direct', outdata);
     gettime('finished_box','rect_segment','done')
     %gettime('setinfo','text_info11',['Data source: Workspace variable ''' p2 '''.'])
     %
     N=outdata.samplenumber; Tp=outdata.periodlength;
     if isempty(Tp)
       if ~isempty(outdata.frequencies), Tp=1/dfcalc(outdata.frequencies);
       else gettime('status','Warning: period length or excitation frequencies are not given')
       end
     end
     if isempty(Tp)|(abs(rem(Tp/outdata.ts+0.5,1)-0.5)<100*N*eps)
       gettime('status',['Data segmentation done.'])
     elseif outdata.expnumber>=4
       gettime('status',['Data segmentation done.'])
     else
       gettime('status', sprintf('#yFractional period in segments. Switch Autoconvert on to avoid too long processing time.'), Me);
     end
   end
   %else %check only
   %  segmdata('status',['Data segmentation checked.'])

elseif strcmp(p1, 'ui_cancel')
  %if ishandle(11), delete(11), end
  delete(MyHand);
  gettime('finished_box','rect_segment','cancel',Me)
   

elseif strcmp(p1,'check_edit') % checks and corrects input value
   h=findobj(MyHand,'tag','segmentedit');
   segmstr=get(h,'string');
   segmnum=str2num(segmstr);
   h2=findobj(MyHand,'tag','overlapedit');
   ovlstr=get(h2,'string');
   ovl=str2num(ovlstr);
   switch sender
   case 'segmentedit'
           if isempty(segmnum) | segmnum <= 1 
                   segmnum=1;
           else
                   segmnum=floor(segmnum(1,1));
           end
                   segmstr=num2str(segmnum);
           set(h,'string',segmstr);
   end
   %case 'overlapedit'
      if isempty(ovl), ovl=0;
      elseif ovl>(segmnum-1)/segmnum*100, ovl=(segmnum-1)/segmnum*100;
      end
      set(h2,'string',num2str(ovl))
   %end
      segmdata('segment#update')
   
elseif strcmp(p1,'ui_edit')
   if ~isempty(p2)
     if strcmp(p2,'segment_edit3')|...
         strcmp(p2,'segment_edit4')|...
         strcmp(p2,'segment_edit5')
       hall=[findobj(MyHand,'tag','segment_edit3');...
         findobj(MyHand,'tag','segment_edit4');...
         findobj(MyHand,'tag','segment_edit5')];
       hsel=findobj(MyHand,'tag',p2);
       set(hall,'foregroundcolor','default')
       set(hsel,'foregroundcolor',[1,0,0])
     end
     if strcmp(p2,'segmentedit')
       hsegm=findobj(MyHand,'tag','segmentedit');
       segmlen=str2num(get(hsegm,'string'));
       if isempty(segmlen)|isnan(segmlen)
         set(hsegm,'foregroundcolor','default')
       else
         set(hsegm,'foregroundcolor',[1,0,0])
       end
     end
     %
     segmdata('segment#update')
   end
   
elseif strcmp(p1, 'segment#update')
   inpdata=guidtard('gettime_main', 'DATA_gotdata');
   tdata=inpdata;
   if isa(tdata,'iddat')
     timevect=inpdata.samplinginstants;
     xt=inpdata.input; yt=inpdata.output; expno=inpdata.expn;
     if isempty(timevect)
       dt=inpdata.ts; fs=1/dt;
       timevect=[0:inpdata.samplen-1]'*dt;
     else
       fs=1/mean(diff(timevect)); dt=1/fs;
     end
   else
     timevect=tdata.places;
     xt=tdata.u; yt=tdata.y;
     expno=size(xt,3);
     fs=1/mean(diff(timevect)); dt=1/fs;
   end
   N=length(timevect); Tr=N*dt; df=fs/N;
   Tp=tdata.periodlength;
   if isempty(Tp)
     freqvect=tdata.frequencies;
     if ~isempty(freqvect), Tp=1/dfcalc(freqvect);
     else Tp=NaN;
     end
   end
   Np=N/(Tr/Tp); M=(N/Np);
   
   hTp=findobj(MyHand,'tag','segment_edit5');
   hNp=findobj(MyHand,'tag','segment_edit4');
   hM=findobj(MyHand,'tag','segment_edit3');
   hall=[hTp;hNp;hM];
   for ii=1:3
     if isequal(get(hall(ii),'foregroundcolor'),[1,0,0])
       break
     end
     ii=ii+1;
   end
   hsel=findobj(MyHand,'tag',['segment_edit',num2str(6-ii)]);
   if ii==3 %# of periods
     M=str2num(get(hsel,'string'));
     Np=N/M; Tp=Np*dt;
   elseif ii==2 %Np
     Np=str2num(get(hsel,'string'));
     M=N/Np; Tp=Np*dt;
   elseif ii==1 %Tp
     Tp=str2num(get(hsel,'string'));
     Np=Tp/dt;
     if abs(rem(Tp-Np*dt+0.5,1)-0.5)<1e-4*Tp
       Np=round(Np); Tp=Np*dt;
     end
     M=N/Np;
   end
   if (ii>=1)&(ii<=3)
     set(hM,'string',M);
     set(hNp,'string',Np);
     set(hTp,'string',Tp);
   end
   %
   hsegm=findobj(allchild(MyHand), 'flat', 'tag', 'segmentedit');
   hoverlap=findobj(allchild(MyHand), 'flat', 'tag', 'overlapedit');
   hsegmno=findobj(allchild(MyHand), 'flat', 'tag', 'segment_text10');
   segmlen=str2num(get(hsegm, 'string'));
   overlap=str2num(get(hoverlap, 'string'));
   
   if isempty(segmlen)|isnan(segmlen)
     segmlen=Np; set(hsegm,'string',num2str(segmlen))
   elseif ~isequal(get(hsegm,'foregroundcolor'),[1,0,0])&~isnan(Np)
     segmlen=Np;
     while abs(rem(segmlen+0.5,1)-0.5)>min(1e-2,N/Np*1e-4)
       segmlen=segmlen+Np;
       if segmlen>N, segmlen=N; break, end
     end
     segmlen=round(segmlen);
     set(hsegm,'string',num2str(segmlen))
   end
   if isempty(overlap)
     overlap=0; set(hoverlap,'string','0')
   end
   dN=max(round(segmlen*(1-overlap/100)),1);
   segmno=floor((N-segmlen)/dN)+1;
   set(hsegmno, 'string', num2str(segmno));
   
   hClose=findobj(allchild(MyHand), 'flat', 'tag', 'segmentdone');
   if ~isempty(segmno)&(segmno>0)
      set(hClose, 'enable', 'on')
   else
      set(hClose, 'enable', 'off')
   end
   
elseif strcmp(p1,'setinfo') % p2: text1, text2, ....text6, edit3 ... 5
   h=findobj(MyHand,'tag',['segment_' p2]);
   set(h,'string',p3)
   
elseif strcmp(p1,'destroyed')
   gettime('finished_box', 'rect_segment', 'cancel', Me);
         
end
